/* This file is part of Cassandre.
   Copyright (c) 2003 Romang Jean-Franois, Adolph Thomas, Grundrich Raphael

   Cassandre is based on the DessChess program, a student project realised at
   University Louis Pasteur in Strasbourg, France ; under the direction of
   professor J.Korczak.

   Cassandre is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Cassandre is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Cassandre; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.

   Contact Info: 
     jeff@proxone.net
*/

/**NODOCUMENT**/

#include "internalbookdata.h"

char *bookBlack[BBSIZE] = 
{
	"Nc3 c5 Nf3 Nf6 e4 d6 g3 g6 Bg2 Bg7 O-O Nc6 d3 O-O h3 Rb8 ",
	"Nf3 Nf6 b3 d5 Bb2 Bg4 e3 Nbd7 Be2 e6 Ne5 Nxe5 Bxe5 Bxe2 Qxe2 c6 ",
	"Nf3 Nf6 b3 d5 Bb2 Bg4 e3 e6 Be2 Nbd7 d3 Bd6 c4 O-O O-O c6 ",
	"Nf3 Nf6 b3 g6 Bb2 Bg7 g3 O-O Bg2 d6 d4 e5 dxe5 Ng4 Qc1 Nxe5 ",
	"Nf3 Nf6 b3 g6 c4 Bg7 Bb2 O-O g3 d6 d4 Nbd7 Nc3 e5 e3 Ng4 ",
	"Nf3 Nf6 b3 g6 g3 b6 Bb2 Bg7 Bg2 Bb7 O-O O-O c4 c5 d3 d5 ",
	"Nf3 Nf6 c4 b6 e3 Bb7 Be2 g6 b3 Bg7 Bb2 c5 O-O O-O Nc3 d5 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 e6 O-O Be7 d4 O-O Nc3 Ne4 Qc2 Nxc3 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 e6 O-O Be7 d4 O-O d5 exd5 Nd4 Bc6 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 g6 Nc3 Bg7 d3 d5 cxd5 Nxd5 Nxd5 Bxd5 ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O e6 Nc3 Be7 d4 cxd4 Qxd4 d6 ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O e6 Nc3 a6 b3 d6 d4 cxd4 ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O e6 d4 cxd4 Qxd4 d6 Nc3 Be7 ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O g6 Nc3 Bg7 d3 O-O e4 Nc6 ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O g6 b3 Bg7 Bb2 O-O Nc3 Ne4 ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O g6 e3 Bg7 d4 cxd4 exd4 Qc8 ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 d4 cxd4 Nxd4 e6 g3 Qb6 Ndb5 Ne5 Bg2 a6 ",
	"Nf3 Nf6 c4 c5 Nc3 b6 e3 g6 d4 Bg7 Be2 O-O O-O d6 d5 e6 ",
	"Nf3 Nf6 c4 c5 Nc3 b6 g3 Bb7 Bg2 d5 cxd5 Nxd5 O-O e6 b3 Be7 ",
	"Nf3 Nf6 c4 c5 Nc3 d5 cxd5 Nxd5 d4 Nxc3 bxc3 g6 e3 Bg7 Bd3 O-O ",
	"Nf3 Nf6 c4 c5 Nc3 d5 cxd5 Nxd5 e4 Nxc3 dxc3 Qxd1+ Kxd1 Nc6 Be3 b6 ",
	"Nf3 Nf6 c4 c5 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Bg7 Qb3 Nc7 Ng5 O-O ",
	"Nf3 Nf6 c4 c5 Nc3 e6 e3 Nc6 d4 d5 cxd5 exd5 Bb5 Bd6 dxc5 Bxc5 ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 Nc6 Bg2 d5 cxd5 Nxd5 O-O Be7 d4 O-O ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 b6 Bg2 Bb7 O-O Be7 b3 O-O Bb2 d6 ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 b6 Bg2 Bb7 O-O Be7 d4 cxd4 Nxd4 Bxg2 ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 b6 Bg2 Bb7 O-O Be7 d4 cxd4 Qxd4 d6 ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 d5 cxd5 exd5 d4 Nc6 Bg2 Be7 O-O O-O ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 d5 cxd5 exd5 d4 Nc6 Bg2 Be7 O-O O-O ",
	"Nf3 Nf6 c4 c5 Nc3 g6 e3 Bg7 d4 O-O Be2 d6 O-O Na6 Re1 Bf5 ",
	"Nf3 Nf6 c4 c5 b3 e6 Bb2 Be7 e3 Nc6 d4 cxd4 exd4 d5 Bd3 b6 ",
	"Nf3 Nf6 c4 c5 b3 e6 Bb2 Be7 e3 Nc6 d4 cxd4 exd4 d5 Bd3 b6 ",
	"Nf3 Nf6 c4 c5 d4 cxd4 Nxd4 d5 cxd5 a6 a3 Nxd5 g3 e5 Nc2 Bc5 ",
	"Nf3 Nf6 c4 c5 d4 cxd4 Nxd4 e6 Nb5 d5 cxd5 a6 N5c3 exd5 Be3 Nc6 ",
	"Nf3 Nf6 c4 c5 d4 cxd4 Nxd4 e6 Nc3 d5 cxd5 Nxd5 Bd2 Bc5 Nb3 Be7 ",
	"Nf3 Nf6 c4 c5 e3 g6 d4 Bg7 Nc3 O-O Be2 cxd4 exd4 d5 O-O Nc6 ",
	"Nf3 Nf6 c4 c5 g3 b6 Bg2 Bb7 O-O e6 Nc3 Be7 Re1 Ne4 Qc2 Nxc3 ",
	"Nf3 Nf6 c4 c5 g3 b6 Bg2 Bb7 O-O e6 d4 cxd4 Qxd4 Be7 Nc3 d6 ",
	"Nf3 Nf6 c4 c5 g3 b6 Bg2 Bb7 b3 g6 Bb2 Bg7 d3 Nc6 Nbd2 d5 ",
	"Nf3 Nf6 c4 c6 Nc3 d5 d4 dxc4 Ne5 b5 g3 Nfd7 Bf4 Nxe5 Bxe5 Nd7 ",
	"Nf3 Nf6 c4 c6 Nc3 d5 d4 e6 Qb3 Be7 Bg5 dxc4 Qxc4 b5 Qb3 Nbd7 ",
	"Nf3 Nf6 c4 c6 Nc3 d5 d4 e6 Qb3 Nbd7 g3 Qb6 Bg2 Be7 O-O O-O ",
	"Nf3 Nf6 c4 c6 Nc3 d5 e3 g6 d4 Bg7 Be2 O-O O-O b6 b4 dxc4 ",
	"Nf3 Nf6 c4 d6 d4 Nbd7 g3 e5 Bg2 g6 b4 Bg7 Bb2 e4 Nfd2 Qe7 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3 Qxc3 b6 g3 Bb7 Bg2 d5 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3 Qxc3 b6 g3 d5 Bg2 c5 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3 Qxc3 d6 g3 e5 Bg2 Nc6 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 g3 O-O Bg2 c5 O-O Nc6 d4 cxd4 Nxd4 Qe7 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 g3 O-O Bg2 d5 O-O d4 Na4 Be7 d3 c5 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Bb4 cxd5 exd5 Bg5 h6 Bh4 c5 e3 Nc6 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Bb4 cxd5 exd5 Bg5 h6 Bh4 g5 Bg3 Ne4 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Be7 Bf4 O-O e3 Nbd7 Rc1 c6 h3 a6 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Be7 Bg5 h6 Bh4 O-O e3 b6 Be2 Nbd7 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"Nf3 Nf6 c4 e6 b3 d5 e3 c5 Bb2 Nc6 cxd5 exd5 Bb5 Bd6 O-O Bg4 ",
	"Nf3 Nf6 c4 e6 d4 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 Qc2 c5 dxc5 Bxc5 ",
	"Nf3 Nf6 c4 e6 d4 d5 Nc3 c6 Bg5 Nbd7 e3 Qa5 cxd5 Nxd5 Qd2 N7b6 ",
	"Nf3 Nf6 c4 e6 d4 d5 Nc3 dxc4 e3 c5 Bxc4 a6 a4 Nc6 O-O Be7 ",
	"Nf3 Nf6 c4 e6 g3 a6 Bg2 b5 b3 Bb7 Nc3 b4 Na4 d6 d4 Nbd7 ",
	"Nf3 Nf6 c4 e6 g3 a6 Bg2 b5 b3 c5 Nc3 Qb6 O-O Bb7 e3 d5 ",
	"Nf3 Nf6 c4 e6 g3 a6 Nc3 d5 cxd5 exd5 Bg2 Bd6 d4 Nbd7 Bf4 Bxf4 ",
	"Nf3 Nf6 c4 e6 g3 a6 Nc3 d5 d4 dxc4 Bg2 Be7 O-O O-O Ne5 Nd5 ",
	"Nf3 Nf6 c4 e6 g3 b6 Bg2 Bb7 O-O c5 b3 Be7 Bb2 O-O d3 a6 ",
	"Nf3 Nf6 c4 e6 g3 b6 Bg2 Bb7 O-O c5 b3 Nc6 Bb2 Be7 Nc3 O-O ",
	"Nf3 Nf6 c4 e6 g3 b6 Bg2 Bb7 O-O c5 b3 Nc6 Bb2 Be7 Nc3 O-O ",
	"Nf3 Nf6 c4 e6 g3 c5 Nc3 d5 cxd5 Nxd5 Bg2 Nc6 O-O Be7 d4 O-O ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 Be7 O-O O-O b3 c5 e3 Nc6 Bb2 b6 ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 Be7 O-O O-O d4 dxc4 Qc2 a6 Bg5 b5 ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 Be7 O-O O-O d4 dxc4 Qc2 a6 a4 Nc6 ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 c6 Qc2 Nbd7 d4 Be7 O-O O-O Nbd2 b6 ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 dxc4 Qa4+ Nbd7 Qxc4 a6 Qb3 c5 d3 Qc7 ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 dxc4 Qa4+ Nbd7 Qxc4 c5 O-O b6 Nd4 Ne5 ",
	"Nf3 Nf6 c4 e6 g3 d5 b3 Be7 Bg2 O-O O-O a5 Bb2 a4 Na3 Nbd7 ",
	"Nf3 Nf6 c4 e6 g3 d5 b3 c5 Bg2 Nc6 O-O Be7 cxd5 exd5 d4 O-O ",
	"Nf3 Nf6 c4 e6 g3 d5 d4 Be7 Bg2 O-O O-O dxc4 Qc2 a6 a4 Bd7 ",
	"Nf3 Nf6 c4 e6 g3 d5 d4 dxc4 Bg2 Nc6 O-O Rb8 Nc3 a6 e3 b5 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 d4 O-O Bf4 d5 Qb3 dxc4 Qxc4 c6 e4 Nbd7 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 c5 d4 cxd4 Nxd4 Nc6 Be3 Ng4 Qxg4 Nxd4 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 Bg4 Be3 Nc6 d5 Bxf3 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 Be3 Ng4 Bg5 f6 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 d5 a5 Be3 Ng4 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 g3 O-O Bg2 Nc6 d4 d6 d5 Ne5 Nxe5 dxe5 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 g3 O-O Bg2 c5 d4 cxd4 Nxd4 Nc6 O-O Nxd4 ",
	"Nf3 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 Qa4+ Bd7 Qh4 e6 Nxd5 exd5 Qd4 f6 ",
	"Nf3 Nf6 c4 g6 b3 Bg7 Bb2 O-O e3 d6 Be2 e5 O-O Nbd7 Nc3 Re8 ",
	"Nf3 Nf6 c4 g6 b3 Bg7 Bb2 O-O g3 d6 Bg2 e5 O-O Nc6 Nc3 Nh5 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O c6 d4 d5 cxd5 cxd5 Ne5 Bf5 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O d5 cxd5 Nxd5 d4 Na6 e4 Nb6 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O d6 Nc3 Nc6 Rb1 e5 b4 e4 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O d6 d4 Nbd7 Nc3 e5 dxe5 dxe5 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O d6 d4 Nc6 Nc3 Bg4 h3 Bxf3 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O d4 d6 O-O Nbd7 Nc3 e5 h3 c6 ",
	"Nf3 Nf6 d4 b6 g3 Bb7 Bg2 d6 b3 Nbd7 O-O e5 e3 e4 Nfd2 h5 ",
	"Nf3 Nf6 d4 c5 c4 cxd4 Nxd4 e6 e3 Nc6 Be2 d5 O-O Bd6 b3 O-O ",
	"Nf3 Nf6 d4 d5 Bf4 c5 e3 Nc6 c3 Qb6 Qc1 Bf5 Nh4 Be4 Nd2 e6 ",
	"Nf3 Nf6 d4 d5 e3 c5 Be2 Nc6 O-O Bg4 Nbd2 e6 c4 Bd6 a3 cxd4 ",
	"Nf3 Nf6 d4 e6 Bf4 d5 e3 a6 Nbd2 Nbd7 c3 c5 Bd3 b5 O-O Bb7 ",
	"Nf3 Nf6 d4 e6 Bg5 h6 Bh4 b6 c4 Bb7 Nc3 Bb4 e3 g5 Bg3 Ne4 ",
	"Nf3 Nf6 d4 e6 c4 b6 g3 Bb7 Bg2 Bb4+ Bd2 Bxd2+ Nbxd2 O-O O-O c5 ",
	"Nf3 Nf6 d4 e6 c4 b6 g3 Bb7 Bg2 Bb4+ Bd2 Bxd2+ Qxd2 O-O O-O d6 ",
	"Nf3 Nf6 d4 e6 c4 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 Ne4 Nxe4 Bxe4 ",
	"Nf3 Nf6 d4 e6 c4 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 Ne4 Qc2 Nxc3 ",
	"Nf3 Nf6 d4 e6 c4 c5 Nc3 cxd4 Nxd4 Bb4 Bd2 Nc6 Nc2 Bc5 Be3 Bxe3 ",
	"Nf3 Nf6 d4 e6 c4 c5 d5 exd5 cxd5 g6 Nc3 Bg7 e4 O-O Be2 d6 ",
	"Nf3 Nf6 d4 e6 c4 d5 Nc3 c6 e3 Nbd7 Bd3 a6 O-O dxc4 Bxc4 b5 ",
	"Nf3 Nf6 d4 e6 g3 b5 Bg2 Bb7 O-O c5 c3 Na6 Bg5 Be7 Nbd2 O-O ",
	"Nf3 Nf6 d4 e6 g3 b6 Bg2 Bb7 O-O c5 c4 cxd4 Qxd4 Be7 Nc3 d6 ",
	"Nf3 Nf6 d4 e6 g3 d5 Bg2 Be7 O-O O-O c4 dxc4 Qc2 a6 Qxc4 b5 ",
	"Nf3 Nf6 d4 g6 Bf4 Bg7 e3 d6 h3 O-O c4 c6 Nc3 Nbd7 Be2 a6 ",
	"Nf3 Nf6 d4 g6 Nc3 d5 Bf4 Bg7 h3 O-O e3 c5 Be2 cxd4 exd4 Ne4 ",
	"Nf3 Nf6 d4 g6 e3 Bg7 Bd3 O-O O-O d6 e4 Nbd7 h3 c5 c3 e5 ",
	"Nf3 Nf6 e3 d5 b3 Bg4 Bb2 Nbd7 Be2 e6 d4 Bd6 Nbd2 Qe7 O-O O-O ",
	"Nf3 Nf6 g3 b5 Bg2 Bb7 O-O e6 d3 Be7 e4 d6 a4 a6 axb5 axb5 ",
	"Nf3 Nf6 g3 b5 Bg2 Bb7 O-O e6 d3 d5 Nbd2 Be7 e4 O-O Qe2 c5 ",
	"Nf3 Nf6 g3 b5 Bg2 Bb7 a4 b4 a5 a6 c3 e6 d4 c5 Nbd2 Be7 ",
	"Nf3 Nf6 g3 b5 Bg2 Bb7 d4 e6 O-O Be7 c3 O-O a4 b4 Nbd2 Na6 ",
	"Nf3 Nf6 g3 b5 c3 Bb7 a4 a6 e3 Nc6 d4 e6 b4 Be7 Nbd2 Na7 ",
	"Nf3 Nf6 g3 d5 Bg2 Bf5 O-O e6 c4 Nbd7 b3 Be7 Nc3 c6 Bb2 h6 ",
	"Nf3 Nf6 g3 d5 Bg2 Bf5 c4 dxc4 Na3 Be6 Ng5 Bd5 e4 Bc6 Nxc4 h6 ",
	"Nf3 Nf6 g3 d5 Bg2 c5 c4 dxc4 Na3 Nc6 Nxc4 e6 b3 Be7 Bb2 O-O ",
	"Nf3 Nf6 g3 d5 Bg2 c6 O-O Bf5 d3 e6 c4 dxc4 dxc4 Qxd1 Rxd1 Nbd7 ",
	"Nf3 Nf6 g3 d5 Bg2 c6 O-O Bg4 c4 e6 cxd5 exd5 d3 Nbd7 Bf4 Be7 ",
	"Nf3 Nf6 g3 d5 Bg2 c6 c4 dxc4 Na3 b5 d3 cxd3 Ne5 a6 O-O Bb7 ",
	"Nf3 Nf6 g3 d5 Bg2 c6 c4 g6 b3 Qb6 O-O Bg7 d4 O-O Ba3 Re8 ",
	"Nf3 Nf6 g3 d6 Bg2 g6 O-O Bg7 d3 O-O e4 e5 Nbd2 c6 c3 Qc7 ",
	"Nf3 Nf6 g3 d6 d4 Nbd7 Bg2 e5 O-O Be7 c4 O-O Nc3 c6 Qc2 Qc7 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O c3 c6 d3 d5 Nbd2 Nbd7 Qc2 e5 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O c4 d5 d4 Nc6 Ne5 dxc4 Nxc6 bxc6 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O c4 d5 d4 dxc4 Na3 c3 bxc3 c5 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O c4 d6 d4 Nbd7 Qc2 e5 Rd1 Re8 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 c5 e4 Nc6 Nbd2 d6 c3 Ne8 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 c5 e4 Nc6 Nbd2 d6 c3 Ne8 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 d5 Nbd2 c5 e4 Nc6 Re1 e6 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 d6 e4 Nbd7 Nbd2 e5 Ne1 Nc5 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 d6 e4 c5 Nc3 Nc6 h3 Rb8 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d4 c5 c3 b6 Ne5 d5 a4 Bb7 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d4 d6 Nc3 Nbd7 e4 e5 dxe5 dxe5 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d4 d6 c4 Nbd7 Nc3 e5 e4 c6 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 c4 c6 O-O O-O d4 d5 Qb3 dxc4 Qxc4 Be6 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 d3 d6 O-O O-O e4 c5 c3 Nc6 Ne1 Rb8 ",
	"Nf3 Nf6 g3 g6 Bg2 d5 d4 Bg7 c4 dxc4 Qa4+ Nfd7 O-O Nc6 Qxc4 O-O ",
	"Nf3 Nf6 g3 g6 b3 Bg7 Bb2 c5 c4 d6 Bg2 e5 O-O Nc6 Nc3 O-O ",
	"Nf3 Nf6 g3 g6 b3 Bg7 Bb2 c5 c4 d6 Bg2 e5 O-O O-O e3 Nc6 ",
	"Nf3 Nf6 g3 g6 c4 c6 Bg2 Bg7 Nc3 O-O d4 d5 cxd5 cxd5 Ne5 b6 ",
	"Nf3 Nf6 g3 g6 c4 c6 Bg2 Bg7 d4 O-O Nc3 d5 cxd5 cxd5 Ne5 b6 ",
	"Nf3 Nf6 g3 g6 c4 c6 Bg2 Bg7 d4 O-O Nc3 d5 cxd5 cxd5 Ne5 b6 ",
	"Nf3 c5 b3 Nc6 Bb2 d6 c4 e5 Nc3 g6 g3 Bg7 d3 Nge7 Bg2 O-O ",
	"Nf3 c5 b3 Nf6 Bb2 e6 e3 Be7 c4 O-O d4 cxd4 exd4 Qa5+ Nbd2 Ba3 ",
	"Nf3 c5 b3 Nf6 Bb2 e6 e3 Be7 d4 cxd4 exd4 O-O Nbd2 b6 Bd3 Bb7 ",
	"Nf3 c5 b3 d5 Bb2 Nf6 e3 g6 Bb5+ Nc6 Ne5 Qc7 O-O Bg7 d4 O-O ",
	"Nf3 c5 b3 d5 Bb2 f6 c4 d4 d3 e5 e3 Ne7 Be2 Nec6 Nbd2 Be7 ",
	"Nf3 c5 b3 d5 Bb2 f6 c4 d4 d3 e5 e3 Ne7 Be2 Nec6 Nbd2 Be7 ",
	"Nf3 c5 b3 d5 c4 d4 g3 Nc6 d3 Nf6 Bg2 e5 O-O Be7 Nbd2 O-O ",
	"Nf3 c5 c4 Nc6 Nc3 Nd4 e3 Nxf3+ Qxf3 g6 b3 Bg7 Bb2 d6 g3 Nh6 ",
	"Nf3 c5 c4 Nc6 Nc3 g6 e3 Nf6 d4 cxd4 exd4 d5 cxd5 Nxd5 Qb3 Nxc3 ",
	"Nf3 c5 c4 Nc6 Nc3 g6 e3 d6 d4 Bg7 d5 Ne5 Nd2 f5 Be2 Nf6 ",
	"Nf3 c5 c4 Nc6 Nc3 g6 g3 Bg7 Bg2 e5 d3 Nge7 O-O O-O Ne1 d6 ",
	"Nf3 c5 c4 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 Qb6 Nc2 e6 e3 Be7 Be2 O-O ",
	"Nf3 c5 c4 Nc6 d4 cxd4 Nxd4 Nf6 g3 Qb6 Nc2 d6 Bg2 g6 Nc3 Bg7 ",
	"Nf3 c5 c4 Nc6 d4 cxd4 Nxd4 g6 e4 Bg7 Nc2 Nf6 Nc3 d6 Be2 O-O ",
	"Nf3 c5 c4 Nf6 Nc3 d5 cxd5 Nxd5 d4 Nxc3 bxc3 g6 e3 Bg7 Bd3 O-O ",
	"Nf3 c5 c4 Nf6 Nc3 d5 cxd5 Nxd5 e4 Nb4 Bc4 Be6 Bxe6 Nd3+ Kf1 fxe6 ",
	"Nf3 c5 c4 Nf6 Nc3 e6 g3 b6 Bg2 Bb7 O-O d6 d4 cxd4 Qxd4 a6 ",
	"Nf3 c5 c4 Nf6 Nc3 e6 g3 d5 cxd5 Nxd5 Bg2 Nc6 O-O Be7 d4 O-O ",
	"Nf3 c5 c4 Nf6 g3 b6 Bg2 Bb7 O-O e6 Nc3 Be7 b3 O-O Bb2 d6 ",
	"Nf3 c5 c4 Nf6 g3 b6 Bg2 Bb7 O-O e6 Nc3 Be7 b3 O-O Bb2 d6 ",
	"Nf3 c5 c4 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nc6 O-O e5 d3 Be7 Nbd2 O-O ",
	"Nf3 c5 c4 Nf6 g3 e6 Bg2 Be7 d4 d5 cxd5 exd5 O-O O-O b3 Nc6 ",
	"Nf3 c5 c4 Nf6 g3 e6 Bg2 Be7 d4 d5 cxd5 exd5 O-O O-O b3 Nc6 ",
	"Nf3 c5 c4 b6 g3 Bb7 Bg2 g6 O-O Bg7 Nc3 Nc6 e3 Nh6 d4 Nf5 ",
	"Nf3 c5 c4 g6 d4 cxd4 Nxd4 Bg7 Nc3 Nc6 e3 Nf6 Be2 O-O O-O d6 ",
	"Nf3 c5 c4 g6 g3 Bg7 Bg2 Nc6 Nc3 Nh6 d3 Nf5 e4 Nfd4 Nxd4 Nxd4 ",
	"Nf3 c5 c4 g6 g3 Bg7 Bg2 Nc6 Nc3 e5 d3 Nge7 O-O O-O Ne1 Rb8 ",
	"Nf3 c5 c4 g6 g3 Bg7 Bg2 Nc6 O-O Nh6 d4 cxd4 Bxh6 Bxh6 Nxd4 Bg7 ",
	"Nf3 c5 e4 e6 d3 Nc6 g3 Nge7 Bg2 g6 Bg5 Bg7 Qc1 h6 Bd2 b6 ",
	"Nf3 c5 e4 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 g3 Nge7 Nb3 Na5 Bg2 Nec6 ",
	"Nf3 c5 e4 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 g5 hxg5 Bxg5 Nc6 ",
	"Nf3 c5 e4 g6 d4 cxd4 Nxd4 Bg7 c4 Nc6 Be3 Nf6 Nc3 O-O Be2 d6 ",
	"Nf3 c5 g3 Nc6 Bg2 g6 O-O Bg7 c4 e5 Nc3 Nge7 Ne1 a6 Nc2 Rb8 ",
	"Nf3 c5 g3 b5 e4 Bb7 d3 e6 Bg2 d6 O-O Be7 Re1 Nd7 c4 a6 ",
	"Nf3 c5 g3 d5 Bg2 Nc6 O-O e5 d3 Be7 e4 Nf6 Nc3 d4 Ne2 Nd7 ",
	"Nf3 c5 g3 d5 Bg2 Nc6 d4 e6 O-O Nf6 c4 Be7 dxc5 Bxc5 Nbd2 O-O ",
	"Nf3 c5 g3 g6 Bg2 Bg7 O-O Nc6 c3 e5 d3 Nge7 a3 O-O b4 d6 ",
	"Nf3 c5 g3 g6 Bg2 Bg7 O-O Nc6 c4 e6 Nc3 Nge7 e3 O-O d4 cxd4 ",
	"Nf3 c5 g3 g6 Bg2 Bg7 c4 Nc6 Nc3 d6 a3 Nh6 d3 O-O Bd2 Nf5 ",
	"Nf3 c5 g3 g6 Bg2 Bg7 d4 cxd4 Nxd4 Nc6 Nb3 d6 Nc3 Nf6 O-O O-O ",
	"Nf3 d5 b3 Nf6 Bb2 e6 e3 c5 d4 Nc6 Bd3 Bd6 O-O O-O c4 b6 ",
	"Nf3 d5 b3 c5 Bb2 f6 e3 e5 Bb5+ Nc6 O-O Bd6 Be2 Nge7 d3 Be6 ",
	"Nf3 d5 c4 c6 b3 Bf5 g3 Nf6 Bg2 Nbd7 Bb2 e6 O-O Bd6 d3 O-O ",
	"Nf3 d5 c4 c6 b3 Bf5 g3 Nf6 Bg2 e6 O-O Nbd7 Bb2 Bd6 d3 O-O ",
	"Nf3 d5 c4 c6 e3 Nf6 Nc3 Bg4 cxd5 Nxd5 Be2 e6 d4 Nd7 O-O Qc7 ",
	"Nf3 d5 c4 c6 e3 Nf6 Nc3 Nbd7 cxd5 cxd5 d4 e6 Bd3 Bd6 O-O O-O ",
	"Nf3 d5 c4 d4 b4 f6 d3 e5 a3 c5 g3 cxb4 Bg2 Nc6 O-O a5 ",
	"Nf3 d5 c4 d4 e3 Nc6 exd4 Nxd4 Nxd4 Qxd4 Nc3 e5 d3 Ne7 Qe2 Bd7 ",
	"Nf3 d5 c4 dxc4 e3 Nf6 Bxc4 e6 O-O c5 d4 a6 Qe2 b5 Bb3 Bb7 ",
	"Nf3 d5 c4 dxc4 e3 Nf6 Bxc4 e6 O-O c5 d4 a6 Qe2 b5 Bb3 Bb7 ",
	"Nf3 d5 d4 Bf5 c4 e6 Nc3 c6 Bf4 Bd6 Bxd6 Qxd6 Qb3 Qe7 g3 Nf6 ",
	"Nf3 d5 d4 Bg4 Ne5 Bf5 c4 f6 Nf3 c6 Nc3 e6 g3 Bb4 Bg2 Ne7 ",
	"Nf3 d5 d4 Nf6 c4 c6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O O-O ",
	"Nf3 d5 d4 Nf6 c4 c6 Nc3 dxc4 e3 b5 a4 b4 Na2 e6 Bxc4 Be7 ",
	"Nf3 d5 d4 Nf6 c4 dxc4 e3 e6 Bxc4 c5 O-O a6 Qe2 b5 Bd3 cxd4 ",
	"Nf3 d5 d4 Nf6 c4 e6 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Qb3 c6 ",
	"Nf3 d5 d4 c5 c4 e6 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 Nc3 O-O ",
	"Nf3 d5 d4 c5 c4 e6 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 Nc3 O-O ",
	"Nf3 d5 d4 c5 c4 e6 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 Nc3 O-O ",
	"Nf3 d5 e3 Nf6 b3 c5 Bb2 Nc6 Bb5 Qb6 Bxc6+ Qxc6 Ne5 Qc7 d3 g6 ",
	"Nf3 d5 g3 Bg4 Bg2 Nf6 c4 c6 cxd5 cxd5 Qb3 Bxf3 Bxf3 Qc8 Nc3 e6 ",
	"Nf3 d5 g3 Bg4 Bg2 c6 b3 Nd7 Bb2 Ngf6 O-O e6 d3 Bc5 Nbd2 O-O ",
	"Nf3 d5 g3 Nf6 Bg2 c6 O-O Bg4 d3 Nbd7 Nbd2 e5 e4 dxe4 dxe4 Bc5 ",
	"Nf3 d5 g3 Nf6 Bg2 g6 c4 d4 d3 Bg7 b4 O-O Nbd2 c5 Nb3 cxb4 ",
	"Nf3 d5 g3 c6 Bg2 Bg4 Ne5 Bh5 g4 Bg6 h4 f6 Nxg6 hxg6 d4 e6 ",
	"Nf3 d5 g3 c6 Bg2 Bg4 h3 Bxf3 exf3 e6 f4 Bd6 O-O Nd7 d3 h5 ",
	"Nf3 d6 d4 Bg4 c4 Nd7 Nc3 e5 e3 Be7 Be2 Ngf6 h3 Bh5 b3 c6 ",
	"Nf3 d6 d4 Bg4 e3 e6 c4 Nd7 Be2 Ngf6 Nc3 Be7 O-O O-O e4 e5 ",
	"Nf3 d6 d4 Bg4 e4 Nf6 Nc3 e6 Be2 Be7 O-O O-O Bf4 c6 h3 Bxf3 ",
	"Nf3 d6 d4 Bg4 e4 Nf6 Nc3 e6 h3 Bh5 Qe2 a6 g4 Bg6 h4 h5 ",
	"Nf3 d6 d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Be2 Bg4 Be3 Nfd7 O-O Bxf3 ",
	"Nf3 d6 g3 g6 Bg2 Bg7 O-O Nf6 c4 O-O Nc3 c6 d4 Qa5 h3 Be6 ",
	"Nf3 e6 c4 Nf6 Nc3 c5 g3 b6 e4 Bb7 d3 d6 Bg2 Be7 O-O O-O ",
	"Nf3 e6 c4 Nf6 d4 d5 Nc3 Be7 Qc2 Nc6 e3 O-O a3 dxc4 Bxc4 Bd6 ",
	"Nf3 e6 c4 c5 Nc3 Nf6 d4 cxd4 Nxd4 Bb4 Nb5 a6 Nd6+ Ke7 Nxc8+ Qxc8 ",
	"Nf3 e6 c4 c5 Nc3 Nf6 d4 cxd4 Nxd4 Bb4 Nb5 a6 Nd6+ Ke7 Nxc8+ Qxc8 ",
	"Nf3 e6 c4 d5 d4 Nf6 Nc3 Be7 cxd5 exd5 Bg5 c6 Qc2 Na6 e3 Nb4 ",
	"Nf3 e6 g3 b5 Bg2 Bb7 O-O c5 d3 Nf6 e4 d6 a4 b4 Nbd2 Be7 ",
	"Nf3 f5 e4 fxe4 Ng5 Nf6 d3 e5 dxe4 Bc5 Bc4 Qe7 Nc3 Bxf2+ Kxf2 Qc5+ ",
	"Nf3 f5 e4 fxe4 Ng5 e5 d3 e3 Bxe3 Nc6 Qh5+ g6 Qf3 Qf6 Qg3 Nge7 ",
	"Nf3 g6 c4 Bg7 Nc3 c5 d4 cxd4 Nxd4 Nc6 e3 Nf6 Be2 O-O O-O Nxd4 ",
	"Nf3 g6 c4 Bg7 Nc3 c5 g3 Nc6 Bg2 Nf6 O-O O-O d3 b6 e4 Bb7 ",
	"Nf3 g6 c4 Bg7 Nc3 e5 g3 f5 d4 e4 Nd2 Nf6 Bg2 O-O O-O d6 ",
	"Nf3 g6 c4 Bg7 d4 Nf6 Nc3 d5 Qa4+ c6 cxd5 Nxd5 e4 Nb6 Qd1 Bg4 ",
	"Nf3 g6 d4 Bg7 c4 d6 Nc3 Nf6 e4 O-O Be2 e5 O-O Nbd7 d5 Nc5 ",
	"Nf3 g6 d4 Bg7 e4 d6 c3 Nf6 Bd3 O-O O-O Nc6 b4 Bg4 h3 Bxf3 ",
	"Nf3 g6 d4 Bg7 e4 d6 c3 Nf6 Bd3 O-O O-O Nc6 d5 Nb8 c4 Bg4 ",
	"Nf3 g6 d4 Bg7 e4 d6 c3 Nf6 Nbd2 O-O Be2 Nc6 O-O e5 dxe5 Nxe5 ",
	"Nf3 g6 d4 Bg7 e4 d6 c3 Nf6 Nbd2 O-O g3 c5 Bg2 cxd4 Nxd4 Nc6 ",
	"Nf3 g6 d4 Bg7 g3 d5 Bg2 Nf6 O-O O-O Bf4 c6 Nbd2 Nh5 Be5 f6 ",
	"Nf3 g6 d4 Bg7 g3 d6 Bg2 Nd7 O-O e5 dxe5 dxe5 Nc3 Ngf6 Nd5 O-O ",
	"Nf3 g6 d4 Nf6 Bf4 Bg7 e3 d6 h3 O-O Be2 b6 O-O c5 Nbd2 Ba6 ",
	"Nf3 g6 d4 Nf6 Bg5 Bg7 Nbd2 c5 Bxf6 Bxf6 Ne4 Bxd4 Nxd4 cxd4 Qxd4 O-O ",
	"Nf3 g6 e4 Bg7 d4 d6 Nbd2 Nf6 Bd3 O-O O-O Nc6 Re1 Re8 d5 Nb8 ",
	"Nf3 g6 e4 Bg7 d4 d6 c4 Bg4 Be2 Nc6 Be3 e5 d5 Bxf3 Bxf3 Nd4 ",
	"Nf3 g6 e4 Bg7 d4 d6 c4 Nf6 Nc3 O-O Be2 e5 O-O Nc6 Be3 Ng4 ",
	"Nf3 g6 e4 Bg7 d4 d6 c4 Nf6 Nc3 O-O Be2 e5 O-O Nc6 Be3 Ng4 ",
	"Nf3 g6 e4 c5 c4 Nc6 d4 Bg7 d5 Nd4 Nxd4 cxd4 Bd3 e5 O-O d6 ",
	"Nf3 g6 e4 d6 d4 Bg7 Be2 Nf6 Nbd2 Nc6 c3 O-O O-O Re8 b4 e5 ",
	"Nf3 g6 e4 d6 d4 Nf6 Nc3 Bg7 Be2 O-O O-O Bg4 Be3 Nc6 h3 Bxf3 ",
	"Nf3 g6 g3 Bg7 Bg2 d6 d3 e5 e4 Nc6 Nc3 Nge7 Be3 O-O Qd2 Nd4 ",
	"Nf3 g6 g3 Bg7 c4 c5 Bg2 Nc6 Nc3 e6 O-O Nge7 d3 O-O Bf4 e5 ",
	"a3 e5 c4 Nf6 Nc3 d5 cxd5 Nxd5 e3 Be6 Nf3 Bd6 Be2 O-O d4 Nxc3 ",
	"b3 d5 Bb2 Bg4 h3 Bh5 Nf3 Nd7 e3 Ngf6 Be2 e6 d3 Bd6 Nbd2 Qe7 ",
	"b3 d5 Bb2 Nf6 e3 Bg4 Be2 Bxe2 Qxe2 Nbd7 f4 e6 Nf3 Bd6 O-O Qe7 ",
	"b3 d5 Bb2 Nf6 e3 e6 f4 b6 Nf3 Bb7 Be2 c5 O-O Nc6 Ne5 Be7 ",
	"b3 e5 Bb2 Nc6 e3 d6 Bb5 Bd7 Nc3 a6 Bxc6 Bxc6 Nf3 Ne7 Qe2 Ng6 ",
	"b4 Nf6 Bb2 g6 e3 Bg7 Nf3 O-O c4 d6 d4 e6 Nc3 Qe7 Be2 e5 ",
	"c4 Nf6 Nc3 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qb6 Nb3 e6 e3 a6 Be2 d6 ",
	"c4 Nf6 Nc3 c5 Nf3 d5 cxd5 Nxd5 d4 Nxc3 bxc3 g6 e4 Bg7 Bb5+ Nc6 ",
	"c4 Nf6 Nc3 c5 Nf3 e6 d4 cxd4 Nxd4 Bb4 Qb3 Bc5 Nf3 b6 Bg5 Bb7 ",
	"c4 Nf6 Nc3 c5 Nf3 e6 e3 Nc6 d4 d5 a3 cxd4 exd4 Be7 Bg5 O-O ",
	"c4 Nf6 Nc3 c5 Nf3 e6 e3 Nc6 d4 d5 cxd5 exd5 Bb5 Bd6 dxc5 Bxc5 ",
	"c4 Nf6 Nc3 c5 Nf3 e6 e3 d5 cxd5 exd5 d4 Nc6 Be2 Be7 dxc5 Bxc5 ",
	"c4 Nf6 Nc3 c5 Nf3 e6 g3 b6 Bg2 Bb7 O-O Be7 d4 cxd4 Qxd4 d6 ",
	"c4 Nf6 Nc3 c5 g3 d5 cxd5 Nxd5 Bg2 Nc7 Nf3 Nc6 O-O e5 b3 Be7 ",
	"c4 Nf6 Nc3 c5 g3 e6 Nf3 d5 cxd5 exd5 d4 Nc6 Bg2 Be7 O-O O-O ",
	"c4 Nf6 Nc3 c6 Nf3 d5 e3 e6 d4 Nbd7 cxd5 exd5 Bd3 Bd6 O-O O-O ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nxc3 bxc3 Bg7 Nf3 O-O O-O c5 ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nxc3 bxc3 Bg7 h4 Nd7 h5 c6 ",
	"c4 Nf6 Nc3 d5 d4 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 e5 Bb5+ Nd7 ",
	"c4 Nf6 Nc3 d5 d4 g6 Nf3 Bg7 e3 O-O Be2 e6 O-O b6 cxd5 exd5 ",
	"c4 Nf6 Nc3 d6 g3 g6 Bg2 Bg7 Nf3 O-O O-O c6 d4 Qa5 Qc2 Qh5 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 d4 e4 Nd2 Bb4 e3 Bxc3 bxc3 O-O Be2 Qe7 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 e3 Bb4 Qc2 O-O d3 Re8 Bd2 Bxc3 Bxc3 d5 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 e4 Bb4 d3 O-O g3 d6 Bg2 Bg4 h3 Bxf3 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bb4 Bg2 O-O O-O Re8 d3 d6 Bd2 Bf5 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bb4 Bg2 O-O O-O e4 Ng5 Bxc3 bxc3 Re8 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bb4 Nd5 Nxd5 cxd5 Nd4 Nxd4 exd4 Qc2 Qe7 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bb4 Nd5 e4 Nh4 Bc5 Bg2 d6 d3 exd3 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bb4 Nd5 e4 Nh4 O-O Bg2 Re8 O-O Bc5 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bb4 Nd5 e4 Nh4 d6 Nxb4 Nxb4 d4 exd3 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bc5 Bg2 O-O O-O Re8 e3 Bb4 Nd5 Bf8 ",
	"c4 Nf6 Nc3 e5 Nf3 d6 d4 Nbd7 e4 g6 Be2 Bg7 O-O O-O Re1 Re8 ",
	"c4 Nf6 Nc3 e5 g3 Bb4 Bg2 O-O Nf3 Re8 O-O e4 Nd4 Nc6 Nc2 Bxc3 ",
	"c4 Nf6 Nc3 e5 g3 g6 Bg2 Bg7 e4 d6 Nge2 Be6 d4 O-O d5 Bd7 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 Qc2 O-O a3 Bxc3 Qxc3 b6 e3 Bb7 Be2 c5 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 Qc2 c5 g3 Nc6 Bg2 O-O O-O Qe7 d3 h6 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 Qe2 Bb4 e5 Ng8 d4 Ne7 Qd3 d5 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 Qe2 c5 e5 Ng8 d4 cxd4 Nxd4 Nc6 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O b3 d5 cxd5 exd5 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O d4 Ne4 Qc2 Nxc3 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 g3 Bb7 Bg2 Be7 d4 Ne4 Bd2 O-O d5 f5 ",
	"c4 Nf6 Nc3 e6 Nf3 c5 d4 cxd4 Nxd4 Bb4 Nc2 Bxc3+ bxc3 Qa5 Nb4 O-O ",
	"c4 Nf6 Nc3 e6 Nf3 c5 g3 b6 Bg2 Bb7 O-O Be7 b3 O-O Bb2 d6 ",
	"c4 Nf6 Nc3 e6 Nf3 c5 g3 b6 Bg2 Bb7 O-O Be7 d4 cxd4 Qxd4 O-O ",
	"c4 Nf6 Nc3 e6 Nf3 c5 g3 b6 Bg2 Bb7 O-O a6 b3 d6 Bb2 Be7 ",
	"c4 Nf6 Nc3 e6 Nf3 c5 g3 b6 e4 Bb7 d3 Be7 Bg2 O-O O-O d6 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Be7 Bg5 h6 Bh4 O-O Rc1 b6 Bxf6 Bxf6 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c5 cxd5 Nxd5 e3 Be7 Bd3 cxd4 exd4 b6 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c5 cxd5 Nxd5 e3 Be7 Bd3 cxd4 exd4 b6 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c6 e3 Ne4 Bd3 f5 g4 Bb4 Bd2 Bxc3 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 dxc4 e4 Bb4 Bg5 c5 Bxf6 Qxf6 Bxc4 cxd4 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 e3 c5 d4 Nc6 a3 dxc4 Bxc4 a6 O-O b5 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 a3 Bxc3+ bxc3 c5 e3 Nc6 Ne2 b6 Ng3 Ba6 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 a3 Bxc3+ bxc3 c5 f3 d5 cxd5 Nxd5 dxc5 Qa5 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 O-O Bd3 c5 d5 b5 dxe6 fxe6 cxb5 a6 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 O-O Bd3 d5 Nf3 c5 O-O dxc4 Bxc4 Qe7 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 b6 Ne2 Ba6 Ng3 Bxc3+ bxc3 d5 Qf3 O-O ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 c5 Bd3 O-O Nf3 d5 O-O Nc6 a3 cxd4 ",
	"c4 Nf6 Nc3 e6 d4 c5 Nf3 cxd4 Nxd4 Bb4 Bd2 Nc6 e3 O-O Be2 d5 ",
	"c4 Nf6 Nc3 e6 d4 c5 d5 exd5 cxd5 g6 Nf3 Bg7 Bf4 d6 h3 O-O ",
	"c4 Nf6 Nc3 e6 e4 c5 e5 Ng8 Nf3 Nc6 d4 cxd4 Nxd4 Nxe5 Bf4 d6 ",
	"c4 Nf6 Nc3 e6 e4 c5 f4 Nc6 Nf3 d5 e5 Ng4 cxd5 exd5 Qb3 Nb4 ",
	"c4 Nf6 Nc3 e6 e4 d5 e5 Ne4 Nf3 Be7 Qc2 Ng5 Nxg5 Bxg5 cxd5 exd5 ",
	"c4 Nf6 Nc3 e6 g3 d5 Bg2 Be7 Nf3 d4 Nb5 c5 d3 a6 Na3 Nc6 ",
	"c4 Nf6 Nc3 g6 Nf3 Bg7 e4 d6 Be2 O-O O-O e5 d4 Nc6 dxe5 Nxe5 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 e4 O-O Be3 d6 f3 e5 dxe5 dxe5 Qxd8 Rxd8 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 h6 Bf4 e6 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 e4 d6 Be2 O-O Nf3 e5 d5 Nbd7 Bg5 h6 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 e4 d6 Nf3 O-O Be2 e5 d5 Nbd7 O-O Nc5 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 g3 O-O Bg2 c5 Nf3 cxd4 Nxd4 Nc6 O-O Ng4 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 a6 Bd3 c5 dxc5 dxc5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 b6 Bd3 a6 Nge2 c5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 c5 Nge2 Nc6 d5 Ne5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 e5 d5 Nh5 Be3 f5 Nge2 O-O ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O Nf3 d5 cxd5 Nxd5 O-O c5 Qb3 Nb6 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O Nf3 d5 cxd5 Nxd5 O-O c6 e4 Nb6 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O Nf3 d6 O-O Nbd7 Qc2 e5 d3 Ne8 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O Nf3 d6 d3 e5 Bg5 h6 Bxf6 Bxf6 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O d4 d6 f4 Nbd7 Nf3 e5 O-O Qe7 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O e4 c5 Nge2 Nc6 O-O d6 a3 Bd7 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O e4 c5 Nge2 Nc6 O-O d6 a3 Bd7 ",
	"c4 Nf6 Nf3 b6 g3 Bb7 Bg2 c5 O-O g6 Nc3 Bg7 d4 cxd4 Qxd4 d6 ",
	"c4 Nf6 Nf3 c5 Nc3 d5 cxd5 Nxd5 e4 Nb4 Bb5+ N8c6 a3 Nd3+ Ke2 Nf4+ ",
	"c4 Nf6 Nf3 c5 Nc3 d5 cxd5 Nxd5 g3 Nc6 Bg2 Nc7 d3 e5 O-O Be7 ",
	"c4 Nf6 Nf3 c5 g3 b6 Bg2 Bb7 O-O e6 b3 Be7 Bb2 O-O d3 d6 ",
	"c4 Nf6 Nf3 e6 d4 b6 g3 Ba6 Qa4 Be7 Nc3 Bb7 Bg2 O-O O-O Ne4 ",
	"c4 Nf6 Nf3 e6 d4 d5 e3 Be7 Nbd2 O-O Bd3 c5 dxc5 Na6 O-O Nxc5 ",
	"c4 Nf6 Nf3 g6 b3 Bg7 Bb2 O-O g3 d6 Bg2 e5 d3 Nbd7 O-O Ne8 ",
	"c4 Nf6 Nf3 g6 b3 Bg7 Bb2 O-O g3 d6 Bg2 e5 d4 e4 Nfd2 Re8 ",
	"c4 Nf6 Nf3 g6 b4 Bg7 Bb2 O-O e3 b6 d4 c5 dxc5 bxc5 b5 a6 ",
	"c4 Nf6 Nf3 g6 d4 Bg7 g3 O-O Bg2 d6 O-O Nbd7 Nc3 e5 e4 c6 ",
	"c4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 d4 Nc6 Nc3 a6 d5 Na5 ",
	"c4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O d4 d6 Nc3 Nbd7 O-O e5 e4 c6 ",
	"c4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O d4 d6 Nc3 Nbd7 O-O e5 e4 c6 ",
	"c4 Nf6 d4 e6 Nf3 b6 Nc3 Bb7 a3 Be7 d5 d6 e4 c6 dxe6 fxe6 ",
	"c4 Nf6 d4 e6 g3 d5 Bg2 Be7 Nf3 O-O O-O dxc4 Qc2 a6 a4 Bd7 ",
	"c4 Nf6 d4 g6 Nc3 Bg7 Bg5 d6 Nf3 O-O e3 c5 Be2 h6 Bh4 g5 ",
	"c4 Nf6 d4 g6 Nc3 Bg7 e4 O-O f4 d6 Nf3 c5 d5 e6 Bd3 exd5 ",
	"c4 Nf6 d4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 Nc6 d5 Ne7 ",
	"c4 Nf6 g3 c6 Bg2 d5 Nf3 dxc4 Na3 e5 Nxc4 e4 Ng5 Bc5 d3 exd3 ",
	"c4 Nf6 g3 c6 Nf3 d5 b3 Bf5 Bb2 e6 Bg2 Nbd7 O-O h6 d3 Bc5 ",
	"c4 Nf6 g3 c6 Nf3 d5 b3 Qb6 Bg2 e5 O-O e4 Ne1 h5 Nc3 h4 ",
	"c4 Nf6 g3 c6 Qa4 g6 Bg2 Bg7 e4 O-O Ne2 e5 Nbc3 d6 O-O Na6 ",
	"c4 Nf6 g3 e5 Bg2 c6 Nc3 d5 cxd5 cxd5 Qb3 Nc6 d3 d4 Nd5 Nxd5 ",
	"c4 Nf6 g3 e5 Bg2 c6 Nf3 e4 Nd4 d5 cxd5 Qxd5 Nc2 Qh5 h3 Bc5 ",
	"c4 Nf6 g3 e5 Bg2 c6 d4 exd4 Qxd4 d5 Nf3 c5 Qd3 Nc6 cxd5 Nb4 ",
	"c4 Nf6 g3 e6 b3 d5 Nf3 c5 Bg2 Nc6 O-O Be7 cxd5 exd5 d4 O-O ",
	"c4 Nf6 g3 g6 Bg2 Bg7 Nc3 O-O Nf3 d5 cxd5 Nxd5 O-O Nc6 Qb3 Nb6 ",
	"c4 b6 d4 Bb7 Nc3 Nf6 Bf4 d6 Nf3 Nbd7 d5 e5 Bg5 h6 Bxf6 Qxf6 ",
	"c4 c5 Nc3 Nc6 Nf3 e5 e3 Nf6 d4 cxd4 exd4 e4 Ne5 Bb4 Be2 Qa5 ",
	"c4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nf3 e5 d3 d6 Bd2 Nge7 O-O Rb8 ",
	"c4 c5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nc7 Nf3 Nc6 O-O e5 b3 Be7 ",
	"c4 c5 Nc3 g6 Nf3 Bg7 d4 cxd4 Nxd4 Nc6 Nc2 d6 e4 Nh6 h4 f5 ",
	"c4 c5 Nc3 g6 Nf3 Bg7 e3 Nf6 d4 O-O Be2 cxd4 exd4 d5 O-O Nc6 ",
	"c4 c5 Nc3 g6 g3 Bg7 Bg2 Nc6 a3 e6 b4 Nge7 bxc5 Qa5 Bb2 O-O ",
	"c4 c5 Nc3 g6 g3 Bg7 Bg2 Nc6 e3 e5 Nge2 Nge7 b3 O-O O-O Rb8 ",
	"c4 c5 Nf3 Nc6 Nc3 Nd4 e3 Nxf3+ Qxf3 g6 b3 Bg7 Bb2 d6 g3 Rb8 ",
	"c4 c5 Nf3 Nc6 Nc3 Nd4 e3 Nxf3+ Qxf3 g6 b3 Bg7 Bb2 d6 g3 Rb8 ",
	"c4 c5 Nf3 Nc6 Nc3 g6 e3 d6 d4 cxd4 exd4 Bg4 Be2 Bg7 Be3 Nh6 ",
	"c4 c5 Nf3 Nc6 Nc3 g6 e3 d6 d4 cxd4 exd4 Bg4 Be2 Bg7 O-O Nh6 ",
	"c4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Ndb5 Bb4 a3 Bxc3+ Nxc3 d5 ",
	"c4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 e3 d5 cxd5 exd5 Be2 Bd6 ",
	"c4 c5 Nf3 Nc6 g3 g6 Bg2 Bg7 Nc3 e5 d3 Nge7 O-O O-O Be3 d6 ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 d4 cxd4 Nxd4 e6 Ndb5 d5 cxd5 Nxd5 Nxd5 exd5 ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 d4 cxd4 Nxd4 e6 a3 Be7 e4 O-O Nb3 b6 ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 e3 e6 d4 d5 a3 Ne4 Bd3 Nxc3 bxc3 Be7 ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 e3 e6 d4 d5 a3 a6 b3 Bd6 Bd3 O-O ",
	"c4 c5 Nf3 Nf6 Nc3 d5 cxd5 Nxd5 d4 Nxc3 bxc3 g6 e4 Bg7 Bb5+ Nd7 ",
	"c4 c5 Nf3 Nf6 Nc3 d5 cxd5 Nxd5 e3 Nxc3 bxc3 g6 Ba3 Qc7 Bc4 Bg7 ",
	"c4 c5 Nf3 Nf6 Nc3 d5 cxd5 Nxd5 e3 e6 d4 Nc6 Bd3 cxd4 exd4 Be7 ",
	"c4 c5 Nf3 Nf6 Nc3 e6 e3 Nc6 d4 d5 cxd5 exd5 Be2 cxd4 Nxd4 Bd6 ",
	"c4 c5 Nf3 Nf6 Nc3 e6 g3 b6 d3 Be7 Bg2 Bb7 e4 O-O O-O d6 ",
	"c4 c5 Nf3 Nf6 Nc3 e6 g3 b6 e4 d6 d3 Bb7 Bg2 Be7 O-O O-O ",
	"c4 c5 Nf3 Nf6 g3 b6 Bg2 Bb7 O-O g6 b3 Bg7 Bb2 O-O Nc3 Na6 ",
	"c4 c5 Nf3 b6 g3 Bb7 Bg2 g6 d4 cxd4 Qxd4 Nf6 Nc3 Bg7 Bg5 d6 ",
	"c4 c5 Nf3 g6 d4 cxd4 Nxd4 Nc6 e4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"c4 c5 Nf3 g6 d4 cxd4 Nxd4 Nc6 e4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"c4 c5 g3 g6 Bg2 Bg7 Nc3 Nc6 Nf3 e6 O-O Nge7 d3 O-O Bg5 h6 ",
	"c4 c5 g3 g6 Bg2 Bg7 Nc3 Nc6 e3 e5 Nge2 Nge7 Rb1 O-O a3 a5 ",
	"c4 c5 g3 g6 Bg2 Bg7 e3 Nf6 Nc3 e6 Nge2 O-O O-O Nc6 Nf4 b6 ",
	"c4 c5 g3 g6 Bg2 Bg7 e3 Nf6 Nc3 e6 Nge2 O-O O-O Nc6 Nf4 b6 ",
	"c4 c6 Nf3 d5 d4 Nf6 e3 Bf5 Bd3 Bxd3 Qxd3 e6 Nc3 Nbd7 O-O Be7 ",
	"c4 c6 Nf3 g6 g3 Bg7 Bg2 Nf6 O-O O-O Nc3 d5 cxd5 cxd5 d3 Nc6 ",
	"c4 c6 d4 d5 Nc3 Nf6 e3 g6 Nf3 Bg7 Be2 O-O O-O Be6 cxd5 Bxd5 ",
	"c4 c6 d4 d5 Nf3 Nf6 Nc3 e6 Qb3 Be7 Bg5 Nbd7 e3 O-O Bd3 b6 ",
	"c4 c6 d4 d5 e3 Nf6 Nc3 e6 Nf3 Ne4 Be2 Bd6 O-O Nd7 Nxe4 dxe4 ",
	"c4 c6 e4 d5 exd5 cxd5 cxd5 Nf6 Qa4+ Nbd7 Nc3 g6 g4 Bg7 g5 Nh5 ",
	"c4 c6 e4 d5 exd5 cxd5 d4 Nf6 Nc3 Nc6 Bg5 e6 Nf3 dxc4 Bxc4 Be7 ",
	"c4 d5 cxd5 Qxd5 Nc3 Qd8 d4 Nf6 e4 e5 Nf3 exd4 Qxd4 Qxd4 Nxd4 c6 ",
	"c4 d6 d4 e5 Nc3 Nd7 Nf3 Ngf6 g3 g6 Bg2 Bg7 O-O O-O h3 c6 ",
	"c4 e5 Nc3 Nc6 Nf3 f5 d3 d6 g3 Nf6 Bg2 g6 Rb1 a5 O-O Bg7 ",
	"c4 e5 Nc3 Nc6 Nf3 f5 d4 e4 Bg5 Be7 Bxe7 Ncxe7 Ng5 h6 Nh3 Nf6 ",
	"c4 e5 Nc3 Nc6 e3 Nf6 Nf3 Bb4 Qc2 O-O Nd5 Re8 a3 Bf8 Bd3 g6 ",
	"c4 e5 Nc3 Nc6 g3 Nf6 Bg2 Bb4 e3 d6 Nge2 Bg4 Qb3 Rb8 Nd5 Bc5 ",
	"c4 e5 Nc3 Nc6 g3 d6 Bg2 Bd7 e3 Qc8 h3 g6 Nge2 Bg7 b3 Nge7 ",
	"c4 e5 Nc3 Nc6 g3 f5 Bg2 Nf6 d3 Bc5 e3 f4 exf4 O-O Nge2 Qe8 ",
	"c4 e5 Nc3 Nc6 g3 f5 Bg2 Nf6 e3 d6 Nge2 g6 d4 e4 O-O Bg7 ",
	"c4 e5 Nc3 Nc6 g3 f5 Bg2 Nf6 e3 g6 d4 e4 f3 exf3 Nxf3 d6 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nf3 f5 d3 Nf6 O-O d6 Rb1 O-O ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 Rb1 Nge7 b4 O-O e3 a6 Nge2 d6 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 Rb1 a5 a3 f5 d3 Nf6 e3 O-O ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nf3 f5 Nd5 Nge7 Bg5 h6 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 e3 d6 Nge2 h5 d4 h4 d5 Nb8 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 e3 d6 Nge2 h5 d4 h4 d5 Nce7 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 e3 f5 Nge2 Nf6 d4 d6 O-O O-O ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 a3 e4 Ng5 Qe7 d3 exd3 Qxd3 Ne5 Qc2 d6 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d3 d6 g3 g6 Bg2 Bg7 O-O O-O Rb1 Nd4 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d3 d6 g3 g6 Bg2 Bg7 O-O O-O Rb1 a5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d3 g6 g3 Bg7 Bg2 O-O O-O d6 Rb1 a5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Nxc6 bxc6 g3 Rb8 Bg2 Ba6 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Bb4 Nd5 e4 Ng1 O-O a3 Bd6 Qc2 Re8 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Bb4 Qc2 Bxc3 Qxc3 Qe7 d3 d5 cxd5 Nxd5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Bb4 Qc2 Bxc3 bxc3 O-O Be2 d6 O-O e4 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Bb4 Qc2 O-O Nd5 Re8 Qf5 d6 Nxf6+ gxf6 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Be7 Be2 O-O O-O d5 cxd5 Nxd5 d3 Be6 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Be7 a3 O-O b4 d6 Be2 Re8 d3 Bf8 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Be7 a3 O-O b4 d6 Be2 Re8 d3 Bf8 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e4 Bb4 d3 O-O g3 d6 Bg2 Bg4 h3 Bxf3 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 Bb4 Bg2 O-O O-O Re8 d3 Bxc3 bxc3 e4 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 Bb4 Nd5 Bc5 Bg2 O-O d3 h6 a3 a5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 d5 cxd5 Nxd5 Bg2 Nb6 d3 Be7 O-O O-O ",
	"c4 e5 Nc3 Nf6 Nf3 d6 g3 g6 Bg2 Bg7 O-O O-O d3 c6 Rb1 Ne8 ",
	"c4 e5 Nc3 Nf6 Nf3 d6 g3 g6 Bg2 Bg7 d3 O-O Bd2 Nh5 Qc1 f5 ",
	"c4 e5 Nc3 Nf6 d3 Bc5 Nf3 d6 e3 O-O Be2 Qe7 O-O a5 b3 Nbd7 ",
	"c4 e5 Nc3 Nf6 g3 Bb4 Bg2 O-O Nf3 Re8 O-O c6 d3 h6 Ne4 Nxe4 ",
	"c4 e5 Nc3 Nf6 g3 Bb4 Bg2 O-O Nf3 Re8 O-O e4 Nd4 Nc6 Nc2 Bxc3 ",
	"c4 e5 Nc3 Nf6 g3 Bb4 Bg2 O-O Nf3 Re8 O-O e4 Nd4 Nc6 Nc2 Bxc3 ",
	"c4 e5 Nc3 Nf6 g3 Bb4 Bg2 O-O e4 Bxc3 dxc3 d6 Qe2 b6 Nf3 Bb7 ",
	"c4 e5 Nc3 Nf6 g3 Bb4 Nf3 e4 Nd4 Nc6 Nc2 Bxc3 bxc3 O-O Bg2 Re8 ",
	"c4 e5 Nc3 Nf6 g3 Be7 Bg2 O-O Nf3 d6 O-O Nbd7 d3 c6 Ne1 Nb6 ",
	"c4 e5 Nc3 Nf6 g3 d6 Bg2 g6 e3 Bg7 Nge2 O-O O-O Nbd7 d4 c6 ",
	"c4 e5 Nc3 d6 d4 exd4 Qxd4 Nc6 Qd2 g6 b3 Bg7 Bb2 Nf6 g3 O-O ",
	"c4 e5 Nc3 d6 d4 exd4 Qxd4 Nf6 g3 Nc6 Qd2 Be6 Nd5 Ne5 b3 Ne4 ",
	"c4 e5 Nc3 d6 g3 Be6 Bg2 c6 d3 Nf6 Nf3 h6 O-O Be7 b3 O-O ",
	"c4 e5 Nc3 d6 g3 f5 Bg2 Nf6 d3 g6 Nh3 Bg7 O-O O-O Bd2 c6 ",
	"c4 e5 Nc3 d6 g3 f5 Bg2 Nf6 d3 g6 e4 Bg7 Nge2 O-O O-O c6 ",
	"c4 e5 Nc3 d6 g3 f5 Bg2 Nf6 e3 g6 Nge2 Bg7 O-O O-O d3 c6 ",
	"c4 e5 Nc3 d6 g3 f5 d4 e4 f3 Nf6 Bg2 exf3 Nxf3 g6 O-O Bg7 ",
	"c4 e5 Nc3 d6 g3 g6 d4 Nc6 dxe5 dxe5 Qxd8+ Nxd8 Nf3 Bd6 Nb5 Bd7 ",
	"c4 e5 Nf3 Nc6 d4 Bb4+ Nc3 exd4 Nxd4 Nf6 Bg5 h6 Bh4 g5 Bg3 Ne4 ",
	"c4 e5 a3 Nf6 e3 Be7 Qc2 O-O Nc3 d6 Nf3 Re8 Be2 Bf8 O-O Nc6 ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 Rb1 a5 e3 Nf6 Nge2 O-O a3 Re8 ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 Rb1 d6 b4 a6 a4 Nf6 b5 axb5 ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 d3 d6 Rb1 Be6 b4 Qd7 Nf3 h6 ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 e3 d6 Nge2 Nge7 d4 exd4 exd4 Bg4 ",
	"c4 e5 g3 Nc6 Nc3 g6 Bg2 Bg7 Rb1 f5 d3 Nf6 e3 O-O Nge2 d6 ",
	"c4 e5 g3 Nf6 Bg2 Nc6 Nf3 d5 cxd5 Nxd5 O-O Be7 d4 exd4 Nxd4 Nxd4 ",
	"c4 e5 g3 Nf6 Bg2 c6 d4 exd4 Qxd4 d5 cxd5 cxd5 Nf3 Nc6 Qa4 Bc5 ",
	"c4 e5 g3 Nf6 Bg2 c6 d4 exd4 Qxd4 d5 cxd5 cxd5 Nf3 Nc6 Qa4 Bc5 ",
	"c4 e5 g3 Nf6 Bg2 c6 d4 exd4 Qxd4 d5 cxd5 cxd5 Nf3 Nc6 Qa4 Be7 ",
	"c4 e5 g3 d6 Nc3 g6 d4 Nc6 d5 Nce7 e4 Bg7 h4 Nf6 Bg5 O-O ",
	"c4 e5 g3 d6 d4 exd4 Qxd4 Nf6 Bg2 g6 Qe3+ Be7 Nh3 O-O Nf4 c6 ",
	"c4 e5 g3 g6 Bg2 Bg7 Nc3 Ne7 b3 O-O Bb2 Nbc6 e3 f5 Nge2 Kh8 ",
	"c4 e6 Nc3 Nf6 Nf3 Bb4 Qc2 O-O a3 Bxc3 Qxc3 b6 b4 Bb7 Bb2 d6 ",
	"c4 e6 Nc3 c5 e4 Nc6 f4 Nge7 Nf3 d5 d3 g6 Be2 Bg7 O-O O-O ",
	"c4 e6 Nc3 d5 cxd5 exd5 d4 c6 g3 Nf6 Bg2 Bd6 Nf3 O-O O-O Bf5 ",
	"c4 e6 Nc3 d5 d4 Be7 Nf3 Nf6 Bg5 h6 Bh4 O-O Rc1 dxc4 e3 c5 ",
	"c4 e6 Nc3 d5 d4 Be7 Nf3 Nf6 Bg5 h6 Bh4 O-O e3 b6 Rc1 Bb7 ",
	"c4 e6 Nc3 d5 d4 Be7 Nf3 Nf6 Bg5 h6 Bh4 O-O e3 b6 Rc1 Bb7 ",
	"c4 e6 Nc3 d5 d4 Nf6 Bg5 Be7 e3 O-O Nf3 h6 Bh4 b6 cxd5 Nxd5 ",
	"c4 e6 Nc3 d5 d4 Nf6 Bg5 Nbd7 e3 c6 cxd5 exd5 Bd3 Be7 Qc2 Nh5 ",
	"c4 e6 Nc3 d5 d4 Nf6 Nf3 Be7 Bg5 Nbd7 e3 h6 Bh4 O-O Qc2 c5 ",
	"c4 e6 Nc3 d5 d4 Nf6 Nf3 Nbd7 Bg5 h6 Bh4 Be7 e3 Ne4 Bxe7 Qxe7 ",
	"c4 e6 Nc3 d5 d4 Nf6 cxd5 exd5 Bg5 Be7 e3 O-O Bd3 Nbd7 Nf3 Re8 ",
	"c4 e6 Nc3 d5 d4 Nf6 cxd5 exd5 Bg5 Be7 e3 O-O Qc2 c6 Bd3 Nbd7 ",
	"c4 e6 Nc3 d5 d4 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"c4 e6 Nc3 d5 d4 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"c4 e6 Nc3 d5 d4 c6 Nf3 Nf6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"c4 e6 Nc3 d5 d4 c6 Nf3 Nf6 Bg5 dxc4 e4 b5 e5 h6 Bxf6 gxf6 ",
	"c4 e6 Nc3 d5 d4 c6 e3 Nf6 Nf3 Nbd7 Qc2 Bd6 Be2 O-O b3 a6 ",
	"c4 e6 Nf3 Nf6 Nc3 d5 d4 Bb4 Bg5 h6 Bxf6 Qxf6 e3 c5 a3 cxd4 ",
	"c4 e6 Nf3 d5 d4 c5 cxd5 exd5 g3 Nf6 Bg2 Nc6 O-O Be7 dxc5 O-O ",
	"c4 e6 Nf3 d5 g3 Nf6 Bg2 Be7 O-O O-O b3 c5 Bb2 Nc6 e3 b6 ",
	"c4 e6 d4 d5 Nc3 Be7 Nf3 Nf6 Bf4 c5 dxc5 Na6 e3 Nxc5 cxd5 exd5 ",
	"c4 e6 d4 d5 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"c4 e6 d4 d5 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"c4 e6 e4 c5 Nf3 Nc6 Nc3 Nd4 b3 g6 Nxd4 cxd4 Nb5 e5 Na3 d6 ",
	"c4 e6 g3 Nf6 Bg2 c5 Nf3 Nc6 O-O d5 cxd5 Nxd5 d4 Be7 dxc5 Bxc5 ",
	"c4 e6 g3 d5 Bg2 Nf6 Nf3 Be7 O-O O-O b3 b6 Bb2 Bb7 e3 c5 ",
	"c4 e6 g3 d5 Bg2 Nf6 Nf3 Be7 O-O O-O d4 c6 b3 b5 c5 Nbd7 ",
	"c4 e6 g3 d5 Bg2 Nf6 Nf3 Be7 d4 O-O Qc2 c5 dxc5 Qa5+ Nc3 dxc4 ",
	"c4 e6 g3 d5 Bg2 Nf6 Nf3 Nc6 O-O Be7 b3 O-O Bb2 d4 d3 e5 ",
	"c4 e6 g3 d5 Bg2 c6 Qc2 dxc4 Qxc4 b5 Qc2 Bb7 d3 Nf6 Nc3 a6 ",
	"c4 e6 g3 d5 Bg2 d4 b4 c5 b5 e5 d3 Bd6 e4 Qc7 Ne2 h5 ",
	"c4 e6 g3 d5 Bg2 d4 b4 c5 b5 e5 d3 Bd6 e4 Qc7 Ne2 h5 ",
	"c4 e6 g3 d5 Bg2 d4 d3 c5 e4 e5 f4 exf4 Bxf4 Nc6 Nf3 Nge7 ",
	"c4 e6 g3 d5 Bg2 g6 d4 Bg7 Nf3 Ne7 O-O O-O Nc3 Nbc6 cxd5 exd5 ",
	"c4 e6 g3 d5 cxd5 exd5 Bg2 Nf6 Nf3 Be7 O-O O-O b3 Ne4 Bb2 Bf6 ",
	"c4 e6 g3 f5 Bg2 Nf6 d4 Be7 Nc3 d5 Nf3 O-O b3 c6 O-O Qe8 ",
	"c4 f5 Nf3 Nf6 g3 d6 d4 c6 Bg2 Qc7 Nc3 e5 O-O e4 Ne1 Be7 ",
	"c4 f5 d4 Nf6 g3 e6 Bg2 Be7 Nf3 d5 O-O O-O Nc3 c6 Qc2 Qe8 ",
	"c4 f5 g3 Nf6 Bg2 d6 Nc3 e5 d3 Be7 Nf3 O-O O-O Na6 Rb1 c6 ",
	"c4 f5 g3 Nf6 Bg2 g6 Nc3 Bg7 Nf3 O-O O-O Nc6 d4 d6 d5 Ne5 ",
	"c4 g6 Nc3 Bg7 Nf3 c5 d4 cxd4 Nxd4 Nc6 Nc2 Bxc3+ bxc3 Nf6 f3 d6 ",
	"c4 g6 Nc3 Bg7 Nf3 c5 g3 Nc6 Bg2 e6 O-O Nge7 d3 O-O Bd2 d5 ",
	"c4 g6 Nc3 Bg7 d4 c5 d5 Nf6 e4 d6 Bd3 O-O f4 a6 Nge2 b5 ",
	"c4 g6 Nc3 Bg7 d4 d6 e4 Nc6 d5 Nd4 Be3 c5 Nge2 Qb6 Na4 Qa5+ ",
	"c4 g6 Nc3 Bg7 d4 d6 e4 Nd7 Be3 Ngf6 f3 O-O Qd2 c5 Nge2 Qa5 ",
	"c4 g6 Nc3 Bg7 d4 d6 e4 c5 d5 Bxc3+ bxc3 e5 dxe6 Bxe6 f4 Qh4+ ",
	"c4 g6 Nc3 Bg7 g3 Nc6 Bg2 d6 Nf3 e5 d3 f5 O-O Nf6 Rb1 h6 ",
	"c4 g6 Nc3 Bg7 g3 Nf6 Bg2 O-O d3 d6 Rb1 e5 e4 Nc6 Nge2 Nh5 ",
	"c4 g6 Nc3 Bg7 g3 c5 Bg2 Nc6 Nf3 Nh6 a3 O-O O-O Nf5 Rb1 Nfd4 ",
	"c4 g6 Nc3 Bg7 g3 c5 Bg2 Nc6 b3 e6 Bb2 Nge7 Na4 Bxb2 Nxb2 O-O ",
	"c4 g6 Nc3 Bg7 g3 c5 Bg2 Nc6 b3 e6 Bb2 Nge7 Na4 Bxb2 Nxb2 O-O ",
	"c4 g6 Nc3 Bg7 g3 c5 Bg2 Nc6 b3 e6 Bb2 Nge7 Na4 Bxb2 Nxb2 O-O ",
	"c4 g6 Nc3 Bg7 g3 c5 Bg2 Nc6 b3 e6 Bb2 Nge7 Na4 Bxb2 Nxb2 O-O ",
	"c4 g6 Nc3 Bg7 g3 d6 d4 c5 Be3 cxd4 Bxd4 Nf6 Nd5 Nbd7 Nf3 O-O ",
	"c4 g6 Nc3 Bg7 g3 e5 Bg2 d6 d3 f5 e3 a5 Nge2 Nf6 O-O O-O ",
	"c4 g6 Nc3 Bg7 g3 e5 Bg2 d6 d3 f5 e4 Nf6 Nge2 O-O h3 c6 ",
	"c4 g6 Nc3 Bg7 g3 e5 Bg2 d6 e3 Nf6 Nge2 O-O O-O c6 d4 Qe7 ",
	"c4 g6 Nc3 Bg7 g3 e5 Bg2 d6 e3 Nf6 Nge2 O-O O-O c6 d4 Re8 ",
	"c4 g6 Nc3 c5 g3 Bg7 Bg2 Nc6 Nf3 e5 O-O Nge7 Ne1 O-O Nc2 d6 ",
	"c4 g6 Nc3 c5 g3 Bg7 Bg2 Nc6 Nf3 e6 O-O Nge7 d3 O-O Bd2 d5 ",
	"c4 g6 Nc3 c5 g3 Bg7 Bg2 Nc6 Nf3 e6 O-O Nge7 d3 O-O Bd2 d5 ",
	"c4 g6 Nc3 c5 g3 Bg7 Bg2 Nc6 e3 d6 Nge2 Nf6 O-O O-O d3 Bd7 ",
	"c4 g6 Nf3 Bg7 Nc3 d6 d4 Nf6 e4 O-O Be2 e5 dxe5 dxe5 Qxd8 Rxd8 ",
	"c4 g6 Nf3 Bg7 d4 Nf6 Nc3 O-O e4 d6 Be2 e5 O-O Nc6 d5 Ne7 ",
	"c4 g6 Nf3 Bg7 d4 Nf6 Nc3 O-O e4 d6 Be2 e5 O-O Nc6 d5 Ne7 ",
	"c4 g6 Nf3 Bg7 d4 Nf6 Nc3 d5 Qb3 dxc4 Qxc4 O-O e4 Na6 Qb3 c5 ",
	"c4 g6 Nf3 Bg7 g3 d6 Bg2 e5 O-O Nc6 Nc3 f5 d3 Nf6 Nd5 h6 ",
	"c4 g6 Nf3 Bg7 g3 d6 Bg2 e5 d3 f5 Nc3 Nc6 O-O Nf6 Rb1 O-O ",
	"c4 g6 d4 Bg7 Nc3 Nf6 e4 d6 Be2 O-O Bg5 Nbd7 Qc1 c5 d5 b5 ",
	"c4 g6 d4 Bg7 Nc3 Nf6 e4 d6 Nf3 O-O h3 e5 d5 Na6 Be3 Nh5 ",
	"c4 g6 d4 Nf6 Nc3 Bg7 e4 d6 f3 a6 Be3 c6 c5 O-O Nge2 Nbd7 ",
	"c4 g6 d4 Nf6 Nc3 d5 Nf3 Bg7 Qa4+ c6 cxd5 Nxd5 e4 Nb6 Qc2 Bg4 ",
	"c4 g6 e4 Bg7 d4 d6 Nc3 Nf6 Nf3 O-O Be2 e5 Be3 Ng4 Bg5 f6 ",
	"c4 g6 e4 Bg7 d4 d6 Nc3 Nf6 f3 O-O Be3 Nbd7 Bd3 c5 Nge2 cxd4 ",
	"c4 g6 g3 Bg7 Bg2 c5 Nc3 Nc6 e3 Bxc3 bxc3 f5 f4 Nf6 Nf3 b6 ",
	"c4 g6 g3 Bg7 Bg2 c5 Nc3 Nc6 e3 Nf6 d4 O-O Nge2 d6 O-O Bf5 ",
	"c4 g6 g3 Bg7 Bg2 e5 Nc3 d6 d3 Ne7 e4 O-O Nge2 Nbc6 O-O f5 ",
	"c4 g6 g3 Bg7 Bg2 e5 Nc3 d6 e4 f5 exf5 gxf5 Qh5+ Kf8 d3 Nf6 ",
	"d4 Nf6 Bg5 Ne4 Bf4 c5 d5 Qb6 Bc1 e6 f3 Qa5+ c3 Nf6 e4 d6 ",
	"d4 Nf6 Bg5 c5 c3 Qb6 Qb3 cxd4 Qxb6 axb6 Bxf6 gxf6 cxd4 Nc6 Nf3 Nb4 ",
	"d4 Nf6 Bg5 c5 d5 Ne4 Bf4 d6 Nd2 Nf6 e4 g6 Ne2 b5 Ng3 b4 ",
	"d4 Nf6 Bg5 d6 Nc3 Nbd7 e4 e5 Nf3 c6 a4 h6 Be3 Ng4 Bc1 exd4 ",
	"d4 Nf6 Bg5 e6 e4 h6 Bxf6 Qxf6 Nf3 b6 Bd3 Bb7 c3 Qd8 Nbd2 Be7 ",
	"d4 Nf6 Bg5 g6 Bxf6 exf6 h4 f5 h5 Bg7 e3 d6 Bc4 Nd7 Ne2 Nb6 ",
	"d4 Nf6 Nc3 d5 Bg5 Nbd7 Nf3 h6 Bh4 e6 e3 Be7 Bd3 c5 O-O a6 ",
	"d4 Nf6 Nc3 d5 Bg5 h6 Bxf6 exf6 e3 c6 Bd3 Bd6 Qf3 O-O Nge2 Re8 ",
	"d4 Nf6 Nc3 g6 Bg5 Bg7 Qd2 h6 Bf4 d6 O-O-O Nh5 Be3 c6 h3 Qa5 ",
	"d4 Nf6 Nd2 d5 e3 c5 c3 cxd4 exd4 Bf5 Ngf3 e6 Qb3 Qc7 Ne5 Bd6 ",
	"d4 Nf6 Nf3 b6 Bg5 Bb7 e3 e6 Bd3 Be7 O-O c5 c4 h6 Bxf6 Bxf6 ",
	"d4 Nf6 Nf3 b6 c4 Bb7 Nc3 d6 Qc2 Nbd7 e4 e5 d5 g6 h3 Bg7 ",
	"d4 Nf6 Nf3 b6 c4 e6 e3 Bb7 Bd3 Be7 O-O O-O Nc3 d5 cxd5 exd5 ",
	"d4 Nf6 Nf3 b6 e3 Bb7 Bd3 c5 O-O Nc6 c3 e6 Ne5 d6 Nxc6 Bxc6 ",
	"d4 Nf6 Nf3 b6 e3 Bb7 Bd3 c5 O-O e6 Nbd2 Nc6 c3 Qc7 Qe2 d5 ",
	"d4 Nf6 Nf3 b6 e3 Bb7 Nbd2 e6 Bd3 c5 O-O Nc6 c3 Be7 e4 cxd4 ",
	"d4 Nf6 Nf3 b6 e3 c5 Bd3 Bb7 c4 e6 O-O Be7 Nc3 d5 cxd5 exd5 ",
	"d4 Nf6 Nf3 b6 e3 c5 c4 Bb7 Nc3 cxd4 exd4 e6 Bd3 Be7 O-O O-O ",
	"d4 Nf6 Nf3 b6 g3 Bb7 Bg2 c5 O-O cxd4 Nxd4 Bxg2 Kxg2 g6 b3 Bg7 ",
	"d4 Nf6 Nf3 b6 g3 Bb7 Bg2 c5 c4 cxd4 O-O Qc7 Qxd4 Nc6 Qf4 e5 ",
	"d4 Nf6 Nf3 b6 g3 Bb7 Bg2 c5 dxc5 bxc5 c4 g6 b3 Bg7 Bb2 O-O ",
	"d4 Nf6 Nf3 b6 g3 Bb7 Bg2 e6 O-O Be7 b3 O-O Bb2 d6 Nbd2 Nbd7 ",
	"d4 Nf6 Nf3 b6 g3 Bb7 Bg2 g6 O-O Bg7 c3 O-O Bf4 c5 Na3 d6 ",
	"d4 Nf6 Nf3 b6 g3 Bb7 Bg2 g6 O-O Bg7 c4 O-O Nbd2 c5 d5 e6 ",
	"d4 Nf6 Nf3 b6 g3 Bb7 c4 e5 dxe5 Ng4 Bg2 Nxe5 Nbd2 Be7 O-O Ng6 ",
	"d4 Nf6 Nf3 b6 g3 c5 Bg2 Bb7 dxc5 bxc5 c4 g6 b3 Bg7 Bb2 O-O ",
	"d4 Nf6 Nf3 c5 c3 b6 Bf4 Bb7 Nbd2 g6 h3 Bg7 e3 O-O Bd3 d5 ",
	"d4 Nf6 Nf3 c5 c3 e6 Bf4 b6 e3 Be7 Nbd2 O-O h3 d6 Be2 Bb7 ",
	"d4 Nf6 Nf3 c5 c3 e6 Bg5 Be7 e3 b6 Nbd2 Bb7 Bd3 O-O O-O Nc6 ",
	"d4 Nf6 Nf3 c5 c3 g6 g3 b6 Bg2 Bb7 O-O Bg7 Nbd2 O-O Re1 d5 ",
	"d4 Nf6 Nf3 c5 c4 cxd4 Nxd4 Nc6 Nc3 Qb6 e3 e6 Be2 Be7 O-O O-O ",
	"d4 Nf6 Nf3 c5 c4 cxd4 Nxd4 e6 e3 Nc6 Be2 Bb4+ Bd2 Bc5 Nb3 Bb6 ",
	"d4 Nf6 Nf3 c5 c4 cxd4 Nxd4 e6 e3 Nc6 Be2 d5 Nc3 Bc5 O-O Bxd4 ",
	"d4 Nf6 Nf3 c5 d5 b5 c4 Bb7 Nc3 b4 Qb3 Qa5 Nd1 e6 e4 Nxe4 ",
	"d4 Nf6 Nf3 c5 d5 b5 c4 Bb7 g3 g6 Bg2 bxc4 Nc3 Bg7 O-O O-O ",
	"d4 Nf6 Nf3 c5 d5 d6 Nc3 g6 g3 Bf5 Bg2 Na6 O-O Qd7 Re1 Ne4 ",
	"d4 Nf6 Nf3 c5 d5 e6 Nc3 exd5 Nxd5 Nxd5 Qxd5 Be7 e4 O-O Bc4 d6 ",
	"d4 Nf6 Nf3 c5 d5 e6 c4 exd5 cxd5 d6 Nc3 g6 Bf4 Bg7 Qa4+ Bd7 ",
	"d4 Nf6 Nf3 c5 d5 e6 c4 exd5 cxd5 d6 Nc3 g6 Nd2 Bg7 e4 O-O ",
	"d4 Nf6 Nf3 c5 d5 g6 Nc3 Bg7 a4 O-O e4 d6 Be2 e6 O-O exd5 ",
	"d4 Nf6 Nf3 c5 e3 g6 c3 Bg7 Bd3 O-O Qc2 d5 O-O Nc6 Nbd2 c4 ",
	"d4 Nf6 Nf3 c6 Bf4 d6 h3 Qb6 b3 c5 dxc5 Qxc5 c4 g6 Nc3 Bg7 ",
	"d4 Nf6 Nf3 c6 Bf4 d6 h3 Qb6 b3 c5 dxc5 Qxc5 c4 g6 Nc3 Bg7 ",
	"d4 Nf6 Nf3 d5 Bg5 c5 e3 Ne4 Bf4 Qb6 Qc1 Nc6 c3 Bf5 Nbd2 Rc8 ",
	"d4 Nf6 Nf3 d5 c4 c6 Nc3 Bf5 Qb3 Qb6 Qxb6 axb6 cxd5 Nxd5 Nxd5 cxd5 ",
	"d4 Nf6 Nf3 d5 c4 c6 cxd5 cxd5 Nc3 Nc6 Bf4 Bf5 e3 a6 Bd3 Bxd3 ",
	"d4 Nf6 Nf3 d5 c4 c6 e3 Bf5 Nc3 e6 Bd3 Bxd3 Qxd3 Nbd7 O-O Bb4 ",
	"d4 Nf6 Nf3 d5 c4 e6 Bg5 Nbd7 e3 c6 Nc3 Qa5 Bxf6 Nxf6 Bd3 dxc4 ",
	"d4 Nf6 Nf3 d5 c4 e6 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Qc2 Nc6 ",
	"d4 Nf6 Nf3 d5 c4 e6 e3 c5 Nc3 Nc6 cxd5 Nxd5 Bd3 Be7 O-O O-O ",
	"d4 Nf6 Nf3 d5 e3 e6 Bd3 c5 b3 Nc6 O-O Bd6 Bb2 O-O Nbd2 Qe7 ",
	"d4 Nf6 Nf3 d5 e3 e6 Nbd2 c5 c3 Nc6 Bd3 Bd6 O-O O-O dxc5 Bxc5 ",
	"d4 Nf6 Nf3 d5 e3 g6 c4 Bg7 Nc3 O-O Qb3 e6 Be2 Nc6 Qc2 dxc4 ",
	"d4 Nf6 Nf3 d5 g3 Bf5 Bg2 e6 O-O Be7 c4 O-O Nh4 Be4 Nc3 Bxg2 ",
	"d4 Nf6 Nf3 d5 g3 Bf5 Bg2 e6 c4 c6 Nc3 Nbd7 O-O h6 Bf4 Be7 ",
	"d4 Nf6 Nf3 d6 Nc3 d5 Bf4 e6 e3 Bb4 Bd3 c5 O-O c4 Be2 Bxc3 ",
	"d4 Nf6 Nf3 d6 b3 g6 Bb2 Bg7 Nbd2 O-O e3 Nbd7 Be2 e5 dxe5 Ng4 ",
	"d4 Nf6 Nf3 d6 c3 Nbd7 Bf4 c6 Qc2 Qc7 e4 e5 Bg3 Be7 Bd3 O-O ",
	"d4 Nf6 Nf3 d6 e3 Bg4 Be2 Nbd7 O-O e5 dxe5 dxe5 Nc3 c6 h3 Bh5 ",
	"d4 Nf6 Nf3 e6 Bf4 c5 e3 Qb6 Qc1 Nc6 c3 d5 h3 Bd7 Nbd2 Rc8 ",
	"d4 Nf6 Nf3 e6 Bg5 Be7 Nbd2 c5 e4 cxd4 e5 Nd5 Bxe7 Qxe7 Nxd4 O-O ",
	"d4 Nf6 Nf3 e6 Bg5 c5 c3 Qb6 Qc2 cxd4 Nxd4 Nc6 e3 d5 Nd2 Bd7 ",
	"d4 Nf6 Nf3 e6 Bg5 c5 c3 cxd4 cxd4 Qb6 Qb3 Ne4 Bf4 Nc6 e3 Bb4+ ",
	"d4 Nf6 Nf3 e6 Bg5 c5 e3 Be7 Be2 b6 O-O Bb7 c3 Nc6 Nbd2 O-O ",
	"d4 Nf6 Nf3 e6 Bg5 c5 e3 Be7 Nbd2 b6 c3 Bb7 Bd3 cxd4 exd4 Nd5 ",
	"d4 Nf6 Nf3 e6 Bg5 c5 e3 Nc6 c3 Qb6 Qb3 d5 Nbd2 Bd7 Be2 cxd4 ",
	"d4 Nf6 Nf3 e6 Bg5 c5 e3 Qb6 Qc1 Nc6 c3 d5 Bd3 Bd7 Nbd2 Rc8 ",
	"d4 Nf6 Nf3 e6 Bg5 d5 Nbd2 Be7 e3 Nbd7 Bd3 c5 c3 b6 O-O Bb7 ",
	"d4 Nf6 Nf3 e6 Bg5 d5 c4 Be7 Nc3 O-O e3 Nbd7 Bd3 Re8 O-O Nf8 ",
	"d4 Nf6 Nf3 e6 Bg5 h6 Bh4 b6 e3 Bb7 Nbd2 d6 Bd3 Nbd7 c3 g5 ",
	"d4 Nf6 Nf3 e6 Bg5 h6 Bxf6 Qxf6 Nbd2 d6 c3 Nd7 g3 g6 Bg2 Bg7 ",
	"d4 Nf6 Nf3 e6 Bg5 h6 Bxf6 Qxf6 e4 b6 a3 Bb7 Nc3 d6 Qd2 Nd7 ",
	"d4 Nf6 Nf3 e6 Bg5 h6 Bxf6 Qxf6 e4 d6 Nc3 c6 e5 Qd8 exd6 Bxd6 ",
	"d4 Nf6 Nf3 e6 c4 Bb4+ Bd2 Bxd2+ Nbxd2 O-O e4 d6 Qc2 Nc6 Rd1 Qe7 ",
	"d4 Nf6 Nf3 e6 c4 Bb4+ Bd2 Qe7 Nc3 b6 e3 Bxc3 Bxc3 Ne4 Rc1 Bb7 ",
	"d4 Nf6 Nf3 e6 c4 Bb4+ Bd2 Qe7 g3 Nc6 Bg2 Bxd2+ Nbxd2 d6 O-O a5 ",
	"d4 Nf6 Nf3 e6 c4 Bb4+ Bd2 c5 g3 Qb6 d5 exd5 cxd5 Nxd5 Bg2 Nf6 ",
	"d4 Nf6 Nf3 e6 c4 b6 Bg5 Bb7 e3 Be7 Nc3 Ne4 Bxe7 Qxe7 Bd3 Nxc3 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb4 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb4 Qb3 c5 a3 Bxc3+ Qxc3 O-O g3 cxd4 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb4 Qc2 Bb7 a3 Bxc3+ Qxc3 d6 e3 Nbd7 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb7 Bg5 Be7 e3 Ne4 Bxe7 Qxe7 Nxe4 Bxe4 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 Nxc3 bxc3 c5 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb7 e3 d5 cxd5 exd5 Bd3 Bd6 O-O O-O ",
	"d4 Nf6 Nf3 e6 c4 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 Nf3 e6 c4 b6 g3 Bb7 Bg2 Bb4+ Bd2 Qe7 O-O O-O Nc3 Nc6 ",
	"d4 Nf6 Nf3 e6 c4 b6 g3 Bb7 Bg2 Bb4+ Nbd2 c5 e3 cxd4 exd4 Qc7 ",
	"d4 Nf6 Nf3 e6 c4 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 Ne4 Qc2 Nxc3 ",
	"d4 Nf6 Nf3 e6 c4 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 Ne4 Qc2 Nxc3 ",
	"d4 Nf6 Nf3 e6 c4 c5 Nc3 cxd4 Nxd4 Bb4 Nb5 d5 Bf4 O-O e3 a6 ",
	"d4 Nf6 Nf3 e6 c4 c5 e3 d5 Nc3 Nc6 a3 cxd4 exd4 Be7 cxd5 exd5 ",
	"d4 Nf6 Nf3 e6 c4 c5 g3 cxd4 Nxd4 d5 Bg2 e5 Nc2 d4 O-O Nc6 ",
	"d4 Nf6 Nf3 e6 c4 d5 Bg5 Nbd7 Nc3 c6 Rc1 h6 Bh4 dxc4 e4 Qa5 ",
	"d4 Nf6 Nf3 e6 c4 d5 Nc3 Be7 Bg5 Nbd7 e3 O-O Rc1 c6 Bd3 h6 ",
	"d4 Nf6 Nf3 e6 c4 d5 Nc3 Nbd7 Bg5 c6 e3 Qa5 Nd2 Bb4 Qc2 O-O ",
	"d4 Nf6 Nf3 e6 c4 d5 Nc3 Nbd7 Bg5 c6 e3 Qa5 cxd5 Nxd5 Qd2 Bb4 ",
	"d4 Nf6 Nf3 e6 e3 b6 Bd3 Bb7 O-O Be7 b3 O-O Bb2 Ne4 c4 f5 ",
	"d4 Nf6 Nf3 e6 e3 b6 Bd3 Bb7 O-O Ne4 Nbd2 f5 c3 Be7 Qc2 d5 ",
	"d4 Nf6 Nf3 e6 e3 b6 Bd3 Bb7 O-O d5 Ne5 Nbd7 f4 g6 b3 Bg7 ",
	"d4 Nf6 Nf3 e6 e3 c5 Bd3 Nc6 O-O Qc7 c4 cxd4 exd4 d5 b3 Bd7 ",
	"d4 Nf6 Nf3 e6 e3 c5 Bd3 Nc6 O-O d5 b3 Bd6 Bb2 O-O Nbd2 Nb4 ",
	"d4 Nf6 Nf3 e6 e3 c5 c3 d5 Bd3 Nbd7 Nbd2 Be7 O-O O-O e4 dxe4 ",
	"d4 Nf6 Nf3 e6 e3 c5 c3 d5 Bd3 Nbd7 O-O b6 Nbd2 Bb7 Ne5 Nxe5 ",
	"d4 Nf6 Nf3 e6 g3 c5 Bg2 d5 O-O cxd4 Nxd4 e5 Nb3 Be7 Nc3 d4 ",
	"d4 Nf6 Nf3 e6 g3 c5 c3 b6 Bg2 Bb7 O-O Be7 dxc5 bxc5 c4 O-O ",
	"d4 Nf6 Nf3 e6 g3 c5 c4 cxd4 Nxd4 d5 Bg2 e5 Nf3 e4 Nfd2 dxc4 ",
	"d4 Nf6 Nf3 e6 g3 c5 dxc5 Bxc5 Bg2 d5 O-O Nc6 Nfd2 h5 Nb3 Be7 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 Nbd2 c5 c3 cxd4 cxd4 d5 Bxb8 Rxb8 Qa4+ Bd7 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 Nbd2 c5 c3 cxd4 cxd4 d5 Bxb8 Rxb8 Qa4+ Bd7 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 Nbd2 d6 e4 O-O Bd3 Nbd7 Qe2 Nh5 Be3 e5 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 c3 b6 e3 Bb7 h3 O-O Be2 d6 O-O c5 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 O-O Nbd2 b6 c3 c5 h3 d6 Be2 Ba6 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 O-O h3 b6 Be2 Bb7 O-O d6 c4 Ne4 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 d6 Be2 O-O O-O c5 Nc3 b6 h3 Na6 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 d6 h3 c5 c3 cxd4 exd4 O-O Be2 Be6 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 d6 h3 c5 c3 cxd4 exd4 O-O Be2 Be6 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 h3 O-O e3 b6 Bd3 Bb7 Nbd2 c5 c3 d6 ",
	"d4 Nf6 Nf3 g6 Bf4 d6 e3 Nh5 Bg5 h6 Bh4 g5 Nfd2 Ng7 Bg3 Nf5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 O-O e3 d6 Bd3 Nbd7 Qe2 h6 Bxf6 Nxf6 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 c5 c3 cxd4 cxd4 Nc6 e3 O-O a3 h6 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 Bf5 Be2 O-O O-O Nbd7 c4 dxc4 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 O-O Bd3 Nbd7 O-O Re8 c4 c5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 O-O Bd3 Nbd7 h4 Qe8 Bf4 c5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 O-O Bd3 c5 c4 cxd4 Nxd4 dxc4 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 O-O Be2 b6 O-O c5 c3 Bb7 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 O-O c3 b6 Bd3 Bb7 Qe2 Ne4 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 O-O c3 b6 Bd3 Bb7 Qe2 Ne4 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 O-O c3 b6 Bd3 Bb7 Qe2 Ne4 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d6 e4 h6 Bxf6 Bxf6 Bb5+ c6 Bd3 O-O ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 c3 d5 Nbd2 Nbd7 e3 O-O b4 c6 Be2 Re8 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 c3 d5 Nbd2 O-O e3 Nbd7 Be2 Re8 Qb3 c6 ",
	"d4 Nf6 Nf3 g6 Nbd2 Bg7 e4 O-O Bd3 d6 h3 Nc6 c3 e5 dxe5 Nxe5 ",
	"d4 Nf6 Nf3 g6 Nbd2 c5 c3 cxd4 cxd4 Nc6 e3 Bg7 Be2 O-O O-O d6 ",
	"d4 Nf6 Nf3 g6 Nbd2 d5 c4 c6 e3 Bg7 Bd3 O-O b3 Bf5 Qc2 Bxd3 ",
	"d4 Nf6 Nf3 g6 Nc3 Bg7 e4 d6 h3 O-O Be3 c6 a4 a5 Be2 Nbd7 ",
	"d4 Nf6 Nf3 g6 Nc3 d5 Bf4 Bg7 Qd2 Ne4 Nxe4 dxe4 Ne5 Be6 e3 Nd7 ",
	"d4 Nf6 Nf3 g6 Nc3 d5 Bf4 Bg7 e3 O-O Be2 Nh5 Bg5 h6 Bh4 g5 ",
	"d4 Nf6 Nf3 g6 Nc3 d5 Bf4 Bg7 e3 O-O Be2 b6 Ne5 Bb7 h4 h6 ",
	"d4 Nf6 Nf3 g6 Nc3 d5 h3 Bg7 e3 Ne4 Nxe4 dxe4 Nd2 f5 Bc4 Nc6 ",
	"d4 Nf6 Nf3 g6 c3 Bg7 Bf4 d6 h3 O-O Nbd2 Bf5 g4 Bd7 Bg2 Nc6 ",
	"d4 Nf6 Nf3 g6 c3 Bg7 Bg5 d5 Nbd2 Nbd7 b4 Ne4 Nxe4 dxe4 Nd2 h6 ",
	"d4 Nf6 Nf3 g6 c3 Bg7 Nbd2 d6 e4 Nbd7 Bd3 e5 d5 O-O Nf1 Nxd5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O Bf4 d5 e3 c5 Be2 cxd4 exd4 Nc6 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e3 d6 Bd3 Bg4 h3 Bxf3 Qxf3 Nc6 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e3 d6 Bd3 Nbd7 O-O e5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e3 d6 g3 Nc6 Bg2 e5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 c6 d5 d6 Be2 Na6 O-O Nc5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 Nbd7 Bf4 Nh5 Be3 e5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 e5 Be3 h6 O-O Ng4 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 e5 O-O a5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 e5 d5 Nbd7 O-O Nc5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 e5 dxe5 dxe5 Qc2 Nc6 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 h3 e5 dxe5 dxe5 Be3 Qe7 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O g3 d5 cxd5 Nxd5 Bg2 c5 O-O Nxc3 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O g3 d6 Bg2 Nbd7 O-O e5 e4 exd4 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O g3 d6 Bg2 c5 O-O Nc6 h3 cxd4 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 Bf4 O-O Rc1 c6 e3 Be6 Qb3 Qb6 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 Bf4 O-O Rc1 dxc4 e3 Be6 Ng5 Bd5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 Qb3 dxc4 Qxc4 O-O Bf4 c6 e4 b5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 Qb3 dxc4 Qxc4 O-O e4 Na6 Be2 c5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 Qb3 dxc4 Qxc4 O-O e4 Na6 Be2 c5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 Qb3 dxc4 Qxc4 O-O e4 Na6 Bf4 c5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 Qb3 dxc4 Qxc4 O-O e4 c6 Qb3 e5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Be3 Qa5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 e3 O-O Qb3 e6 Be2 b6 cxd5 exd5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 e3 d6 Nc3 O-O Bd3 Nc6 O-O e5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 g3 O-O Bg2 d6 O-O Nbd7 Nc3 e5 e4 c6 ",
	"d4 Nf6 Nf3 g6 e3 Bg7 b3 d6 Bb2 O-O Bd3 Nbd7 O-O e5 Be2 Re8 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d5 Nbd2 a5 a4 Na6 Nb3 b6 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 Nc3 Nbd7 b3 e5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 Nc3 d5 Ne5 c6 e4 Be6 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 c3 Nbd7 Nbd2 e5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 c4 Nbd7 Qc2 e5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 c4 Nc6 Nc3 a6 Bg5 Rb8 ",
	"d4 Nf6 Nf3 g6 g3 b6 Bg2 Bb7 O-O Bg7 Nbd2 c5 c3 O-O Re1 d6 ",
	"d4 Nf6 Nf3 g6 h3 Bg7 Bf4 O-O Nbd2 c5 e3 b6 Bd3 Bb7 c3 d6 ",
	"d4 Nf6 c3 g6 Bg5 Bg7 Nd2 O-O e4 d6 f4 c5 dxc5 dxc5 Bc4 Nc6 ",
	"d4 Nf6 c4 b6 Nc3 Bb7 f3 d5 cxd5 Nxd5 Nxd5 Qxd5 e4 Qd7 Bc4 g6 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 Nc6 Nc3 g6 e4 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 a6 Nc3 e6 Bg5 Nc6 e3 Be7 Be2 Qa5 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 b6 Nc3 Bb7 Bg5 e6 e3 d6 Bh4 Be7 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e5 Nb5 d5 cxd5 Bc5 N5c3 O-O a3 a5 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e5 Nb5 d5 cxd5 Bc5 N5c3 O-O e3 e4 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e5 Nb5 d5 cxd5 Bc5 N5c3 O-O g3 Ng4 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 Nc3 Bb4 Bd2 Nc6 a3 Be7 Bf4 d6 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 Nc3 Bb4 Bd2 Nc6 e3 O-O Be2 d5 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 Nc3 Bb4 Nb5 O-O a3 Bxc3+ Nxc3 d5 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 Nc3 Bb4 Nc2 Bxc3+ bxc3 Qa5 Qd3 Nc6 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 Nc3 Bb4 e3 Ne4 Qc2 Nxc3 bxc3 Be7 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 Nc3 Bb4 g3 O-O Bg2 d5 cxd5 Nxd5 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 Nc3 d5 Bg5 e5 Nb3 d4 Nd5 Be7 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 g3 d5 Bg2 e5 Nf3 d4 O-O Nc6 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 g3 d5 Bg2 e5 Nf3 d4 O-O Nc6 ",
	"d4 Nf6 c4 c5 Nf3 e6 g3 cxd4 Nxd4 d5 Bg2 e5 Nf3 d4 O-O Nc6 ",
	"d4 Nf6 c4 c5 d5 b5 Bg5 Ne4 Bf4 Qa5+ Nd2 g5 b4 Qxb4 Rb1 Qc3 ",
	"d4 Nf6 c4 c5 d5 b5 Nd2 bxc4 e4 Qa5 Qc2 e6 Bxc4 exd5 exd5 d6 ",
	"d4 Nf6 c4 c5 d5 b5 Nf3 g6 cxb5 a6 Nc3 axb5 d6 Bg7 e4 O-O ",
	"d4 Nf6 c4 c5 d5 b5 Nf3 g6 cxb5 a6 bxa6 Bg7 Nc3 Bxa6 g3 d6 ",
	"d4 Nf6 c4 c5 d5 b5 Nf3 g6 cxb5 a6 e3 Bg7 Nc3 Bb7 a4 O-O ",
	"d4 Nf6 c4 c5 d5 b5 a4 b4 Nd2 g6 e4 d6 Ngf3 Bg7 g3 e6 ",
	"d4 Nf6 c4 c5 d5 b5 a4 b4 g3 Bb7 Bg2 e5 Nf3 d6 O-O g6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 Nc3 axb5 e4 Qa5 e5 Ne4 Bd2 Nxd2 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 Nc3 axb5 e4 b4 Nb5 d6 Bf4 g5 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 b6 Qxb6 Nc3 d6 Nf3 g6 g3 Bg7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 b6 Qxb6 Nc3 d6 e4 g6 Bc4 Bg7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 b6 Qxb6 Nc3 g6 e4 d6 a4 Bg7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 Bxa6 Nc3 d6 Nf3 g6 g3 Bg7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 Nc3 Bxa6 Nf3 d6 e4 Bxf1 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 Nc3 Bxa6 Nf3 d6 g3 Bg7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 Nc3 Bxa6 e4 Bxf1 Kxf1 d6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 Nc3 Bxa6 f4 Bg7 Nf3 Qa5 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 Nc3 Bxa6 g3 d6 Bg2 Bg7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 Nc3 Bxa6 g3 d6 Bg2 Nbd7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 g3 d6 Bg2 Bg7 Nc3 Bxa6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 Bb7 Nc3 Qa5 Bd2 axb5 Bxb5 Qb6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 Bb7 Nc3 Qa5 Bd2 axb5 Bxb5 Qb6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 Bb7 Nc3 Qa5 Bd2 axb5 Bxb5 Qb6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 Bb7 Nc3 Qa5 Bd2 axb5 Bxb5 Qb6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 Bb7 Nc3 Qa5 bxa6 Nxa6 Bd2 Qb6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 Bb7 Nc3 Qa5 bxa6 Nxa6 Bd2 Qb6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 f3 axb5 e4 Qa5+ Bd2 b4 Na3 d6 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 Nf3 Bg7 e4 O-O Be2 e5 dxe6 Bxe6 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 Be2 O-O Bg5 e6 Qd2 exd5 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 Bg5 O-O Qd2 a6 f3 e6 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 Bg5 h6 Bh4 g5 Bg3 Qa5 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 Nf3 O-O Be2 e6 O-O exd5 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Bf4 Bg7 Qa4+ Bd7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Bg5 Bg7 e3 h6 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Bg5 Bg7 e3 h6 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Nd2 Bg7 Nc4 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Nd2 Bg7 Nc4 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 e4 Bg7 Bd3 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 e4 Bg7 Be2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 e4 Bg7 Be2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 e4 Bg7 Bf4 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 e4 Bg7 Bg5 h6 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 g3 Bg7 Bg2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Bd3 Bg7 Nf3 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Bf4 Bg7 Qa4+ Bd7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Bf4 a6 Nf3 b5 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Bf4 a6 a4 Bg7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Bd3 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Bd3 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Be2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Be2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Bg5 a6 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 f4 Bg7 Nf3 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 g3 Bg7 Bg2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 g6 e4 d6 Be2 Bg7 f4 O-O ",
	"d4 Nf6 c4 c5 d5 e6 g3 exd5 cxd5 b5 a4 b4 b3 g6 Bg2 d6 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 Nf3 O-O e4 d6 Bf4 a6 a4 Qa5 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 O-O Bd3 d6 Nge2 e6 O-O exd5 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 O-O Bd3 e6 Nge2 exd5 cxd5 d6 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 O-O Bd3 e6 h3 exd5 exd5 Re8+ ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 O-O Nf3 d6 h3 a6 a4 e6 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 O-O Nge2 e6 Ng3 exd5 cxd5 d6 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Ne8 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Ne8 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e6 O-O exd5 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 g3 O-O Bg2 d6 Nf3 e6 O-O exd5 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 d6 e4 Bg7 Be2 O-O Bg5 b5 cxb5 a6 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 d6 e4 Bg7 f4 O-O Nf3 e6 Be2 exd5 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 d6 e4 Bg7 f4 O-O Nf3 e6 dxe6 fxe6 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 d6 e4 Bg7 h3 O-O Be3 e6 dxe6 Bxe6 ",
	"d4 Nf6 c4 c5 d5 g6 g3 Bg7 Bg2 O-O Nf3 Na6 O-O d6 Nc3 Nc7 ",
	"d4 Nf6 c4 c6 Nc3 d5 Nf3 dxc4 e3 b5 a4 b4 Na2 e6 Bxc4 Nbd7 ",
	"d4 Nf6 c4 c6 Nc3 d5 Nf3 e6 e3 Nbd7 Qc2 Bd6 Bd2 O-O O-O-O c5 ",
	"d4 Nf6 c4 c6 Nc3 d5 cxd5 cxd5 Nf3 Nc6 Bf4 e6 e3 Nh5 Bg5 Qb6 ",
	"d4 Nf6 c4 d6 Nc3 Bf5 f3 e5 e4 exd4 Qxd4 Be6 Nd5 Nc6 Qe3 Be7 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 Bg5 e5 e3 c6 Bd3 Qa5 Qd2 d5 dxe5 dxc4 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 Nf3 e5 e3 Be7 Bd3 O-O Qc2 Re8 O-O Bf8 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 Nf3 c6 Be2 Be7 O-O O-O b3 Re8 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 Nf3 g6 Be2 Bg7 O-O O-O Be3 c6 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 f4 exd4 Qxd4 Nc5 Be3 Qe7 Nd5 Nxd5 ",
	"d4 Nf6 c4 d6 Nc3 e5 Nf3 Nbd7 g3 g6 Bg2 Bg7 O-O O-O b3 Re8 ",
	"d4 Nf6 c4 d6 Nc3 e5 Nf3 Nbd7 g3 g6 Bg2 Bg7 O-O O-O b3 Re8 ",
	"d4 Nf6 c4 d6 Nc3 e5 Nf3 Nbd7 g3 g6 Bg2 Bg7 O-O O-O e4 c6 ",
	"d4 Nf6 c4 d6 Nc3 e5 d5 g6 e4 Bg7 f3 O-O Be3 Nh5 Qd2 f5 ",
	"d4 Nf6 c4 d6 Nc3 e5 dxe5 dxe5 Qxd8+ Kxd8 Bg5 c6 Nf3 Nd7 O-O-O Kc7 ",
	"d4 Nf6 c4 d6 Nc3 e5 dxe5 dxe5 Qxd8+ Kxd8 Bg5 c6 Nf3 Nd7 O-O-O Kc7 ",
	"d4 Nf6 c4 d6 Nc3 g6 e4 Bg7 f3 O-O Be3 a6 Qd2 c6 Bd3 e5 ",
	"d4 Nf6 c4 d6 Nc3 g6 e4 Bg7 f3 O-O Be3 e5 d5 Nh5 Qd2 Qh4+ ",
	"d4 Nf6 c4 d6 Nc3 g6 e4 Bg7 f3 c5 dxc5 dxc5 Qxd8+ Kxd8 Be3 Nfd7 ",
	"d4 Nf6 c4 d6 Nf3 Nbd7 Nc3 e5 e4 g6 Be3 Bg7 dxe5 dxe5 h3 c6 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 Bf4 Nc6 Nf3 Bb4+ Nc3 Qe7 Qd5 Bxc3+ bxc3 Qa3 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 Bf4 Nc6 Nf3 Bb4+ Nc3 Qe7 Qd5 Bxc3+ bxc3 Qa3 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 e4 h5 Nh3 Nxe5 Nc3 d6 Nf4 Nbc6 Be2 g6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Bg5 h6 Bh4 b6 Nf3 Bb7 e3 g5 Bg3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Bg5 h6 Bh4 c5 d5 b5 dxe6 fxe6 cxb5 d5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Bg5 h6 Bh4 c5 d5 d6 f3 O-O e4 Re8 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Bg5 h6 Bh4 c5 e3 cxd4 exd4 d5 Rc1 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 Qb3 Bxc3+ Qxc3 Bb7 g3 d6 Bg2 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 e3 Bb7 Bd3 Ne4 Qc2 f5 O-O Nxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 e3 Bb7 Bd3 O-O O-O d5 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 e3 Nc6 Bd3 Bxc3+ bxc3 d6 e4 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 e3 Nc6 Bd3 Bxc3+ bxc3 d6 e4 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 e3 Nc6 Bd3 Bxc3+ bxc3 d6 e4 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 e3 O-O Qc2 b6 Bd3 Bb7 O-O Bxf3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 g3 Bxc3+ bxc3 Qa5 Qd3 Ne4 Bd2 f5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 g3 Nc6 Bg2 Qa5 d5 Bxc3+ bxc3 Ne7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 g3 b6 Bg2 Bb7 d5 exd5 Nh4 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 g3 cxd4 Nxd4 O-O Bg2 d5 Qb3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 d5 Bg5 Nbd7 e3 c5 cxd5 exd5 Bd3 Qa5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 c5 Bd2 Nc6 dxc5 O-O e3 Bxc5 Be2 d5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 c5 dxc5 Nc6 Nf3 Qa5 Bd2 Qxc5 a3 Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 Nc6 Nf3 d5 a3 Bxc3+ bxc3 Na5 Ne5 Nd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 Nc6 Nf3 d5 e3 O-O a3 Bxc3+ Qxc3 Bd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O Bg5 h6 Bh4 Nc6 e3 Re8 Bd3 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O Bg5 h6 Bh4 c5 dxc5 Na6 a3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O Bg5 h6 Bh4 c5 dxc5 Na6 e3 Nxc5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O Bg5 h6 Bh4 c5 e3 cxd4 exd4 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O Nf3 c5 dxc5 Na6 a3 Bxc3+ Qxc3 Nxc5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O Nf3 c5 dxc5 Na6 g3 Nxc5 Bg2 Nce4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b6 Bg5 Bb7 Nf3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b6 Nf3 Bb7 e3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b6 Nf3 Bb7 g3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 d6 Bg5 Nbd7 e3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 d6 g3 Qe7 Bg2 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 b6 a3 Bxc3+ Qxc3 Bb7 Bg5 h6 Bh4 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 Nf3 Nc6 dxc5 Bxc5 Bg5 Be7 O-O-O Qa5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Na6 a3 Bxc3+ Qxc3 Nxc5 b4 Nce4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 O-O Bf4 Na6 Bd6 Re8 a3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 O-O Nf3 Na6 e3 Nxc5 Bd2 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 O-O a3 Bxc5 Nf3 Nc6 Bf4 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 e3 O-O a3 Bxc3+ Qxc3 Nc6 Bd3 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 Nf3 c5 cxd5 Qxd5 a3 Bxc3+ bxc3 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 Nf3 c5 cxd5 exd5 Bd2 cxd4 Nxd4 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 a3 Bxc3+ Qxc3 Nc6 Nf3 Ne4 Qb3 Na5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 a3 Bxc3+ Qxc3 Ne4 Qc2 c5 dxc5 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 Be6 Nf3 Nbd7 a3 Be7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 O-O e3 h6 Bf4 c5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bh4 c5 O-O-O Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bh4 c5 O-O-O Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bxf6 Qxf6 a3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bxf6 Qxf6 a3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Nf3 c5 Bg5 h6 Bxf6 Qxf6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qd3 c5 d5 O-O Bd2 exd5 cxd5 d6 g3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 Ne4 e3 f5 Qh5+ g6 Qh6 Qg5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 O-O Bg5 h6 Bh4 d5 e3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 O-O e3 b6 Bd3 Bb7 Ne2 Bxg2 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 e3 Nc6 Bd3 b6 Ne2 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 e3 Nc6 Bd3 e5 Ne2 e4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 e4 Qa5 e5 Ne4 Bd2 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 f3 d5 cxd5 Nxd5 Qd2 Qa5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 f3 d5 cxd5 Nxd5 dxc5 f5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 f3 d6 e4 Nc6 Ne2 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 d6 f3 O-O e4 e5 Be3 Qe7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 Nc6 Bd3 e5 Ne2 exd4 exd4 d5 c5 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Ne2 Nc6 a3 Bxc3+ bxc3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 Nc6 O-O Bxc3 bxc3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 Nc6 d5 exd5 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 b6 O-O Bb7 Na4 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 d5 O-O Nc6 a3 Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 d5 O-O dxc4 Bxc4 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 d5 O-O dxc4 Bxc4 Qe7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 d5 O-O dxc4 Bxc4 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 a3 Bxc3+ bxc3 Nc6 Ne2 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Ne2 c5 O-O Nc6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Ne2 c5 cxd5 exd5 O-O b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 Nc6 O-O dxc4 Bxc4 Bd6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 b6 O-O Bb7 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 b6 a3 Bxc3+ bxc3 Ba6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 c5 O-O Nbd7 Bd2 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 c5 O-O Nc6 a3 Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 c5 O-O dxc4 Bxc4 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 c5 O-O dxc4 Bxc4 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 cxd5 exd5 Ne2 c5 O-O Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Bd6 c5 Be7 b4 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 Nf4 b6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 Nf4 c6 Bd3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 Ng3 b6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 Ng3 c5 dxc5 Bxc5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 cxd5 Nxd5 Qc2 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 cxd5 exd5 g3 a5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 cxd5 exd5 g3 c6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 cxd5 exd5 g3 c6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Nf3 c5 Bd3 d5 O-O cxd4 exd4 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Nf3 c5 Be2 d5 O-O Nbd7 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Nf3 c5 Be2 d5 O-O cxd4 exd4 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Nf3 c5 Be2 d5 O-O cxd4 exd4 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 Ne4 Qc2 f5 O-O Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 O-O O-O c5 dxc5 Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 O-O O-O d5 a3 Bd6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 O-O O-O d5 a3 Bd6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 O-O O-O d5 a3 Bd6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 f3 c5 Ne2 cxd4 exd4 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 f3 c5 a3 Bxc3+ bxc3 d5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 Ng3 Bxc3+ bxc3 d5 Qf3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 Ng3 Bxc3+ bxc3 d5 Qf3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 Ng3 O-O e4 Nc6 Bd3 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 a3 Be7 Nf4 d5 cxd5 Bxf1 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 a3 Be7 Ng3 d5 cxd5 Bxf1 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 a3 Bxc3+ Nxc3 d5 b3 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 a3 Bxc3+ Nxc3 d5 b3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 a3 Bxc3+ Nxc3 d5 b4 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Bb7 a3 Be7 d5 O-O g3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ne4 Bd2 Nxd2 Qxd2 Bb7 a3 Be7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ne4 Bd2 Nxd2 Qxd2 O-O a3 Be7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ne4 Qc2 f5 f3 Nxc3 bxc3 Bd6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Nf3 Bb7 Bd3 O-O Qc2 d5 O-O dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 Nc6 Ne2 cxd4 exd4 d5 O-O dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 Nc6 Ne2 d5 cxd5 Nxd5 O-O cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 Nc6 Nf3 Bxc3+ bxc3 d6 O-O e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 Nc6 Nf3 Bxc3+ bxc3 d6 e4 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 Nc6 Nf3 Bxc3+ bxc3 d6 e4 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 Nc6 Nf3 d5 O-O O-O a3 Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 d5 O-O Nbd7 a3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 d5 O-O Nbd7 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 d5 O-O dxc4 Bxc4 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 d5 O-O dxc4 Bxc4 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 d5 O-O dxc4 Bxc4 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 d5 Nf3 O-O O-O b6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 cxd4 exd4 d5 a3 Be7 c5 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Nf3 Nc6 d5 Ne7 dxe6 Bxc3+ bxc3 dxe6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Nf3 b6 Bd3 Bb7 O-O O-O Na4 Qe7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Nf3 b6 Be2 Bb7 O-O O-O Na4 Qe7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 Nf3 O-O Bd3 c5 O-O Nc6 a3 Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 a3 Be7 Nf3 O-O Bd3 b6 O-O c5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 c5 d5 d6 Bd2 O-O e4 Re8 Nge2 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 a3 Bxc3+ bxc3 b6 cxd5 exd5 e3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 a3 Bxc3+ bxc3 c5 cxd5 Nxd5 Qd3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 a3 Bxc3+ bxc3 c5 cxd5 Nxd5 dxc5 Qa5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 g3 O-O Nf3 b6 Bg2 Bb7 O-O Bxc3 bxc3 d6 ",
	"d4 Nf6 c4 e6 Nc3 b6 e4 Bb4 Bd3 Bb7 Qe2 c5 d5 O-O Be3 exd5 ",
	"d4 Nf6 c4 e6 Nc3 b6 e4 Bb7 e5 Ne4 Qc2 Nxc3 bxc3 d6 Nf3 Nd7 ",
	"d4 Nf6 c4 e6 Nc3 c5 Nf3 a6 e3 d5 cxd5 exd5 Be2 Nc6 dxc5 Bxc5 ",
	"d4 Nf6 c4 e6 Nc3 c5 Nf3 d5 cxd5 cxd4 Qa4+ Bd7 Qxd4 exd5 Bg5 Be7 ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 Nf3 g6 Bf4 Bg7 Qa4+ Bd7 ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 Nf3 g6 Nd2 Bg7 Nc4 O-O ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 Nf3 g6 e4 Bg7 Be2 O-O ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 Nf3 g6 g3 Bg7 Bg2 O-O ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 e4 g6 Be2 Bg7 Nf3 O-O ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Be2 O-O ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 g6 e4 d6 Bd3 Bg7 Nge2 O-O ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 g6 e4 d6 Bd3 Bg7 Nge2 O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 Bxf6 Bxf6 cxd5 exd5 e3 O-O Bd3 c5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Nf3 Nbd7 Rc1 c6 Bd3 h6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Nf3 h6 Bh4 b6 Bd3 Bb7 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Rc1 Nbd7 Nf3 c6 Bd3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O cxd5 Nxd5 Bxe7 Qxe7 Nf3 Nxc3 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 Nf3 c6 Qb3 Be7 e3 O-O Be2 b6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 cxd5 exd5 e3 c6 Bd3 Be7 Qc2 O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 Be7 Nf3 O-O Qc2 b6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 c6 a3 Be7 Nf3 h6 Bh4 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 c6 a3 Be7 Qc2 O-O Nf3 Re8 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 c5 cxd5 cxd4 Qxd4 Be7 e4 Nc6 Qe3 Nb4 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 c5 cxd5 cxd4 Qxd4 Be7 e4 Nc6 Qe3 Nb4 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 Be7 g3 O-O Bg2 dxc4 O-O Nbd7 e4 c6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 c5 cxd5 cxd4 Qxd4 exd5 e4 Nc6 Bb5 Nxe4 ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 Nxd5 Nf3 c5 e3 Nc6 Bd3 Be7 O-O O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Nf3 cxd4 cxd4 Bb4+ ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Nf3 cxd4 cxd4 Bb4+ ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Nf3 cxd4 cxd4 Bb4+ ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 Be7 e3 c6 Bd3 Bg4 Qc2 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 d5 e3 b6 Nf3 Bb7 cxd5 exd5 Bd3 Bd6 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Bxd2+ Qxd2 Ne4 Qc2 f5 g3 Qe7 Bg2 O-O ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Qe7 g3 Nc6 Bg2 Bxd2+ Nbxd2 O-O O-O d6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 a5 Nc3 O-O e3 d6 Qc2 Nbd7 a3 Bxc3 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 a5 g3 b6 Bg2 Bb7 O-O O-O Bf4 Be7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 a3 bxa3 Rxa3 O-O e3 b6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 g3 O-O Bg2 d6 O-O Nc6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 g3 O-O Bg2 d6 O-O Nc6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 b6 a3 Bxd2+ Bxd2 Bb7 Bg5 h6 Bh4 d6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 b6 e3 Bb7 Bd3 O-O O-O d5 a3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 d5 a3 Be7 Qc2 b6 e4 dxe4 Nxe4 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nc3 c5 e3 O-O Bd3 d5 O-O dxc4 Bxc4 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Bf4 Bb7 Nc3 Bb4 Qb3 a5 e3 Ne4 Bd3 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Bg5 Bb7 e3 h6 Bh4 Bb4+ Nfd2 Be7 Nc3 O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Bg5 Bb7 e3 h6 Bh4 Bxc3+ bxc3 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Qc2 Bb7 a3 Bxc3+ Qxc3 O-O e3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 e3 Bb7 Bd3 c5 O-O O-O Bd2 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 Bb4 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 Be7 e3 Ne4 Bxe7 Qxe7 Nxe4 Bxe4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 h6 Bh4 Be7 Qc2 c5 Rd1 Bxf3 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 h6 Bh4 Be7 e3 Ne4 Bxe7 Qxe7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 h6 Bh4 g5 Bg3 Nh5 e3 Nxg3 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 Nxc3 Qxc3 h6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 Nxc3 bxc3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 c5 dxc5 Bxc5 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 c5 e4 Nxc3 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 e3 Nd7 Bd3 c5 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 e3 g6 Bb5+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 e3 g6 Bb5+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 Bg5 Be7 Bxf6 Bxf6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 Bd2 Be7 Qc2 O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 e3 Be7 Bb5+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 e3 Be7 Bb5+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 e3 Be7 Bb5+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 exd5 Bf4 Bd6 Bg3 a6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 e3 Nbd7 cxd5 exd5 Be2 Bd6 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 Be7 O-O O-O Nc3 d5 b3 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 Be7 O-O c5 Nbd2 Nc6 a3 cxd4 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 d5 O-O Bd6 b3 O-O Bb2 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 d5 b3 Bd6 O-O O-O Bb2 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Nc3 d5 Bd3 Be7 O-O O-O Qe2 c5 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Nc3 d5 cxd5 exd5 Bb5+ c6 Bd3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Nc3 d5 cxd5 exd5 Bb5+ c6 Bd3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 Nbd2 Bb7 Bg2 Be7 O-O O-O Qc2 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Bg2 O-O O-O d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Bg2 c6 Bc3 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 c5 dxc5 Bxc5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Bd2 Bxd2+ Nbxd2 O-O O-O c5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Bd2 Bxd2+ Qxd2 O-O O-O d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Bd2 Bxd2+ Qxd2 d6 Nc3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Bd2 Qe7 O-O Bxd2 Qxd2 O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Bd2 c5 Bxb4 cxb4 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Bd2 c5 O-O O-O d5 Bxd2 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Nbd2 O-O O-O Nc6 Qc2 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Nbd2 O-O O-O d5 a3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Nbd2 c5 O-O cxd4 Qa4 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 Nc3 Ne4 Bd2 Bf6 Rc1 Bxd4 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 Nc3 Ne4 Nxe4 Bxe4 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 Ne4 Qc2 Nxc3 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 Ne4 Qc2 Nxc3 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 Ne4 Qc2 Nxc3 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 d5 Ne5 Qc8 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 d5 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 c5 d5 exd5 Nh4 g6 Nc3 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 c5 dxc5 Bxc5 Nc3 Ne4 Nxe4 Bxe4 ",
	"d4 Nf6 c4 e6 Nf3 c5 Nc3 cxd4 Nxd4 Bb4 Bd2 Nc6 Nc2 Bc5 e3 d5 ",
	"d4 Nf6 c4 e6 Nf3 c5 Nc3 cxd4 Nxd4 Bb4 Bd2 O-O e3 Nc6 Be2 d5 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 b5 Bg5 h6 Bxf6 Qxf6 Nc3 b4 Nb5 Kd8 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Bf4 a6 e4 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Nd2 Nbd7 e4 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 e4 Bg7 Be2 O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 e4 Bg7 Bg5 h6 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 e4 Bg7 Nd2 O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 g3 Bg7 Bg2 O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 g6 Nc3 Bg7 Bf4 a6 e4 O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 g6 Nc3 Bg7 e4 d6 Be2 O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 e3 b6 Nc3 cxd4 exd4 Bb7 Be2 Bb4 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 e3 d5 a3 cxd4 exd4 Be7 Nc3 O-O Bf4 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 c5 e3 d5 a3 cxd4 exd4 Be7 Nc3 O-O Bf4 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Be7 Nc3 O-O e3 Nbd7 Rc1 a6 a3 dxc4 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Be7 e3 h6 Bh4 O-O cxd5 Nxd5 Bxe7 Qxe7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Nbd7 Nc3 c6 e3 Qa5 Qb3 Ne4 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 h6 Bxf6 Qxf6 Nc3 c6 Qb3 Nd7 e3 Bd6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 Bg5 h6 Bxf6 Qxf6 cxd5 exd5 Rc1 O-O ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 cxd5 exd5 Bg5 h6 Bh4 c5 e3 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 cxd5 exd5 Bg5 h6 Bh4 c5 e3 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 cxd5 exd5 Bg5 h6 Bh4 c5 e3 O-O ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Qc2 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Qc2 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Qc2 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 Nbd7 e3 h6 Bh4 O-O Rc1 dxc4 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O Rc1 b6 cxd5 exd5 e3 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 h6 Bh4 b6 Be2 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 h6 Bh4 b6 Bxf6 Bxf6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 h6 Bh4 b6 Rc1 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bh4 O-O e3 b6 Rc1 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bh4 O-O e3 b6 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c5 cxd5 cxd4 Qxd4 exd5 Bg5 Be7 e3 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c5 e3 Nc6 a3 Ne4 Qc2 Nxc3 bxc3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c5 e3 Nc6 a3 Ne4 Qc2 Nxc3 bxc3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 Bg5 Nbd7 cxd5 exd5 e3 Be7 Bd3 O-O ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 Bg5 h6 Bxf6 Qxf6 Qb3 Nd7 g3 Qe7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 Bg5 h6 Bxf6 Qxf6 e3 Nd7 Bd3 Bb4 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 cxd5 cxd5 Bf4 Nc6 e3 Nh5 Bg5 Qb6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 cxd5 cxd5 Bf4 Nc6 e3 Nh5 Bg5 Qb6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 e3 Nbd7 Bd3 Bb4 a3 Ba5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 e3 Nbd7 Be2 Be7 O-O O-O Qc2 b6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 e3 Nbd7 Be2 Be7 O-O O-O Qc2 b6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 e3 Nbd7 Qc2 Bd6 b3 O-O Be2 e5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 dxc4 e3 a6 a4 c5 Bxc4 Nc6 O-O Be7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 dxc4 e3 c5 Bxc4 a6 dxc5 Qxd1+ Kxd1 Bxc5 ",
	"d4 Nf6 c4 e6 Nf3 d5 e3 Be7 Bd3 O-O O-O dxc4 Bxc4 c5 Qe2 cxd4 ",
	"d4 Nf6 c4 e6 Nf3 d5 g3 Be7 Bg2 O-O O-O Nbd7 Qc2 c6 b3 b6 ",
	"d4 Nf6 c4 e6 Nf3 d5 g3 Be7 Bg2 O-O O-O dxc4 Qc2 a6 a4 c5 ",
	"d4 Nf6 c4 e6 Nf3 d5 g3 dxc4 Bg2 b5 a4 c6 O-O Bb7 Nc3 a6 ",
	"d4 Nf6 c4 e6 e3 b6 Nf3 Bb7 Be2 d5 b3 Nbd7 Bb2 Bd6 Nbd2 O-O ",
	"d4 Nf6 c4 e6 g3 Bb4+ Bd2 Be7 Bg2 d5 Nf3 O-O O-O c6 Qc2 Nbd7 ",
	"d4 Nf6 c4 e6 g3 Bb4+ Bd2 Qe7 Bg2 Nc6 Nf3 Bxd2+ Nbxd2 d6 O-O O-O ",
	"d4 Nf6 c4 e6 g3 Bb4+ Bd2 Qe7 Bg2 Nc6 e3 O-O Ne2 e5 O-O exd4 ",
	"d4 Nf6 c4 e6 g3 Bb4+ Nd2 d5 Bg2 O-O Nf3 b6 O-O Bb7 Ne5 Be7 ",
	"d4 Nf6 c4 e6 g3 c5 Nf3 cxd4 Nxd4 d5 Bg2 e5 Nb3 d4 e3 a5 ",
	"d4 Nf6 c4 e6 g3 c5 Nf3 cxd4 Nxd4 d5 Bg2 e5 Nb3 d4 e3 a5 ",
	"d4 Nf6 c4 e6 g3 c5 d5 exd5 cxd5 b5 a4 b4 f3 g6 e4 Bg7 ",
	"d4 Nf6 c4 e6 g3 c5 d5 exd5 cxd5 d6 Bg2 g6 Nf3 Bg7 Nc3 O-O ",
	"d4 Nf6 c4 e6 g3 c5 d5 exd5 cxd5 d6 Nc3 g6 Bg2 Bg7 Nf3 O-O ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 Bd7 Nbd2 Bb4 Qc2 Bb5 O-O Nc6 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 Bd7 Ne5 Bc6 Nxc6 Nxc6 O-O Qd7 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 Nbd7 O-O c6 a4 b5 axb5 cxb5 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 Nc6 Qa4 Bb4+ Bd2 Nd5 Bxb4 Nxb4 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 a6 O-O b5 Ne5 Nd5 Nc3 Bb7 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 b5 Ne5 Nd5 O-O Bb7 e4 Nf6 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 c5 O-O Nc6 Qa4 Bd7 Qxc4 cxd4 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Qa4+ Bd7 Qxc4 Bc6 Nf3 Bd5 Qd3 c5 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Qa4+ Bd7 Qxc4 Bc6 Nf3 Be7 Nc3 O-O ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Qa4+ Bd7 Qxc4 Bc6 Nf3 Nbd7 Nc3 Nb6 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Qa4+ Bd7 Qxc4 Bc6 Nf3 Nbd7 Nc3 Nb6 ",
	"d4 Nf6 c4 e6 g3 d5 Nf3 Be7 Bg2 O-O O-O dxc4 Na3 Bxa3 bxa3 b5 ",
	"d4 Nf6 c4 e6 g3 d5 Nf3 dxc4 Bg2 Bd7 Ne5 Bc6 Nxc6 Nxc6 Qa4 Qd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Bf4 d6 Qd2 Nbd7 Rd1 c5 d5 Nh5 Bh6 Bxh6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 O-O Bf4 c5 d5 d6 e4 Qa5 Bd3 Bg4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 O-O e3 c5 Be2 cxd4 exd4 d5 O-O Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 O-O e3 c5 Be2 cxd4 exd4 d5 c5 b6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 O-O e3 d5 cxd5 Nxd5 Nxd5 Qxd5 Qc2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 O-O e3 d6 Be2 Nbd7 O-O e5 b4 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 O-O e4 d6 h3 e5 Be3 Qe7 d5 b6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 O-O g3 d5 cxd5 Nxd5 Bg2 c5 e3 cxd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 O-O g3 d6 Bg2 c6 O-O Nbd7 b3 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 d6 Bf4 Nh5 Qd2 Nxf4 Qxf4 Nd7 Ng5 O-O ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Be2 d6 f4 c5 Nf3 cxd4 Nxd4 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Be3 d6 Be2 e5 dxe5 dxe5 Qc2 Ng4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Bg5 d6 Qd2 c5 d5 e6 Bd3 exd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Nf3 d6 Be2 e5 dxe5 dxe5 Qxd8 Rxd8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Nge2 d6 g3 e5 Bg2 exd4 Nxd4 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O e5 Ne8 f4 d6 Be3 c5 dxc5 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O e5 Ne8 f4 d6 Nf3 dxe5 fxe5 Bg4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 a6 Qd2 b5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 b5 cxb5 a6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 e6 Nf3 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 e6 Nf3 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 e6 Nf3 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 e6 Nf3 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 e6 Nf3 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 e6 Qd2 exd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 h6 Be3 e6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 Be3 Ng4 Bg5 f6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 Be3 Qe7 d5 Na6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 Be3 c6 Qd2 exd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 Be3 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 Be3 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 d5 Na6 Nd2 c5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 d5 a5 Be3 Ng4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O f4 c5 Nf3 cxd4 Nxd4 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Bg5 Nbd7 f4 O-O Nf3 c5 d5 b5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Bd3 Bg4 O-O Nc6 Be3 Nd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Bd3 e5 d5 a5 h3 Na6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 Nbd7 Bg5 h6 Bh4 g5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 Nbd7 O-O e5 b3 exd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 Nbd7 O-O e5 h3 c6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 c5 d5 e6 Nd2 exd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 Qe7 d5 Ne8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 c6 dxe5 dxe5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Na6 Be3 c6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 d5 Nbd7 Bg5 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 d5 Nbd7 O-O Nc5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 d5 Nh5 g3 Nd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 dxe5 dxe5 Qxd8 Rxd8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 Nbd7 Be3 e5 Nge2 a6 Qd2 O-O ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 Nbd7 Be3 e5 d5 a5 Bd3 Nc5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 Nc6 Be3 a6 Nge2 Rb8 Qd2 O-O ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 Nc6 Be3 a6 Qd2 Rb8 Rb1 O-O ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nbd7 Qd2 c5 Nge2 a6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Nge2 Rb8 Qd2 a6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Nge2 a6 Qd2 Rb8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Nge2 a6 g4 Rb8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Nge2 a6 h4 h5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Qd2 a6 Nge2 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 a6 Bd3 c5 dxc5 dxc5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 a6 Qd2 c6 O-O-O b5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 b6 Bd3 Bb7 Nge2 c5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 b6 Bd3 a6 Qd2 c5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 c6 Bd3 a6 Nge2 b5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 Nge2 c6 Qd2 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 Nge2 c6 Qd2 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Nh5 Qd2 f5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Nh5 Qd2 f5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c5 g4 Ne8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Qd2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Qd2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Qd2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Qd2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Bg5 a6 Qd2 Nc6 Rd1 Rb8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Nge2 c5 Be3 Nbd7 Qd2 a6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Nge2 c6 Be3 a6 d5 c5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Nge2 c6 Be3 e5 Qd2 exd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Nge2 c6 Be3 e5 Qd2 exd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 c5 dxc5 dxc5 Qxd8+ Kxd8 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 c6 Be3 a6 Bd3 O-O Nge2 b5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 c6 Be3 a6 Qd2 b5 Bd3 bxc4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 Nge2 Nfd7 Be3 Bh6 Qd2 Bxe3 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 Nge2 O-O Be3 c6 Qd2 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 Nge2 O-O Be3 c6 Qd2 exd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 Nge2 O-O Bg5 c6 Qd2 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 Nge2 O-O Bg5 c6 Qd2 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f4 O-O Nf3 c5 d5 e6 Be2 exd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f4 O-O Nf3 c5 d5 e6 Be2 exd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f4 O-O Nf3 c5 d5 e6 dxe6 Bxe6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f4 O-O Nf3 c5 d5 e6 dxe6 fxe6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f4 c5 d5 O-O Nf3 e6 Be2 exd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 h3 O-O Be3 e5 d5 Nh5 Be2 f5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 h3 c6 Be3 a6 Nf3 b5 e5 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 g3 O-O Bg2 d6 Nf3 Nbd7 O-O e5 e4 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 g3 O-O Bg2 d6 Nf3 Nbd7 O-O e5 h3 Re8 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 Nf3 O-O Rc1 dxc4 e4 c5 dxc5 Na6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 O-O Qb3 c5 cxd5 cxd4 exd4 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 O-O Rc1 c5 dxc5 Be6 Nf3 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 O-O Rc1 c5 dxc5 Be6 Nf3 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 O-O Rc1 c5 dxc5 Qa5 cxd5 Rd8 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 c5 dxc5 Qa5 Qa4+ Qxa4 Nxa4 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 c6 Nf3 O-O Bd3 dxc4 Bxc4 Nd5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bg5 Ne4 Bh4 Nxc3 bxc3 dxc4 e3 Be6 Rb1 b6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bg5 Ne4 Bh4 c6 e3 Bg7 Nf3 O-O Bd3 Nxc3 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bf4 O-O Rc1 dxc4 e3 Be6 Ng5 Bd5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bf4 O-O Rc1 dxc4 e4 Bg4 Bxc4 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bf4 O-O e3 c5 dxc5 Ne4 Qb3 Na6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bf4 O-O e3 c5 dxc5 Qa5 Rc1 Ne4 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bg5 Ne4 Bh4 Nxc3 bxc3 dxc4 e3 b5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qa4+ Bd7 Qb3 dxc4 Qxc4 O-O e4 b5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Na6 Be2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Na6 Be2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Na6 Be2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 a6 Be2 b5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 a6 Qb3 b5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 a6 Qb3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 cxd5 Nxd5 Qb3 Nxc3 bxc3 O-O e3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Be3 Bg4 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Rb1 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Rb1 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 e3 O-O Be2 dxc4 Bxc4 Nfd7 O-O Nb6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 e3 O-O Be2 e6 O-O b6 a4 a5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 e3 O-O Be2 e6 O-O c6 cxd5 exd5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 e3 O-O b4 b6 Bb2 c5 bxc5 bxc5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 e3 O-O cxd5 Nxd5 Bc4 Nb6 Bb3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 Nc6 a4 Na5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 Qd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 Qd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 cxd4 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Be3 c5 Bc4 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Be3 c5 Qd2 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Be3 c5 Qd2 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Nf3 O-O Be2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Nf3 c5 Rb1 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Bb5+ Bd7 Bxd7+ Qxd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Bc4 Bg7 Ne2 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Bc4 Bg7 Ne2 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Bc4 Bg7 Ne2 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Bc4 Bg7 Ne2 cxd4 ",
	"d4 Nf6 c4 g6 Nc3 d5 e3 Bg7 Nf3 O-O b4 c6 Qb3 dxc4 Bxc4 b5 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 c6 O-O d5 Nbd2 Ne4 Qb3 Nxd2 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d5 cxd5 Nxd5 O-O Nb6 Nc3 a5 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d6 O-O Nbd7 Nc3 e5 Qc2 c6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d6 O-O Nc6 d5 Na5 Nfd2 c5 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 c5 Bg2 cxd4 Nxd4 O-O Nc3 Nc6 O-O Nxd4 ",
	"d4 Nf6 c4 g6 d5 d6 Nc3 Bg7 e4 c6 Nf3 Bg4 Be2 Nbd7 Be3 O-O ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nbd7 O-O e5 e4 Re8 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nbd7 O-O e5 e4 c6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nbd7 O-O e5 e4 c6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nbd7 O-O e5 e4 c6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nbd7 O-O e5 e4 c6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nbd7 O-O e5 e4 c6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nbd7 O-O e5 h3 c6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nc6 O-O e5 d5 Ne7 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nc6 O-O e5 d5 Ne7 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 e3 Nbd7 Nge2 e5 b3 Re8 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 e3 Nbd7 Nge2 e5 b3 Re8 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nf3 d6 O-O Nbd7 Nc3 e5 e4 c6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nf3 d6 O-O Nc6 Nc3 Bf5 d5 Na5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nf3 d6 O-O Nc6 Nc3 e5 dxe5 Nxe5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O e4 d6 Ne2 e5 O-O Nbd7 Nbc3 c6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 c5 d5 O-O Nf3 e6 Nc3 exd5 cxd5 d6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 c5 d5 d6 Nc3 O-O Nf3 e6 O-O exd5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 c5 d5 d6 Nc3 O-O Nf3 e6 O-O exd5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 e4 Nb6 Ne2 c5 d5 e6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 e4 Nb6 Ne2 e5 Be3 exd4 ",
	"d4 Nf6 c4 g6 g3 Bg7 Nf3 O-O Bg2 d6 Nc3 Nc6 O-O Bf5 Ne1 Qc8 ",
	"d4 Nf6 c4 g6 g3 c5 d5 d6 Bg2 Bg7 Nh3 b5 cxb5 Qa5+ Bd2 Qxb5 ",
	"d4 Nf6 c4 g6 g3 c6 Bg2 d5 Nf3 Bg7 cxd5 cxd5 Nc3 O-O Ne5 e6 ",
	"d4 Nf6 c4 g6 g3 c6 Bg2 d5 cxd5 cxd5 Nc3 Bg7 e3 O-O Nge2 Nc6 ",
	"d4 Nf6 c4 g6 g3 d5 cxd5 Qxd5 Nf3 Bg7 Nc3 Qh5 Qb3 O-O Bf4 c5 ",
	"d4 Nf6 e3 e6 Bd3 Be7 f4 c5 c3 b6 Nf3 O-O O-O Ba6 Bxa6 Nxa6 ",
	"d4 Nf6 g3 c5 d5 e6 c4 exd5 cxd5 d6 Bg2 g6 b3 Bg7 Bb2 O-O ",
	"d4 Nf6 g3 d5 Bg2 Bf5 c4 c6 cxd5 cxd5 Nc3 Nc6 Nf3 e6 O-O Be7 ",
	"d4 Nf6 g3 d5 c4 c6 Bg2 Bf5 Qb3 Qb6 Nc3 e6 c5 Qxb3 axb3 e5 ",
	"d4 b6 e4 Bb7 Bd3 e6 Nf3 c5 c3 Nf6 Qe2 cxd4 cxd4 Nc6 a3 Be7 ",
	"d4 c5 d5 d6 c4 g6 e4 Bg7 Bd3 e6 Nc3 Ne7 Nge2 exd5 exd5 Nd7 ",
	"d4 c5 d5 d6 e4 g6 Nf3 Bg7 Be2 Na6 O-O Nc7 Nc3 f5 Bd3 fxe4 ",
	"d4 c5 e3 Nf6 c4 g6 Nc3 Bg7 g3 cxd4 exd4 d5 cxd5 Nxd5 Bg2 Be6 ",
	"d4 c5 e3 Nf6 c4 g6 Nf3 Bg7 Be2 O-O dxc5 Na6 O-O Nxc5 Nc3 b6 ",
	"d4 c6 c4 d5 Nc3 Nf6 Nf3 e6 cxd5 exd5 Qc2 Be7 Bg5 g6 e4 dxe4 ",
	"d4 d5 Bf4 Nf6 e3 Bg4 Be2 Bxe2 Qxe2 c6 Nd2 e6 c3 Nbd7 e4 Nxe4 ",
	"d4 d5 Nc3 Nf6 g3 Bf5 Bg2 e6 a3 c5 e3 Nc6 Nge2 Rc8 O-O Be7 ",
	"d4 d5 Nf3 Bg4 c4 Bxf3 gxf3 Nc6 Nc3 e6 e3 Bb4 cxd5 Qxd5 Bd2 Bxc3 ",
	"d4 d5 Nf3 Nf6 Bf4 e6 e3 c5 c3 Nc6 Nbd2 Qb6 Qb3 Bd7 Qxb6 axb6 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 Ne4 e3 e6 Bd3 f5 Ne5 Qh4 Bxe4 fxe4 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 Qb6 Qc2 Bg4 e3 e6 Bd2 Nbd7 Bd3 Be7 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 dxc4 a4 Bf5 e3 Na6 Bxc4 Nb4 O-O e6 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 dxc4 e3 b5 Be2 Nd5 O-O e6 e4 Nxc3 ",
	"d4 d5 Nf3 Nf6 c4 c6 e3 e6 Bd3 Nbd7 O-O Bd6 Nc3 dxc4 Bxc4 O-O ",
	"d4 d5 Nf3 Nf6 c4 dxc4 Nc3 Bf5 e3 e6 Bxc4 Nbd7 O-O Be7 Re1 O-O ",
	"d4 d5 Nf3 Nf6 c4 dxc4 Nc3 a6 e3 e6 Bxc4 b5 Bd3 Bb7 O-O Nbd7 ",
	"d4 d5 Nf3 Nf6 c4 dxc4 e3 a6 Bxc4 b5 Bd3 Bb7 O-O Nbd7 Qe2 c5 ",
	"d4 d5 Nf3 Nf6 c4 dxc4 e3 e6 Bxc4 c5 O-O Nc6 Qe2 a6 Nc3 Qc7 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 dxc4 e3 c5 Nc3 a6 a4 cxd4 exd4 Bb4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Be2 dxc4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Be2 dxc4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Be7 Bg5 Nbd7 e3 O-O Rc1 b6 cxd5 exd5 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bg5 Bb4 e3 c5 Bd3 Qa5 Qb3 Ne4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bg5 Be7 e3 O-O Rc1 c6 Qc2 dxc4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bg5 c6 e3 Qa5 Nd2 dxc4 Bxf6 Nxf6 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 c5 Bg5 cxd4 Qxd4 Be7 cxd5 exd5 e3 Nc6 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 b4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 dxc4 e3 a6 Bxc4 b5 Bd3 Bb7 a4 b4 ",
	"d4 d5 Nf3 Nf6 c4 e6 cxd5 exd5 Nc3 c6 Qc2 Na6 a3 Nc7 Bg5 g6 ",
	"d4 d5 Nf3 Nf6 c4 e6 cxd5 exd5 Nc3 c6 Qc2 Na6 a3 Nc7 Bg5 g6 ",
	"d4 d5 Nf3 Nf6 c4 e6 e3 c5 Nc3 Nc6 a3 dxc4 Bxc4 a6 O-O b5 ",
	"d4 d5 Nf3 Nf6 e3 c5 c4 e6 Bd3 Nc6 O-O a6 Nc3 dxc4 Bxc4 b5 ",
	"d4 d5 Nf3 Nf6 e3 e6 Bd3 Nbd7 Nbd2 Bd6 e4 dxe4 Nxe4 b6 O-O Bb7 ",
	"d4 d5 Nf3 Nf6 e3 e6 Bd3 c5 c3 Nbd7 Nbd2 Qc7 O-O Be7 Re1 O-O ",
	"d4 d5 Nf3 Nf6 e3 e6 Bd3 c5 c3 Nc6 Nbd2 Be7 O-O O-O e4 dxe4 ",
	"d4 d5 Nf3 Nf6 e3 e6 c4 Nbd7 Nc3 c6 Bd3 Bd6 O-O O-O e4 dxc4 ",
	"d4 d5 Nf3 c5 c4 dxc4 dxc5 Qxd1+ Kxd1 Nc6 e3 Bg4 Bxc4 e6 a3 Bxc5 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 Nc3 Be6 g3 Nf6 Bg2 Nc6 O-O c4 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 Nc3 O-O ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 dxc5 Bxc5 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 g3 Nf6 Bg2 Be7 O-O O-O Nc3 Nc6 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 g3 Nf6 Bg2 Be7 O-O O-O Nc3 Nc6 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 g3 Nf6 Bg2 Be7 O-O O-O Nc3 Nc6 ",
	"d4 d5 Nf3 c5 c4 e6 e3 Nc6 Bd3 Nf6 O-O Bd6 b3 O-O Bb2 b6 ",
	"d4 d5 Nf3 c5 c4 e6 e3 Nc6 Nc3 Nf6 Bd3 Bd6 a3 O-O O-O Qe7 ",
	"d4 d5 Nf3 c5 c4 e6 e3 Nf6 Bd3 Nc6 O-O dxc4 Bxc4 a6 Nc3 b5 ",
	"d4 d5 Nf3 c5 dxc5 Nf6 Nc3 Nc6 a3 d4 Na4 e5 b4 e4 Ng1 b5 ",
	"d4 d5 Nf3 c5 dxc5 e6 e4 Bxc5 exd5 exd5 Bb5+ Nc6 O-O Ne7 Nbd2 O-O ",
	"d4 d5 Nf3 c5 e3 e6 c3 Nf6 Nbd2 Nc6 Bd3 Bd6 O-O O-O dxc5 Bxc5 ",
	"d4 d5 Nf3 c6 c4 e6 Nc3 dxc4 e3 b5 a4 Qb6 axb5 cxb5 Ne5 Bb7 ",
	"d4 d5 Nf3 c6 e3 Bg4 c4 e6 Nc3 Nd7 Bd3 Ngf6 O-O Be7 b3 O-O ",
	"d4 d5 Nf3 e6 c4 c5 cxd5 exd5 Nc3 Nc6 Bf4 cxd4 Nxd4 Bb4 e3 Nf6 ",
	"d4 d5 Nf3 e6 c4 c5 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 dxc5 Bxc5 ",
	"d4 d5 Nf3 e6 c4 c6 Nbd2 Nf6 g3 c5 cxd5 Nxd5 dxc5 Bxc5 Bg2 Bxf2+ ",
	"d4 d5 Nf3 e6 e3 Nf6 Bd3 c5 b3 Nc6 O-O Qc7 Bb2 Bd6 Nbd2 O-O ",
	"d4 d5 Nf3 e6 e3 Nf6 Nbd2 c5 Be2 Nc6 O-O Qb6 c3 Be7 Bd3 O-O ",
	"d4 d5 c4 Nc6 Nc3 dxc4 d5 Ne5 Bf4 Ng6 Bg3 e5 dxe6 Bxe6 Nf3 Nf6 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 Bf5 cxd5 Nxd5 Nd2 Bg6 Nc4 Nd7 g3 b5 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 dxc4 e3 b5 a4 b4 Na2 e6 Bxc4 Be7 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 e6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 e6 e3 Nbd7 Bd3 Bb4 O-O O-O Bd2 Bd6 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 Bg4 Qb3 Qb6 Qxb6 axb6 cxd5 Nxd5 Nxd5 cxd5 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bb3 b4 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Qc2 Bd6 b3 O-O Be2 Re8 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 f4 c5 Nf3 Nc6 a3 Be7 dxc5 Bxc5 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Bd3 O-O O-O Bg4 h3 Bxf3 ",
	"d4 d5 c4 c6 Nc3 e5 dxe5 d4 Ne4 Qa5+ Nd2 Nd7 e6 fxe6 g3 e5 ",
	"d4 d5 c4 c6 Nc3 e5 e3 exd4 Qxd4 Nf6 Nf3 Be6 e4 dxc4 Qxd8+ Kxd8 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O a5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bg4 Ne5 Bh5 f3 Nfd7 Nxc4 e5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bg4 Ne5 Bh5 g3 a5 Bg2 e6 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bg4 Ne5 Bh5 h3 Nbd7 g4 Bg6 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Na6 e3 Be6 a5 Bd5 Nd2 g6 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Na6 e3 Bg4 Bxc4 e6 O-O Nb4 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 e4 b5 e5 Nd5 a4 e6 axb5 Nxc3 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 Bg5 dxc4 a4 Bb4 Rc1 Qa5 Bd2 c5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Be2 a6 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 Bd2 O-O O-O-O c5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 Bd3 O-O O-O dxc4 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 Be2 O-O O-O Re8 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 Be2 O-O O-O dxc4 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 a3 Bd6 b4 O-O Bb2 Qe7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 a6 c5 Nbd7 b4 a5 b5 e5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Qc2 dxc4 Qxc4 Bf5 g3 e6 Bg2 Nbd7 e3 Be7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Qc2 g6 Bf4 dxc4 Qxc4 Bg7 Nc3 O-O e4 b5 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 Bf5 Bd3 Bxd3 Qxd3 e6 O-O Nbd7 Nc3 Be7 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 Bf5 Nc3 e6 Qb3 Qb6 Na4 Qc7 cxd5 exd5 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 Bf5 cxd5 cxd5 Nc3 e6 Qb3 Qc7 Bd2 Nc6 ",
	"d4 d5 c4 c6 cxd5 cxd5 Nc3 Nc6 Nf3 Nf6 Bf4 Bf5 Qb3 Na5 Qa4+ Bd7 ",
	"d4 d5 c4 c6 cxd5 cxd5 Nc3 Nf6 Nf3 Nc6 Bf4 Bf5 e3 e6 Bb5 Nd7 ",
	"d4 d5 c4 c6 cxd5 cxd5 Nf3 Nf6 Bf4 Nc6 e3 Nh5 Bg3 Nxg3 hxg3 g6 ",
	"d4 d5 c4 c6 e3 Nf6 Nc3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 c6 e3 Nf6 Nc3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Be2 a6 ",
	"d4 d5 c4 c6 e3 Nf6 Nc3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Be2 a6 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 Nc3 c6 a4 Bg4 Ne5 Bh5 f3 Nfd7 Nxc4 e5 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 Nc3 c6 e4 b5 e5 Nd5 a4 Nxc3 bxc3 e6 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 Bg4 Bxc4 e6 h3 Bh5 Nc3 a6 g4 Bg6 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 Bg4 h3 Bh5 Bxc4 e6 Nc3 a6 Be2 Nc6 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 c5 Bxc4 e6 O-O Nc6 Qe2 a6 Rd1 b5 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 e6 Bxc4 c5 Nc3 a6 O-O b5 Bd3 cxd4 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 e6 Bxc4 c5 O-O a6 Qe2 b5 Bd3 cxd4 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 e6 Bxc4 c5 O-O a6 a4 Nc6 Qe2 cxd4 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 e6 Bxc4 c5 O-O a6 a4 cxd4 exd4 Nc6 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 g6 Bxc4 Bg7 O-O O-O Nc3 Nfd7 Qe2 Nb6 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 Bg4 Bxc4 e6 Qb3 Bxf3 gxf3 b5 Be2 Nd7 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 Bg4 Bxc4 e6 Qb3 Bxf3 gxf3 b5 Be2 Nd7 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 Nf6 Bxc4 e6 O-O c5 Qe2 Nc6 dxc5 Bxc5 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 e6 Bxc4 c5 O-O Nf6 Qe2 b5 Bb3 Bb7 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 e6 Bxc4 c5 O-O Nf6 Qe2 b5 Bb3 Bb7 ",
	"d4 d5 c4 dxc4 Nf3 a6 e4 b5 a4 Bb7 b3 Bxe4 bxc4 b4 Nbd2 Bb7 ",
	"d4 d5 c4 dxc4 e3 Nf6 Bxc4 e6 Nf3 c5 O-O a6 e4 b5 Bd3 Bb7 ",
	"d4 d5 c4 dxc4 e4 Nf6 e5 Nd5 Bxc4 Nb6 Bd3 Nc6 Be3 Be6 Nc3 Qd7 ",
	"d4 d5 c4 dxc4 e4 Nf6 e5 Nd5 Bxc4 Nb6 Bd3 Nc6 Be3 g6 Nc3 Bg7 ",
	"d4 d5 c4 dxc4 e4 Nf6 e5 Nd5 Bxc4 Nb6 Bd3 Nc6 Ne2 Bg4 f3 Be6 ",
	"d4 d5 c4 dxc4 e4 c5 d5 Nf6 Nc3 b5 Bf4 Qa5 a4 Nxe4 Ne2 Nd6 ",
	"d4 d5 c4 e5 dxe5 d4 Nf3 Nc6 a3 Bg4 Bg5 Be7 Bxe7 Qxe7 Nbd2 O-O-O ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 Bg5 O-O e3 h6 Bh4 b6 cxd5 Nxd5 ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 Bg5 O-O e3 h6 Bh4 b6 cxd5 Nxd5 ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 Bg5 h6 Bh4 O-O e3 b6 Qb3 Bb7 ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 e3 O-O b3 b6 Bb2 Bb7 Bd3 c5 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 c6 e3 Bf5 g4 Be6 h3 Nf6 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 c6 e3 Bf5 g4 Be6 h3 Nf6 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 c6 e3 Bf5 g4 Bg6 h4 h5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bf4 Be7 e3 O-O Rc1 c5 dxc5 Bxc5 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 Nf3 Nbd7 e3 O-O c5 Ne4 Nxe4 dxe4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 Nf3 h6 Bh4 O-O e3 Nbd7 c5 b6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Nbd7 Nf3 O-O Qc2 dxc4 Bxc4 c5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Nbd7 Nf3 O-O Rc1 c6 Bd3 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Nbd7 Nf3 O-O Rc1 c6 Qc2 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Ne4 Bxe7 Qxe7 Bd3 Nxc3 bxc3 Nd7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Ne4 Bxe7 Qxe7 Bd3 Nxc3 bxc3 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Ne4 Bxe7 Qxe7 cxd5 Nxc3 bxc3 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 Nbd7 Qc2 c5 Rd1 Qa5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 Nbd7 Qc2 c5 Rd1 Qa5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Qb3 Nbd7 Nf3 c6 Bd3 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 h6 Bh4 O-O Nf3 b6 Qc2 c5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 Nf3 Bb4 e3 c5 cxd5 exd5 a3 Bxc3+ ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Bb4 cxd5 exd5 Bd3 c5 Ne2 cxd4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Bb4 cxd5 exd5 Qb3 c5 dxc5 Qa5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Be7 Nf3 O-O Rc1 Re8 Qc2 a6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Be7 Nf3 O-O Rc1 a6 a3 h6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Be7 Nf3 O-O Rc1 c6 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 c6 Nf3 Be7 Qc2 O-O Rd1 h6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 c6 Nf3 Be7 Qc2 O-O a3 Re8 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 c6 Nf3 Qa5 Nd2 Bb4 Qc2 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 c6 cxd5 exd5 Bd3 Bd6 Nf3 O-O ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 c5 Bg5 cxd4 Qxd4 Nc6 Qh4 Be7 O-O-O Qa5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 c5 cxd5 cxd4 Qxd4 Nxd5 e4 Nxc3 Qxd8+ Kxd8 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 c6 Bg5 dxc4 e4 b5 a4 Qb6 Bxf6 gxf6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 c6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 e6 Nc3 Nf6 cxd5 exd5 Bg5 Be7 e3 Nbd7 Bd3 O-O Nge2 c6 ",
	"d4 d5 c4 e6 Nc3 Nf6 cxd5 exd5 Bg5 Be7 e3 c6 Bd3 Nbd7 Nf3 O-O ",
	"d4 d5 c4 e6 Nc3 Nf6 cxd5 exd5 Bg5 c6 Qc2 Na6 e3 Nc7 Bd3 Be7 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 Bg5 Be7 Bxe7 Ngxe7 e3 cxd4 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 e3 Nf6 Be2 Bd6 dxc5 Bxc5 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Be6 Bg2 Be7 O-O Nf6 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 e4 dxe4 d5 f5 Bb5+ Bd7 Nh3 Bxb5 ",
	"d4 d5 c4 e6 Nc3 c5 e3 Nf6 Nf3 Nc6 Bd3 dxc4 Bxc4 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 c5 e3 Nf6 Nf3 Nc6 Bd3 dxc4 Bxc4 a6 O-O cxd4 ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 Nf6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 Nf6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 Nf6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 Nf6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 Nf6 cxd5 exd5 Bg5 h6 Bxf6 Qxf6 Qb3 Bd6 ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 Nf6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 Nf6 e3 Nbd7 Qc2 Bd6 Be2 O-O O-O Re8 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Ne5 Nxe5 dxe5 Nd7 f4 Bb4 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Qc2 Bd6 b3 O-O Be2 dxc4 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Qc2 Bd6 g4 dxc4 e4 e5 ",
	"d4 d5 c4 e6 Nc3 dxc4 Nf3 a6 a4 c5 e3 Nf6 Bxc4 Nc6 O-O Qc7 ",
	"d4 d5 c4 e6 Nc3 dxc4 e3 Nf6 Bxc4 a6 Nf3 c5 O-O Nc6 dxc5 Bxc5 ",
	"d4 d5 c4 e6 Nc3 dxc4 e3 Nf6 Bxc4 c5 Nf3 a6 O-O b5 Bd3 Bb7 ",
	"d4 d5 c4 e6 Nf3 Nf6 Bg5 Nbd7 Nc3 c6 e3 Be7 Rc1 O-O Bd3 b6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 Bb4 Bg5 h6 Bxf6 Qxf6 a3 Bxc3+ bxc3 c5 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 Be7 Bg5 Nbd7 e3 O-O Bd3 dxc4 Bxc4 c5 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 Nbd7 cxd5 exd5 Bf4 c6 e3 Nh5 Bd3 Nxf4 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c5 e3 Nc6 cxd5 exd5 Bd3 a6 dxc5 Bxc5 ",
	"d4 d5 c4 e6 Nf3 Nf6 g3 dxc4 Bg2 Bd7 Nbd2 Bb4 Qc2 Bxd2+ Bxd2 Bc6 ",
	"d4 d5 c4 e6 Nf3 a6 cxd5 exd5 Nc3 Be7 Qb3 Nf6 Bg5 c6 e3 Nbd7 ",
	"d4 d5 c4 e6 Nf3 a6 cxd5 exd5 Nc3 Nf6 Bg5 Be7 e3 O-O Bd3 c6 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 Be3 c4 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 Be3 c4 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 Nc3 O-O ",
	"d4 d5 c4 e6 Nf3 c6 Nbd2 Nf6 e3 Nbd7 Bd3 g6 O-O Bg7 e4 dxe4 ",
	"d4 d5 c4 e6 Nf3 c6 Nc3 dxc4 a4 Bb4 g3 c5 Bg2 Nc6 Be3 Nf6 ",
	"d4 d5 c4 e6 Nf3 c6 Qc2 Nf6 g3 Ne4 Bg2 Bd6 O-O O-O b3 Nd7 ",
	"d4 d5 c4 e6 Nf3 c6 e3 Nf6 Nc3 Nbd7 Bd3 Bb4 O-O O-O Bd2 Qe7 ",
	"d4 d5 e3 Nf6 Bd3 Bg4 Nf3 e6 c4 Nbd7 Qb3 Bxf3 gxf3 c5 cxd5 exd5 ",
	"d4 d5 e3 Nf6 Bd3 Nc6 f4 Nb4 Bd2 Bg4 Nf3 e6 Bxb4 Bxb4+ c3 Bd6 ",
	"d4 d5 e3 Nf6 Bd3 Nc6 f4 Nb4 Nf3 Nxd3+ cxd3 e6 Nc3 Be7 O-O O-O ",
	"d4 d5 e3 Nf6 Bd3 c5 c3 Nc6 dxc5 a5 Nd2 e5 Bb5 Bxc5 Ngf3 Qc7 ",
	"d4 d5 e3 Nf6 Bd3 c5 c3 Nc6 f4 Bg4 Nf3 e6 Nbd2 Bd6 g3 Rc8 ",
	"d4 d5 e3 c5 Bd3 c4 Be2 Nc6 f4 Bf5 Nf3 e6 O-O Bd6 c3 h6 ",
	"d4 d6 Nf3 g6 c4 Bg7 Nc3 e5 e4 Nc6 Bg5 f6 Be3 Nh6 dxe5 dxe5 ",
	"d4 d6 Nf3 g6 e4 Bg7 c3 Nf6 Bd3 Nc6 O-O O-O Nbd2 e5 dxe5 dxe5 ",
	"d4 d6 Nf3 g6 g3 Bg7 Bg2 Nc6 O-O Nf6 d5 Nb4 c4 O-O Nc3 a5 ",
	"d4 d6 c4 e5 Nc3 exd4 Qxd4 Nf6 g3 Nc6 Qd2 g6 Bg2 Bg7 Nh3 O-O ",
	"d4 d6 c4 e5 Nf3 Nd7 Nc3 g6 Bg5 f6 Be3 Ne7 dxe5 dxe5 g3 Bg7 ",
	"d4 d6 c4 e5 Nf3 Nd7 Nc3 g6 g3 Bg7 Bg2 Ne7 O-O O-O e4 a6 ",
	"d4 d6 c4 e5 Nf3 e4 Ng5 f5 Nc3 Nf6 Nh3 c6 e3 Na6 Nf4 Be7 ",
	"d4 d6 c4 e5 Nf3 e4 Ng5 f5 Nc3 c6 Nh3 Na6 e3 Nf6 Be2 Be7 ",
	"d4 d6 c4 e5 dxe5 dxe5 Qxd8+ Kxd8 Nc3 Be6 b3 c6 g3 Nd7 Bh3 Bxh3 ",
	"d4 d6 c4 e5 dxe5 dxe5 Qxd8+ Kxd8 Nc3 Be6 e3 Nd7 Nf3 f6 Be2 c6 ",
	"d4 d6 c4 e5 dxe5 dxe5 Qxd8+ Kxd8 Nc3 Na6 Bg5+ f6 O-O-O+ Ke8 Bd2 Be6 ",
	"d4 d6 c4 g6 Nc3 Bg7 e4 Nf6 f4 O-O Nf3 c5 d5 b5 cxb5 a6 ",
	"d4 d6 e4 Nf6 Nc3 e5 dxe5 dxe5 Qxd8+ Kxd8 Bg5 Be6 O-O-O+ Nd7 f4 exf4 ",
	"d4 d6 e4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O c6 h3 Qc7 a4 a5 ",
	"d4 d6 e4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Be3 b6 e5 Ng4 Bg1 c5 ",
	"d4 d6 e4 Nf6 f3 d5 Nc3 dxe4 Bg5 exf3 Nxf3 g6 Bc4 Bg7 Ne5 O-O ",
	"d4 d6 e4 Nf6 f3 d5 Nc3 e6 Bg5 dxe4 fxe4 Be7 Nf3 O-O Bd3 c5 ",
	"d4 d6 e4 Nf6 f3 d5 e5 Nfd7 Bd3 c5 c3 Nc6 Ne2 e6 O-O cxd4 ",
	"d4 d6 e4 Nf6 f3 d5 e5 Nfd7 c4 dxc4 Bxc4 e6 f4 c5 Nf3 cxd4 ",
	"d4 d6 e4 g6 Be3 Bg7 Nc3 a6 a4 Nf6 h3 O-O Nf3 d5 e5 Ne4 ",
	"d4 d6 e4 g6 Nf3 Bg7 Be2 Nf6 Nc3 O-O O-O Bg4 a4 Nc6 Be3 e5 ",
	"d4 d6 e4 g6 g3 Bg7 Bg2 Nc6 Ne2 e5 d5 Nce7 c4 f5 Nbc3 Nf6 ",
	"d4 e6 Nd2 d5 Ngf3 Nf6 e3 c5 a3 cxd4 exd4 Bd6 Bd3 O-O O-O Nc6 ",
	"d4 e6 Nf3 Nf6 Bg5 d5 e3 Be7 Nbd2 Nbd7 c4 O-O Rc1 h6 Bh4 a6 ",
	"d4 e6 Nf3 Nf6 c4 b6 g3 Bb7 Bg2 Be7 O-O O-O b3 d5 cxd5 exd5 ",
	"d4 e6 Nf3 Nf6 c4 b6 g3 Bb7 Bg2 Be7 O-O O-O b3 d5 cxd5 exd5 ",
	"d4 e6 Nf3 Nf6 c4 c5 d5 b5 e4 Nxe4 dxe6 fxe6 Bd3 Nf6 Ng5 Qe7 ",
	"d4 e6 Nf3 Nf6 c4 d5 g3 Be7 Bg2 O-O O-O dxc4 Qc2 a6 Qxc4 b5 ",
	"d4 e6 Nf3 Nf6 g3 c5 Bg2 cxd4 O-O d5 Nxd4 Be7 c4 O-O cxd5 Nxd5 ",
	"d4 e6 Nf3 c5 c3 Nc6 e4 d5 e5 Bd7 Be2 Nh6 O-O cxd4 cxd4 Nf5 ",
	"d4 e6 Nf3 c5 c3 Nc6 e4 d5 e5 Bd7 Be2 Nh6 O-O cxd4 cxd4 Nf5 ",
	"d4 e6 Nf3 c5 e4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 g5 hxg5 Bxg5 Nc6 ",
	"d4 e6 Nf3 f5 c4 Nf6 g3 d5 Bg2 c6 O-O Bd6 Nc3 O-O Qc2 Ne4 ",
	"d4 e6 Nf3 f5 g3 Nf6 Bg2 Be7 O-O O-O c4 d5 Nc3 c6 Rb1 Kh8 ",
	"d4 e6 Nf3 f5 g3 Nf6 Bg2 Be7 O-O O-O c4 d6 b3 Qe8 Bb2 Nbd7 ",
	"d4 e6 c4 Bb4+ Bd2 a5 e4 d6 Nf3 Nf6 Qc2 e5 d5 Na6 a3 Bxd2+ ",
	"d4 e6 c4 Bb4+ Nc3 Nf6 e3 b6 Bd3 Bb7 Nf3 Ne4 O-O f5 Ne2 Be7 ",
	"d4 e6 c4 Bb4+ Nc3 c5 e3 Nf6 a3 Bxc3+ bxc3 O-O Bd3 d5 cxd5 exd5 ",
	"d4 e6 c4 Bb4+ Nd2 d5 e3 Nf6 Qa4+ Nc6 a3 Bxd2+ Bxd2 Ne4 Nf3 Nxd2 ",
	"d4 e6 c4 Nf6 Nc3 Bb4 Qc2 O-O Nf3 d6 e4 e5 d5 Bxc3+ bxc3 Na6 ",
	"d4 e6 c4 Nf6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 e3 b6 Bd3 Bb7 f3 Nc6 ",
	"d4 e6 c4 Nf6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 Ne4 O-O f5 Qc2 Bxc3 ",
	"d4 e6 c4 Nf6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 Nc6 d5 Ne7 e4 Bxc3+ ",
	"d4 e6 c4 Nf6 Nc3 Bb4 e3 c5 Ne2 cxd4 exd4 d5 c5 Ne4 Bd2 Nxd2 ",
	"d4 e6 c4 Nf6 Nc3 Bb4 f3 c5 d5 b5 e4 bxc4 Bxc4 exd5 Bxd5 Nxd5 ",
	"d4 e6 c4 Nf6 Nf3 b6 g3 Bb7 Bg2 Be7 Nc3 O-O Qc2 d5 cxd5 exd5 ",
	"d4 e6 c4 Nf6 Nf3 c5 d5 exd5 cxd5 g6 Nc3 Bg7 e4 d6 Nd2 O-O ",
	"d4 e6 c4 Nf6 Nf3 c5 e3 d5 a3 a6 Nc3 dxc4 dxc5 Qc7 Bxc4 Bxc5 ",
	"d4 e6 c4 Nf6 Nf3 d5 g3 Be7 Bg2 O-O O-O c6 Qc2 b6 Nbd2 Bb7 ",
	"d4 e6 c4 Nf6 g3 Bb4+ Bd2 c5 Nf3 Qb6 Bxb4 Qxb4+ Qd2 Qxc4 Na3 Qa4 ",
	"d4 e6 c4 Nf6 g3 c5 d5 exd5 cxd5 d6 Bg2 g6 Nf3 Bg7 O-O O-O ",
	"d4 e6 c4 c5 d5 exd5 cxd5 d6 Nc3 g6 g3 Nf6 Bg2 Bg7 Nf3 O-O ",
	"d4 e6 c4 d5 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 Nbd7 Rc1 c6 Bd3 a6 ",
	"d4 e6 c4 d5 e3 Nf6 Nf3 c5 Nc3 Nc6 a3 Bd6 dxc5 Bxc5 b4 Bd6 ",
	"d4 e6 c4 f5 Nc3 Bb4 Bd2 Nf6 g3 O-O Bg2 d6 a3 Bxc3 Bxc3 Nbd7 ",
	"d4 e6 c4 f5 Nc3 Nf6 Bd2 b6 e3 Bb7 f3 c5 Bd3 Nc6 Nge2 Bd6 ",
	"d4 e6 c4 f5 Nc3 Nf6 Nf3 Bb4 Qb3 Qe7 a3 Bxc3+ Qxc3 O-O e3 d6 ",
	"d4 e6 c4 f5 Nc3 Nf6 e3 Be7 Bd3 O-O Nge2 d6 Qc2 g6 e4 Nc6 ",
	"d4 e6 c4 f5 Nc3 Nf6 e3 d5 Bd3 c6 h3 Bd6 g4 O-O Qc2 Na6 ",
	"d4 e6 c4 f5 Nc3 Nf6 g3 Bb4 Bg2 O-O Nf3 Ne4 Qc2 d6 O-O Bxc3 ",
	"d4 e6 c4 f5 Nf3 Nf6 Nc3 Be7 g3 O-O Bg2 d6 O-O Qe8 Re1 Qg6 ",
	"d4 e6 c4 f5 Nf3 Nf6 g3 d5 Bg2 c6 O-O Bd6 b3 Qe7 Nbd2 b6 ",
	"d4 e6 c4 f5 e3 Nf6 Nc3 d5 Nh3 c6 Bd2 Bd6 Qc2 O-O O-O-O Qe7 ",
	"d4 e6 c4 f5 e3 Nf6 Nc3 d5 Nh3 c6 Bd2 Bd6 Qc2 O-O O-O-O Qe7 ",
	"d4 e6 c4 f5 f4 Nf6 Nf3 b6 a3 a5 Nc3 Bb7 e3 Be7 Be2 O-O ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Bb4+ Bd2 Be7 Nc3 O-O Nh3 d6 Nf4 Qe8 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Bb4+ Bd2 Be7 Nf3 d5 Nc3 c6 O-O O-O ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Be7 Nc3 O-O Nf3 d5 O-O c6 Qc2 Qe8 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Be7 Nc3 d5 Nf3 c6 O-O O-O b3 Qe8 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Be7 Nc3 d5 b3 O-O Nf3 c6 O-O Ne4 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Be7 Nf3 O-O d5 Ne4 O-O Bf6 Nbd2 Nxd2 ",
	"d4 e6 e3 Nf6 Nf3 c5 Nbd2 Nc6 c3 d6 e4 Qc7 a3 Be7 Bd3 O-O ",
	"d4 e6 e3 f5 c4 Bb4+ Nc3 Bxc3+ bxc3 Nf6 Bd3 O-O Ne2 d6 Qc2 c5 ",
	"d4 e6 e4 d5 Nc3 Bb4 e5 c5 a3 Ba5 Qg4 Ne7 dxc5 Bxc3+ bxc3 Nd7 ",
	"d4 e6 e4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 cxd4 cxd4 Qc7 ",
	"d4 e6 e4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Qg4 f5 Qg3 cxd4 ",
	"d4 e6 e4 d5 Nc3 Nc6 Nf3 Nf6 exd5 exd5 Bb5 Bb4 O-O O-O Bxc6 bxc6 ",
	"d4 e6 e4 d5 Nd2 c5 exd5 exd5 Ngf3 a6 dxc5 Bxc5 Nb3 Ba7 Bg5 Nf6 ",
	"d4 e6 e4 d5 Nd2 c5 exd5 exd5 Ngf3 a6 dxc5 Bxc5 Nb3 Ba7 Bg5 Nf6 ",
	"d4 e6 e4 d5 exd5 exd5 Nf3 Bg4 h3 Bh5 Be2 Bd6 Ne5 Bxe2 Qxe2 Ne7 ",
	"d4 e6 e4 d5 exd5 exd5 Nf3 Bg4 h3 Bh5 Be2 Nc6 O-O Bd6 Nc3 Nge7 ",
	"d4 e6 g3 c5 Nf3 b5 Bg2 Bb7 O-O Nf6 c3 Na6 Na3 Nc7 Bf4 a6 ",
	"d4 e6 g3 f5 Bg2 Nf6 Nf3 d5 O-O Bd6 c4 c6 b3 Qe7 Nbd2 O-O ",
	"d4 f5 Bg5 g6 Nc3 Bg7 e3 d6 h4 h6 Bf4 Nf6 Bc4 c6 Nf3 e6 ",
	"d4 f5 Bg5 g6 Nc3 d5 e3 Bg7 h4 c6 Bd3 Qb6 Rb1 Nd7 Nf3 Ngf6 ",
	"d4 f5 Nc3 Nf6 Bg5 e6 e4 fxe4 Nxe4 Be7 Bxf6 Bxf6 Qh5+ g6 Nxf6+ Qxf6 ",
	"d4 f5 Nc3 d5 Bg5 c6 e3 Qb6 Na4 Qa5+ c3 Nd7 b4 Qc7 Nf3 e5 ",
	"d4 f5 Nf3 Nf6 g3 e6 Bg2 Be7 c4 O-O O-O d5 Nbd2 b6 Qc2 c6 ",
	"d4 f5 Nf3 e6 Nbd2 Nf6 e3 b6 Bd3 Bb7 Qe2 Ne4 Ne5 Qh4 Bxe4 fxe4 ",
	"d4 f5 c4 e6 Nc3 Nf6 Bg5 Bb4 Qb3 c5 d5 e5 e3 O-O Bd3 d6 ",
	"d4 f5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Bd3 b6 Nge2 Bb7 O-O Nh5 ",
	"d4 f5 e3 Nf6 Nf3 b6 b3 Bb7 Nbd2 e6 Bb2 a5 a3 Be7 Bd3 O-O ",
	"d4 f5 e4 fxe4 Nc3 Nf6 Bg5 Nc6 d5 Ne5 Qd4 Nf7 Bxf6 exf6 Nxe4 Be7 ",
	"d4 f5 e4 fxe4 Nc3 Nf6 Bg5 c6 f3 Qa5 Qd2 e3 Bxe3 Nd5 Bd3 Nxe3 ",
	"d4 f5 e4 fxe4 Nc3 Nf6 Bg5 g6 f3 exf3 Nxf3 d5 Bd3 Nc6 O-O Bg7 ",
	"d4 f5 g3 Nf6 Bg2 d6 Nf3 g6 O-O Bg7 c4 O-O Nc3 Qe8 d5 Na6 ",
	"d4 f5 g3 Nf6 Bg2 d6 d5 c6 c4 e5 dxe6 Bxe6 Qc2 Na6 Nh3 g6 ",
	"d4 f5 g3 Nf6 Bg2 e6 Nf3 Be7 O-O O-O c4 c6 Nc3 d5 Bg5 Nbd7 ",
	"d4 f5 g3 Nf6 Bg2 e6 Nf3 Be7 O-O O-O c4 c6 Nc3 d5 Bg5 Nbd7 ",
	"d4 f5 g3 Nf6 Bg2 g6 Nf3 Bg7 b3 O-O Bb2 d5 c4 c6 O-O Be6 ",
	"d4 f5 g3 Nf6 Bg2 g6 Nh3 Bg7 Nf4 Nc6 d5 Ne5 Nc3 c6 Nd3 Nf7 ",
	"d4 f5 g3 Nf6 Bg2 g6 Nh3 Bg7 c4 d6 d5 O-O Nc3 c6 Nf4 Bd7 ",
	"d4 f5 g3 e6 Bg2 Nf6 Nh3 d5 O-O Bd6 c4 c6 Nc3 Nbd7 cxd5 exd5 ",
	"d4 g6 Nf3 Bg7 g3 c5 d5 d6 c4 b5 cxb5 Nf6 Nc3 a6 bxa6 Qa5 ",
	"d4 g6 c4 Bg7 Nc3 Nf6 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 g6 c4 Bg7 Nc3 c5 e3 Nf6 Nf3 O-O Be2 d6 O-O Bf5 b3 Nc6 ",
	"d4 g6 c4 Bg7 Nc3 d6 Nf3 Nf6 Bg5 O-O e3 c6 Be2 a6 O-O b5 ",
	"d4 g6 c4 Bg7 Nc3 d6 Nf3 Nf6 e4 O-O Be2 e5 d5 a5 h4 Na6 ",
	"d4 g6 c4 Bg7 Nc3 d6 Nf3 Nf6 g3 O-O Bg2 Nbd7 O-O a6 e4 c5 ",
	"d4 g6 c4 Bg7 Nc3 d6 e4 Nd7 Be3 c5 Nge2 a6 Nc1 Ngf6 Be2 O-O ",
	"d4 g6 c4 Bg7 Nc3 d6 e4 e5 dxe5 dxe5 Qxd8+ Kxd8 f4 Be6 Nf3 Nd7 ",
	"d4 g6 c4 Bg7 Nf3 c5 d5 f5 g3 d6 Bg2 Na6 O-O Nf6 Nc3 O-O ",
	"d4 g6 c4 Bg7 e4 c5 d5 d6 Nc3 Nf6 Be2 O-O f4 e6 Nf3 exd5 ",
	"d4 g6 c4 Bg7 e4 d6 Nc3 Nf6 f3 O-O Be3 Nbd7 Nh3 e5 d5 Nc5 ",
	"d4 g6 c4 Bg7 e4 d6 Nc3 e5 Nf3 exd4 Nxd4 Ne7 Be3 O-O Qd2 Nbc6 ",
	"d4 g6 c4 Nf6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 Nc6 ",
	"d4 g6 e4 Bg7 Nc3 d6 Nf3 Bg4 Be2 Nc6 Ng1 Bd7 Be3 e5 Nf3 Nf6 ",
	"d4 g6 e4 Bg7 Nc3 d6 f4 Nf6 Nf3 O-O Bd3 Na6 O-O c5 d5 Nc7 ",
	"d4 g6 e4 Bg7 Nf3 d6 Bc4 Nf6 Qe2 Nc6 Nc3 Bg4 e5 Bxf3 Qxf3 Nxd4 ",
	"d4 g6 e4 Bg7 Nf3 d6 Bc4 c6 O-O Nf6 Nc3 d5 Bd3 Bg4 e5 Nfd7 ",
	"d4 g6 e4 Bg7 Nf3 d6 c3 Nf6 Nbd2 O-O Bc4 Nc6 O-O e5 dxe5 dxe5 ",
	"d4 g6 e4 Bg7 c4 d6 Nc3 c5 d5 Nf6 Nf3 O-O h3 e5 Bg5 h6 ",
	"d4 g6 e4 d6 Nc3 Bg7 Nge2 Nc6 h3 e5 Be3 Nf6 g3 Bd7 Bg2 Qc8 ",
	"d4 g6 e4 d6 Nf3 Nf6 Nbd2 Bg7 Bc4 O-O Bb3 Nc6 O-O Bg4 c3 e5 ",
	"d4 g6 g3 Bg7 Bg2 c5 d5 d6 Nf3 Nf6 O-O b5 c4 bxc4 Nfd2 Ba6 ",
	"e3 g6 d4 Bg7 Bd3 c5 c3 Nf6 Nf3 b6 O-O Bb7 Qe2 O-O Re1 Ne4 ",
	"e4 Nc6 Nc3 Nf6 d4 e5 dxe5 Nxe5 f4 Nc6 e5 Ng8 Bc4 d6 Nf3 Bg4 ",
	"e4 Nc6 Nf3 e5 Bb5 a6 Ba4 d6 O-O Bd7 d4 Nf6 c3 g6 Nbd2 Qe7 ",
	"e4 Nc6 d4 d5 e5 Bf5 Nf3 e6 Bd3 Bxd3 cxd3 Nge7 Qb3 Nf5 Be3 Be7 ",
	"e4 Nf6 Nc3 d5 e5 Nfd7 d4 e6 Nce2 c5 c3 Nc6 f4 Be7 Nf3 O-O ",
	"e4 Nf6 Nc3 d5 e5 Nfd7 f4 e6 Nf3 c5 Bb5 a6 Bxd7+ Bxd7 O-O Nc6 ",
	"e4 Nf6 Nc3 e5 Nf3 Nc6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Qe7 ",
	"e4 Nf6 d3 e5 Nf3 Nc6 Be2 d5 Nbd2 g6 O-O Bg7 c3 a5 a4 O-O ",
	"e4 Nf6 e5 Nd5 Nc3 Nxc3 dxc3 d5 Nf3 c5 Bf4 Nc6 Qd2 Bg4 O-O-O e6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bf5 Bd3 Qd7 O-O Nc6 Bxf5 Qxf5 c4 Nb6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 c6 Ng5 Bf5 e6 fxe6 g4 Bg6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 c4 Nb6 Be3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 c4 Nb6 exd6 cxd6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 c4 Nb6 exd6 cxd6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 c4 Nb6 exd6 cxd6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 h3 Bh5 c4 Nb6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 c4 Nb6 exd6 cxd6 Be3 Be7 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 h3 Bxf3 Qxf3 dxe5 dxe5 e6 a3 Nd7 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 h3 Bxf3 Qxf3 dxe5 dxe5 e6 g3 Nc6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Nc6 c4 Nb6 e6 fxe6 h4 e5 d5 Nd4 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 dxe5 Nxe5 g6 Bc4 c6 O-O Bg7 Re1 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 Nbd2 O-O h3 a5 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 Ng5 d5 f4 f6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Nc6 e6 fxe6 h4 e5 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 c6 O-O Bg7 exd6 Qxd6 Nbd2 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bd3 Bg7 O-O O-O h3 dxe5 dxe5 Nc6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bd3 Bg7 exd6 cxd6 O-O O-O c4 Nb6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Be2 Bg7 c4 Nb6 exd6 cxd6 h3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Be2 Bg7 c4 Nb6 exd6 exd6 Bg5 f6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 c4 Nb6 Nc3 Bg7 Bf4 Nc6 c5 dxc5 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 c4 Nb6 exd6 cxd6 h3 Bg7 Be3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 cxd6 Be3 g6 d5 Bg7 Bd4 Bxd4 ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 cxd6 Nc3 g6 Bd3 Bg7 Nge2 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 cxd6 Nc3 g6 Be3 Bg7 Be2 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 cxd6 Nc3 g6 h3 Bg7 Nf3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 exd6 Bd3 Be7 h3 Nc6 Nf3 Nb4 ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 f4 Bf5 Nc3 e6 Be2 dxe5 fxe5 Be7 ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 f4 dxe5 fxe5 Nc6 Be3 Bf5 Nc3 e6 ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 f4 dxe5 fxe5 Nc6 Be3 Bf5 Nf3 e6 ",
	"e4 Nf6 e5 Nd5 d4 d6 f4 dxe5 fxe5 c5 c4 Nb4 d5 Bf5 Na3 e6 ",
	"e4 b6 d4 Bb7 Bd3 e6 Nh3 c5 c3 cxd4 cxd4 Nc6 Be3 Nb4 Nc3 Nxd3+ ",
	"e4 c5 Nc3 Nc6 Bb5 g6 f4 Nd4 Bc4 Bg7 Nf3 d6 O-O e6 Nxd4 cxd4 ",
	"e4 c5 Nc3 Nc6 Bc4 Nf6 d3 d6 Nge2 e6 Bg5 Be7 Qc1 O-O O-O a6 ",
	"e4 c5 Nc3 Nc6 Nf3 Nf6 Bc4 e6 d3 d5 exd5 exd5 Bb3 Be7 Bg5 Be6 ",
	"e4 c5 Nc3 Nc6 Nf3 e6 Bb5 Nge7 O-O a6 Bxc6 Nxc6 d4 cxd4 Nxd4 d6 ",
	"e4 c5 Nc3 Nc6 Nf3 e6 d4 cxd4 Nxd4 Qc7 g3 a6 Bg2 d6 O-O Nf6 ",
	"e4 c5 Nc3 Nc6 Nf3 g6 d4 cxd4 Nxd4 Bg7 Be3 Nf6 Nb3 O-O Be2 d6 ",
	"e4 c5 Nc3 Nc6 Nge2 e5 g3 d6 Bg2 g6 d3 Bg7 O-O Nge7 f4 O-O ",
	"e4 c5 Nc3 Nc6 Nge2 e6 d4 cxd4 Nxd4 Nf6 Nxc6 bxc6 e5 Nd5 Ne4 Qc7 ",
	"e4 c5 Nc3 Nc6 Nge2 e6 d4 cxd4 Nxd4 Nf6 Nxc6 bxc6 e5 Nd5 Ne4 Qc7 ",
	"e4 c5 Nc3 Nc6 Nge2 g6 d4 cxd4 Nxd4 Bg7 Nde2 Nf6 g3 d6 Bg2 O-O ",
	"e4 c5 Nc3 Nc6 f4 g6 Nf3 Bg7 Bc4 e6 e5 d6 exd6 Qxd6 Ne4 Qe7 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 d6 O-O Rb8 d3 b5 Nd5 e6 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 d6 d3 Nf6 O-O O-O h3 a6 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 e6 d3 Nge7 O-O O-O Be3 Nd4 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 Rb8 f4 b5 a3 a5 Nf3 b4 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 b6 Nge2 d6 O-O Bb7 f4 f5 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 b6 Nge2 d6 O-O Bb7 f4 f5 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 b6 Nge2 d6 O-O Bb7 f4 f5 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Be3 Nd4 Nce2 Nxe2 Nxe2 Bxb2 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Be3 Nd4 Qd2 Qa5 f4 e6 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Be3 e6 f4 Nge7 Nf3 O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nge2 Nf6 O-O O-O h3 Ne8 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nge2 Nf6 O-O O-O h3 Ne8 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nge2 e5 Nd5 Nge7 c3 Nxd5 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nge2 e5 Nd5 Nge7 c3 Nxd5 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nge2 e5 O-O Nge7 a3 O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 f4 Nf6 Nge2 O-O h3 Ne8 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 f4 e6 Nf3 Nge7 Be3 O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 f4 e6 Nf3 Nge7 O-O O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 f4 e6 Nf3 Nge7 O-O O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 d3 Bg7 Bg2 d6 Be3 Rb8 Qd2 b5 Nge2 Nd4 ",
	"e4 c5 Nc3 d6 Nf3 a6 g3 Nc6 Bg2 Bg4 h3 Bxf3 Bxf3 g6 d3 Bg7 ",
	"e4 c5 Nc3 d6 Nge2 Nf6 d4 cxd4 Nxd4 a6 a4 e5 Nf3 Qc7 Bg5 Nbd7 ",
	"e4 c5 Nc3 d6 Nge2 a6 d4 cxd4 Nxd4 Nf6 f4 e6 Nf3 Nbd7 Bd3 b5 ",
	"e4 c5 Nc3 d6 f4 Nc6 Nf3 g6 Bb5 Bd7 O-O Bg7 d3 a6 Bxc6 Bxc6 ",
	"e4 c5 Nc3 d6 f4 Nc6 Nf3 g6 Bb5 Bg7 d3 e6 e5 d5 Bxc6+ bxc6 ",
	"e4 c5 Nc3 d6 f4 Nc6 Nf3 g6 Bc4 Bg7 O-O e6 d3 Nge7 Qe1 h6 ",
	"e4 c5 Nc3 d6 g3 Nc6 Bg2 g6 d3 Bg7 Nh3 b6 O-O Bb7 f4 Qd7 ",
	"e4 c5 Nc3 d6 g3 Nc6 Bg2 g6 d3 Bg7 f4 b6 Nf3 Bb7 O-O Qd7 ",
	"e4 c5 Nc3 e6 Nf3 d6 g3 Nc6 Bg2 Nf6 d3 Be7 O-O O-O h3 Rb8 ",
	"e4 c5 Nc3 e6 Nf3 d6 g3 Nf6 Bg2 Be7 O-O O-O b3 Nc6 Bb2 Bd7 ",
	"e4 c5 Nc3 e6 g3 d5 Bg2 Nf6 Nge2 Be7 O-O O-O Nf4 dxe4 Nxe4 Qc7 ",
	"e4 c5 Nc3 e6 g3 d5 d3 Nc6 exd5 exd5 Bg2 d4 Ne4 Nf6 Ne2 Nxe4 ",
	"e4 c5 Nc3 e6 g3 d5 exd5 exd5 Bg2 Nf6 d4 cxd4 Qxd4 Nc6 Qd1 d4 ",
	"e4 c5 Nc3 e6 g3 d5 exd5 exd5 d4 Nf6 Bg2 cxd4 Qxd4 Nc6 Qa4 Bb4 ",
	"e4 c5 Ne2 Nc6 b3 Nf6 Nbc3 e6 Bb2 d5 Ng3 Bd6 Bb5 O-O Bd3 Ne5 ",
	"e4 c5 Ne2 Nf6 Nbc3 d5 exd5 Nxd5 Nxd5 Qxd5 Nc3 Qd8 Bc4 Nc6 d3 e6 ",
	"e4 c5 Ne2 Nf6 Nbc3 e5 g3 g6 Bg2 Bg7 d3 O-O Be3 d6 h3 Nc6 ",
	"e4 c5 Ne2 Nf6 d3 Nc6 Nd2 d5 c3 dxe4 dxe4 g6 Qc2 Bg7 a4 O-O ",
	"e4 c5 Ne2 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 Qc7 Bd3 g6 f4 Bg7 ",
	"e4 c5 Nf3 Nc6 Bb5 Nf6 Qe2 Nd4 Nxd4 cxd4 e5 Nd5 c3 Qb6 Bc4 Qc6 ",
	"e4 c5 Nf3 Nc6 Bb5 d6 d4 cxd4 Qxd4 Bd7 Bxc6 Bxc6 Nc3 Nf6 Bg5 e6 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 Bxc6 bxc6 O-O Ne7 b3 Ng6 Bb2 f6 d4 cxd4 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 O-O Nge7 Nc3 Nd4 Nxd4 cxd4 Ne2 a6 Ba4 Nc6 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 O-O Nge7 Nc3 Nd4 Nxd4 cxd4 Ne2 a6 Bd3 d5 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 O-O Nge7 c3 a6 Ba4 b5 Bc2 Bb7 a4 Ng6 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 O-O Nge7 c3 a6 Bxc6 Nxc6 d4 d5 e5 Bd7 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 Re1 Nf6 e5 Nd5 Nc3 Nc7 Bc4 b6 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 Re1 a6 Bxc6 dxc6 Nc3 e5 a4 a5 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 Re1 e5 c3 Nge7 b4 d6 bxc5 dxc5 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 Nf6 Qe2 O-O d4 cxd4 cxd4 a6 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 a6 Ba4 b5 Bc2 e5 a4 Bb7 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 a6 Bxc6 dxc6 d3 Nf6 h3 O-O ",
	"e4 c5 Nf3 Nc6 Nc3 Nf6 d4 cxd4 Nxd4 d6 Be2 e6 Be3 Be7 Qd2 O-O ",
	"e4 c5 Nf3 Nc6 Nc3 Nf6 d4 cxd4 Nxd4 d6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 Nc3 Nf6 g3 d5 exd5 Nxd5 Bg2 g6 O-O Bg7 Re1 Nxc3 ",
	"e4 c5 Nf3 Nc6 Nc3 d6 d4 cxd4 Nxd4 Nf6 Bc4 e6 Be3 Be7 Qe2 a6 ",
	"e4 c5 Nf3 Nc6 Nc3 e6 d4 cxd4 Nxd4 Qc7 g3 a6 Bg2 d6 O-O Bd7 ",
	"e4 c5 Nf3 Nc6 Nc3 g6 d4 cxd4 Nxd4 Bg7 Be3 Nf6 Be2 O-O Qd2 d5 ",
	"e4 c5 Nf3 Nc6 Nc3 g6 d4 cxd4 Nxd4 Bg7 Be3 d6 Be2 Nf6 O-O Bd7 ",
	"e4 c5 Nf3 Nc6 c3 d5 exd5 Qxd5 Be2 Nf6 O-O e5 c4 Qd8 d3 Bd6 ",
	"e4 c5 Nf3 Nc6 c3 d5 exd5 Qxd5 Na3 Bg4 Be2 e6 Nb5 Rc8 Nxa7 Bxf3 ",
	"e4 c5 Nf3 Nc6 c3 d5 exd5 Qxd5 d4 Bg4 Be2 cxd4 cxd4 e6 O-O Nf6 ",
	"e4 c5 Nf3 Nc6 c3 d5 exd5 Qxd5 d4 Bg4 Be2 e6 O-O Nf6 h3 Bh5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bb5 Bd7 Be3 g6 f3 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bb5 Bd7 O-O e6 Be3 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Qb6 Nb3 e6 O-O Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Qb6 Ndb5 a6 Be3 Qa5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Bb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Bb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Bb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Be3 a6 a3 Qc7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 O-O Be7 a3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 O-O a6 Be3 Qc7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Bd7 Be3 e6 Qd2 a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e5 Nb3 Be7 Be3 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 Be3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 Be3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Kh1 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Nxc6 bxc6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 g6 Be3 Bg7 Nb3 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 g6 Be3 Bg7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 g6 Be3 Bg7 f3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 e6 Be2 Be7 Bf3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 Bd7 Qd2 Rc8 O-O-O Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Bb5 Bd7 O-O Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Bb5 Qb6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Be2 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Be2 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Be2 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Nxc6 bxc6 e5 Qa5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 h6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 h6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 h6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Nb3 e6 f4 a6 Be3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 f3 e5 Nb3 Be6 Be3 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 f4 g6 Nxc6 bxc6 e5 Nd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g3 g6 Bg2 Bd7 O-O Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g3 g6 Bg2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g3 g6 Bg2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Be3 a6 Na3 Rb8 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Be3 a6 Na3 Rb8 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Nd5 Nxd5 exd5 Ne7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Bf4 d6 Bb5 Qc7 Bg5 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Ndb5 d6 a4 a6 Na3 d5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Nxc6 bxc6 e5 Nd5 Ne4 Qc7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qb6 Nb3 Nf6 Nc3 e6 Bd3 Be7 O-O d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qb6 Nb3 Nf6 Nc3 e6 Bd3 a6 f4 d5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qb6 Nb3 Nf6 Nc3 e6 Be3 Qc7 Bd3 Ne5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nb5 Qb8 c4 Nf6 N5c3 e6 Be3 Bd6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 Be2 a6 O-O Nf6 Be3 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 Be2 a6 O-O Nf6 Be3 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 f4 a6 Nxc6 bxc6 Bd3 d5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 g3 a6 Bg2 Nf6 O-O Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 g3 a6 Bg2 d6 O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 g3 a6 Bg2 d6 O-O Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 d5 Bb5 dxe4 Nxc6 Qxd1+ Kxd1 a6 Ba4 Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 d5 exd5 Qxd5 Be3 e6 Nc3 Bb4 Nb5 Qe5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 Be3 Nf6 N1c3 Be7 Bg5 a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 N1c3 a6 Na3 b5 Nd5 Nge7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 c4 Be6 N1c3 a6 Na3 Rc8 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 c4 Be7 N1c3 a6 Na3 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 c4 Be7 N1c3 a6 Na3 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 g3 a6 N5c3 Nf6 Bg2 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 Qc7 Be3 Nf6 Be2 a6 a3 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 Qc7 Be3 Nf6 a3 a6 f3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 a6 Be2 Qc7 f4 d6 Be3 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 d6 Bc4 Nf6 Bb3 Be7 f4 Qa5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 d6 Be3 Nf6 f4 Be7 Qf3 e5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 c4 Nf6 Bg5 Qa5+ Bd2 Qe5 Nxc6 Qxe4+ ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 a5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O O-O Nxe4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Be2 O-O O-O d5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Be2 O-O f4 e5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Nb3 O-O Be2 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Nb3 Nf6 Be2 O-O O-O d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Nb3 d5 Be2 Nf6 h4 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nxc6 bxc6 Qd4 Nf6 e5 Nd5 e6 f6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nxc6 bxc6 Qd4 f6 Bc4 e6 O-O Nh6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 O-O Be2 b6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 O-O Be2 b6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 O-O Be2 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 O-O Be2 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 d6 Be2 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 a6 Bc4 e6 c3 Qc7 O-O d6 a4 Nf6 d3 Be7 Na3 Nc6 ",
	"e4 c5 Nf3 a6 Nc3 b5 a4 b4 Nd5 Bb7 d3 Bxd5 exd5 Nf6 d4 Nxd5 ",
	"e4 c5 Nf3 a6 c4 e6 Nc3 Nc6 d4 cxd4 Nxd4 Qc7 Be2 Nf6 Be3 Bb4 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Qxd7 Nc3 Nc6 d4 cxd4 Nxd4 g6 O-O Bg7 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Qxd7 O-O Nc6 c3 Nf6 Qe2 e6 d4 cxd4 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Qxd7 O-O Nc6 c3 Nf6 Re1 e6 d4 cxd4 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Qxd7 O-O Nc6 c3 d5 exd5 Qxd5 d4 e6 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Qxd7 O-O Nc6 d3 e6 Nbd2 g6 a4 Bg7 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 a4 Nc6 O-O Nf6 Re1 g6 c3 Bg7 d4 cxd4 ",
	"e4 c5 Nf3 d6 Bb5+ Nc6 O-O Bd7 c3 Nf6 Re1 a6 Bxc6 Bxc6 d4 Bxe4 ",
	"e4 c5 Nf3 d6 Bb5+ Nc6 O-O a6 Bxc6+ bxc6 d4 cxd4 Qxd4 e5 Qd3 Nf6 ",
	"e4 c5 Nf3 d6 Bb5+ Nc6 c3 Nf6 Qe2 e6 d4 cxd4 cxd4 d5 e5 Nd7 ",
	"e4 c5 Nf3 d6 Bb5+ Nd7 c3 Nf6 Qe2 a6 Ba4 c4 Bc2 Qc7 b3 cxb3 ",
	"e4 c5 Nf3 d6 Bb5+ Nd7 d4 Nf6 Nc3 cxd4 Qxd4 e5 Qd3 h6 Be3 Be7 ",
	"e4 c5 Nf3 d6 Bb5+ Nd7 d4 Nf6 Nc3 cxd4 Qxd4 e5 Qd3 h6 Be3 Be7 ",
	"e4 c5 Nf3 d6 Bb5+ Nd7 d4 Nf6 Nc3 cxd4 Qxd4 e5 Qd3 h6 O-O Be7 ",
	"e4 c5 Nf3 d6 Bc4 e6 O-O Nf6 d3 Be7 Re1 O-O Bb3 Nc6 c3 b5 ",
	"e4 c5 Nf3 d6 Nc3 Nf6 d4 cxd4 Nxd4 a6 Bc4 e6 Bb3 b5 O-O Be7 ",
	"e4 c5 Nf3 d6 Nc3 Nf6 e5 dxe5 Nxe5 e6 Bb5+ Nbd7 d4 Be7 d5 exd5 ",
	"e4 c5 Nf3 d6 Nc3 a6 d4 cxd4 Nxd4 Nf6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 Nc3 a6 g3 Nc6 Bg2 g6 d4 Bg4 dxc5 dxc5 Be3 Qa5 ",
	"e4 c5 Nf3 d6 c3 Nf6 Bd3 Nc6 Bc2 Bg4 d3 g6 Nbd2 Bg7 h3 Bd7 ",
	"e4 c5 Nf3 d6 c3 Nf6 Bd3 Nc6 O-O Bg4 h3 Bh5 Re1 e6 Bf1 d5 ",
	"e4 c5 Nf3 d6 c3 Nf6 Bd3 g6 Bc2 Bg7 d4 O-O h3 cxd4 cxd4 Nc6 ",
	"e4 c5 Nf3 d6 c3 Nf6 Bd3 g6 Bc2 Bg7 d4 cxd4 cxd4 O-O Nc3 Nc6 ",
	"e4 c5 Nf3 d6 d4 Nf6 Bd3 cxd4 Nxd4 Nc6 Nxc6 bxc6 c4 g6 Bd2 Bg7 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 Nbd7 Bc4 g6 f3 a6 Be3 b5 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 a6 a4 Nc6 Be2 e5 Nf3 h6 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 a6 f4 e6 Qf3 Qb6 Nb3 Qc7 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 e6 Be2 Be7 O-O a6 Be3 Qc7 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 e6 Be2 a6 O-O Qc7 f4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 Qb6 Nb3 e6 Be3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Be3 Bd7 Qe2 Rc8 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Be3 Be7 Bb3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Be3 Be7 Qe2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be2 e5 Nf3 h6 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be2 g6 O-O Bg7 Nb3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 e5 Nf3 h6 Bc4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 g6 f3 Bg7 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 Bd7 Be2 e6 Bxf6 gxf6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 Qb6 Nb3 e6 a4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 a6 Qd2 Qb6 Nb3 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 a6 Qd2 e6 O-O-O Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 a6 Qd2 e6 O-O-O Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O Nxd4 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O Nxd4 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 f4 g6 Be2 Bg7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 g3 e6 Bg2 Bd7 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Be7 O-O b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 Be3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 Qe2 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 a3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 f3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 f3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 f4 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 f4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 f4 b4 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 O-O Be7 Bb3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 a3 Be7 Ba2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 a3 Be7 Ba2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 Nbd7 O-O e6 f4 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be6 O-O Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 Bg5 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nf3 Be7 Bg5 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nf3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 Be3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 a4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 f4 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 f4 Qc7 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 Qc7 Be2 e6 O-O b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nb3 Be6 Nd5 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nb3 Be6 Qd2 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nb3 Be7 Be2 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nb3 Be7 f3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nde2 Be7 h3 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nf3 Qc7 a4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 Nbd7 f3 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 f3 Be7 Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 f3 Be7 Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 f3 Nbd7 g4 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bd3 e6 f4 Qb6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nc6 Qd2 e6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 Qd2 h6 Be3 Ng4 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 Qd2 h6 Be3 Ng4 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 Qd3 Nbd7 f4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 Qe2 h6 Bh4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 Qe2 h6 Bh4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 Qf3 h6 Be3 e5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 Qf3 h6 Bh4 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 Qf3 h6 Bxf6 Qxf6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Be2 Qb6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Nbd7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Nbd7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Nb3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Nb3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd3 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd3 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qc7 Bd3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qc7 Bxf6 gxf6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qc7 Bxf6 gxf6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qc7 Bxf6 gxf6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qc7 Qe2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qc7 Qf3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 b5 a4 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 b5 e5 dxe5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 b5 e5 dxe5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 h6 Bh4 Qb6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 g3 Be7 Be3 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 Nc6 Be2 e5 Nb3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 Nc6 Be2 e6 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 Nc6 Be2 e6 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Nbd7 Be2 e5 Nf5 Nc5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Nbd7 Be2 e5 fxe5 dxe5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Nbd7 a4 g6 Bd3 Bg7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Bd3 g6 Nf3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Bd3 g6 O-O Bg7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Nf3 Nbd7 Bd3 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Nf3 Nbd7 a4 g6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Nf3 e6 Bd3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 a4 g6 Bd3 Bg7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nb3 Nbd7 a4 b6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Nbd7 a4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Qc7 Bd3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Qc7 Bd3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Qc7 Bd3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Qc7 Bd3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Bd3 b5 Qf3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Be2 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Qf3 Nbd7 g4 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Qf3 Nbd7 g4 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Qf3 Qb6 a3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 a4 Nc6 Be3 e5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 g3 e5 Nde2 Be7 Bg2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 g3 e5 Nde2 Be7 Bg5 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 g3 e6 Bg2 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 g3 e6 Bg2 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 g3 e6 Bg2 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 g3 e6 Bg2 Be7 O-O Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 h3 g6 g4 Bg7 g5 Nh5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 a6 Na3 b5 Nd5 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 Be7 O-O O-O Be3 a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 Be7 O-O O-O f4 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 Be7 O-O O-O f4 a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 a6 a4 Be7 Be3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be3 a6 f4 Qc7 Bd3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 f4 a6 Qf3 Qb6 Nb3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 f4 a6 Qf3 Qb6 Nb3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g3 Be7 Bg2 O-O O-O Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 Nc6 g5 Nd7 Be3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 a6 g5 Nfd7 Be3 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Bc4 Bg7 O-O O-O h3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be2 Bg7 Be3 Nc6 Nb3 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be2 Bg7 Be3 Nc6 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Bc4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 a6 Bc4 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 f4 Nc6 Bb5 Bd7 Bxc6 bxc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 f4 Nc6 Nxc6 bxc6 e5 Nd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 f3 Nc6 c4 e6 Nc3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 f3 Nc6 c4 e6 Nc3 Be7 Nc2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 f3 e5 Bb5+ Nbd7 Nf5 d5 exd5 a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 f3 e6 Bb5+ Nbd7 Be3 Be7 Nc3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 Nc3 Nf6 Bg5 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 Nc3 Nf6 Bg5 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 Nc3 Nf6 Bg5 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 c4 Nf6 Nc3 g6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 a6 Be3 Nf6 Nc3 Nc6 Qd2 e6 Be2 Be7 ",
	"e4 c5 Nf3 e6 Be2 Nc6 O-O Nf6 Nc3 d5 exd5 Nxd5 d4 cxd4 Nxd4 Nxc3 ",
	"e4 c5 Nf3 e6 Nc3 Nc6 d4 cxd4 Nxd4 Qc7 g3 a6 Bg2 Nf6 O-O Be7 ",
	"e4 c5 Nf3 e6 Nc3 Nc6 d4 cxd4 Nxd4 a6 g3 Nxd4 Qxd4 Ne7 Bf4 Nc6 ",
	"e4 c5 Nf3 e6 Nc3 Nc6 d4 cxd4 Nxd4 a6 g3 d6 Bg2 Bd7 O-O Nf6 ",
	"e4 c5 Nf3 e6 Nc3 Nc6 g3 d5 exd5 exd5 Bg2 d4 Ne2 Nf6 d3 Bd6 ",
	"e4 c5 Nf3 e6 Nc3 a6 d4 cxd4 Nxd4 Qc7 Bd3 Nc6 Nb3 Nf6 O-O b5 ",
	"e4 c5 Nf3 e6 Nc3 a6 g3 Nc6 Bg2 Nge7 d4 cxd4 Nxd4 Nxd4 Qxd4 Nc6 ",
	"e4 c5 Nf3 e6 Nc3 a6 g3 Nc6 Bg2 d6 O-O Nf6 d3 Be7 Re1 O-O ",
	"e4 c5 Nf3 e6 Nc3 a6 g3 Qc7 Bg2 d6 O-O Nf6 d4 cxd4 Nxd4 Be7 ",
	"e4 c5 Nf3 e6 Nc3 a6 g3 d6 Bg2 Nf6 O-O Be7 e5 dxe5 Nxe5 Nbd7 ",
	"e4 c5 Nf3 e6 b3 Nf6 e5 Nd5 Bb2 Be7 c4 Nc7 Nc3 f6 Ne4 fxe5 ",
	"e4 c5 Nf3 e6 b3 Nf6 e5 Nd5 Bb2 Nc6 c4 Nc7 Nc3 d6 exd6 Bxd6 ",
	"e4 c5 Nf3 e6 b3 b6 Bb2 Bb7 Nc3 Nf6 e5 Nd5 Nxd5 Bxd5 c4 Bb7 ",
	"e4 c5 Nf3 e6 b3 d6 Bb2 Nc6 Bb5 Bd7 O-O Nf6 Re1 Be7 d4 cxd4 ",
	"e4 c5 Nf3 e6 c3 d5 e5 Nc6 d4 Qb6 a3 c4 Nbd2 Bd7 Be2 Na5 ",
	"e4 c5 Nf3 e6 c3 d5 exd5 exd5 d4 Nc6 Be2 Bd6 O-O Nge7 dxc5 Bxc5 ",
	"e4 c5 Nf3 e6 c4 Nc6 Nc3 Nf6 d4 cxd4 Nxd4 Bb4 Nxc6 dxc6 Qxd8+ Kxd8 ",
	"e4 c5 Nf3 e6 d3 Nc6 g3 Nge7 Bg2 g6 O-O Bg7 Re1 e5 Nc3 d6 ",
	"e4 c5 Nf3 e6 d3 Nc6 g3 d5 Nbd2 Bd6 Bg2 Nge7 O-O O-O Re1 Bc7 ",
	"e4 c5 Nf3 e6 d3 Nc6 g3 d5 Nbd2 Bd6 Bg2 Nge7 O-O O-O Re1 Qc7 ",
	"e4 c5 Nf3 e6 d3 Nc6 g3 d5 Nbd2 g6 Bg2 Bg7 O-O Nge7 Re1 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Bc5 Nb3 Bb6 Nc3 Ne7 Bf4 O-O Bd6 Nbc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Be3 Nf6 Bd3 e5 Nxc6 bxc6 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Be3 Nf6 Nc3 Bb4 Bd3 a6 Ne2 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Be3 Nf6 Nxc6 bxc6 Bd3 d5 e5 Nd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 Bf4 e5 Be3 a6 N5c3 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N5c3 Be7 Be2 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Nf6 Ndb5 Bb4 a3 Bxc3+ Nxc3 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Nf6 Nxc6 bxc6 e5 Nd5 Nxd5 cxd5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 Nf6 Be3 a6 O-O Bb4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 Nf6 O-O a6 Be3 Bb4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Be3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Be3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Be3 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Kh1 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Kh1 Nxd4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Kh1 Nxd4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Kh1 Nxd4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Kh1 Nxd4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Kh1 Nxd4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 a4 Bb4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 f4 Nxd4 Qxd4 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be3 Nf6 Bd3 a6 O-O b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be3 a6 Bd3 b5 O-O Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 f4 a6 Be3 b5 Nb3 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 g3 Nf6 Bg2 d6 O-O Bd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 g3 a6 Bg2 Nf6 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 g3 a6 Bg2 Nf6 O-O d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 g3 a6 Bg2 Nf6 O-O d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 g3 a6 Bg2 d6 O-O Bd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 Qc7 O-O Nf6 Be3 Bb4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 Qc7 O-O Nf6 Be3 Bb4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 Qc7 O-O Nf6 Be3 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 Qc7 O-O Nf6 Kh1 Bb4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 Qc7 f4 b5 Nxc6 Qxc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be3 Qc7 Bd3 Nf6 O-O Ne5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be3 Qc7 Qd2 Nf6 f3 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 f4 Qc7 Nxc6 Qxc6 Bd3 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 g3 Nge7 Nb3 Na5 Bg2 Nec6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 g3 Nge7 Nb3 Na5 Bg2 Nec6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 g3 Nge7 Nb3 Na5 Qh5 Nxb3 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 g3 Nge7 Nde2 b5 a3 Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 g3 d6 Bg2 Bd7 O-O Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be2 Nf6 Be3 Be7 f4 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be2 Nf6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be2 Nf6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be2 Nf6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be3 Be7 Bc4 Nf6 Qe2 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be3 Nf6 Bc4 Qc7 Bb3 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be3 Nf6 Bc4 a6 Qe2 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be3 Nf6 Be2 Be7 O-O O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be3 Nf6 Be2 Be7 Qd2 Nxd4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 g3 Nf6 Bg2 Bd7 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 g3 Bc5 Nb3 Be7 Bg2 Nf6 O-O d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Bd3 Nc6 Nxc6 dxc6 Bf4 Nd7 Nd2 e5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Bb4 Bd3 d5 e5 Nfd7 Qg4 g6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Nxc6 bxc6 e5 Nd5 Ne4 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Nxc6 bxc6 e5 Nd5 Ne4 f5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Qc7 Bd3 a6 O-O b5 Qe2 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Qc7 g3 d6 Bg2 Nc6 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Be7 O-O a6 Bb3 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Be7 O-O a6 Bb3 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bd3 Be7 O-O O-O Qe2 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bd3 Nc6 Bb5 Bd7 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 Be3 a6 f4 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O Be3 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O f4 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O f4 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O f4 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O f4 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 f4 O-O O-O a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 Be3 Qc7 O-O b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 O-O Be7 Be3 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 a4 Nc6 Be3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 a6 Bd3 b5 a3 Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 a6 Be2 Nbd7 f4 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 a6 Qd2 b5 f3 Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 a6 f4 b5 a3 Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 f4 Nc6 Be3 e5 Nxc6 bxc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 f4 a6 Be2 Be7 O-O O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 f4 a6 Be3 b5 Qf3 Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g3 Nc6 Bg2 Bd7 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 Nc6 g5 Nd7 Rg1 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 g5 hxg5 Bxg5 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 h4 Be7 Be3 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 h4 Nc6 Rg1 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nc6 Nxc6 bxc6 O-O d5 Nd2 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nc6 Nxc6 dxc6 O-O e5 Nd2 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nc6 Nxc6 dxc6 O-O e5 Nd2 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O Qc7 Be3 d6 Nc3 Nbd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O Qc7 Nc3 Bc5 Nb3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O Qc7 Qe2 d6 c4 Nbd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O Qc7 Qe2 d6 c4 Nbd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O Qc7 c4 d6 Nc3 g6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O d6 Qe2 g6 c4 Bg7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O d6 c4 Qc7 Qe2 g6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 b5 O-O Bb7 Qe2 Nf6 Nd2 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 b6 O-O Bb7 Nc3 d6 Kh1 Nd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 d6 O-O Nf6 Be3 g6 c4 Bg7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Nc6 Be2 Qc7 f4 b5 Nxc6 Qxc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Nc6 Be3 Nf6 Bd3 d5 exd5 exd5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Bd2 Nc6 Nf3 Nf6 Be2 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Bd3 Nc6 Be3 Nf6 O-O b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Bd3 Nc6 Nde2 Nf6 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Bd3 Nc6 Nxc6 bxc6 O-O Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Bd3 Nf6 O-O Nc6 Nxc6 dxc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Be2 b5 a3 Bb7 f4 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Be3 Bb4 Bd2 Nf6 Bd3 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Be3 Nf6 a3 b5 Bd3 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 a3 Nc6 Be3 Nf6 Be2 Bd6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 a3 b5 g3 Bb7 Bg2 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 f4 b5 Bd3 Bb7 Qf3 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 f4 b5 a3 Bb7 Qf3 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 g3 Bb4 Ne2 Nf6 Bg2 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 d6 Be2 Nf6 f4 Be7 O-O O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 c4 Nf6 Nc3 Bb4 Bd2 O-O e5 Bxc3 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 c4 Nf6 Nc3 Bb4 Bd3 Nc6 Ne2 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 c4 Nf6 Nc3 Bb4 Bd3 Nc6 Ne2 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 c4 Nf6 Nc3 Qc7 Bd3 Be7 f4 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 c4 Nf6 Nc3 Qc7 Bd3 Nc6 Nf3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 c4 Nf6 Nc3 Qc7 Be2 Bc5 Be3 d6 ",
	"e4 c5 Nf3 g6 Bc4 Bg7 c3 e6 d4 cxd4 Nxd4 a6 O-O Ne7 a4 d5 ",
	"e4 c5 Nf3 g6 Nc3 Bg7 d4 cxd4 Nxd4 Nc6 Be3 Nf6 f3 O-O Bc4 Qb6 ",
	"e4 c5 Nf3 g6 c3 d5 Bb5+ Bd7 Bxd7+ Qxd7 exd5 Qxd5 d4 cxd4 Qxd4 Qxd4 ",
	"e4 c5 Nf3 g6 c4 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Nc2 Bg7 Be2 Nd7 ",
	"e4 c5 Nf3 g6 d4 Bg7 Nc3 cxd4 Nxd4 d6 Be3 Nf6 Bc4 Ng4 Bb5+ Kf8 ",
	"e4 c5 Nf3 g6 d4 cxd4 Nxd4 Bg7 c4 Nf6 Nc3 d6 Be2 O-O O-O Nc6 ",
	"e4 c5 Nf3 g6 d4 cxd4 Nxd4 Nc6 Nc3 Bg7 Be3 Nf6 Bc4 Qa5 O-O O-O ",
	"e4 c5 b3 d6 f4 Nf6 Bb5+ Nc6 Bxc6+ bxc6 Qe2 g6 Bb2 Bg7 c4 O-O ",
	"e4 c5 b4 cxb4 a3 bxa3 Bxa3 d6 Nf3 Nc6 d4 g6 h4 Bg4 c3 Bg7 ",
	"e4 c5 c3 Nf6 e5 Nd5 Nf3 Nc6 Na3 g6 g3 Bg7 Bg2 Nc7 Qe2 O-O ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 cxd4 Bc4 Qc7 Qe2 Nb6 Bb3 Nc6 Nf3 d5 ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 cxd4 Nf3 Nc6 Bc4 Nb6 Bb3 d5 exd6 Qxd6 ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 cxd4 Nf3 Nc6 cxd4 d6 Bc4 Nb6 Bb5 dxe5 ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 cxd4 cxd4 Nc6 Nf3 d6 Nc3 Nxc3 bxc3 Qa5 ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 e6 c4 Nb6 d5 d6 exd6 Bxd6 Nc3 e5 ",
	"e4 c5 c3 d5 exd5 Qxd5 Nf3 Nc6 d4 Bg4 Be2 cxd4 cxd4 e6 Nc3 Qa5 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 Nc6 Nf3 Nf6 Be2 cxd4 cxd4 e6 O-O Be7 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 Nc6 dxc5 Qxc5 Be3 Qa5 Nf3 Nf6 Bc4 e6 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 Nf6 Nf3 Bg4 Be2 e6 O-O Nc6 Be3 cxd4 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 e6 Nf3 Nf6 Bd3 Be7 O-O O-O Qe2 cxd4 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 e6 Nf3 Nf6 Be3 Be7 Be2 cxd4 cxd4 O-O ",
	"e4 c5 c3 d6 Nf3 Nf6 Bd3 Nc6 Bc2 Bg4 d3 e6 Nbd2 Be7 h3 Bh5 ",
	"e4 c5 c3 d6 Nf3 Nf6 Bd3 Nc6 Bc2 Bg4 d3 e6 Nbd2 Be7 h3 Bh5 ",
	"e4 c5 c3 e6 d4 d5 exd5 exd5 Nf3 Bd6 Be3 c4 b3 cxb3 axb3 Ne7 ",
	"e4 c5 c3 e6 d4 d5 exd5 exd5 Nf3 Nc6 Nbd2 cxd4 cxd4 Bd6 Bd3 Nge7 ",
	"e4 c5 c4 Nc6 Nc3 Nf6 d3 e6 f4 d5 e5 Ng8 Nf3 Nge7 Be2 Nf5 ",
	"e4 c5 c4 Nc6 Nc3 g6 d3 Bg7 g3 d6 Bg2 e6 Nge2 Nge7 Bg5 h6 ",
	"e4 c5 c4 Nc6 f4 g6 Nf3 Bg7 Nc3 e6 b3 Nge7 Bb2 d5 e5 b6 ",
	"e4 c5 d4 cxd4 c3 Nf6 e5 Nd5 cxd4 Nc6 Nc3 Nxc3 bxc3 d5 Bd3 e6 ",
	"e4 c5 d4 cxd4 c3 Nf6 e5 Nd5 cxd4 e6 Nf3 Nc6 Bd3 d6 a3 dxe5 ",
	"e4 c5 f4 e6 Nf3 d5 e5 Nc6 d3 Nge7 Nc3 Nf5 Be2 Be7 O-O O-O ",
	"e4 c5 g3 Nc6 Bg2 e6 f4 d5 d3 dxe4 dxe4 Qxd1+ Kxd1 e5 Nc3 Bg4+ ",
	"e4 c5 g3 d5 exd5 Qxd5 Nf3 Bg4 Bg2 Qe6+ Kf1 Nc6 h3 Bh5 d3 Qd7 ",
	"e4 c5 g3 g6 Bg2 Bg7 d3 Nc6 Ne2 e6 O-O Nge7 Nbc3 d6 Be3 Nd4 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 Be2 e6 d4 Nf6 e5 Nfd7 O-O Be7 Ne1 Bxe2 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 Be2 Nbd7 Qg3 g6 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 Be2 Nbd7 Qg3 g6 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 Be2 Nbd7 Qg3 g6 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 g3 Bb4 Bd2 d4 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 g3 Bb4 Bd2 d4 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 g3 Bb4 Bd2 d4 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 g3 Bb4 Bd2 d4 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 g3 Bb4 Bd2 d4 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 g3 Bb4 Bd2 d4 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 e6 Be2 Nd7 O-O Ngf6 d4 dxe4 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 e6 d4 Nf6 Bg5 dxe4 Nxe4 Be7 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Nd7 a4 Ngf6 Nxf6+ Nxf6 a5 a6 Bc4 Bf5 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Nf6 Nxf6+ gxf6 Bc4 Qc7 O-O Bg4 d4 e6 ",
	"e4 c6 Nc3 d5 d4 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 Bd3 Bxd3 ",
	"e4 c6 Nc3 d5 d4 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 Bd3 Bxd3 ",
	"e4 c6 Nf3 d5 exd5 cxd5 Bb5+ Nc6 Ne5 Bd7 Nxd7 Qxd7 d4 a6 Bxc6 Qxc6 ",
	"e4 c6 c4 d5 cxd5 cxd5 exd5 Nf6 Nc3 Nxd5 Nf3 e6 d4 Be7 Bd3 Nc6 ",
	"e4 c6 c4 d5 cxd5 cxd5 exd5 Nf6 Nc3 Nxd5 d4 Nc6 Nf3 Bg4 Qb3 Bxf3 ",
	"e4 c6 c4 d5 exd5 cxd5 cxd5 Nf6 Nc3 Nxd5 Nf3 Nc6 d4 Bg4 Qb3 Bxf3 ",
	"e4 c6 c4 d5 exd5 cxd5 cxd5 Nf6 Nc3 Nxd5 Nf3 Nxc3 bxc3 g6 d4 Bg7 ",
	"e4 c6 d3 d5 Nd2 e5 Ngf3 Bd6 Qe2 Nf6 g3 O-O Bg2 Re8 O-O a5 ",
	"e4 c6 d3 d5 Nd2 e5 Ngf3 Bd6 g3 Ne7 Bg2 O-O O-O Nd7 Re1 f5 ",
	"e4 c6 d3 e5 g3 g6 d4 Nf6 Nc3 Qa5 Bg2 d6 Ne2 Bg7 dxe5 dxe5 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Bc4 e6 N1e2 Nf6 O-O Bd6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 N1e2 Nf6 h4 h6 Nf4 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 N1e2 Nf6 h4 h6 Nf4 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 Bd3 Qc7 O-O Ngf6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 Bd3 e6 O-O Ngf6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 h4 h6 Bd3 Bxd3 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 h4 h6 Bd3 Bxd3 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nf6 Be2 Nbd7 c3 Qc7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 f4 e6 Nf3 Bd6 Bd3 Ne7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 N1e2 Nf6 Nf4 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 Bd3 Bxd3 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nh3 Bh7 Bc4 Nf6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 h5 Bh7 Nf3 Nf6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Qf3 e6 Be3 Qa5+ Bd2 Qd5 Bd3 Qxd4 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 a5 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 a5 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 a5 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 h6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Nxf6+ Nxf6 c3 e6 Nf3 Be7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Ng3 c5 d5 Nb6 Bb5+ Bd7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Ng5 Ngf6 Bd3 Qc7 Qe2 h6 N5f3 e6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nf6 Nxf6+ exf6 g3 Bd6 Bg2 O-O Nf3 Qa5+ ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nf6 Nxf6+ gxf6 Be2 Bf5 Nf3 e6 O-O Bg7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 Bd3 Ngf6 O-O e6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 Bd3 Qc7 O-O e6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bd3 h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Bc4 Ngf6 Nxf6+ Nxf6 Nf3 Bf5 O-O e6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Nf3 Ngf6 Ng3 c5 Bd3 cxd4 Nxd4 g6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Ng5 Ngf6 Bd3 Qc7 Ne2 e6 Bf4 Bd6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Ng5 Ngf6 Bd3 e6 N1f3 Bd6 Qe2 h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 c3 Ngf6 Nxf6+ Nxf6 Bc4 e6 Nf3 Be7 ",
	"e4 c6 d4 d5 e5 Bf5 Bd3 Bxd3 Qxd3 e6 Nc3 Qb6 Nge2 c5 dxc5 Bxc5 ",
	"e4 c6 d4 d5 e5 Bf5 Bd3 Bxd3 Qxd3 e6 Ne2 Qb6 O-O Qa6 Qd1 c5 ",
	"e4 c6 d4 d5 e5 Bf5 Bd3 Bxd3 Qxd3 e6 Nf3 Qa5+ Bd2 Qa6 Nc3 Ne7 ",
	"e4 c6 d4 d5 e5 Bf5 Nc3 Qb6 g4 Bd7 Na4 Qc7 Be3 e6 Bg2 Ne7 ",
	"e4 c6 d4 d5 e5 Bf5 Nc3 Qb6 g4 Bd7 Na4 Qc7 Nc5 e6 Nd3 c5 ",
	"e4 c6 d4 d5 e5 Bf5 Nc3 Qb6 g4 Bd7 Na4 Qc7 Nc5 e6 Nxd7 Nxd7 ",
	"e4 c6 d4 d5 e5 Bf5 Nf3 e6 Be2 c5 O-O Nc6 c3 cxd4 cxd4 Nge7 ",
	"e4 c6 d4 d5 e5 Bf5 Nf3 e6 Be2 c5 O-O Nc6 c3 cxd4 cxd4 Nge7 ",
	"e4 c6 d4 d5 e5 Bf5 c3 e6 Be2 c5 a3 c4 Nd2 Nc6 Ngf3 Be7 ",
	"e4 c6 d4 d5 e5 Bf5 c3 e6 Be3 Nd7 Nd2 Ne7 f4 f6 Ngf3 fxe5 ",
	"e4 c6 d4 d5 e5 Bf5 h4 h6 g4 Bd7 c3 c5 Bg2 e6 Ne2 Bb5 ",
	"e4 c6 d4 d5 e5 Bf5 h4 h6 g4 Bd7 c3 c5 Bg2 e6 Ne2 Bb5 ",
	"e4 c6 d4 d5 e5 c5 c4 Nc6 dxc5 d4 Bf4 e6 Nf3 Bxc5 a3 a5 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nc6 c3 Nf6 Bf4 Bg4 Nf3 e6 Nbd2 Bd6 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nc6 c3 Nf6 Bf4 Bg4 Qb3 Na5 Qa4+ Bd7 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nc6 c3 Nf6 Bg5 Bg4 Ne2 e6 Qb3 Qd7 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nc6 c3 Qc7 Ne2 Bg4 Qb3 Bxe2 Bxe2 Rd8 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nf6 Bf4 Nc6 c3 Bg4 Nf3 a6 Nbd2 e6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Bg5 dxc4 d5 Ne5 Qd4 Nd3+ ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Bg5 e6 Nf3 dxc4 Bxc4 Be7 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Bb4 Qb3 Nc6 Bd3 O-O ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Bb4 cxd5 Nxd5 Bd2 Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Bb4 cxd5 exd5 Bb5+ Bd7 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 Bf4 dxc4 Bxc4 O-O ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 g6 Qb3 Bg7 cxd5 O-O Be2 Nbd7 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 g6 Qb3 Bg7 cxd5 O-O Be2 Nbd7 ",
	"e4 d5 exd5 Nf6 c4 c6 Nc3 cxd5 cxd5 Nxd5 Nf3 Nc6 Bc4 e6 d4 Nxc3 ",
	"e4 d5 exd5 Nf6 c4 c6 d4 cxd5 Nc3 g6 Qb3 Bg7 cxd5 O-O Nf3 Nbd7 ",
	"e4 d5 exd5 Nf6 c4 c6 dxc6 Nxc6 Nf3 e5 d3 e4 dxe4 Qxd1+ Kxd1 Nxe4 ",
	"e4 d5 exd5 Nf6 c4 e6 dxe6 Bxe6 Nf3 Nc6 Be2 Bc5 O-O Qd7 d3 O-O ",
	"e4 d5 exd5 Nf6 c4 e6 dxe6 Bxe6 d4 Bb4+ Bd2 Bxd2+ Qxd2 Qe7 Qe2 Nc6 ",
	"e4 d5 exd5 Nf6 d4 Nxd5 Nf3 Bg4 Be2 Nc6 c4 Nb6 d5 Bxf3 gxf3 Ne5 ",
	"e4 d5 exd5 Nf6 d4 Nxd5 Nf3 Bg4 Be2 c6 O-O e6 c4 Nf6 Nc3 Nbd7 ",
	"e4 d5 exd5 Nf6 d4 Nxd5 Nf3 Bg4 Be2 e6 O-O Nd7 c4 N5f6 Nc3 c6 ",
	"e4 d5 exd5 Nf6 d4 Nxd5 c4 Nb6 Nc3 e5 Nf3 exd4 Qxd4 Nc6 Qxd8+ Nxd8 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 Bc4 Nf6 d3 Bg4 Ne2 e6 Bf4 Bd6 Qd2 Bxe2 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 Nf6 Bc4 Nc6 Ne2 Be6 Bd3 O-O-O O-O Bf5 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 Nf6 Bd2 c6 Nf3 Bf5 Bc4 Qc7 Ne5 e6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 Nf6 Bd3 Nc6 Bd2 e5 Nb5 Qb6 Qe2 a6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 Nf6 Bd3 Nc6 Ne2 Bg4 f3 Bh5 Bd2 e5 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 Nf6 Bd3 Nc6 Ne2 Bg4 f3 Bh5 Be3 O-O-O ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 Nf6 Nf3 Bf5 Ne5 c6 Bc4 e6 O-O Nbd7 ",
	"e4 d6 d4 Nf6 Bd3 e5 c3 d5 dxe5 Nxe4 Nf3 Nc6 Nbd2 Nc5 Bc2 Bg4 ",
	"e4 d6 d4 Nf6 Nc3 c6 Be2 Nbd7 Nf3 e5 O-O Be7 Re1 O-O a4 Qc7 ",
	"e4 d6 d4 Nf6 Nc3 c6 Be3 Nbd7 h3 e5 f4 Qb6 Qd2 Qxb2 Rb1 Qa3 ",
	"e4 d6 d4 Nf6 Nc3 c6 Nf3 Bg4 a4 e6 Be2 d5 e5 Nfd7 O-O c5 ",
	"e4 d6 d4 Nf6 Nc3 c6 f4 Qa5 Bd3 e5 Nf3 Bg4 fxe5 dxe5 Be3 Nbd7 ",
	"e4 d6 d4 Nf6 Nc3 c6 f4 Qa5 Bd3 e5 dxe5 dxe5 Nf3 Bg4 fxe5 Nfd7 ",
	"e4 d6 d4 Nf6 Nc3 c6 f4 Qa5 Bd3 e5 dxe5 dxe5 Nf3 Bg4 fxe5 Nfd7 ",
	"e4 d6 d4 Nf6 Nc3 g6 Bc4 Bg7 Qe2 c6 e5 Nd5 Bd2 O-O Bb3 a5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be2 Bg7 Be3 c6 a4 a5 h3 Na6 Nf3 Nb4 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be3 Bg7 Qd2 O-O O-O-O c6 f3 b5 g4 Qa5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be3 c6 Qd2 Nbd7 O-O-O Qa5 Kb1 b5 Bd3 Nb6 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be3 c6 a4 Bg7 Qd2 Ng4 Bg5 h6 Bh4 a5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Bg5 c6 Qd2 Nbd7 f3 b5 Nh3 Bg7 Bh6 O-O ",
	"e4 d6 d4 Nf6 Nc3 g6 Bg5 h6 Bf4 Bg7 h3 c5 dxc5 Qa5 Qd2 Qxc5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bg4 Be3 Nc6 Qd2 e5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bg4 Be3 Nc6 Qd2 e5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bg4 Be3 Nc6 h3 Bxf3 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O b6 Be3 Bb7 Nd2 e5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O c6 a4 a5 e5 dxe5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nge2 Bg7 g3 O-O Bg2 e5 O-O c6 a4 a5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Nbd7 e5 Ne8 Qe2 c5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Nc6 d5 Nb4 O-O c6 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Be2 c5 d5 e6 dxe6 Bxe6 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Be2 c5 dxc5 Qa5 Nd2 Qxc5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Be2 c5 dxc5 Qa5 O-O Qxc5+ ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Be2 c5 dxc5 Qa5 O-O Qxc5+ ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O e5 Nfd7 h4 Nb6 h5 Bg4 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 c5 Bb5+ Bd7 Bxd7+ Nfxd7 d5 Na6 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 c5 dxc5 Qa5 Bd3 Qxc5 Qe2 Bg4 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 c5 dxc5 Qa5 Bd3 Qxc5 Qe2 Bg4 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 c5 dxc5 Qa5 Bd3 Qxc5 Qe2 O-O ",
	"e4 d6 d4 Nf6 Nc3 g6 g3 Bg7 Bg2 Nbd7 Nge2 e5 O-O O-O dxe5 dxe5 ",
	"e4 d6 d4 Nf6 f3 g6 c4 Bg7 Nc3 O-O Be3 a6 Qd2 Nc6 Nge2 Rb8 ",
	"e4 d6 d4 e5 Nf3 exd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 Qd2 O-O f3 Nc6 ",
	"e4 d6 d4 g6 Bc4 Nf6 Qe2 Nc6 Nf3 Bg4 c3 e5 Bb5 exd4 cxd4 Nd7 ",
	"e4 d6 d4 g6 Nc3 Bg7 Be3 c6 Qd2 b5 Bd3 Nd7 a4 b4 Nce2 Rb8 ",
	"e4 d6 d4 g6 Nc3 Bg7 Nf3 a6 a4 b6 Be2 Nf6 O-O O-O Re1 c5 ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 Nf6 Nf3 O-O Bd3 Na6 O-O c5 d5 Bg4 ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 Nf6 Nf3 O-O Be2 c5 dxc5 Qa5 O-O Qxc5+ ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 Nf6 Nf3 c5 Bb5+ Bd7 e5 Ng4 e6 fxe6 ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 c6 Nf3 Bg4 Be3 Qb6 Qd2 Bxf3 gxf3 Qa5 ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 c6 Nf3 Bg4 Be3 Qb6 Qd3 Nf6 Be2 d5 ",
	"e4 d6 d4 g6 Nf3 Bg7 Nc3 Nf6 Be2 O-O O-O c6 a4 Qc7 a5 e5 ",
	"e4 d6 d4 g6 Nf3 Nf6 Nc3 Bg7 Be2 O-O O-O Bg4 Be3 Nc6 Qd2 e5 ",
	"e4 d6 d4 g6 c4 Bg7 Nc3 Nc6 Nge2 e5 d5 Nce7 Ng3 c5 a3 h5 ",
	"e4 e5 Bc4 Bc5 Nf3 Nc6 Nc3 Nf6 d3 d6 Be3 Bb6 Qd2 O-O O-O-O Be6 ",
	"e4 e5 Bc4 Nf6 d3 Nc6 Nc3 Bc5 f4 d6 Nf3 O-O Na4 Bg4 Nxc5 dxc5 ",
	"e4 e5 Bc4 Nf6 d3 Nc6 Nf3 Bc5 O-O a6 c3 Ba7 Bb3 O-O Bg5 h6 ",
	"e4 e5 Bc4 Nf6 d3 c6 Nf3 Be7 O-O d6 c3 O-O Re1 Nbd7 Nbd2 Nb6 ",
	"e4 e5 Bc4 Nf6 d3 c6 Nf3 d6 O-O Be7 Bb3 O-O Nc3 Nbd7 d4 b5 ",
	"e4 e5 Bc4 Nf6 d3 c6 Qe2 Bc5 Nf3 O-O O-O d5 Bb3 a5 a4 h6 ",
	"e4 e5 Nc3 Bc5 Nf3 d6 Na4 Bb6 Nxb6 axb6 d4 exd4 Qxd4 Qf6 Bg5 Qxd4 ",
	"e4 e5 Nc3 Bc5 g3 Nc6 Bg2 a6 d3 d6 Nge2 Nge7 Nd5 O-O O-O Be6 ",
	"e4 e5 Nc3 Bc5 g3 Nc6 Bg2 a6 d3 d6 Nge2 Nge7 Nd5 O-O O-O Be6 ",
	"e4 e5 Nc3 Bc5 g3 Nc6 Bg2 d6 Na4 Be6 Nxc5 dxc5 d3 Nf6 Ne2 Qd6 ",
	"e4 e5 Nc3 Nc6 Bc4 Nf6 d3 Bb4 Ne2 d5 exd5 Nxd5 a3 Bxc3+ bxc3 Be6 ",
	"e4 e5 Nc3 Nc6 f4 exf4 Nf3 g5 h4 g4 Ng5 h6 Nxf7 Kxf7 d4 d5 ",
	"e4 e5 Nc3 Nf6 Bc4 Bb4 d3 c6 Qe2 O-O Bg5 d5 Bxf6 gxf6 Bb3 d4 ",
	"e4 e5 Nc3 Nf6 Bc4 Bb4 f4 d6 Nf3 O-O Nd5 Nxd5 Bxd5 Nc6 c3 Bc5 ",
	"e4 e5 Nc3 Nf6 Bc4 Nc6 d3 Bb4 Bg5 d6 Nf3 h6 Bh4 Qe7 a3 Bxc3+ ",
	"e4 e5 Nc3 Nf6 Bc4 Nxe4 Qh5 Nd6 Qxe5+ Qe7 Qxe7+ Bxe7 Bb3 Nf5 Nf3 c6 ",
	"e4 e5 Nc3 Nf6 Nf3 Nc6 Bb5 Nd4 Ba4 Nxf3+ Qxf3 Bc5 d3 c6 Bb3 d6 ",
	"e4 e5 Nc3 Nf6 f4 d5 d3 Nc6 fxe5 Nxe5 d4 Ng6 exd5 Nxd5 Nxd5 Qxd5 ",
	"e4 e5 Nc3 Nf6 f4 d5 d3 d4 Nce2 Nc6 Nf3 Bd6 c3 Bg4 fxe5 Bxe5 ",
	"e4 e5 Nc3 Nf6 f4 d5 d3 exf4 e5 d4 Nce2 Nd5 Nxf4 Bb4+ Kf2 Nc6 ",
	"e4 e5 Nc3 Nf6 f4 d5 fxe5 Nxe4 Nf3 Bb4 Qe2 Bxc3 bxc3 O-O Qe3 f6 ",
	"e4 e5 Nc3 Nf6 f4 d5 fxe5 Nxe4 Nf3 Be7 Qe2 Nxc3 bxc3 O-O Qe3 f6 ",
	"e4 e5 Nc3 Nf6 f4 d5 fxe5 Nxe4 Nf3 Be7 Qe2 Nxc3 dxc3 c5 Bf4 Nc6 ",
	"e4 e5 Nc3 Nf6 f4 d5 fxe5 Nxe4 Nf3 Be7 d4 O-O Bd3 f5 exf6 Bxf6 ",
	"e4 e5 Nc3 Nf6 f4 d5 fxe5 Nxe4 Qf3 f5 d3 Nxc3 bxc3 d4 Nh3 Nc6 ",
	"e4 e5 Nc3 Nf6 g3 Bb4 Bg2 O-O Nge2 c6 d4 d5 exd5 exd4 Qxd4 Nxd5 ",
	"e4 e5 Nc3 Nf6 g3 Bc5 Bg2 Nc6 Nge2 h5 Na4 Be7 d4 h4 d5 Na5 ",
	"e4 e5 Nc3 Nf6 g3 Bc5 Bg2 Nc6 d3 a6 Nge2 d6 h3 Be6 f4 h6 ",
	"e4 e5 Nc3 Nf6 g3 d5 exd5 Nxd5 Bg2 Nxc3 bxc3 Nc6 Ne2 Bc5 O-O O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Bc5 O-O Nd4 Nxd4 Bxd4 c3 Bb6 d4 c6 Ba4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 Bc5 O-O d6 c3 Bd7 d4 Bb6 Bg5 Nf6 dxe5 Nxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 Bc5 c3 Qe7 O-O f6 d4 Bb6 Na3 Nd8 Nc4 Nf7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 Bc4 Nf6 Qe2 Bc5 e5 O-O O-O d5 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Bc5 c3 O-O d4 Bb6 Bg5 h6 Bh4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Nc3 d6 d4 Bd7 Be3 O-O Qe2 Ng4 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Re1 d6 d4 Bd7 Nc3 exd4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Be7 Qe2 Nd6 Bxc6 bxc6 dxe5 Nb7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Be7 Qe2 Nd6 Bxc6 bxc6 dxe5 Nb7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Be7 Qe2 Nd6 Bxc6 bxc6 dxe5 Nb7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Be7 Qe2 Nd6 Bxc6 bxc6 dxe5 Nb7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Ba4 e4 Re1 Be7 Ne5 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Bxc6 dxc6 dxe5 Nf5 Qxd8+ Kxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Bxc6 dxc6 dxe5 Nf5 Qxd8+ Kxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 Nc3 Be7 d4 Bd7 Re1 exd4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 d4 Bd7 Nc3 Be7 Bxc6 Bxc6 Qd3 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 d4 Bd7 Nc3 Be7 Re1 exd4 Nxd4 Nxd4 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 d4 Bd7 Nc3 Be7 Re1 exd4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 d4 Bd7 Nc3 exd4 Nxd4 Be7 Re1 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d3 Bc5 Nc3 d6 Bg5 Bb4 O-O Bxc3 bxc3 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d3 Bc5 Nc3 d6 Bg5 h6 Be3 Bb6 a4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d3 Bc5 c3 d6 b4 Bb6 a4 a6 Bc4 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d3 d6 Nc3 Bd7 O-O g6 Bg5 h6 Bxf6 Qxf6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d3 d6 O-O Bd7 c3 Be7 Nbd2 O-O Re1 Re8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d3 d6 c3 Bd7 O-O g6 Re1 Bg7 Nbd2 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d3 d6 c3 Bd7 O-O g6 Re1 Bg7 Nbd2 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d4 Nxe4 dxe5 d5 O-O Bc5 Nbd2 O-O Qe2 Nxd2 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d4 exd4 Nxd4 Be7 O-O a6 Nxc6 bxc6 Bd3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d4 exd4 e5 Nd5 O-O Bc5 c3 O-O cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d4 exd4 e5 Ne4 O-O a6 Ba4 Nc5 Bxc6 dxc6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d4 exd4 e5 Ne4 O-O a6 Bxc6 dxc6 Qxd4 Bf5 ",
	"e4 e5 Nf3 Nc6 Bb5 Nge7 d4 exd4 Nxd4 g6 Nxc6 Nxc6 Bxc6 bxc6 Qd4 f6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Bxc6 bxc6 Nc3 d6 d4 Nd7 dxe5 dxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Bxc6 dxc6 Nc3 Bd6 d4 Bb4 Nxe5 Nxe4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Bxc6 dxc6 d3 Nd7 Nbd2 Be7 Nc4 Bf6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 Be7 O-O O-O d3 d6 h3 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 Be7 O-O b5 Bb3 O-O a4 b4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 Be7 O-O b5 Bb3 O-O a4 b4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 Be7 O-O b5 Bb3 O-O d3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 Be7 O-O b5 Bb3 d6 a4 b4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 Be7 O-O b5 Bb3 d6 a4 b4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 Be7 O-O b5 Bb3 d6 d3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 b5 Bb3 Bb4 O-O O-O d3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 b5 Bb3 d6 Ng5 d5 Nxd5 Nd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Bc5 c3 Ba7 d4 O-O Bg5 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Bxc6 dxc6 Nc3 Nd7 d4 f6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Bxc6 dxc6 Nxe5 Nxe4 Qe2 Nd6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Bxc6 dxc6 Qe1 Nd7 d4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Bxc6 dxc6 d3 Nd7 Nbd2 f6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 d6 a4 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 b4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 b4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d3 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O h3 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O h3 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O h3 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 Nc3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 d6 d4 b5 dxe5 Nxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 c3 Nxe4 Qe2 Nc5 Bxc6 dxc6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 d3 d6 c3 O-O Nbd2 Ne8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 d4 exd4 Re1 b5 e5 Nxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 d4 exd4 e5 Ne4 Nxd4 Nc5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 d4 exd4 e5 Ne4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 Re1 Nc5 Bxc6 dxc6 Nxe5 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 Be7 Qe2 b5 Bb3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 Be7 Nxe5 Nxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 Be7 Nxe5 Nxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 Re1 Bc5 c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 c3 Nxe4 d4 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 d3 Bc5 a4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 d3 Bc5 a4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 d3 Bd6 a4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 d3 Be7 c4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 d3 Be7 c4 b4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Be7 Re1 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 Bxc6+ bxc6 d4 Nxe4 Qe2 f5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 Re1 Bd7 c3 Be7 d4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 Re1 Bd7 c3 Be7 d4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 d4 b5 dxe5 dxe5 Bb3 Qxd1 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 d4 b5 dxe5 dxe5 Qxd8+ Nxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 Be7 c3 b5 Bb3 d6 O-O O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Bc5 a4 Rb8 axb5 axb5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Bc5 a4 Rb8 axb5 axb5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Bc5 c3 O-O O-O d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Bc5 c3 O-O d3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Bc5 c3 O-O d3 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Bc5 c3 d6 d3 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Bc5 c3 d6 h3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Be7 c3 O-O O-O d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Be7 c3 O-O O-O d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 d6 c3 b5 Bb3 Be7 O-O O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 Bc5 O-O b5 Bb3 d6 c3 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 Bc5 c3 b5 Bc2 d5 exd5 Nxd5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 b5 Bb3 Be7 c3 O-O Nbd2 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 Bd7 Nbd2 g6 O-O Bg7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 Be7 O-O O-O Re1 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 Be7 O-O O-O Re1 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 Be7 O-O O-O Re1 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 b5 Bc2 g6 a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 g6 Nbd2 Bg7 O-O O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 g6 h3 Bg7 Be3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c4 g6 Nc3 Bg7 Nd5 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c4 g6 Nc3 Bg7 Nd5 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c4 g6 d4 exd4 Nxd4 Bd7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d4 exd4 O-O Be7 e5 Ne4 Nxd4 Nxd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d4 exd4 O-O Be7 e5 Ne4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d4 exd4 O-O Be7 e5 Ne4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d4 exd4 O-O Be7 e5 Ne4 Re1 Nc5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 b5 Bb3 Na5 d4 exd4 Qxd4 Ne7 c3 Nxb3 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 Bxc6+ bxc6 d4 f6 Be3 Ne7 Nc3 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 Bxc6+ bxc6 d4 f6 Nc3 Ne7 Be3 Rb8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 Bxc6+ bxc6 d4 f6 O-O g6 Ne1 Bg7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 Re1 g6 d4 Bg7 c3 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 c4 g6 d4 Bg7 Be3 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nbd2 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nbd2 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nbd2 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nbd2 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 O-O Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 g6 Bg5 f6 Be3 Nh6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Nf6 d4 Bd7 O-O Be7 Nbd2 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 f5 exf5 Bxf5 O-O Bd3 Re1 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 f5 exf5 Bxf5 d4 e4 Bg5 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 f5 exf5 Bxf5 d4 e4 Ng5 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 d4 Bd7 Bb3 Be7 dxe5 dxe5 Qd5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 d4 Bd7 dxe5 Nxe5 Bxd7+ Nxd7 O-O Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 d4 b5 Bb3 Nxd4 Nxd4 exd4 Qxd4 c5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 f5 Bxc6 dxc6 Nxe5 Qd4 Nf3 Qxe4+ Kf1 Bd7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bc4 Nf6 d3 Bc5 Be3 Bxe3 fxe3 d5 exd5 Nxd5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 bxc6 d4 exd4 Qxd4 d6 O-O Ne7 Nc3 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 Nc3 Bg4 h3 Bxf3 Qxf3 Bc5 d3 Qf6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 Nc3 f6 d3 Bd6 Be3 c5 Ne2 Ne7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 Nc3 f6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 Nc3 f6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O Ne7 Nxe5 Qd4 Qh5 g6 Qg5 Bg7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O Qd6 d3 Ne7 Be3 Ng6 Nbd2 c5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O Qe7 b3 Bg4 h3 Bh5 Bb2 f6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 Bg4 c3 Bd6 h3 Bh5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 Bg4 dxe5 Qxd1 Rxd1 fxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 Bg4 dxe5 Qxd1 Rxd1 fxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 exd4 Nxd4 Bd6 Qh5+ g6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 exd4 Nxd4 Ne7 Be3 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 exd4 Nxd4 c5 Nb3 Qxd1 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d3 f6 Be3 Bg4 Nbd2 Qd7 h3 Bh5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd6 Be3 c5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd6 O-O Ne7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd7 Be3 O-O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd7 Be3 O-O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd7 Be3 O-O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd7 O-O O-O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 exd4 Qxd4 Qxd4 Nxd4 c5 Ne2 Bd7 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 Nc3 Bd7 d4 exd4 Nxd4 g6 Nf3 Bg7 Bg5 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 c3 a6 Ba4 f5 d4 fxe4 Ng5 exd4 Nxe4 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 Bd7 Nc3 exd4 Nxd4 Nxd4 Qxd4 Bxb5 Nxb5 Ne7 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 Bd7 d5 Nb8 Bd3 Be7 Nc3 Nf6 Ne2 c6 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 exd4 Nxd4 Bd7 Nc3 Nf6 O-O Be7 Nf5 Bxf5 ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 Nf6 exf5 Nd4 Nxe5 Bc5 O-O O-O Nf3 Nxf3+ ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 fxe4 Nxe4 d5 Ng3 Bg4 h3 Bxf3 Qxf3 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 f5 d4 fxe4 Nxe5 Nxe5 dxe5 c6 Bc4 Qa5+ Bd2 Qxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 a6 Ba4 d6 d4 Bd7 Re1 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 a6 Ba4 d6 d4 Bd7 Re1 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 a6 Ba4 d6 d4 Bd7 dxe5 dxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 c3 a6 Ba4 d6 d4 Bd7 Bg5 f6 Be3 Nh6 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 c3 a6 Ba4 d6 d4 Bd7 Bg5 f6 Be3 Nh6 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 c3 a6 Bc4 Bg7 d4 d6 O-O Nge7 Ng5 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 g6 c3 d6 d4 Bd7 dxe5 dxe5 Qe2 Bg7 Be3 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 c3 d6 d4 Bd7 dxe5 dxe5 Qe2 Bg7 Be3 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 d4 exd4 Bg5 Be7 Bxe7 Ngxe7 Nxd4 O-O Nc3 a6 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 d4 exd4 Bg5 Be7 Bxe7 Qxe7 O-O Nf6 e5 Nh5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 Nc3 Nf6 d3 d6 Be3 Bb6 Qd2 Bg4 Ng5 Bh5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 Nc3 d6 h3 Be6 Bb3 Nf6 d3 Qd7 O-O O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 O-O d6 c3 Bb6 d4 Qe7 a4 a6 h3 Nf6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bb6 c3 d6 a4 a6 a5 Ba7 b5 axb5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 O-O Nf6 d4 O-O d5 Ne7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 O-O Nf6 d4 O-O d5 Ne7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 O-O Nf6 d4 O-O dxe5 Nxe4 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 Bb6 dxe5 Nge7 O-O O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 d6 Bg5 Nge7 d5 Nb8 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 exd4 O-O Nf6 e5 d5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 exd4 O-O d6 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 exd4 e5 d5 exd6 Qxd6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 Bb6 a4 Nf6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 d4 exd4 cxd4 Bb6 d5 Na5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 b4 Bb6 d3 d6 O-O O-O Nbd2 Ne7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 b4 Bb6 d3 d6 a4 a6 O-O O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d3 d6 O-O a6 Nbd2 O-O Bb3 Ba7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d3 d6 h3 Be6 Bb3 d5 exd5 Bxd5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d3 d6 h3 O-O Bg5 Bb6 Nbd2 Be6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 cxd4 Bb4+ Bd2 Bxd2+ Nbxd2 Nxe4 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 cxd4 Bb4+ Bd2 Bxd2+ Nbxd2 d5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 cxd4 Bb4+ Bd2 Bxd2+ Nbxd2 d5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 cxd4 Bb4+ Nc3 Nxe4 O-O Bxc3 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 e5 d5 Bb3 Ne4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Qe7 d4 Bb6 O-O Nf6 a4 a6 Re1 d6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Qe7 d4 Bb6 O-O d6 b4 Nf6 a4 a6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Qe7 d4 Bb6 O-O d6 h3 Nf6 Re1 O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 d3 Nf6 Nc3 h6 Ne2 d6 c3 O-O h3 Kh8 ",
	"e4 e5 Nf3 Nc6 Bc4 Be7 d4 d6 c3 Nf6 dxe5 Nxe5 Nxe5 dxe5 Qc2 O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Be7 d4 d6 d5 Nb8 Bd3 Nf6 c4 O-O Nc3 c6 ",
	"e4 e5 Nf3 Nc6 Bc4 Be7 d4 d6 h3 Nf6 Nc3 O-O dxe5 Nxe5 Bb3 c6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 Bc5 Bxf7+ Ke7 Bd5 Qe8 d3 d6 Bxc6 bxc6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 Bb5+ c6 dxc6 bxc6 Be2 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 Bb5+ c6 dxc6 bxc6 Be2 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 d3 h6 Nf3 e4 Qe2 Nxc4 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Nd4 c3 b5 Bf1 Nxd5 cxd4 Qxg5 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 O-O Nxe4 d4 d5 Bb3 exd4 Nxd4 Bc5 Be3 O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d3 Bc5 Be3 Bb6 Nc3 d6 h3 Ne7 Qd2 c6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d3 Bc5 Nc3 d6 Be3 Bb6 O-O Be6 Bb3 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d3 d5 exd5 Nxd5 Bxd5 Qxd5 h3 Bb4+ Bd2 O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 Ng5 Ne5 Bb3 h6 f4 hxg5 fxe5 Nxe4 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O Be7 Nxd4 O-O Nc3 d6 b3 Ne5 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O Nxe4 Re1 d5 Bxd5 Qxd5 Nc3 Qd8 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O Nxe4 Re1 d5 Nc3 dxc4 Rxe4+ Be7 ",
	"e4 e5 Nf3 Nc6 Bc4 d6 Nc3 Na5 Bb3 Nxb3 axb3 c5 Qe2 Ne7 d3 h6 ",
	"e4 e5 Nf3 Nc6 Nc3 Bb4 Bb5 Nf6 d3 Nd4 Ba4 b5 Bb3 d5 Nxe5 Nxb3 ",
	"e4 e5 Nf3 Nc6 Nc3 Bb4 Bc4 d6 d3 Nf6 Bd2 Be6 Bb3 Qd7 Nd5 Bxd2+ ",
	"e4 e5 Nf3 Nc6 Nc3 Bc5 Bb5 d6 d4 exd4 Nxd4 Bd7 Nxc6 bxc6 Ba4 Qf6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O Bxc6 dxc6 Nxe5 Re8 Nd3 Ba5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O Bxc6 dxc6 Nxe5 Re8 Nd3 Bxc3 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O Bxc6 dxc6 d3 Bd6 Bg5 h6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O Bxc6 dxc6 d3 Qe7 Qe2 Re8 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 Bxc3 bxc3 d5 Bxc6 bxc6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 Bxc3 bxc3 d6 Bg5 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 Bxc3 bxc3 d6 Bg5 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Bd7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 h6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Ne7 Ne2 Ng6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Ne7 Nh4 c6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Ne7 Nh4 c6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Nd5 Nxd5 exd5 Ne7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Ne2 Bd7 c3 Bc5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Ne2 Ne7 c3 Ba5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 Qe2 O-O a3 Bc5 d3 Nd4 Nxd4 exd4 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bc5 Nxe5 Nd4 Ba4 O-O d3 d5 Bg5 c6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bc5 Nxe5 Nxe5 d4 Bd6 f4 Ng6 e5 c6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bc5 O-O O-O Nxe5 Re8 Nxc6 dxc6 Bc4 b5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Ba4 Bc5 Nxe5 O-O Nd3 Bb6 e5 Ne8 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Ba4 Bc5 Nxe5 O-O d3 d6 Nf3 Bg4 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Ba4 Bc5 Nxe5 O-O d3 d6 Nf3 Bg4 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Bc4 Bc5 Nxe5 Qe7 Nf3 d5 Nxd4 dxc4 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Bc4 Bc5 d3 d6 Bg5 Bg4 Nd5 c6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Bc4 Bc5 d3 d6 Na4 b5 Nxd4 bxc4 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Nxd4 exd4 e5 dxc3 exf6 Qxf6 dxc3 Be7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Nxe5 Qe7 Ng4 Nxg4 Qxg4 Nxc2+ Kd1 Nxa1 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Nxe5 Qe7 f4 Nxb5 Nxb5 d6 Nf3 Qxe4+ ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 d6 d4 Bd7 Be3 exd4 Nxd4 Be7 O-O O-O ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 d6 d4 Bd7 Bxc6 Bxc6 Qd3 exd4 Nxd4 g6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 d6 d4 exd4 Qxd4 Bd7 Bxc6 Bxc6 Bg5 Be7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bc4 Bc5 d3 d6 Bg5 h6 Be3 Bb4 O-O Bxc3 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 Bb4 Bb5 Nxe4 Qd3 d5 Nxe5 O-O O-O Nxe5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 Bb4 Nxe5 Qe7 Qd3 Nxe5 dxe5 Qxe5 Bd2 O-O ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 exd4 Nd5 Nxe4 Qe2 f5 g4 Kf7 Bf4 d6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 exd4 Nxd4 Bb4 Nxc6 bxc6 Bd3 O-O O-O d5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 exd4 Nxd4 Bb4 Nxc6 bxc6 Bd3 O-O O-O d5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 exd4 Nxd4 Bb4 Nxc6 bxc6 Bd3 d5 exd5 cxd5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 exd4 Nxd4 d6 Bb5 Bd7 O-O Be7 f4 O-O ",
	"e4 e5 Nf3 Nc6 Nc3 g6 Bb5 Bg7 O-O Nge7 d3 O-O Bc4 Na5 Bb3 Nxb3 ",
	"e4 e5 Nf3 Nc6 Nc3 g6 d4 exd4 Nd5 Bg7 Bg5 f6 Bf4 d6 Nxd4 Nge7 ",
	"e4 e5 Nf3 Nc6 Nc3 g6 d4 exd4 Nxd4 Bg7 Be3 d6 Bb5 Bd7 Qd2 Nf6 ",
	"e4 e5 Nf3 Nc6 c3 Be7 d4 d6 Bb5 exd4 cxd4 Bd7 Nc3 Nf6 O-O a6 ",
	"e4 e5 Nf3 Nc6 c3 Nf6 d4 Nxe4 d5 Ne7 Nxe5 Ng6 Bd3 Nxe5 Bxe4 Bc5 ",
	"e4 e5 Nf3 Nc6 c3 Nf6 d4 d6 h3 Be7 Be3 O-O d5 Nb8 Bd3 Nbd7 ",
	"e4 e5 Nf3 Nc6 c3 d5 Qa4 f6 Bb5 Ne7 d3 Bg4 Nbd2 a6 Bxc6+ Nxc6 ",
	"e4 e5 Nf3 Nc6 c3 d5 Qa4 f6 Bb5 Ne7 exd5 Qxd5 d4 e4 Bc4 Qh5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Bc5 Ng5 Nh6 Nxf7 Nxf7 Bxf7+ Kxf7 Qh5+ g6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Bc5 Ng5 Nh6 Nxf7 Nxf7 Bxf7+ Kxf7 Qh5+ g6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Bc5 O-O d6 c3 Qf6 Bg5 Qg6 cxd4 Nxd4 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Nf6 Nxd4 Nxe4 O-O d5 Re1 Be7 Bf4 O-O ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Nf6 O-O Nxe4 Bd5 Nf6 Bxc6 dxc6 Nxd4 Be7 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Nf6 O-O Nxe4 Re1 d5 Bxd5 Qxd5 Nc3 Qa5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Nf6 O-O Nxe4 Re1 d5 Bxd5 Qxd5 Nc3 Qa5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Nf6 e5 d5 Bb5 Ne4 Nxd4 Bc5 Be3 Bd7 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Nf6 e5 d5 Bb5 Ne4 Nxd4 Bc5 Be3 Bd7 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Nf6 e5 d5 Bb5 Ne4 Nxd4 Bd7 Nxc6 bxc6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Be3 Bb6 Bc4 Nge7 Nxc6 bxc6 Qf3 d5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Be3 Bb6 Nc3 d6 Nd5 Nf6 Nxb6 axb6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Be3 Bb6 Nc3 d6 Nd5 Nf6 Nxb6 axb6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Be3 Qf6 c3 Nge7 Bc4 Ne5 Be2 Qg6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Be3 Qf6 c3 Nge7 Nc2 b6 Nd2 Qg6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Nb3 Bb6 a4 a6 Nc3 Nf6 Be2 d6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Nb3 Bb6 a4 a6 Nc3 d6 Nd5 Ba7 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nc3 Bb4 Nxc6 bxc6 Bd3 h6 O-O d6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nc3 Bb4 Nxc6 bxc6 Qd3 O-O Bd2 Bxc3 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nxc6 bxc6 Bd3 d5 Qe2 dxe4 Nd2 Bb4 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nxc6 bxc6 Bd3 d5 e5 Ng4 Bf4 Bc5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nxc6 bxc6 e5 Qe7 Qe2 Nd5 c4 Ba6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 c3 dxc3 Nxc3 Bc5 Bc4 d6 h3 Be6 Bb5 Ne7 ",
	"e4 e5 Nf3 Nf6 Bc4 Nxe4 Nc3 Nxc3 dxc3 f6 O-O Qe7 Nh4 d6 Qh5+ Kd8 ",
	"e4 e5 Nf3 Nf6 Nc3 Nc6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Ne7 ",
	"e4 e5 Nf3 Nf6 Nc3 Nc6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 h6 ",
	"e4 e5 Nf3 Nf6 Nc3 Nc6 Bb5 Nd4 Ba4 c6 Nxe5 d5 d3 Bd6 f4 O-O ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 O-O O-O c4 Nf6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 Re1 Bg4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 Re1 Bg4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 Re1 f5 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 c4 Nf6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 c4 Nf6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bg4 O-O Nc6 c3 Be7 ",
	"e4 e5 Nf3 Nf6 d4 Nxe4 Bd3 d5 Nxe5 Bd6 O-O O-O c4 c6 Qc2 Re8 ",
	"e4 e5 Nf3 d6 Bc4 Nc6 d4 Bg4 c3 Qd7 Be3 Nf6 Nbd2 Be7 h3 Bh5 ",
	"e4 e5 Nf3 d6 d4 Nd7 Bc4 c6 O-O Be7 c3 Ngf6 Re1 O-O Nbd2 exd4 ",
	"e4 e5 Nf3 d6 d4 exd4 Nxd4 Nf6 Nc3 Be7 Be2 O-O O-O c5 Nf3 Nc6 ",
	"e4 e5 Nf3 d6 d4 exd4 Qxd4 Bd7 Be3 Nf6 Nc3 Be7 Bc4 Nc6 Qd2 Ne5 ",
	"e4 e5 Nf3 d6 d4 exd4 Qxd4 Be6 Nc3 a6 Be3 Nc6 Qd2 Nf6 Rd1 Be7 ",
	"e4 e5 Nf3 d6 d4 exd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 Bg5 Nf6 Nc3 Be7 ",
	"e4 e5 Nf3 d6 d4 f5 Nc3 fxe4 Nxe4 d5 Ng3 e4 Ne5 Nf6 Bg5 Bd6 ",
	"e4 e5 Nf3 d6 d4 f5 dxe5 fxe4 Ng5 d5 e6 Nh6 Nc3 c6 Ngxe4 dxe4 ",
	"e4 e5 Nf3 f5 Nxe5 Qf6 d4 d6 Nc4 fxe4 Nc3 Qg6 Ne3 Nf6 Bc4 c6 ",
	"e4 e5 d4 exd4 Qxd4 Nc6 Qe3 Nf6 Nc3 Bb4 Bd2 O-O O-O-O Re8 Bc4 d6 ",
	"e4 e5 d4 exd4 Qxd4 Nc6 Qe3 Nf6 Nc3 Bb4 Bd2 O-O O-O-O Re8 Qg3 Nxe4 ",
	"e4 e5 f4 Bc5 Nf3 d6 Bc4 Nc6 c3 Nf6 d3 Qe7 Qe2 Be6 Bb5 Bd7 ",
	"e4 e5 f4 Bc5 Nf3 d6 b4 Bb6 Bc4 Nf6 Qe2 Nc6 c3 O-O d3 exf4 ",
	"e4 e5 f4 d5 exd5 c6 dxc6 Nxc6 Bb5 exf4 Nf3 Bd6 d4 Ne7 O-O O-O ",
	"e4 e5 f4 d5 exd5 e4 Bb5+ c6 dxc6 bxc6 Bc4 Nf6 Qe2 Bc5 Nc3 O-O ",
	"e4 e5 f4 d5 exd5 e4 Nc3 Nf6 d3 Bb4 Bd2 e3 Bxe3 O-O Bd2 Bxc3 ",
	"e4 e5 f4 d5 exd5 e4 d3 Nf6 Nc3 Bb4 Bd2 e3 Bxe3 O-O Be2 Re8 ",
	"e4 e5 f4 exf4 Bc4 Nc6 Nf3 g5 d4 Bg7 h4 h6 hxg5 hxg5 Rxh8 Bxh8 ",
	"e4 e5 f4 exf4 Bc4 Nf6 Nc3 Bb4 e5 d5 Bb3 Ne4 Nf3 c6 Qe2 Bxc3 ",
	"e4 e5 f4 exf4 Bc4 Nf6 Nc3 Bb4 e5 d5 Bb5+ c6 exf6 cxb5 fxg7 Rg8 ",
	"e4 e5 f4 exf4 Bc4 Nf6 Nc3 Nc6 Nf3 Bb4 O-O O-O d3 d6 Bxf4 Bg4 ",
	"e4 e5 f4 exf4 Bc4 Nf6 Nc3 c6 d4 Bb4 e5 Ne4 Kf1 Nxc3 bxc3 d5 ",
	"e4 e5 f4 exf4 Bc4 Nf6 e5 d5 Bb3 Ne4 Nf3 Bg4 O-O Nc6 Ba4 g5 ",
	"e4 e5 f4 exf4 Bc4 Qh4+ Kf1 b5 Bxb5 Nf6 Nf3 Qh6 Nc3 g5 d4 Bg7 ",
	"e4 e5 f4 exf4 Bc4 d5 Bxd5 Nf6 Nc3 Bb4 d3 Nxd5 exd5 O-O Qf3 Re8+ ",
	"e4 e5 f4 exf4 Bc4 d5 Bxd5 Nf6 d3 Nxd5 exd5 Qxd5 Qe2+ Be6 Bxf4 Nc6 ",
	"e4 e5 f4 exf4 Be2 d5 exd5 Nf6 c4 c6 d4 Bb4+ Kf1 cxd5 Bxf4 dxc4 ",
	"e4 e5 f4 exf4 Nc3 Qh4+ Ke2 d5 Nxd5 Bg4+ Nf3 Nc6 Nxc7+ Kd8 Nxa8 Ne5 ",
	"e4 e5 f4 exf4 Nf3 Nf6 e5 Nh5 d4 d5 c4 Bg4 Be2 Be7 O-O O-O ",
	"e4 e5 f4 exf4 Nf3 d5 e5 g5 h3 Nh6 d4 Nf5 Bd3 Ng3 Rh2 h6 ",
	"e4 e5 f4 exf4 Nf3 d5 exd5 Bd6 d4 c6 dxc6 Nxc6 c3 Nge7 Nbd2 O-O ",
	"e4 e5 f4 exf4 Nf3 d5 exd5 Nf6 Bb5+ c6 dxc6 bxc6 Bc4 Nd5 O-O Bd6 ",
	"e4 e5 f4 exf4 Nf3 d5 exd5 Nf6 Bb5+ c6 dxc6 bxc6 Bc4 Nd5 d4 Bd6 ",
	"e4 e5 f4 exf4 Nf3 g5 Bc4 Bg7 O-O h6 c3 d6 d4 Ne7 h4 Ng6 ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ne5 Nf6 Bc4 d5 exd5 Bd6 d4 Nh5 ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ne5 Nf6 Nxg4 Nxe4 d3 Ng3 Bxf4 Nxh1 ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ng5 d5 exd5 h6 Qe2+ Be7 Ne4 f5 ",
	"e4 e6 Nc3 d5 g3 dxe4 Bg2 Bd7 Nh3 Bc6 O-O Nd7 Nxe4 Ngf6 d3 Be7 ",
	"e4 e6 Qe2 Nc6 Nc3 e5 g3 Nf6 Bg2 Bc5 d3 d6 Bg5 h6 Bxf6 Qxf6 ",
	"e4 e6 Qe2 c5 g3 Nc6 Bg2 Nge7 Nc3 g6 d3 Bg7 Be3 d5 exd5 Nd4 ",
	"e4 e6 c4 d5 cxd5 exd5 Qa4+ Nd7 e5 f6 d4 fxe5 dxe5 c6 Nf3 Qe7 ",
	"e4 e6 d3 c5 Nf3 Nc6 Nbd2 d5 Be2 Bd6 c3 Nge7 Nf1 O-O Ne3 f5 ",
	"e4 e6 d3 d5 Nd2 c5 Ngf3 Nc6 Be2 Bd6 O-O Qc7 Re1 Nge7 c3 O-O ",
	"e4 e6 d3 d5 Nd2 c5 g3 Nc6 Bg2 g6 Ne2 Bg7 O-O Nge7 Re1 O-O ",
	"e4 e6 d4 c5 Nf3 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 Bb4 Bd3 d5 exd5 Nxd5 ",
	"e4 e6 d4 c5 Nf3 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 O-O Qc7 f4 Nbd7 ",
	"e4 e6 d4 d5 Bd3 c5 c3 dxe4 Bxe4 Nf6 Bf3 Nc6 dxc5 Qxd1+ Bxd1 Bxc5 ",
	"e4 e6 d4 d5 Nc3 Bb4 Bd2 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 Rg6 Qe3 c5 ",
	"e4 e6 d4 d5 Nc3 Bb4 Bd2 dxe4 Qg4 Qxd4 O-O-O Nf6 Qxg7 Rg8 Qh6 Bf8 ",
	"e4 e6 d4 d5 Nc3 Bb4 Bd2 dxe4 Qg4 Qxd4 O-O-O h5 Qh4 Be7 Bg5 Qe5 ",
	"e4 e6 d4 d5 Nc3 Bb4 Bd3 dxe4 Bxe4 Nf6 Bd3 c5 dxc5 Nbd7 Bd2 Nxc5 ",
	"e4 e6 d4 d5 Nc3 Bb4 Bd3 dxe4 Bxe4 Nf6 Bg5 c5 a3 Bxc3+ bxc3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 Ne2 dxe4 a3 Be7 Nxe4 Nf6 N2g3 O-O Be2 Nc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 Qd3 Ne7 Bd2 b6 Be2 O-O a3 Bxc3 Bxc3 a5 ",
	"e4 e6 d4 d5 Nc3 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 Nbd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 c5 ",
	"e4 e6 d4 d5 Nc3 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 c5 ",
	"e4 e6 d4 d5 Nc3 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 c5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 Bd2 O-O Nf3 c5 dxc5 Nbc6 Bd3 Ng6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 b6 Qg4 Nf5 Bd3 h5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 b6 Qg4 Ng6 Bg5 Qd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Nf3 h6 a4 b6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 O-O Nf3 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 Qc7 Bd3 c4 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 cxd4 Bd3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 cxd4 Bd3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 a4 Nbc6 Nf3 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 a4 Qa5 Bd2 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 Bd2 Bf8 Nf3 Ne7 h4 h5 Bg5 Qd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 Qg4 Bf8 Bg5 Qd7 f4 Nc6 Nf3 h6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 Qg4 Bf8 Nh3 Qd7 Bg5 Nc6 O-O-O Bb7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 a3 Bf8 Nf3 Ne7 Bb5+ Bd7 Bd3 c5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 a3 Bxc3+ bxc3 Ba6 Bd3 Ne7 Bg5 Qd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 a3 Bxc3+ bxc3 Qd7 Qg4 f5 Qg3 Ba6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 Bd2 Nc6 Nb5 Bxd2+ Qxd2 Nxd4 Nxd4 cxd4 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 Bd2 Nc6 Nf3 cxd4 Nb5 Bc5 a3 Nge7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 Bd2 Ne7 Nb5 Bxd2+ Qxd2 O-O c3 Nf5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 Bd2 Ne7 a3 Bxc3 Bxc3 cxd4 Qxd4 Nf5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 Bd2 Nc6 Nb5 Bc7 f4 Nxd4 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 Bd2 cxd4 Nb5 Bc7 f4 Nc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Nb5 Bc7 f4 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Nb5 Bc7 f4 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Nb5 Bc7 f4 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Nb5 Bc7 f4 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Qg4 Ne7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 Bd3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 Bd3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 Bd3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 Bd3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 Bd3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 Be2 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 a4 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Qa5 Bd2 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Qa5 Bd2 c4 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Nf5 Bd3 h5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 O-O Nf3 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 O-O Nf3 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Qc7 Bd3 c4 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 a4 Nbc6 Nf3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 a4 Nbc6 Nf3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 a4 Qa5 Qd2 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Nf3 Bd7 a4 Nc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Nf3 Bd7 a4 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Nf3 Ne7 Bd3 Nd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 cxd4 Qxd4 Nc6 Bb5 Ba5 Nf3 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Bd3 Nc6 Ne2 Nge7 Bg5 f6 Bf4 Bf5 ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Bd3 Nc6 Ne2 Nge7 O-O Bf5 Bxf5 Nxf5 ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Bd3 Nc6 Ne2 Nge7 O-O Bg4 a3 Bxc3 ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Bd3 Nc6 Ne2 Nge7 O-O Bg4 f3 Be6 ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Nf3 Ne7 Bd3 Bg4 O-O Nbc6 Ne2 Bd6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bd3 c5 Nf3 cxd4 Nxd4 Nc6 Bb5 Bd7 exd5 exd5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 e5 h6 Bd2 Bxc3 Bxc3 Ne4 Ba5 O-O ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 e5 h6 Bd2 Bxc3 Bxc3 Ne4 Ba5 O-O ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 Nb5 Nb6 c3 a6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 Qd2 c5 Nb5 O-O ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 Qg4 O-O Nf3 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 Qh5 a6 f4 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 f4 O-O Nf3 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 f4 O-O Qd2 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 f4 O-O Qd2 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 f4 a6 Nf3 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 h4 Nc6 Qg4 Bxg5 hxg5 Nf8 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 h4 c5 Bxe7 Qxe7 Nb5 O-O ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 gxf6 Nf3 Nd7 Qd2 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 gxf6 Nf3 b6 Bd3 Bb7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nf3 Be7 Nxf6+ Bxf6 h4 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nf3 Be7 Nxf6+ Nxf6 Bd3 b6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nxf6+ Nxf6 Nf3 c5 Qd3 Be7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nxf6+ Nxf6 Nf3 c5 Qd3 Be7 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 Nce2 c5 c3 Nc6 f4 Qb6 Nf3 f6 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 dxc5 Nc6 Be3 Nxc5 Bxc5 Bxc5 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 dxc5 Nc6 a3 Bxc5 Qg4 g6 ",
	"e4 e6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Bd3 b6 O-O Bb7 ",
	"e4 e6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Bd3 b6 Qe2 Bb7 ",
	"e4 e6 d4 d5 Nc3 dxe4 Nxe4 Nf6 Bd3 Nbd7 Ne2 Be7 O-O Nxe4 Bxe4 Nf6 ",
	"e4 e6 d4 d5 Nc3 dxe4 Nxe4 Nf6 Bd3 Nxe4 Bxe4 c5 c3 cxd4 cxd4 Bb4+ ",
	"e4 e6 d4 d5 Nd2 Nc6 Bb5 Ne7 Ngf3 a6 Bxc6+ Nxc6 O-O Be7 c3 b6 ",
	"e4 e6 d4 d5 Nd2 Nc6 Ngf3 Nf6 e5 Nd7 Nb3 f6 Bf4 Be7 Qd2 a5 ",
	"e4 e6 d4 d5 Nd2 Nc6 c3 e5 exd5 Qxd5 Ngf3 exd4 Bc4 Qh5 O-O Nf6 ",
	"e4 e6 d4 d5 Nd2 Nc6 c3 f5 exf5 exf5 Bd3 Bd6 Ne2 Nge7 Nf3 O-O ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Bd3 b6 c3 Ba6 Bb1 c5 Ne2 Nc6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Bd3 c5 c3 Nc6 Ne2 Qb6 Nf3 cxd4 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Bd3 c5 c3 Nc6 Ne2 cxd4 cxd4 f6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Ngf3 c5 c3 Nc6 Bd3 Qb6 O-O cxd4 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 c3 c5 Bd3 Nc6 Ne2 cxd4 cxd4 f6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 f4 c5 c3 Nc6 Ngf3 f6 b3 cxd4 ",
	"e4 e6 d4 d5 Nd2 a6 e5 c5 c3 Nc6 Ndf3 Bd7 dxc5 Bxc5 Bd3 Nge7 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 Bb5 cxd4 Nxd4 Bd7 Nxc6 bxc6 Bd3 Qc7 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Bd6 dxc5 Bxc5 Nb3 Bd6 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Bd6 dxc5 Bxc5 Nb3 Qe7+ ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nf6 exd5 Nxd5 c4 Nf6 Nb3 cxd4 Qxd4 Bd7 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 cxd4 exd5 Qxd5 Bc4 Qd6 O-O Nf6 Nb3 Nc6 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 cxd4 exd5 Qxd5 Bc4 Qd6 O-O Nf6 Nb3 Nc6 ",
	"e4 e6 d4 d5 Nd2 c5 dxc5 Bxc5 Bd3 Nf6 e5 Nfd7 Qg4 Nxe5 Qxg7 Nxd3+ ",
	"e4 e6 d4 d5 Nd2 c5 exd5 Qxd5 Ngf3 cxd4 Bc4 Qd6 O-O Nf6 Nb3 Nc6 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 Qxd5 Ngf3 cxd4 Bc4 Qd6 O-O Nf6 Nb3 Nc6 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 Qxd5 dxc5 Bxc5 Ngf3 Nf6 Bd3 O-O Qe2 Nbd7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 Qxd5 dxc5 Bxc5 Ngf3 Nf6 Bd3 O-O Qe2 Nbd7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Bb5+ Nc6 Qe2+ Be7 dxc5 Nf6 Nb3 O-O ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nc6 Bb5 Bd6 dxc5 Bxc5 O-O Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nc6 Bb5 Bd6 dxc5 Bxc5 O-O Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nc6 Be2 Nf6 O-O Be6 Re1 Qb6 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nc6 dxc5 Bxc5 Nb3 Bd6 Bg5 Nge7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 c4 b3 cxb3 axb3 Bb4 Bb5+ Bd7 ",
	"e4 e6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Nf3 Ngf6 Bd3 Be7 O-O O-O Ng3 c5 ",
	"e4 e6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Be3 Be7 Bd3 a6 ",
	"e4 e6 d4 d5 e5 c5 Nf3 Nc6 Bd3 cxd4 O-O Bc5 a3 Nge7 Nbd2 Ng6 ",
	"e4 e6 d4 d5 e5 c5 Nf3 Nc6 Be3 Nge7 c3 Nf5 Qd2 Nxe3 fxe3 Be7 ",
	"e4 e6 d4 d5 e5 c5 Nf3 cxd4 Qxd4 Nc6 Qf4 f5 Bd3 Nge7 O-O Ng6 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Bd7 a3 a5 Bd3 Qb6 Bc2 h6 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Nh6 a3 cxd4 cxd4 Nf5 b4 Bd7 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Qb6 a3 c4 Nbd2 Bd7 Be2 Na5 ",
	"e4 e6 d4 d5 exd5 exd5 Bd3 Bd6 Nf3 Bg4 O-O Nc6 c3 Nge7 Bg5 Qd7 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Bd6 Bd3 Bg4 Be3 Ne7 O-O Nbc6 c3 Qd7 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Bd6 Bd3 Nf6 Qe2+ Be7 O-O O-O Ne5 Re8 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Bd6 c4 Nf6 c5 Be7 Nc3 b6 cxb6 axb6 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nf6 Bd3 Bd6 O-O O-O Bg5 Bg4 Nbd2 Nbd7 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nf6 Bd3 Bd6 O-O O-O Bg5 Bg4 Nbd2 Nbd7 ",
	"e4 g6 Nc3 c6 d4 Bg7 Nf3 d6 Bc4 b5 Bb3 b4 Ne2 a5 O-O Ba6 ",
	"e4 g6 Nf3 Bg7 Bc4 c5 O-O Nc6 c3 Qb6 Re1 d6 Bb3 Nf6 d4 cxd4 ",
	"e4 g6 d4 Bg7 Nc3 Nc6 Nf3 d6 h3 Nf6 Bg5 O-O Qd2 d5 exd5 Nxd5 ",
	"e4 g6 d4 Bg7 Nc3 a6 f4 b5 Nf3 d6 Be3 Bb7 Bd3 Nd7 e5 e6 ",
	"e4 g6 d4 Bg7 Nc3 c6 Nf3 d6 Be3 Nf6 Be2 b5 a3 O-O O-O Nbd7 ",
	"e4 g6 d4 Bg7 Nc3 d6 Be2 Nf6 f4 c5 Nf3 cxd4 Nxd4 Nc6 Nxc6 bxc6 ",
	"e4 g6 d4 Bg7 Nc3 d6 Be3 c6 a4 Nf6 h3 O-O Nf3 Nbd7 a5 Rb8 ",
	"e4 g6 d4 Bg7 Nc3 d6 Nf3 Nf6 Be2 O-O O-O c6 h3 Nbd7 e5 Ne8 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 c6 Nf3 b5 Bd3 Bg4 e5 dxe5 dxe5 Nh6 ",
	"e4 g6 d4 Bg7 Nf3 d6 Bc4 Nf6 Qe2 Bg4 e5 dxe5 Bxf7+ Kf8 dxe5 Nfd7 ",
	"e4 g6 d4 Bg7 Nf3 d6 Bc4 Nf6 Qe2 O-O O-O Nc6 Rd1 Bg4 h3 Bxf3 ",
	"e4 g6 d4 Bg7 Nf3 d6 Bc4 Nf6 Qe2 c6 Bb3 O-O O-O a5 a4 Bg4 ",
	"e4 g6 d4 Bg7 Nf3 d6 Be2 Nf6 Nc3 O-O O-O Bg4 Be3 Nc6 d5 Bxf3 ",
	"e4 g6 d4 Bg7 Nf3 d6 Be2 Nf6 Nc3 c6 O-O O-O a4 Bg4 Be3 a5 ",
	"e4 g6 d4 Bg7 Nf3 d6 Nc3 Nf6 Be2 O-O Bf4 Nc6 d5 e5 dxe6 Bxe6 ",
	"e4 g6 d4 Bg7 Nf3 d6 Nc3 Nf6 Be2 O-O O-O a5 a4 Na6 Be3 Nb4 ",
	"e4 g6 d4 Bg7 Nf3 d6 c4 c5 Nc3 Bg4 d5 Nf6 Be2 O-O O-O e6 ",
	"e4 g6 d4 Bg7 c3 d6 f4 Nf6 e5 dxe5 fxe5 Nd5 Nf3 O-O Bc4 c5 ",
	"e4 g6 d4 Bg7 c3 d6 f4 Nf6 e5 dxe5 fxe5 Nd5 Nf3 O-O Bc4 c5 ",
	"e4 g6 d4 Bg7 c4 d6 Nc3 Nf6 f3 O-O Be3 a6 Bd3 c5 d5 e6 ",
	"e4 g6 d4 Bg7 c4 d6 Nc3 Nf6 f3 O-O Bg5 c5 d5 h6 Be3 e6 ",
	"e4 g6 d4 Bg7 f3 c5 Ne2 cxd4 Nxd4 Nc6 c3 Nf6 Be3 O-O Bb5 Qc7 ",
	"e4 g6 d4 Bg7 f4 c5 d5 d6 Nf3 Nf6 Nc3 O-O Be2 e6 O-O exd5 ",
	"e4 g6 d4 d6 Be3 Nf6 Nd2 Bg7 Be2 O-O c3 e5 d5 Nbd7 Qc2 b6 ",
	"e4 g6 d4 d6 Nc3 Bg7 Nf3 Bg4 Be2 Nc6 Be3 e5 dxe5 dxe5 Qxd8+ Rxd8 ",
	"e4 g6 d4 d6 Nc3 Bg7 f4 Nf6 e5 Nfd7 Nf3 c5 e6 fxe6 Ng5 Nf6 ",
	"e4 g6 d4 d6 Nc3 c6 f4 Bg7 Be3 Qb6 Rb1 f5 Nf3 Nd7 exf5 gxf5 ",
	"f4 Nf6 Nf3 g6 b3 Bg7 Bb2 O-O d3 d5 Nbd2 Ng4 Bxg7 Ne3 Qc1 Kxg7 ",
	"f4 Nf6 Nf3 g6 d3 Bg7 e4 O-O Be2 c5 O-O Nc6 a4 d6 Qe1 c4 ",
	"f4 Nf6 Nf3 g6 d3 d5 Nbd2 d4 c3 dxc3 bxc3 Nd5 Qa4+ Nc6 Ne5 Bg7 ",
	"f4 Nf6 Nf3 g6 d3 d5 Nbd2 d4 c3 dxc3 bxc3 Nd5 Qa4+ Nc6 Ne5 Bg7 ",
	"f4 Nf6 b3 d5 Nf3 g6 Bb2 Bg7 e3 c5 Be2 O-O O-O Nc6 Ne5 Bd7 ",
	"f4 c5 Nf3 g6 e4 Bg7 Be2 Nc6 O-O d6 d3 e6 Na3 Nge7 c3 O-O ",
	"f4 c5 Nf3 g6 e4 Bg7 Be2 Nc6 O-O d6 d3 e6 Na3 Nge7 c3 O-O ",
	"f4 d5 Nf3 Nf6 e3 Bg4 b3 Nbd7 Bb2 c6 Be2 Qc7 O-O Bxf3 Bxf3 e5 ",
	"f4 d5 Nf3 g6 e3 Bg7 Be2 c5 d3 Nc6 O-O Nf6 Qe1 O-O h3 Re8 ",
	"f4 d5 e3 g6 Nf3 Bg7 Be2 Nf6 O-O O-O d3 c5 Qe1 Nc6 Qh4 e6 ",
	"f4 e5 fxe5 d6 exd6 Bxd6 g3 f5 d3 Nf6 c3 Nc6 Bg2 Ne5 Nd2 Qe7 ",
	"f4 e6 e4 d5 e5 c5 Nf3 Nc6 c4 d4 d3 Nh6 Be2 Be7 Nbd2 O-O ",
	"g3 Nf6 Bg2 d5 b3 e5 Bb2 Bd6 d3 O-O e3 c5 c4 d4 e4 Nc6 ",
	"g3 c5 Bg2 Nc6 c4 Nf6 Nf3 d5 cxd5 Nxd5 Nc3 Nc7 d3 e5 O-O Be7 ",
	"g3 c5 Bg2 Nc6 d3 g6 e4 Bg7 f4 e6 Nf3 Nge7 O-O Rb8 Nbd2 d6 ",
	"g3 c5 Bg2 Nc6 e4 g6 Ne2 Bg7 O-O d6 c3 e5 Na3 Nge7 Nc2 Qb6 ",
	"g3 c5 Bg2 g6 c4 Bg7 Nc3 Nc6 e3 Nh6 Nge2 Nf5 a3 O-O Rb1 a5 ",
	"g3 d5 Bg2 e5 d3 c5 Nc3 Be6 e4 d4 Nce2 Nc6 f4 f6 Bh3 Bxh3 ",
	"g3 d5 Nf3 Bg4 Bg2 Nd7 c4 c6 cxd5 cxd5 Qa4 Nf6 Nc3 e6 d3 Bc5 ",
	"g3 d5 Nf3 c6 Bg2 Bg4 O-O Nd7 d3 e6 Nbd2 Bd6 e4 Ne7 Qe2 O-O ",
	"g3 d5 Nf3 c6 Bg2 Bg4 c4 e6 O-O Bd6 Qb3 Qb6 Qc2 Ne7 Nc3 Nd7 ",
	"g3 d5 Nf3 c6 Bg2 Bg4 c4 e6 b3 Nd7 Bb2 Ngf6 O-O Bd6 cxd5 exd5 ",
	"g3 e5 Bg2 Nf6 c4 c6 Nf3 d6 O-O Bg4 Nc3 Nbd7 d4 Be7 d5 O-O ",
	"g3 e5 Bg2 d5 d3 g6 c4 d4 Nf3 Nc6 O-O Bg7 Nbd2 a5 Rb1 Nf6 ",
	"g3 e5 c4 Nc6 Nc3 g6 Bg2 Bg7 d3 d6 Nf3 f5 Nd5 Nce7 Bg5 h6 ",
	"g3 e5 c4 c6 Nf3 e4 Nd4 d5 cxd5 Qxd5 Nb3 Nf6 Nc3 Qh5 d3 exd3 ",
	"g3 f5 Bg2 Nf6 d3 Nc6 e4 fxe4 dxe4 e5 Be3 b6 f4 Bc5 Bxc5 bxc5 ",
	"g3 g6 Bg2 Bg7 Nf3 Nf6 O-O O-O Re1 c5 e4 Nc6 c3 d6 d3 Ne8 ",
	"g3 g6 Bg2 Bg7 d4 Nf6 e4 d6 Ne2 O-O O-O Nbd7 c4 e5 Nbc3 c6 ",
	"g3 g6 Bg2 Bg7 d4 d5 Nf3 Nf6 O-O O-O c4 dxc4 Na3 c3 bxc3 c5 ",
	"h3 e5 e4 Nf6 Nc3 Bc5 Bc4 b5 Bxb5 c6 Ba4 O-O Nge2 d5 exd5 cxd5 "
};

char *bookWhite[WBSIZE] = 
{
	"Nc3 d5 d4 e6 Nf3 Nf6 Bg5 Bb4 e3 h6 Bf4 a6 Ne5 c5 dxc5 Bxc5 ",
	"Nf3 Nc6 d4 d5 c4 e6 Nbd2 Nf6 e3 Be7 b3 b6 Bb2 O-O Rc1 a5 ",
	"Nf3 Nc6 d4 d5 g3 Nf6 Bg2 e6 O-O Be7 c4 dxc4 Qa4 Bd7 Qxc4 Na5 ",
	"Nf3 Nc6 e4 e5 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"Nf3 Nf6 b3 d5 Bb2 Bf5 g3 e6 Bg2 Nbd7 O-O Bd6 d3 h6 Nbd2 Qe7 ",
	"Nf3 Nf6 b3 g6 Bb2 Bg7 g3 b6 Bg2 Bb7 O-O c5 c4 O-O Nc3 d5 ",
	"Nf3 Nf6 c4 b6 Nc3 Bb7 d4 e6 Bg5 Bb4 Qb3 c5 O-O-O Nc6 d5 Na5 ",
	"Nf3 Nf6 c4 b6 Nc3 Bb7 d4 e6 e3 Be7 Bd3 c5 O-O cxd4 exd4 d5 ",
	"Nf3 Nf6 c4 b6 Nc3 c5 e4 d6 d4 cxd4 Nxd4 Bb7 Qe2 Nbd7 g3 Rc8 ",
	"Nf3 Nf6 c4 b6 d3 g6 e4 d6 Nc3 Bg7 d4 O-O Be2 Bb7 Qc2 e5 ",
	"Nf3 Nf6 c4 b6 d4 Bb7 e3 e6 Bd3 d5 O-O Bd6 Nc3 O-O b3 Nbd7 ",
	"Nf3 Nf6 c4 b6 d4 e6 g3 Bb7 Bg2 Be7 Nc3 Ne4 Qc2 Nxc3 Qxc3 O-O ",
	"Nf3 Nf6 c4 b6 d4 e6 g3 Bb7 Bg2 c5 d5 exd5 Nh4 b5 O-O bxc4 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 c5 O-O e6 Nc3 Be7 b3 O-O Bb2 d5 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 c5 O-O g6 d3 Bg7 e4 O-O Nc3 Nc6 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 c5 O-O g6 d3 Bg7 e4 d6 Nc3 Nbd7 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 c5 O-O g6 d4 Bg7 d5 b5 Nfd2 bxc4 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 c5 O-O g6 d4 cxd4 Nxd4 Bxg2 Kxg2 Bg7 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 c5 O-O g6 d4 cxd4 Qxd4 Bg7 Nc3 d6 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 e6 O-O Be7 Nc3 O-O d4 Ne4 Bd2 f5 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 e6 O-O Be7 b3 O-O Bb2 c5 e3 d5 ",
	"Nf3 Nf6 c4 b6 g3 Bb7 Bg2 e6 d4 c5 O-O cxd4 Qxd4 Be7 Nc3 O-O ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O e6 Nc3 Be7 d4 cxd4 Qxd4 d6 ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O e6 Nc3 Be7 d4 cxd4 Qxd4 d6 ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O g6 Nc3 Bg7 d4 Ne4 Nxe4 Bxe4 ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O g6 d3 Bg7 e4 d6 Nc3 O-O ",
	"Nf3 Nf6 c4 b6 g3 c5 Bg2 Bb7 O-O g6 d4 Bg7 Nc3 Ne4 Nxe4 Bxe4 ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 d4 cxd4 Nxd4 e6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 d4 cxd4 Nxd4 e6 a3 Be7 e3 d5 cxd5 exd5 ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 d4 cxd4 Nxd4 e6 a3 Nxd4 Qxd4 b6 Qf4 Bb7 ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 d4 cxd4 Nxd4 e6 g3 Qb6 Nb3 d5 cxd5 Nxd5 ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 e3 e6 d4 d5 a3 cxd4 exd4 Be7 Bd3 O-O ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 e3 e6 d4 d5 a3 cxd4 exd4 Be7 Bd3 O-O ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 e3 e6 d4 d5 cxd5 exd5 Be2 cxd4 Nxd4 Bd6 ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 e3 e6 d4 d5 cxd5 exd5 Be2 cxd4 exd4 Ne4 ",
	"Nf3 Nf6 c4 c5 Nc3 Nc6 g3 d5 d4 dxc4 d5 Na5 e4 b5 Nxb5 Nxe4 ",
	"Nf3 Nf6 c4 c5 Nc3 b6 d4 cxd4 Nxd4 Bb7 f3 e6 e4 Nc6 Be3 Bc5 ",
	"Nf3 Nf6 c4 c5 Nc3 b6 e4 Nc6 d4 cxd4 Nxd4 Bb7 Bg5 Qb8 Nxc6 Bxc6 ",
	"Nf3 Nf6 c4 c5 Nc3 b6 g3 Bb7 Bg2 e6 O-O Be7 d4 cxd4 Qxd4 d6 ",
	"Nf3 Nf6 c4 c5 Nc3 d5 cxd5 Nxd5 e4 Nxc3 dxc3 Qxd1+ Kxd1 f6 Be3 e5 ",
	"Nf3 Nf6 c4 c5 Nc3 d5 cxd5 Nxd5 g3 Nc6 Bg2 Nc7 Qa4 Bd7 Qe4 g6 ",
	"Nf3 Nf6 c4 c5 Nc3 d5 cxd5 Nxd5 g3 Nc6 Bg2 e6 O-O Be7 d4 O-O ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 Nc6 Bg2 d6 O-O Bd7 d4 cxd4 Nxd4 a6 ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 b6 Bg2 Bb7 O-O Be7 Re1 a6 e4 d6 ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 b6 Bg2 Bb7 O-O a6 b3 d6 Bb2 Be7 ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 b6 e4 Bb7 Qe2 Nc6 Bg2 d6 O-O Be7 ",
	"Nf3 Nf6 c4 c5 Nc3 e6 g3 d5 cxd5 exd5 d4 Nc6 Bg2 Be7 O-O O-O ",
	"Nf3 Nf6 c4 c5 Nc3 g6 d4 cxd4 Nxd4 Nc6 e4 d6 f3 Nxd4 Qxd4 Bg7 ",
	"Nf3 Nf6 c4 c5 d4 b6 Nc3 Bb7 d5 d6 e4 Nbd7 Bf4 g6 Qd2 Bg7 ",
	"Nf3 Nf6 c4 c5 d4 cxd4 Nxd4 e5 Nb5 Bb4+ Bd2 Bxd2+ Qxd2 O-O N1c3 Na6 ",
	"Nf3 Nf6 c4 c5 d4 cxd4 Nxd4 g6 Nc3 Bg7 e4 Nc6 Nc2 d6 Be2 Nd7 ",
	"Nf3 Nf6 c4 c5 g3 Nc6 Bg2 g6 b3 Bg7 Bb2 d6 d4 cxd4 Nxd4 Bd7 ",
	"Nf3 Nf6 c4 c5 g3 d5 cxd5 Nxd5 Bg2 Nc6 d4 Nf6 Qa4 Bd7 dxc5 e5 ",
	"Nf3 Nf6 c4 c5 g3 d5 cxd5 Nxd5 Bg2 Nc6 d4 g6 e4 Nb6 d5 Nb4 ",
	"Nf3 Nf6 c4 c5 g3 d5 cxd5 Nxd5 Nc3 Nc6 Bg2 Nc7 Qa4 Bd7 Qe4 Ne6 ",
	"Nf3 Nf6 c4 c5 g3 g6 Bg2 Bg7 d4 O-O d5 e6 Nc3 exd5 cxd5 d6 ",
	"Nf3 Nf6 c4 c6 Nc3 d5 d4 g6 Bf4 dxc4 a4 Na6 e4 Be6 Ng5 Qd7 ",
	"Nf3 Nf6 c4 c6 Nc3 d5 e3 g6 d4 Bg7 Bd3 O-O O-O Nbd7 Qe2 Re8 ",
	"Nf3 Nf6 c4 c6 Nc3 d5 e3 g6 d4 Bg7 Bd3 O-O O-O a6 Bd2 b5 ",
	"Nf3 Nf6 c4 c6 b3 d5 Bb2 Bf5 d3 e6 Nbd2 Bd6 g3 O-O Bg2 Nbd7 ",
	"Nf3 Nf6 c4 c6 d4 d5 Nc3 dxc4 a4 Bf5 Ne5 Nbd7 Nxc4 Qc7 g3 e5 ",
	"Nf3 Nf6 c4 c6 d4 d5 Nc3 e6 Bg5 Nbd7 e3 Qa5 cxd5 exd5 Bd3 Ne4 ",
	"Nf3 Nf6 c4 c6 d4 d5 Nc3 e6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 b4 ",
	"Nf3 Nf6 c4 d6 d4 Nbd7 g3 e5 Bg2 Be7 O-O O-O Nc3 c6 e4 Qc7 ",
	"Nf3 Nf6 c4 d6 d4 g6 Nc3 Bf5 d5 Bg7 Nd4 Bd7 e4 Na6 Nb3 e5 ",
	"Nf3 Nf6 c4 d6 d4 g6 g3 Bg7 Bg2 O-O O-O Bg4 Nc3 Qd7 Re1 Re8 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 Qb3 c5 a3 Ba5 g3 O-O Bg2 d5 O-O d4 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3 Qxc3 b6 b4 Bb7 Bb2 d6 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 d4 c5 e3 Nc6 Bd3 Bxc3+ bxc3 d6 Qe2 e5 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 g3 O-O Bg2 b6 Ne5 c6 O-O Bb7 d4 d6 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 g3 O-O Bg2 d5 a3 Be7 d4 Nbd7 b3 c6 ",
	"Nf3 Nf6 c4 e6 Nc3 Bb4 g3 b6 Bg2 Bb7 d3 O-O e4 d5 e5 Nfd7 ",
	"Nf3 Nf6 c4 e6 Nc3 b6 e4 Bb7 Bd3 c5 e5 Ng4 O-O Nc6 Be4 f5 ",
	"Nf3 Nf6 c4 e6 Nc3 b6 e4 Bb7 d3 d6 g3 g6 Bg2 Bg7 O-O O-O ",
	"Nf3 Nf6 c4 e6 Nc3 b6 g3 Bb7 Bg2 c5 O-O Nc6 d4 cxd4 Nxd4 Bc5 ",
	"Nf3 Nf6 c4 e6 Nc3 c5 g3 d5 cxd5 Nxd5 Bg2 Nc6 O-O Nf6 e3 Be7 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Bb4 e3 O-O Bd3 b6 O-O Bb7 a3 Bxc3 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Bb4 e3 c5 a3 Bxc3+ bxc3 Nc6 Bb2 O-O ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Be7 Bf4 O-O e3 b6 Rc1 Bb7 cxd5 exd5 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Be7 Bg5 O-O e3 b6 cxd5 exd5 Bd3 Nbd7 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Be7 Bg5 O-O e3 h6 Bh4 b6 Bd3 Bb7 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Be7 Bg5 O-O e3 h6 Bh4 b6 Qb3 Bb7 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Be7 Bg5 h6 Bf4 c5 dxc5 Bxc5 e3 Nc6 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 Be7 Bg5 h6 Bh4 O-O e3 b6 Bd3 Bb7 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 c5 cxd5 Nxd5 e3 Nc6 Bc4 cxd4 exd4 Be7 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 c6 Bg5 dxc4 e4 b5 a4 Qb6 Bxf6 gxf6 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 c6 Bg5 h6 Bxf6 Qxf6 e3 Nd7 Bd3 Qd8 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bb3 Bb7 ",
	"Nf3 Nf6 c4 e6 Nc3 d5 d4 dxc4 e4 c5 Bxc4 cxd4 Nxd4 a6 e5 Qc7 ",
	"Nf3 Nf6 c4 e6 b3 b6 Bb2 Bb7 e3 Be7 Be2 O-O O-O d5 d4 Nbd7 ",
	"Nf3 Nf6 c4 e6 b3 d5 Bb2 Nbd7 g3 Bd6 Bg2 c6 d4 Qa5+ Nbd2 dxc4 ",
	"Nf3 Nf6 c4 e6 d4 Bb4+ Nbd2 O-O a3 Bxd2+ Bxd2 Ne4 Be3 d5 Rc1 dxc4 ",
	"Nf3 Nf6 c4 e6 d4 Bb4+ Nbd2 b6 e3 Bb7 Bd3 Ne4 a3 Bxd2+ Nxd2 Nxd2 ",
	"Nf3 Nf6 c4 e6 d4 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 Ne4 Qc2 Nxc3 ",
	"Nf3 Nf6 c4 e6 d4 b6 g3 Bb7 Bg2 c5 d5 exd5 Nh4 g6 Nc3 Bg7 ",
	"Nf3 Nf6 c4 e6 d4 d5 Bg5 Be7 e3 Nbd7 Nbd2 Ne4 Bxe7 Qxe7 Bd3 f5 ",
	"Nf3 Nf6 c4 e6 d4 d5 Bg5 Be7 e3 O-O Nc3 Nbd7 Bd3 dxc4 Bxc4 c5 ",
	"Nf3 Nf6 c4 e6 d4 d5 Nc3 Be7 g3 O-O Bg2 c6 O-O b6 Ne5 Bb7 ",
	"Nf3 Nf6 c4 e6 d4 d5 Nc3 dxc4 e3 Nbd7 Bxc4 c5 O-O cxd4 exd4 Qc7 ",
	"Nf3 Nf6 c4 e6 d4 d5 e3 Nc6 Nc3 Bb4 Bd2 O-O a3 Bxc3 Bxc3 Ne4 ",
	"Nf3 Nf6 c4 e6 g3 a6 Nc3 c5 Bg2 d6 d4 cxd4 Nxd4 Qc7 Bg5 Be7 ",
	"Nf3 Nf6 c4 e6 g3 b6 Bg2 Bb7 O-O Be7 b3 O-O Bb2 d5 d4 dxc4 ",
	"Nf3 Nf6 c4 e6 g3 b6 Bg2 Bb7 O-O Be7 b3 O-O Bb2 d5 e3 c5 ",
	"Nf3 Nf6 c4 e6 g3 b6 Bg2 Bb7 O-O Be7 b3 O-O Bb2 d6 d4 Nbd7 ",
	"Nf3 Nf6 c4 e6 g3 b6 Bg2 Bb7 O-O c5 Nc3 Be7 d4 cxd4 Qxd4 O-O ",
	"Nf3 Nf6 c4 e6 g3 b6 Bg2 Bb7 b3 c5 Bb2 Na6 O-O Qc7 Nc3 Rd8 ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 Bd6 b3 Qe7 Bb2 c6 d4 Nbd7 Ne5 Nxe5 ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 Be7 O-O O-O d4 c6 Qc2 Nbd7 Nbd2 b6 ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 Be7 O-O O-O d4 c6 Qc2 b6 Rd1 Bb7 ",
	"Nf3 Nf6 c4 e6 g3 d5 Bg2 a6 b3 Bd6 Bb2 Qe7 O-O Nbd7 d4 dxc4 ",
	"Nf3 Nf6 c4 e6 g3 d5 b3 c5 Bg2 Nc6 O-O Be7 d3 O-O Bb2 d4 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 O-O Be2 d6 d4 e5 O-O Nc6 d5 Ne7 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 Be3 Ng4 Bg5 f6 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Na6 Be3 Ng4 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nbd7 Be3 Ng4 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nc6 Be3 Ng4 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O exd4 Nxd4 Re8 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 d5 Na6 Nd2 Kh8 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 d5 a5 Bg5 h6 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 dxe5 dxe5 Qxd8 Rxd8 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O h3 e5 d5 Na6 Be3 Nh5 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 e4 d6 d4 O-O h3 e5 d5 Nh5 Nh2 Qe8 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 g3 O-O Bg2 c5 d4 Nc6 d5 Na5 Nd2 d6 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 g3 O-O Bg2 d6 d4 Nbd7 O-O e5 dxe5 dxe5 ",
	"Nf3 Nf6 c4 g6 Nc3 Bg7 g3 O-O Bg2 d6 d4 Nc6 O-O Bg4 d5 Bxf3 ",
	"Nf3 Nf6 c4 g6 Nc3 d5 Qa4+ Bd7 Qb3 dxc4 Qxc4 Bg7 g3 O-O Bg2 Nc6 ",
	"Nf3 Nf6 c4 g6 Nc3 d5 Qa4+ Bd7 Qb3 dxc4 Qxc4 Bg7 g3 O-O Bg2 Qc8 ",
	"Nf3 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 Qa4+ Bd7 Qh4 Bc6 Qd4 f6 e4 Nxc3 ",
	"Nf3 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 Qa4+ Bd7 Qh4 Nf6 e4 Bg4 Ne5 Be6 ",
	"Nf3 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nb6 h3 Bg7 d4 O-O Be2 Nc6 ",
	"Nf3 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 g3 Bg7 Bg2 Nb6 O-O Nc6 d3 O-O ",
	"Nf3 Nf6 c4 g6 Nc3 d5 d4 Bg7 Bg5 Ne4 cxd5 Nxg5 Nxg5 e6 Nf3 exd5 ",
	"Nf3 Nf6 c4 g6 b3 Bg7 Bb2 O-O g3 d6 Bg2 Nc6 O-O e5 d4 Nd7 ",
	"Nf3 Nf6 c4 g6 b4 Bg7 Bb2 O-O g3 b6 Bg2 Bb7 O-O d6 d3 Nbd7 ",
	"Nf3 Nf6 c4 g6 d4 Bg7 Nc3 O-O e4 d6 Be2 Bg4 Bg5 Nc6 d5 Bxf3 ",
	"Nf3 Nf6 c4 g6 d4 Bg7 Nc3 d5 cxd5 Nxd5 Bd2 O-O Rc1 Nb6 Bg5 h6 ",
	"Nf3 Nf6 c4 g6 d4 Bg7 g3 O-O Bg2 d5 cxd5 Nxd5 O-O Nc6 e4 Nb6 ",
	"Nf3 Nf6 c4 g6 d4 Bg7 g3 O-O Bg2 d6 Nc3 Nbd7 O-O e5 e4 a5 ",
	"Nf3 Nf6 c4 g6 d4 Bg7 g3 O-O Bg2 d6 Nc3 Nc6 O-O Bf5 Ne1 e5 ",
	"Nf3 Nf6 c4 g6 d4 Bg7 g3 O-O Bg2 d6 Nc3 Nc6 O-O Bf5 Ne1 e5 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O c6 b3 Ne4 d4 d5 Bb2 a5 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O d6 Nc3 Nc6 d4 Rb8 h3 a6 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O d6 d4 Nbd7 Nc3 e5 e4 c6 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O d6 d4 Nbd7 Nc3 e5 h3 c6 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O d6 d4 Nbd7 Qc2 e5 Rd1 Re8 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O O-O d6 d4 Nc6 d5 Na5 Nfd2 c5 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O d4 c6 Nc3 d5 cxd5 cxd5 Ne5 e6 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 O-O d4 d6 Nc3 c5 O-O Nc6 d5 Na5 ",
	"Nf3 Nf6 c4 g6 g3 Bg7 Bg2 c6 O-O d5 Ne5 Nbd7 f4 h5 cxd5 cxd5 ",
	"Nf3 Nf6 c4 g6 g3 c5 Bg2 Bg7 d4 O-O O-O Na6 Nc3 d6 b3 Bg4 ",
	"Nf3 Nf6 d4 b6 c4 Bb7 Nc3 e6 a3 d5 cxd5 exd5 Bg5 Be7 e3 O-O ",
	"Nf3 Nf6 d4 c5 d5 d6 Nc3 g6 e4 Bg7 Be2 O-O O-O e5 dxe6 Bxe6 ",
	"Nf3 Nf6 d4 d5 c4 e6 Nc3 c5 cxd5 Nxd5 e3 Be7 Bc4 Nc6 O-O cxd4 ",
	"Nf3 Nf6 d4 d6 c4 g6 Nc3 Bg7 e4 Bg4 h3 Bxf3 Qxf3 O-O Be2 Nfd7 ",
	"Nf3 Nf6 d4 e6 Bg5 c5 e3 Qb6 Qc1 Ne4 Bh4 Nc6 Bd3 d5 c3 Bd7 ",
	"Nf3 Nf6 g3 b5 Bg2 Bb7 Na3 a6 c4 b4 Nc2 e6 O-O c5 b3 Be7 ",
	"Nf3 Nf6 g3 b6 Bg2 Bb7 O-O c5 d3 d5 Nbd2 Nc6 e4 e5 exd5 Nxd5 ",
	"Nf3 Nf6 g3 b6 Bg2 Bb7 O-O g6 d3 Bg7 e4 O-O Nh4 e5 c4 Nc6 ",
	"Nf3 Nf6 g3 b6 Bg2 Bb7 O-O g6 d3 Bg7 e4 d6 Nh4 e5 f4 Nfd7 ",
	"Nf3 Nf6 g3 c5 Bg2 Nc6 O-O e5 c4 d5 Qa4 Bd6 Ng5 Bd7 cxd5 Nb4 ",
	"Nf3 Nf6 g3 c5 Bg2 Nc6 O-O e5 d3 d5 e4 Be7 Nbd2 O-O Re1 dxe4 ",
	"Nf3 Nf6 g3 c5 Bg2 d5 O-O Nc6 d4 e6 c4 Be7 cxd5 exd5 dxc5 Bxc5 ",
	"Nf3 Nf6 g3 d5 Bg2 Bf5 O-O Nbd7 d3 c6 Nbd2 h6 e4 dxe4 dxe4 Nxe4 ",
	"Nf3 Nf6 g3 d5 Bg2 Bf5 O-O e6 c4 c6 d3 Nbd7 b3 Bd6 Bb2 O-O ",
	"Nf3 Nf6 g3 d5 Bg2 Bf5 O-O e6 d3 Bd6 Nbd2 h6 e4 Bg4 h3 Bxf3 ",
	"Nf3 Nf6 g3 d5 Bg2 Bf5 O-O e6 d3 c6 Nbd2 Na6 a3 Nc5 c4 b5 ",
	"Nf3 Nf6 g3 d5 Bg2 Nc6 O-O e5 d3 Bg4 h3 Bf5 Nc3 Qd7 Kh2 h6 ",
	"Nf3 Nf6 g3 d5 Bg2 c5 O-O Nc6 c4 e5 cxd5 Nxd5 d3 Be7 Nbd2 Be6 ",
	"Nf3 Nf6 g3 d5 Bg2 c6 O-O Bf5 d3 h6 c4 e6 Be3 Be7 Qb3 Qc8 ",
	"Nf3 Nf6 g3 d5 Bg2 c6 O-O Bg4 b3 Nbd7 Bb2 e6 c4 Bd6 d4 O-O ",
	"Nf3 Nf6 g3 d5 Bg2 c6 O-O Bg4 h3 Bh5 d3 Nbd7 b3 e5 Bb2 Bd6 ",
	"Nf3 Nf6 g3 d5 Bg2 g6 O-O Bg7 d4 O-O c4 dxc4 Na3 Nc6 Nxc4 Be6 ",
	"Nf3 Nf6 g3 d5 c4 dxc4 Qa4+ Nc6 Qxc4 e5 Bg2 Be6 Qa4 Nd7 d3 Nb6 ",
	"Nf3 Nf6 g3 d6 Bg2 e5 c4 Nc6 Nc3 Be7 d4 O-O O-O Bg4 d5 Nb8 ",
	"Nf3 Nf6 g3 d6 Bg2 e5 c4 g6 Nc3 Bg7 d4 Nbd7 O-O O-O e4 c6 ",
	"Nf3 Nf6 g3 d6 d4 Nbd7 Bg2 e5 O-O Be7 c4 O-O Nc3 a5 e4 c6 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O c4 d5 cxd5 Nxd5 d4 c5 dxc5 Na6 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 c5 Nbd2 Nc6 e4 d6 a4 Rb8 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 c5 e4 Nc6 Nbd2 d6 a4 Ne8 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 d5 Nbd2 c5 e4 Nc6 c3 h6 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 d6 Nbd2 e5 e4 Ne8 c3 f5 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d3 d6 e4 e5 Nbd2 Nbd7 a4 Re8 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d4 d6 b3 Nbd7 Bb2 e5 dxe5 Nh5 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d4 d6 b3 c5 Bb2 Nc6 d5 Na5 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d4 d6 c4 Nbd7 Nc3 e5 e4 exd4 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d4 d6 c4 Nc6 d5 Na5 Nfd2 c5 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 O-O d5 d3 O-O Nbd2 Nc6 e4 dxe4 dxe4 e5 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 c4 c6 O-O O-O d4 d5 Qa4 Nbd7 cxd5 Nb6 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 c4 c6 d4 O-O Nc3 d5 cxd5 cxd5 Ne5 Nc6 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 c4 c6 d4 d5 Nbd2 O-O O-O Bf5 b3 Ne4 ",
	"Nf3 Nf6 g3 g6 Bg2 Bg7 c4 c6 d4 d5 cxd5 cxd5 Nc3 O-O Ne5 Nc6 ",
	"Nf3 Nf6 g3 g6 b3 Bg7 Bb2 O-O Bg2 d5 O-O Nbd7 c4 c6 Qc2 dxc4 ",
	"Nf3 Nf6 g3 g6 b3 Bg7 Bb2 O-O Bg2 d6 d4 e5 dxe5 Ng4 h3 Nxe5 ",
	"Nf3 Nf6 g3 g6 b3 Bg7 Bb2 O-O Bg2 d6 d4 e5 dxe5 Ng4 h3 Nxe5 ",
	"Nf3 Nf6 g3 g6 b3 Bg7 Bb2 d5 c4 c6 Bg2 O-O O-O Nbd7 Qc2 b6 ",
	"Nf3 Nf6 g3 g6 b3 Bg7 Bb2 d6 d4 O-O Bg2 Nc6 d5 Nb4 c4 c5 ",
	"Nf3 Nf6 g3 g6 b3 Bg7 Bb2 d6 d4 O-O Bg2 e5 dxe5 Ng4 h3 Nxe5 ",
	"Nf3 Nf6 g3 g6 b3 a5 Bb2 Bg7 Bg2 d6 d4 c6 O-O O-O Nbd2 a4 ",
	"Nf3 Nf6 g3 g6 b3 d5 Bb2 c5 c4 d4 b4 Bg7 Bg2 O-O O-O Nfd7 ",
	"Nf3 Nf6 g3 g6 b4 Bg7 Bb2 O-O Bg2 d6 d4 e5 dxe5 Ng4 Nbd2 Nc6 ",
	"Nf3 Nf6 g3 g6 b4 Bg7 Bb2 d6 Bg2 O-O O-O e5 d3 Nh5 e4 Nc6 ",
	"Nf3 Nf6 g3 g6 c4 Bg7 Bg2 O-O O-O Nc6 Nc3 d6 d4 a6 d5 Na5 ",
	"Nf3 b5 c3 e6 g3 Bb7 Bg2 Nf6 O-O Be7 d3 d6 a4 a6 axb5 axb5 ",
	"Nf3 c5 b3 d5 e3 Nc6 Bb2 a6 d4 Bg4 dxc5 e5 Be2 Bxf3 Bxf3 e4 ",
	"Nf3 c5 b3 d5 e3 Nf6 Bb2 e6 Bb5+ Bd7 Be2 Nc6 O-O Bd6 c4 O-O ",
	"Nf3 c5 b3 d5 e3 Nf6 Bb2 e6 c4 dxc4 bxc4 Be7 Nc3 O-O Qc2 Nc6 ",
	"Nf3 c5 c4 Nc6 Nc3 Nf6 d4 cxd4 Nxd4 e6 g3 Qb6 Nb3 Bb4 Bg2 d5 ",
	"Nf3 c5 c4 Nc6 Nc3 Nf6 e3 e6 d4 d5 a3 a6 dxc5 Bxc5 b4 Bd6 ",
	"Nf3 c5 c4 Nc6 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nc7 O-O e5 d3 Be7 ",
	"Nf3 c5 c4 Nc6 Nc3 Nf6 g3 d6 Bg2 g6 d4 cxd4 Nxd4 Bd7 e4 Bg7 ",
	"Nf3 c5 c4 Nc6 Nc3 e5 e3 d6 d4 cxd4 exd4 Bg4 Be2 Nf6 O-O Be7 ",
	"Nf3 c5 c4 Nc6 Nc3 e5 g3 g6 Bg2 d6 a3 Be6 d3 Nge7 Rb1 a5 ",
	"Nf3 c5 c4 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 Qb6 Nb3 e6 a3 d5 Be3 Qd8 ",
	"Nf3 c5 c4 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g3 Bb4 Bg2 O-O O-O a6 ",
	"Nf3 c5 c4 Nc6 d4 cxd4 Nxd4 g6 e4 Bg7 Be3 Nf6 Nc3 O-O Be2 d6 ",
	"Nf3 c5 c4 Nc6 e3 g6 d4 cxd4 exd4 Bg7 d5 Ne5 Nxe5 Bxe5 Be2 d6 ",
	"Nf3 c5 c4 Nc6 g3 g6 Bg2 Bg7 O-O e5 Nc3 Nge7 Ne1 d6 a3 O-O ",
	"Nf3 c5 c4 Nf6 Nc3 b6 e4 Nc6 d4 cxd4 Nxd4 Bb7 Be3 e6 f3 Qb8 ",
	"Nf3 c5 c4 Nf6 Nc3 b6 e4 Nc6 d4 cxd4 Nxd4 Bb7 Bf4 d6 Nf3 g6 ",
	"Nf3 c5 c4 Nf6 Nc3 d5 cxd5 Nxd5 d4 cxd4 Qxd4 Nxc3 Qxc3 Nc6 e4 Bg4 ",
	"Nf3 c5 c4 Nf6 Nc3 d5 cxd5 Nxd5 d4 e6 e4 Nxc3 bxc3 cxd4 cxd4 Nc6 ",
	"Nf3 c5 c4 Nf6 Nc3 d5 cxd5 Nxd5 e4 Nb4 Bc4 Nd3+ Ke2 Nf4+ Kf1 Ne6 ",
	"Nf3 c5 c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Qb3 Nb4 Ne4 Bg7 Nxc5 Qa5 ",
	"Nf3 c5 c4 Nf6 Nc3 e6 g3 b6 Bg2 Bb7 O-O d6 b3 Be7 d4 cxd4 ",
	"Nf3 c5 c4 Nf6 Nc3 g6 e4 d6 d4 cxd4 Nxd4 Bg7 Be2 Nc6 Be3 O-O ",
	"Nf3 c5 c4 Nf6 d4 cxd4 Nxd4 g6 Nc3 Bg7 e4 d6 Be2 Nc6 Be3 Bd7 ",
	"Nf3 c5 c4 Nf6 g3 b6 Bg2 Bb7 O-O e6 Nc3 Be7 d4 cxd4 Qxd4 d6 ",
	"Nf3 c5 c4 g6 d4 Bg7 g3 cxd4 Nxd4 d5 Bg2 e5 Qa4+ Bd7 Nb5 Ne7 ",
	"Nf3 c5 c4 g6 d4 cxd4 Nxd4 Bg7 e4 Nc6 Be3 Nf6 Nc3 O-O Be2 d6 ",
	"Nf3 c5 c4 g6 d4 cxd4 Nxd4 Nc6 e4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"Nf3 c5 c4 g6 d4 cxd4 Nxd4 Nc6 e4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"Nf3 c5 c4 g6 e4 d6 d4 Bg4 d5 Bg7 Be2 Qa5+ Bd2 Qb6 Nc3 Nf6 ",
	"Nf3 c5 e4 Nc6 Nc3 d6 d4 cxd4 Nxd4 Nf6 f4 e5 Nf3 Be7 Bc4 O-O ",
	"Nf3 c5 e4 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 Bd7 Qd2 Rc8 O-O-O Nxd4 ",
	"Nf3 c5 e4 d6 Bb5+ Bd7 Bxd7+ Nxd7 O-O Ngf6 Qe2 e6 d4 cxd4 Nxd4 Ne5 ",
	"Nf3 c5 e4 d6 Nc3 Nc6 d4 cxd4 Nxd4 g6 Nd5 e6 Nc3 Nf6 Be2 a6 ",
	"Nf3 c5 e4 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 Bf3 Qc7 g4 Nc6 ",
	"Nf3 c5 e4 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 g3 Nge7 Nb3 Na5 Qh5 Nec6 ",
	"Nf3 c5 g3 Nc6 Bg2 e5 O-O Be7 c4 Nf6 Nc3 d6 d3 O-O a3 a5 ",
	"Nf3 c5 g3 Nc6 Bg2 g6 O-O Bg7 c3 e5 d3 Nge7 a3 O-O b4 cxb4 ",
	"Nf3 c5 g3 g6 Bg2 Bg7 d4 Nc6 d5 Na5 e4 d6 O-O Bg4 Qe2 Nf6 ",
	"Nf3 c6 c4 Nf6 Nc3 d5 d4 dxc4 e4 b5 e5 Nd5 a4 e6 Ng5 Bb4 ",
	"Nf3 d5 b3 Bf5 Bb2 e6 g3 h6 Bg2 Nd7 O-O Ngf6 d3 Be7 e3 O-O ",
	"Nf3 d5 b3 c5 Bb2 Nc6 e3 Nf6 Bb5 Bd7 O-O e6 d3 Be7 Nbd2 O-O ",
	"Nf3 d5 c4 c6 b3 Bf5 Bb2 e6 g3 Nf6 Bg2 Nbd7 O-O h6 d3 Be7 ",
	"Nf3 d5 c4 c6 d4 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"Nf3 d5 c4 c6 d4 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O O-O ",
	"Nf3 d5 c4 c6 d4 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O O-O ",
	"Nf3 d5 c4 c6 d4 Nf6 Nc3 e6 Bg5 Nbd7 e3 Qa5 Nd2 dxc4 Bxf6 Nxf6 ",
	"Nf3 d5 c4 c6 d4 Nf6 e3 e6 Bd3 Nbd7 Nc3 dxc4 Bxc4 b5 Bd3 a6 ",
	"Nf3 d5 c4 c6 d4 e6 Qc2 Nf6 Bg5 h6 Bh4 Nbd7 e3 Be7 Nc3 O-O ",
	"Nf3 d5 c4 c6 e3 Nf6 Nc3 Bf5 cxd5 Nxd5 Bc4 e6 O-O Nxc3 bxc3 Bd3 ",
	"Nf3 d5 c4 c6 e3 Nf6 Nc3 e6 d4 Nbd7 Bd3 Bb4 a3 Ba5 O-O O-O ",
	"Nf3 d5 c4 c6 e3 Nf6 Nc3 e6 d4 Nbd7 Qc2 Bd6 Be2 O-O O-O dxc4 ",
	"Nf3 d5 c4 c6 e3 Nf6 Nc3 g6 d4 Bg7 Bd3 O-O O-O c5 dxc5 dxc4 ",
	"Nf3 d5 c4 d4 b4 c5 Bb2 g6 e3 Bg7 d3 Nh6 Nbd2 O-O exd4 cxd4 ",
	"Nf3 d5 c4 d4 b4 c5 a3 g6 d3 Bg7 Nbd2 Nh6 bxc5 O-O Nb3 Nc6 ",
	"Nf3 d5 c4 d4 b4 g6 Bb2 Bg7 Na3 e5 Nc2 Bg4 e3 Ne7 exd4 exd4 ",
	"Nf3 d5 c4 d4 b4 g6 Bb2 Bg7 g3 e5 d3 Ne7 Bg2 c5 bxc5 Nd7 ",
	"Nf3 d5 c4 d4 b4 g6 d3 Bg7 g3 e5 Bg2 Ne7 O-O O-O Nbd2 Re8 ",
	"Nf3 d5 c4 d4 b4 g6 g3 Bg7 d3 b6 Bg2 Bb7 O-O e5 Nbd2 Ne7 ",
	"Nf3 d5 c4 d4 d3 f6 g3 e5 Bg2 c5 O-O Nc6 e3 Bd6 Nbd2 Nge7 ",
	"Nf3 d5 c4 d4 e3 Nc6 exd4 Nxd4 Nxd4 Qxd4 Nc3 Bg4 Qa4+ c6 d3 Nf6 ",
	"Nf3 d5 c4 d4 e3 Nc6 exd4 Nxd4 Nxd4 Qxd4 Nc3 c6 d3 e5 Be3 Qd8 ",
	"Nf3 d5 c4 d4 g3 g6 Bg2 Bg7 d3 e5 O-O Ne7 b4 O-O Nbd2 a5 ",
	"Nf3 d5 c4 dxc4 Qa4+ c6 Qxc4 Nf6 g3 Bg4 Bg2 Nbd7 d4 Bxf3 Bxf3 e5 ",
	"Nf3 d5 c4 e6 Nc3 Nf6 d4 Be7 g3 O-O Bg2 c6 O-O Nbd7 b3 b6 ",
	"Nf3 d5 c4 e6 b3 Nf6 Bb2 Be7 e3 O-O Be2 c6 O-O Nbd7 Nc3 a6 ",
	"Nf3 d5 c4 e6 b3 Nf6 Bb2 Be7 e3 O-O Nc3 c5 cxd5 Nxd5 Nxd5 exd5 ",
	"Nf3 d5 c4 e6 b3 Nf6 Bb2 Be7 g3 O-O Bg2 c5 O-O Nc6 e3 dxc4 ",
	"Nf3 d5 c4 e6 b3 Nf6 g3 c5 Bg2 Nc6 O-O Be7 cxd5 exd5 d4 O-O ",
	"Nf3 d5 c4 e6 d4 Nf6 Bg5 Nbd7 e3 Be7 Nc3 O-O Rc1 c6 Bd3 a6 ",
	"Nf3 d5 c4 e6 d4 Nf6 Nc3 Bb4 cxd5 exd5 Bg5 Nbd7 Rc1 c5 a3 Bxc3+ ",
	"Nf3 d5 c4 e6 d4 Nf6 Nc3 Be7 Bg5 O-O e3 Nbd7 Rc1 c6 Bd3 dxc4 ",
	"Nf3 d5 c4 e6 d4 Nf6 Nc3 c6 Bg5 Nbd7 e3 Qa5 Nd2 dxc4 Bxf6 Nxf6 ",
	"Nf3 d5 c4 e6 d4 Nf6 Nc3 c6 Bg5 dxc4 e4 b5 a4 Bb4 axb5 cxb5 ",
	"Nf3 d5 c4 e6 d4 Nf6 Nc3 c6 e3 Nbd7 Bd3 Be7 O-O O-O b3 Bb4 ",
	"Nf3 d5 c4 e6 g3 Nf6 Bg2 Be7 O-O O-O b3 c5 Bb2 Nc6 cxd5 exd5 ",
	"Nf3 d5 c4 e6 g3 Nf6 Bg2 Be7 O-O O-O b3 c5 Bb2 Nc6 e3 d4 ",
	"Nf3 d5 c4 e6 g3 Nf6 Bg2 Be7 O-O O-O d4 Nbd7 Nc3 dxc4 e4 c6 ",
	"Nf3 d5 c4 e6 g3 Nf6 Bg2 Be7 O-O O-O d4 Nbd7 Nc3 dxc4 e4 c6 ",
	"Nf3 d5 c4 e6 g3 Nf6 Bg2 dxc4 Qa4+ Nbd7 Qxc4 c5 Qb3 Rb8 a4 b6 ",
	"Nf3 d5 d4 Bf5 c4 e6 Nc3 c6 Bf4 Bd6 Bg3 Ne7 e3 O-O Nh4 h6 ",
	"Nf3 d5 d4 Bf5 c4 e6 Nc3 c6 e3 Nd7 Bd3 Bg6 O-O Ngf6 Qe2 Be7 ",
	"Nf3 d5 d4 Bf5 c4 e6 Qb3 Nc6 c5 Rb8 Bf4 h6 e3 g5 Bg3 Bg7 ",
	"Nf3 d5 d4 Bf5 c4 e6 Qb3 Nc6 c5 Rb8 Nc3 e5 e4 exd4 exf5 dxc3 ",
	"Nf3 d5 d4 Nf6 c4 c6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O O-O ",
	"Nf3 d5 d4 Nf6 c4 c6 cxd5 cxd5 Nc3 Nc6 Bf4 e6 e3 Bd6 Bd3 O-O ",
	"Nf3 d5 d4 Nf6 c4 c6 e3 e6 Bd3 dxc4 Bxc4 c5 O-O Nc6 Qe2 cxd4 ",
	"Nf3 d5 d4 Nf6 c4 e6 Bg5 Be7 Nc3 h6 Bxf6 Bxf6 e3 O-O Rc1 c6 ",
	"Nf3 d5 d4 Nf6 c4 e6 Nc3 Bb4 cxd5 exd5 Bg5 Qd6 Bxf6 gxf6 Qc2 Nc6 ",
	"Nf3 d5 d4 Nf6 c4 e6 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Qc2 c5 ",
	"Nf3 d5 d4 Nf6 c4 e6 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Qc2 c5 ",
	"Nf3 d5 d4 Nf6 c4 e6 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Rc1 c6 ",
	"Nf3 d5 d4 Nf6 c4 e6 Nc3 Be7 g3 O-O Bg2 dxc4 Ne5 Nc6 Bxc6 bxc6 ",
	"Nf3 d5 d4 Nf6 c4 e6 Nc3 c5 cxd5 Nxd5 e3 Nc6 Bc4 cxd4 exd4 Be7 ",
	"Nf3 d5 d4 Nf6 c4 e6 Nc3 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"Nf3 d5 d4 Nf6 c4 e6 Nc3 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"Nf3 d5 d4 Nf6 e3 e6 Bd3 c5 b3 Nc6 O-O Bd6 Bb2 O-O a3 b6 ",
	"Nf3 d5 d4 c5 c4 dxc4 d5 Nf6 Nc3 e6 e4 Nxe4 Nxe4 exd5 Bg5 Qa5+ ",
	"Nf3 d5 d4 e6 c4 Nf6 Bg5 Be7 Nc3 O-O Rc1 h6 Bh4 b6 cxd5 Nxd5 ",
	"Nf3 d5 d4 e6 c4 c5 cxd5 exd5 Bg5 Be7 Bxe7 Nxe7 dxc5 Qa5+ Nc3 Nbc6 ",
	"Nf3 d5 d4 e6 e3 Nf6 Bd3 c5 b3 Nc6 Bb2 Bd6 Nbd2 Nb4 Be2 Qe7 ",
	"Nf3 d5 e3 Nf6 c4 c6 Nc3 e6 d4 Nbd7 Bd3 dxc4 Bxc4 Bb4 O-O O-O ",
	"Nf3 d5 e3 Nf6 c4 e6 b3 Be7 Bb2 O-O Nc3 c5 cxd5 Nxd5 Nxd5 Qxd5 ",
	"Nf3 d5 e3 Nf6 c4 e6 b3 Be7 Bb2 O-O d4 b6 Nbd2 Bb7 Bd3 c5 ",
	"Nf3 d5 g3 Bg4 Bg2 c6 O-O e6 d3 Nd7 b3 Ngf6 Bb2 Bb4 a3 Ba5 ",
	"Nf3 d5 g3 Nc6 d4 Bg4 Bg2 e6 O-O Nf6 c4 Be7 Ne5 Bh5 Nc3 O-O ",
	"Nf3 d5 g3 Nd7 Bg2 e5 O-O Ngf6 d3 Bd6 Nbd2 O-O e4 c6 b3 Re8 ",
	"Nf3 d5 g3 Nf6 Bg2 c6 c4 dxc4 Na3 Qd5 O-O e5 Ng5 e4 d3 Bxa3 ",
	"Nf3 d5 g3 Nf6 Bg2 c6 d3 Bf5 O-O h6 c4 dxc4 Ne5 Nbd7 Nxc4 e6 ",
	"Nf3 d5 g3 c5 Bg2 Nc6 O-O e5 c4 d4 d3 Bd6 e3 Nge7 exd4 cxd4 ",
	"Nf3 d5 g3 c5 Bg2 Nc6 O-O e5 c4 d4 d3 Nf6 e3 Be7 Re1 Nd7 ",
	"Nf3 d5 g3 c6 Bg2 Bg4 O-O Nd7 d3 e6 c4 Ngf6 cxd5 cxd5 Nc3 a6 ",
	"Nf3 d5 g3 c6 Bg2 Bg4 d3 e6 Nbd2 Bd6 O-O Nd7 e4 Ne7 b3 O-O ",
	"Nf3 d5 g3 c6 Bg2 Nf6 O-O Bg4 d3 Nbd7 Nbd2 e6 e4 Be7 h3 Bh5 ",
	"Nf3 d5 g3 g6 Bg2 Bg7 d4 Nf6 O-O O-O c4 dxc4 Na3 Nc6 Nxc4 Be6 ",
	"Nf3 d6 c4 g6 Nc3 Bg7 g3 Nf6 Bg2 O-O O-O c6 d3 a6 Rb1 b5 ",
	"Nf3 d6 d4 Bg4 e4 Nf6 Nc3 e6 Be2 Be7 O-O O-O Be3 Nbd7 Nd2 Bxe2 ",
	"Nf3 d6 d4 Bg4 e4 Nf6 Nc3 e6 Be2 Be7 O-O O-O Be3 Nbd7 Nd2 Bxe2 ",
	"Nf3 d6 d4 Bg4 e4 Nf6 h3 Bh5 Bd3 e6 c4 Be7 Nc3 Nc6 Be3 O-O ",
	"Nf3 d6 d4 Nd7 e4 e5 Bc4 Be7 dxe5 Nxe5 Nxe5 dxe5 Qh5 g6 Qxe5 Nf6 ",
	"Nf3 d6 g3 e5 Bg2 g6 O-O Bg7 c4 Nc6 Nc3 Nf6 d3 O-O Rb1 a5 ",
	"Nf3 d6 g3 g6 d4 Nf6 Bg2 Bg7 O-O O-O c4 c6 Nc3 Bf5 Bf4 Ne4 ",
	"Nf3 e6 c4 d5 g3 Nf6 Bg2 Be7 O-O O-O d4 Nbd7 Nc3 c6 Qd3 b6 ",
	"Nf3 e6 c4 f5 b3 Nf6 Bb2 d6 d4 d5 e3 c6 Bd3 Bb4+ Nbd2 O-O ",
	"Nf3 e6 d4 Nf6 g3 b6 Bg2 Bb7 O-O Be7 c4 O-O Nc3 d6 d5 Nbd7 ",
	"Nf3 e6 g3 b5 Bg2 Bb7 d3 c5 e4 Be7 O-O d6 Re1 Nf6 Nbd2 O-O ",
	"Nf3 f5 e4 fxe4 Ng5 Nf6 d3 d5 dxe4 h6 Nf3 dxe4 Qxd8+ Kxd8 Ne5 Be6 ",
	"Nf3 f5 g3 Nf6 Bg2 e6 O-O Be7 c4 O-O b3 Qe8 Nc3 Qh5 Qc2 Nc6 ",
	"Nf3 f5 g3 Nf6 Bg2 g6 b3 Bg7 Bb2 d6 d4 O-O O-O c6 c4 Na6 ",
	"Nf3 f5 g3 Nf6 Bg2 g6 c3 Bg7 Qb3 e6 d4 O-O Nbd2 d6 Ng5 d5 ",
	"Nf3 f5 g3 b6 Bg2 Bb7 d3 Nf6 Bg5 e6 O-O Be7 Nc3 O-O e4 fxe4 ",
	"Nf3 f5 g3 d6 d4 Nc6 d5 Ne5 Nd4 c5 dxc6 Nxc6 Bg2 Bd7 O-O e5 ",
	"Nf3 g6 c4 Bg7 Nc3 e5 d4 d6 g3 Nd7 Bg2 Ngf6 O-O O-O Qc2 Re8 ",
	"Nf3 g6 c4 Bg7 d4 c5 e4 Nc6 dxc5 Qa5+ Nfd2 Qxc5 Nb3 Qb6 Be2 d6 ",
	"Nf3 g6 c4 Bg7 d4 d6 Nc3 e5 e4 Nd7 Be2 Ngf6 O-O O-O Qc2 c6 ",
	"Nf3 g6 c4 Bg7 d4 d6 Nc3 e5 e4 Nd7 Be2 Ngf6 O-O O-O Qc2 c6 ",
	"Nf3 g6 d4 Bg7 c4 Nf6 g3 O-O Bg2 d6 O-O Nc6 Nc3 a6 Nd5 Bg4 ",
	"Nf3 g6 d4 Bg7 e4 d6 Be2 Nf6 Nc3 O-O O-O Bg4 Bg5 Nc6 h3 Bxf3 ",
	"Nf3 g6 d4 Bg7 e4 d6 Be2 Nf6 Nc3 O-O O-O Bg4 Bg5 Nc6 h3 Bxf3 ",
	"Nf3 g6 d4 Bg7 e4 d6 h3 c6 Be2 Nf6 Nc3 O-O a4 Nbd7 a5 e5 ",
	"Nf3 g6 d4 Bg7 g3 Nf6 Bg2 O-O c4 c5 O-O cxd4 Nxd4 Nc6 Nc3 Nxd4 ",
	"Nf3 g6 d4 Bg7 g3 d5 Bg2 c5 dxc5 Qa5+ Nfd2 Nf6 Nc3 Qxc5 Nb3 Qc7 ",
	"Nf3 g6 d4 Nf6 c4 Bg7 Nc3 O-O Bg5 h6 Bh4 c5 e3 d6 Be2 cxd4 ",
	"Nf3 g6 d4 c5 dxc5 Qa5+ Qd2 Qxc5 b4 Qc6 Bb2 Nf6 Nd4 Qb6 c4 Bg7 ",
	"Nf3 g6 d4 d6 c4 Bg7 Nc3 Nf6 e4 O-O Be2 Nbd7 O-O e5 Be3 c6 ",
	"Nf3 g6 e4 Bg7 d4 d6 Bc4 e6 O-O Ne7 Bb3 O-O c3 e5 dxe5 dxe5 ",
	"Nf3 g6 e4 Bg7 d4 d6 Be2 Nf6 Nc3 O-O O-O Nc6 h3 e5 dxe5 Nxe5 ",
	"Nf3 g6 e4 Bg7 d4 d6 Nc3 Bg4 Be3 Nc6 Bb5 a6 Bxc6+ bxc6 h3 Bxf3 ",
	"Nf3 g6 e4 Bg7 d4 d6 Nc3 Nf6 Bc4 O-O O-O c6 Qe2 Nbd7 e5 Nd5 ",
	"Nf3 g6 e4 Bg7 d4 d6 Nc3 Nf6 Be2 O-O O-O Nc6 d5 Nb8 Re1 e5 ",
	"Nf3 g6 e4 Bg7 d4 d6 Nc3 Nf6 Be2 O-O O-O Nc6 d5 Nb8 Re1 e5 ",
	"Nf3 g6 e4 Bg7 d4 d6 Nc3 a6 Be2 b5 O-O Nd7 e5 e6 Bf4 d5 ",
	"Nf3 g6 e4 Bg7 d4 d6 h3 Nf6 Nc3 O-O Be3 d5 e5 Ne4 Bd3 Nxc3 ",
	"Nf3 g6 e4 c5 c3 b6 d4 Bb7 Bc4 e6 d5 Bg7 Bg5 Qc7 O-O Nf6 ",
	"Nf3 g6 e4 d6 c4 Nf6 Nc3 Bg7 d4 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"Nf3 g6 e4 d6 d4 Nf6 Nbd2 Bg7 Bc4 O-O Qe2 c6 Bb3 Bg4 e5 dxe5 ",
	"Nf3 g6 e4 d6 d4 Nf6 Nbd2 Bg7 Bc4 O-O Qe2 c6 Bb3 Bg4 e5 dxe5 ",
	"Nf3 g6 g3 Bg7 Bg2 c5 O-O Nc6 c4 d6 Nc3 Bd7 e3 Bxc3 bxc3 f5 ",
	"Nf3 g6 g3 Bg7 Bg2 e5 O-O Nc6 c4 d6 Nc3 f5 d3 Nf6 Nd5 Ne7 ",
	"a3 e5 c4 Nf6 Nc3 d5 cxd5 Nxd5 e3 Be6 Nf3 Bd6 Be2 O-O O-O Nxc3 ",
	"b3 d5 Bb2 Bg4 f3 Bf5 f4 e6 e3 Nf6 Nf3 Nbd7 g3 Bd6 Bg2 c6 ",
	"b3 d5 Bb2 Nf6 Nf3 e6 g3 Be7 Bg2 O-O O-O c5 c4 Nc6 cxd5 Nxd5 ",
	"b3 d5 Bb2 c5 Nf3 Nc6 e3 Nf6 Bb5 Bd7 O-O e6 d3 Be7 Bxc6 Bxc6 ",
	"b3 e5 Bb2 Nc6 c4 Nf6 e3 Be7 a3 O-O Qc2 Re8 d3 Bf8 Nf3 a5 ",
	"b3 e5 Bb2 Nc6 c4 Nf6 e3 Be7 a3 O-O d3 d5 cxd5 Qxd5 Nc3 Qd6 ",
	"b3 e5 Bb2 Nc6 c4 Nf6 e3 g6 Nf3 d6 d4 Bg7 dxe5 Ng4 Nc3 Ngxe5 ",
	"b3 e5 Bb2 d6 g3 Nc6 Bg2 f5 c4 Nf6 Nc3 g6 d3 Bg7 Nf3 O-O ",
	"c4 Nc6 Nc3 e5 g3 g6 Bg2 Bg7 d3 d6 e4 Be6 Nge2 Qd7 Nd5 Nce7 ",
	"c4 Nc6 Nc3 e5 g3 g6 Bg2 Bg7 d3 d6 e4 Be6 Nge2 Qd7 Nd5 Nce7 ",
	"c4 Nc6 d4 e5 d5 Nce7 Nc3 Nf6 g3 Ng6 Bg2 Bb4 Qc2 a5 e4 d6 ",
	"c4 Nc6 d4 e5 d5 Nce7 Nc3 Ng6 e4 Nf6 Nf3 Bb4 Qc2 Bxc3+ bxc3 d6 ",
	"c4 Nf6 Nc3 b6 d4 Bb7 Qc2 d5 Bg5 e6 cxd5 exd5 e3 Be7 Bd3 h6 ",
	"c4 Nf6 Nc3 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qb6 Nb3 e6 g3 Ne5 e4 Bb4 ",
	"c4 Nf6 Nc3 c5 Nf3 Nc6 d4 cxd4 Nxd4 d5 cxd5 Nxd5 Nxc6 bxc6 Bd2 e6 ",
	"c4 Nf6 Nc3 c5 Nf3 d5 cxd5 Nxd5 d4 cxd4 Qxd4 Nxc3 Qxc3 Nc6 e4 Bg4 ",
	"c4 Nf6 Nc3 c5 Nf3 d5 cxd5 Nxd5 e3 Nxc3 bxc3 g6 d3 Bg7 Qc2 Nc6 ",
	"c4 Nf6 Nc3 c5 Nf3 d5 cxd5 Nxd5 e4 Nb4 Bb5+ N8c6 d4 cxd4 a3 dxc3 ",
	"c4 Nf6 Nc3 c5 Nf3 d5 cxd5 Nxd5 e4 Nb4 Bb5+ N8c6 d4 cxd4 a3 dxc3 ",
	"c4 Nf6 Nc3 c5 Nf3 d5 cxd5 Nxd5 e4 Nb4 Bc4 Nd3+ Ke2 Nxc1+ Rxc1 e6 ",
	"c4 Nf6 Nc3 c5 Nf3 d5 cxd5 Nxd5 e4 Nb4 Bc4 e6 O-O N8c6 d3 Be7 ",
	"c4 Nf6 Nc3 c5 Nf3 e6 e3 d5 d4 Nc6 a3 Ne4 Bd3 Nxc3 bxc3 Qa5 ",
	"c4 Nf6 Nc3 c5 Nf3 e6 g3 Be7 Bg2 O-O O-O a6 d4 cxd4 Qxd4 Qc7 ",
	"c4 Nf6 Nc3 c5 Nf3 e6 g3 b6 Bg2 Bb7 O-O Be7 b3 O-O Bb2 d6 ",
	"c4 Nf6 Nc3 c5 Nf3 e6 g3 b6 Bg2 Bb7 O-O Be7 b3 d6 d4 cxd4 ",
	"c4 Nf6 Nc3 c5 Nf3 e6 g3 b6 Bg2 Bb7 O-O Be7 d4 cxd4 Qxd4 O-O ",
	"c4 Nf6 Nc3 c5 Nf3 e6 g3 d5 cxd5 Nxd5 Bg2 Nc6 O-O Nc7 b3 Be7 ",
	"c4 Nf6 Nc3 c5 Nf3 g6 g3 Nc6 Bg2 Bg7 O-O O-O d4 cxd4 Nxd4 Nxd4 ",
	"c4 Nf6 Nc3 c5 g3 Nc6 Bg2 g6 Nf3 Bg7 d4 Qb6 d5 Nd4 Nxd4 cxd4 ",
	"c4 Nf6 Nc3 c5 g3 Nc6 Bg2 g6 a3 Bg7 Rb1 a5 Nf3 d5 cxd5 Nxd5 ",
	"c4 Nf6 Nc3 c5 g3 d5 cxd5 Nxd5 Bg2 Nxc3 bxc3 g6 Qa4+ Nd7 h4 Bg7 ",
	"c4 Nf6 Nc3 c5 g3 d5 cxd5 Nxd5 Bg2 e6 Nf3 Nc6 O-O Be7 d4 O-O ",
	"c4 Nf6 Nc3 c5 g3 e6 Nf3 d5 cxd5 Nxd5 Bg2 Nc6 O-O Be7 Nxd5 exd5 ",
	"c4 Nf6 Nc3 c5 g3 e6 Nf3 d5 cxd5 Nxd5 Bg2 Nc6 O-O Be7 Nxd5 exd5 ",
	"c4 Nf6 Nc3 c5 g3 e6 Nf3 d5 cxd5 Nxd5 Bg2 Nc6 O-O Nxc3 bxc3 Be7 ",
	"c4 Nf6 Nc3 c5 g3 g6 Bg2 Bg7 a3 Nc6 Rb1 a5 d3 O-O Bg5 d6 ",
	"c4 Nf6 Nc3 c6 d4 d5 cxd5 cxd5 Nf3 Nc6 Bf4 Bf5 e3 Qb6 a3 e6 ",
	"c4 Nf6 Nc3 c6 e4 d5 exd5 cxd5 d4 Nc6 Nf3 e6 c5 Be7 Bb5 Bd7 ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 Nf3 g6 Qa4+ Nc6 Ne5 Nb4 a3 Bg7 axb4 Bxe5 ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 Nf3 g6 Qb3 Nb6 d4 Bg7 Bg5 Be6 Qc2 Nc6 ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nb6 d3 Bg7 Be3 O-O Qc1 N8d7 ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nb6 d3 Bg7 h4 h6 Be3 c6 ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nb6 h4 h6 d3 Bg7 Be3 N8d7 ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nxc3 bxc3 Bg7 Qb3 Nc6 Nf3 O-O ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nxc3 bxc3 Bg7 Qb3 Nc6 Nf3 O-O ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nxc3 bxc3 Bg7 Qb3 Nc6 Nf3 O-O ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nxc3 bxc3 Bg7 Rb1 Nd7 Nf3 O-O ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nxc3 bxc3 Bg7 Rb1 Nd7 c4 O-O ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nxc3 bxc3 Bg7 Rb1 Nd7 c4 O-O ",
	"c4 Nf6 Nc3 d5 cxd5 Nxd5 g3 g6 Bg2 Nxc3 bxc3 Bg7 Rb1 c6 Nf3 O-O ",
	"c4 Nf6 Nc3 d6 d4 Nbd7 e4 e5 Nf3 g6 Be2 Bg7 O-O O-O Re1 c6 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bb4 Bg2 O-O O-O e4 Ng5 Bxc3 bxc3 Re8 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bb4 Bg2 O-O O-O e4 Ng5 Bxc3 bxc3 Re8 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bb4 Nd5 e4 Nh4 O-O Bg2 Re8 O-O Bc5 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Bc5 Nxe5 Bxf2+ Kxf2 Nxe5 e4 c5 d3 d6 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 Nd4 Bg2 Nxf3+ Bxf3 Bb4 Qc2 O-O O-O Re8 ",
	"c4 Nf6 Nc3 e5 Nf3 Nc6 g3 d5 cxd5 Nxd5 Bg2 Nb6 O-O Be7 a3 Be6 ",
	"c4 Nf6 Nc3 e5 e3 Nc6 a3 Be7 g3 d5 cxd5 Nxd5 Bg2 Be6 Nge2 O-O ",
	"c4 Nf6 Nc3 e5 g3 Bb4 Bg2 O-O Nf3 Re8 O-O Bxc3 bxc3 Nc6 d3 d6 ",
	"c4 Nf6 Nc3 e5 g3 Bb4 Bg2 O-O a3 Bxc3 bxc3 e4 Nh3 Re8 O-O d6 ",
	"c4 Nf6 Nc3 e5 g3 c6 Nf3 e4 Nd4 d5 cxd5 Qb6 Nb3 cxd5 Bg2 a5 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 Qc2 O-O a3 Bxc3 Qxc3 b6 e3 Bb7 b4 d6 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 Qc2 O-O a3 Bxc3 Qxc3 d6 d3 e5 e3 b6 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 Qc2 O-O a3 Bxc3 Qxc3 d6 e3 Nbd7 Be2 b6 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 Qc2 c5 a3 Ba5 e3 Nc6 d4 d6 Bd3 e5 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 Qc2 c5 a3 Ba5 e3 O-O d4 b6 Bd3 Bb7 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 d4 O-O e3 c5 Bd3 d5 O-O dxc4 Bxc4 b6 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 d4 O-O e3 d5 Bd3 c5 O-O Nbd7 cxd5 exd5 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 g3 b6 Bg2 Bb7 O-O O-O Qb3 Bxc3 Qxc3 d6 ",
	"c4 Nf6 Nc3 e6 Nf3 Bb4 g3 c5 Bg2 O-O O-O Nc6 b3 d5 Na4 Qd6 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 d4 Bb7 a3 d5 cxd5 Nxd5 e3 Be7 Bb5+ c6 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 Bd3 Bb4 e5 Ng8 Be4 Bxe4 Nxe4 d5 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 Bd3 c5 O-O Nc6 e5 Ng4 Be4 Qc8 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 Bd3 c5 e5 Ng4 h3 Bxf3 Qxf3 Nxe5 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 Bd3 d6 Bc2 c5 d4 cxd4 Nxd4 Be7 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 Qe2 Bb4 e5 Ng8 g3 Nc6 Bg2 Nd4 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 Qe2 c5 e5 Ng8 d4 Bxf3 Qxf3 Nc6 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 Qe2 c5 e5 Ng8 d4 Bxf3 Qxf3 Nc6 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 d3 c5 e5 Ng8 d4 cxd4 Nxd4 Nc6 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 d3 c5 g3 Nc6 Bg2 Be7 O-O O-O ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 d3 d6 g3 Be7 Bg2 O-O O-O c5 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 d3 d6 g3 Be7 Bg2 O-O O-O c5 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 Bb7 d3 d6 g3 Be7 Bg2 O-O O-O c5 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 e4 d5 e5 Ne4 cxd5 exd5 Nxe4 dxe4 Qa4+ Bd7 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O d4 Ne4 Qc2 Nxc3 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 g3 Bb7 Bg2 Be7 d4 Ne4 Bd2 d6 d5 Nxd2 ",
	"c4 Nf6 Nc3 e6 Nf3 b6 g3 Bb7 Bg2 Be7 d4 Ne4 Bd2 d6 d5 Nxd2 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Bb4 Qb3 Nc6 Bg5 h6 Bxf6 Qxf6 e3 dxc4 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Bb4 cxd5 exd5 Bg5 h6 Bh4 c5 e3 Nc6 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Qc2 Nc6 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Be7 Bf4 O-O e3 c5 dxc5 Qa5 a3 dxc4 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Be7 Bg5 O-O e3 Nbd7 Rc1 c6 Bd3 dxc4 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Be7 Bg5 O-O e3 Ne4 Bxe7 Qxe7 Rc1 Nc6 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Be7 Bg5 h6 Bh4 O-O e3 b6 Rc1 Bb7 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Be7 Bg5 h6 Bh4 O-O e3 b6 Rc1 Bb7 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Be7 g3 O-O Bg2 Nbd7 O-O c6 b3 b6 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 Be7 g3 O-O Bg2 Nbd7 Qd3 c5 cxd5 Nxd5 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c5 cxd5 cxd4 Qxd4 Nxd5 e4 Nxc3 Qxc3 Bd7 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 c6 e3 Nbd7 Qc2 Bd6 b3 O-O Be2 e5 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 d4 dxc4 Qa4+ Nbd7 e4 c6 Qxc4 Be7 Be2 O-O ",
	"c4 Nf6 Nc3 e6 Nf3 d5 e3 Be7 b3 O-O Bb2 b6 d4 Bb7 Bd3 Nbd7 ",
	"c4 Nf6 Nc3 e6 Nf3 d5 e3 c5 cxd5 exd5 d4 Nc6 Be2 cxd4 Nxd4 Bd6 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 Nf3 c5 e3 O-O Bd3 d5 O-O Nbd7 cxd5 exd5 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 Qc2 O-O Nf3 c5 dxc5 Na6 Bd2 Nxc5 e3 b6 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 Qe8 Nf3 b6 g3 Bb7 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bxf6 Qxf6 a3 Bxc3+ ",
	"c4 Nf6 Nc3 e6 d4 Bb4 a3 Bxc3+ bxc3 b6 f3 Nc6 e4 Ba6 Bg5 h6 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 a3 Bxc3+ bxc3 c5 f3 d5 cxd5 exd5 e3 Bf5 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 O-O Bd3 b6 Ne2 d5 cxd5 exd5 a3 Bd6 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 O-O Bd3 d5 Nf3 b6 O-O Bb7 cxd5 exd5 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 O-O Bd3 d5 a3 dxc4 Bxc4 Bd6 f4 c5 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 O-O Bd3 d6 Ne2 e5 O-O Nc6 d5 Nb8 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 b6 Ne2 Ba6 a3 Bxc3+ Nxc3 d5 b3 O-O ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 b6 Ne2 Ba6 a3 Bxc3+ Nxc3 d5 b3 O-O ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 c5 Bd3 Nc6 Nf3 d5 a3 Bxc3+ bxc3 dxc4 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 c5 Ne2 d5 a3 Bxc3+ Nxc3 cxd4 exd4 dxc4 ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 c5 Ne2 d5 a3 cxd4 axb4 dxc3 Nxc3 O-O ",
	"c4 Nf6 Nc3 e6 d4 Bb4 e3 d5 a3 Bxc3+ bxc3 c5 cxd5 exd5 Bd3 O-O ",
	"c4 Nf6 Nc3 e6 d4 d5 Bg5 Be7 e3 Nbd7 Nf3 O-O Rc1 c6 Bd3 dxc4 ",
	"c4 Nf6 Nc3 e6 d4 d5 Bg5 Nbd7 e3 c6 a3 Be7 Nf3 O-O Rc1 b6 ",
	"c4 Nf6 Nc3 e6 d4 d5 cxd5 exd5 Bg5 c6 e3 Be7 Qc2 O-O Bd3 Nbd7 ",
	"c4 Nf6 Nc3 e6 e4 c5 e5 Ng8 Nf3 Nc6 d4 cxd4 Nxd4 Nxe5 Ndb5 a6 ",
	"c4 Nf6 Nc3 e6 e4 c5 e5 Ng8 d4 cxd4 Qxd4 Nc6 Qe4 d6 Nf3 dxe5 ",
	"c4 Nf6 Nc3 e6 e4 d5 e5 d4 exf6 dxc3 bxc3 Qxf6 d4 c5 Nf3 cxd4 ",
	"c4 Nf6 Nc3 e6 e4 d5 e5 d4 exf6 dxc3 bxc3 Qxf6 d4 c5 Nf3 cxd4 ",
	"c4 Nf6 Nc3 e6 g3 d5 Bg2 d4 Ne4 Nxe4 Bxe4 Nd7 d3 a5 Bg2 Nc5 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 Nf3 O-O Bg5 c5 e3 cxd4 Nxd4 Nc6 Be2 d6 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 Nf3 d5 Bf4 O-O Rc1 c5 dxc5 Be6 e3 Nc6 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 e4 d6 Bd3 Nc6 Nge2 e5 d5 Nd4 Nxd4 exd4 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 e4 d6 Be2 O-O Bg5 h6 Be3 Kh7 h3 c5 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 e4 d6 Nf3 O-O Be2 Bg4 Be3 Nfd7 Ng1 Bxe2 ",
	"c4 Nf6 Nc3 g6 d4 Bg7 e4 d6 f3 O-O Be3 Nc6 Nge2 Rb8 Qd2 a6 ",
	"c4 Nf6 Nc3 g6 e4 Bg7 d4 d6 Be2 O-O Nf3 e5 O-O Nbd7 Re1 c6 ",
	"c4 Nf6 Nc3 g6 e4 Bg7 d4 d6 Nf3 Bg4 Be2 O-O Be3 Nfd7 Rc1 e5 ",
	"c4 Nf6 Nc3 g6 e4 Bg7 d4 d6 f3 e5 d5 Nh5 Be3 f5 Qd2 Qh4+ ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 Bd3 O-O Nge2 Nc6 O-O e5 d5 Ne7 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 Be2 O-O f4 c5 Nf3 cxd4 Nxd4 Nc6 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 Nf3 O-O h3 c5 Be2 cxd4 Nxd4 Nc6 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 Nf3 O-O h3 e5 d5 Na6 Bg5 Qe8 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 Nbd7 Bg5 c6 Qd2 a6 Rd1 Qc7 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 Nc6 Nge2 Rb8 Nc1 e5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 Nc6 Nge2 Rb8 Qd2 Re8 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 Nc6 Nge2 a6 Rb1 Bd7 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 b6 Bd3 a6 Nge2 c5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 c5 dxc5 dxc5 Qxd8 Rxd8 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 e5 d5 Ne8 Qd2 f5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 e5 d5 Ne8 Qd2 f5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 e5 d5 Nh5 Qd2 Qh4+ ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 e5 d5 Nh5 Qd2 f5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 e5 d5 Nh5 Qd2 f5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 e5 d5 c6 Bd3 cxd5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Be3 e5 d5 c6 Nge2 cxd5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Bg5 c5 d5 e6 Qd2 exd5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Bg5 c6 Qd2 a6 Bd3 b5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Nge2 b6 Bg5 a6 Qd2 c5 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 O-O Nge2 b6 Bg5 c5 Qd2 Nc6 ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 e5 Nge2 Nbd7 Bg5 c6 Qd2 O-O ",
	"c4 Nf6 Nc3 g6 e4 d6 d4 Bg7 f3 e5 Nge2 O-O Bg5 c6 Qd2 exd4 ",
	"c4 Nf6 Nc3 g6 e4 e5 Nge2 Bg7 g3 O-O Bg2 d6 O-O Be6 d3 Qd7 ",
	"c4 Nf6 Nc3 g6 e4 e5 g3 Nc6 Bg2 d6 Nge2 Bg7 d3 Be6 Nd5 Ne7 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O Nf3 d6 O-O c6 d4 Qa5 h3 e5 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O d3 d6 Bd2 Nc6 Qc1 e6 Nf3 d5 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O d4 d6 Nf3 Bg4 h3 Bxf3 Bxf3 Nc6 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O d4 d6 Nf3 Bg4 h3 Bxf3 Bxf3 Nc6 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O d4 d6 Nf3 Nbd7 O-O e5 e4 exd4 ",
	"c4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O d4 d6 Nf3 a6 O-O Nc6 d5 Na5 ",
	"c4 Nf6 Nf3 b6 g3 Bb7 d4 Bxf3 exf3 e6 Nc3 d5 cxd5 Nxd5 Qa4+ c6 ",
	"c4 Nf6 Nf3 b6 g3 Bb7 d4 Bxf3 exf3 e6 Nc3 d5 cxd5 Nxd5 Qa4+ c6 ",
	"c4 Nf6 Nf3 b6 g3 c5 Bg2 Bb7 O-O e6 Nc3 a6 b3 Be7 d4 cxd4 ",
	"c4 Nf6 Nf3 c5 Nc3 Nc6 d4 cxd4 Nxd4 Nxd4 Qxd4 g6 e4 d6 Be3 Bg7 ",
	"c4 Nf6 Nf3 c5 g3 d5 cxd5 Nxd5 Bg2 Nc6 O-O e5 Nc3 Nc7 d3 Be7 ",
	"c4 Nf6 Nf3 c5 g3 g6 b3 Bg7 Bb2 O-O Bg2 Nc6 O-O b6 d4 cxd4 ",
	"c4 Nf6 Nf3 c5 g3 g6 b3 Nc6 Bb2 Bg7 Bg2 O-O O-O d6 d4 cxd4 ",
	"c4 Nf6 Nf3 c6 Nc3 d5 d4 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"c4 Nf6 Nf3 c6 Nc3 d5 e3 g6 d4 Bg7 cxd5 Nxd5 Bc4 O-O O-O b6 ",
	"c4 Nf6 Nf3 c6 Nc3 d5 e3 g6 d4 Bg7 cxd5 Nxd5 Bc4 O-O O-O b6 ",
	"c4 Nf6 Nf3 c6 d4 d5 Nc3 dxc4 a4 Bf5 Ne5 e6 f3 Bb4 Nxc4 O-O ",
	"c4 Nf6 Nf3 c6 d4 d5 Nc3 dxc4 a4 Bf5 Ne5 e6 f3 Bb4 Nxc4 O-O ",
	"c4 Nf6 Nf3 c6 d4 d5 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"c4 Nf6 Nf3 e6 Nc3 b6 e4 Bb7 d3 d6 g3 Be7 Bg2 c5 O-O O-O ",
	"c4 Nf6 Nf3 e6 Nc3 b6 g3 Bb7 Bg2 Be7 d4 Ne4 Bd2 Bf6 O-O O-O ",
	"c4 Nf6 Nf3 e6 Nc3 d5 e3 Be7 b3 O-O Bb2 b6 d4 Bb7 Bd3 dxc4 ",
	"c4 Nf6 Nf3 e6 d4 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Bg2 c6 Bc3 d5 ",
	"c4 Nf6 Nf3 e6 d4 d5 Nc3 a6 Bg5 Be7 e3 Nbd7 Rc1 dxc4 Bxc4 b5 ",
	"c4 Nf6 Nf3 e6 g3 b6 Bg2 Bb7 O-O Be7 Nc3 O-O Qc2 d6 b3 Nbd7 ",
	"c4 Nf6 Nf3 e6 g3 d5 Bg2 Be7 O-O O-O b3 b6 Bb2 Bb7 cxd5 Nxd5 ",
	"c4 Nf6 Nf3 e6 g3 d5 Bg2 Nc6 cxd5 exd5 O-O g6 d4 Bg7 Nc3 O-O ",
	"c4 Nf6 Nf3 e6 g3 d5 Bg2 c5 O-O Nc6 cxd5 exd5 d4 Be6 Nc3 Be7 ",
	"c4 Nf6 Nf3 e6 g3 d5 Bg2 c5 O-O Nc6 cxd5 exd5 d4 Be7 Nc3 O-O ",
	"c4 Nf6 Nf3 g6 Nc3 Bg7 e4 O-O d4 d6 Be2 e5 Be3 c6 Qd2 Nbd7 ",
	"c4 Nf6 Nf3 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nbd7 Qc2 c6 ",
	"c4 Nf6 Nf3 g6 Nc3 Bg7 e4 d6 d4 O-O Be2 e5 O-O Nbd7 Qc2 exd4 ",
	"c4 Nf6 Nf3 g6 Nc3 d5 Qa4+ Bd7 Qb3 dxc4 Qxc4 Bg7 g3 O-O Bg2 Nc6 ",
	"c4 Nf6 Nf3 g6 b3 Bg7 Bb2 O-O g3 d6 d4 c5 Bg2 Ne4 O-O Nc6 ",
	"c4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 Nc3 a6 d4 Nc6 d5 Na5 ",
	"c4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 d4 Nbd7 Nc3 e5 e4 c6 ",
	"c4 Nf6 Nf3 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 Nc3 O-O O-O Nc6 Nxd5 Qxd5 ",
	"c4 Nf6 d4 b6 Nc3 Bb7 Qc2 c5 d5 e5 e4 d6 g3 Be7 Bg2 Bc8 ",
	"c4 Nf6 d4 b6 Nc3 Bb7 Qc2 e6 e4 Bb4 Bd3 c5 d5 exd5 exd5 b5 ",
	"c4 Nf6 d4 d6 Nc3 g6 e4 Bg7 f3 O-O Bg5 c6 Qd2 Re8 Nge2 a6 ",
	"c4 Nf6 d4 e6 Nc3 Bb4 Qc2 c5 dxc5 Bxc5 Nf3 Nc6 Bg5 O-O Rd1 h6 ",
	"c4 Nf6 d4 e6 Nc3 Bb4 e3 b6 Ne2 Bb7 a3 Be7 d5 O-O Ng3 b5 ",
	"c4 Nf6 d4 e6 Nc3 Be7 Nf3 O-O Bg5 b6 e3 Bb7 Bd3 d6 Qe2 c5 ",
	"c4 Nf6 d4 e6 Nc3 c5 d5 exd5 cxd5 d6 Nf3 g6 g3 Bg7 Bg2 O-O ",
	"c4 Nf6 d4 e6 Nc3 d5 cxd5 exd5 Bg5 Be7 e3 O-O Bd3 Nbd7 Nge2 Re8 ",
	"c4 Nf6 d4 e6 g3 d5 Bg2 Bd6 Nf3 c6 b3 Nbd7 Bb2 O-O O-O b6 ",
	"c4 Nf6 d4 e6 g3 d5 Bg2 Be7 Nf3 O-O O-O dxc4 Qc2 Nbd7 Nbd2 Nb6 ",
	"c4 Nf6 d4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"c4 Nf6 d4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Ne8 Qd2 f5 ",
	"c4 Nf6 d4 g6 Nc3 Bg7 e4 d6 g3 O-O Bg2 Nc6 Nge2 Bd7 h3 h6 ",
	"c4 Nf6 d4 g6 Nc3 d5 Nf3 Bg7 Qb3 c6 cxd5 Nxd5 Bd2 O-O e4 Nb6 ",
	"c4 Nf6 d4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nc6 O-O Bg4 d5 Na5 ",
	"c4 Nf6 d4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nc6 O-O a6 b3 Rb8 ",
	"c4 Nf6 g3 c5 Bg2 Nc6 Nc3 g6 Nf3 Bg7 O-O O-O b3 d5 cxd5 Nxd5 ",
	"c4 Nf6 g3 c6 Bg2 d5 b3 Bf5 Bb2 e6 Nf3 Bd6 O-O Nbd7 d3 O-O ",
	"c4 Nf6 g3 c6 Bg2 d5 b3 Bf5 Bb2 e6 Nf3 Bd6 d3 h6 Nbd2 O-O ",
	"c4 Nf6 g3 c6 Bg2 d5 b3 Bf5 Bb2 e6 Nf3 Nbd7 O-O Bd6 d3 h6 ",
	"c4 Nf6 g3 c6 Bg2 e5 Nf3 d6 Nc3 Be7 Qc2 Be6 b3 Qd7 d4 Bf5 ",
	"c4 Nf6 g3 c6 Nf3 d5 b3 Bf5 Ba3 g6 d3 Bg7 Nbd2 Qb6 Bg2 Ng4 ",
	"c4 Nf6 g3 c6 Nf3 d5 b3 Bf5 Ba3 g6 d3 Bg7 Nbd2 Qb6 Bg2 Ng4 ",
	"c4 Nf6 g3 c6 Nf3 d5 b3 Bf5 Bg2 e6 Bb2 Nbd7 O-O h6 d3 Be7 ",
	"c4 Nf6 g3 c6 Nf3 d5 b3 Bf5 Bg2 e6 Bb2 Nbd7 O-O h6 d3 Be7 ",
	"c4 Nf6 g3 c6 Nf3 d5 b3 Bg4 Bg2 e6 O-O Bd6 Bb2 O-O Na3 Nbd7 ",
	"c4 Nf6 g3 c6 Nf3 d5 b3 g6 Bb2 Bg7 Bg2 O-O O-O Nbd7 Qc2 Re8 ",
	"c4 Nf6 g3 e5 Nc3 Bb4 Bg2 O-O e4 Nc6 a3 Bxc3 dxc3 d6 Ne2 Be6 ",
	"c4 Nf6 g3 e5 d3 Bb4+ Nc3 O-O Bg2 Re8 e4 c6 Ne2 d5 exd5 cxd5 ",
	"c4 Nf6 g3 e6 Bg2 c5 Nf3 d5 O-O Nc6 cxd5 Nxd5 d4 Be7 Nc3 O-O ",
	"c4 Nf6 g3 e6 Bg2 c5 Nf3 d5 cxd5 Nxd5 Nc3 Be7 O-O O-O d4 Nc6 ",
	"c4 Nf6 g3 e6 Bg2 d5 Nf3 Be7 O-O O-O d4 c6 Qc2 b6 Rd1 Bb7 ",
	"c4 Nf6 g3 e6 Bg2 d5 d4 c5 cxd5 Nxd5 Nf3 Nc6 O-O cxd4 Nxd4 Be7 ",
	"c4 Nf6 g3 g6 Bg2 Bg7 Nc3 O-O d4 d6 Nf3 Nc6 O-O Rb8 Bd2 a6 ",
	"c4 Nf6 g3 g6 Bg2 Bg7 Nc3 O-O d4 d6 Nf3 c6 h3 a6 O-O b5 ",
	"c4 Nf6 g3 g6 Bg2 Bg7 Nc3 e6 e3 O-O Nge2 e5 O-O c6 f4 Re8 ",
	"c4 Nf6 g3 g6 Bg2 Bg7 Nf3 O-O O-O c5 d4 cxd4 Nxd4 Nc6 Nc2 d6 ",
	"c4 Nf6 g3 g6 Bg2 Bg7 d4 O-O Nc3 d6 Nf3 Nc6 O-O Bf5 d5 Na5 ",
	"c4 b6 d4 Bb7 Nc3 e6 a3 f5 d5 Nf6 g3 a5 Bg2 Na6 Nh3 Bd6 ",
	"c4 b6 d4 Bb7 d5 e5 e4 d6 Nc3 Be7 Nf3 Nf6 h3 O-O Be3 Nbd7 ",
	"c4 c5 Nc3 Nc6 Nf3 Nf6 e3 e6 d4 d5 cxd5 Nxd5 Bc4 Nb6 Bb5 a6 ",
	"c4 c5 Nc3 Nc6 Nf3 Nf6 g3 g6 Bg2 Bg7 O-O O-O d4 cxd4 Nxd4 Nxd4 ",
	"c4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nf3 d6 d3 e5 a3 Nge7 Rb1 a5 ",
	"c4 c5 Nc3 Nc6 g3 g6 b3 Bg7 Bb2 Nf6 Bg2 O-O Nf3 e5 O-O d6 ",
	"c4 c5 Nc3 Nf6 Nf3 d5 cxd5 Nxd5 d4 Nxc3 bxc3 g6 e3 Bg7 Bd3 O-O ",
	"c4 c5 Nc3 Nf6 g3 Nc6 Bg2 e6 Nf3 d5 cxd5 Nxd5 O-O Be7 d4 Nxc3 ",
	"c4 c5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nc7 d3 Qd7 Nf3 Nc6 O-O e5 ",
	"c4 c5 Nc3 g6 g3 Bg7 Bg2 Nc6 a3 a6 Rb1 Rb8 b4 cxb4 axb4 b5 ",
	"c4 c5 Nf3 Nc6 Nc3 Nf6 d4 cxd4 Nxd4 g6 Nc2 Bg7 e4 d6 Be2 O-O ",
	"c4 c5 Nf3 Nc6 Nc3 Nf6 d4 cxd4 Nxd4 g6 e4 Bg7 Be3 d6 h3 Nxd4 ",
	"c4 c5 Nf3 Nc6 Nc3 Nf6 d4 cxd4 Nxd4 g6 e4 Nxd4 Qxd4 d6 Be3 Bg7 ",
	"c4 c5 Nf3 Nc6 Nc3 e5 e3 Nf6 d4 cxd4 exd4 e4 Ne5 Bb4 Be2 Qa5 ",
	"c4 c5 Nf3 Nc6 Nc3 g6 e3 Bg7 d4 d6 h3 Nf6 d5 Na5 e4 O-O ",
	"c4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 Qb6 Nb3 e6 e4 Bb4 Qe2 d6 ",
	"c4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g3 Bb4 Bg2 O-O O-O d5 ",
	"c4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 e4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"c4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 e4 Bg7 Be3 Nf6 Nc3 O-O Be2 b6 ",
	"c4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 e4 Bg7 Be3 Nf6 Nc3 O-O Be2 d6 ",
	"c4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 e4 Nf6 Nc3 Nxd4 Qxd4 d6 Be2 Bg7 ",
	"c4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 e4 Nf6 Nc3 Nxd4 Qxd4 d6 Be2 Bg7 ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 d4 cxd4 Nxd4 d5 Qa4 Qb6 Ndb5 e6 Bf4 e5 ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 d4 cxd4 Nxd4 e6 Ndb5 d5 Bf4 e5 cxd5 exf4 ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 d4 cxd4 Nxd4 e6 a3 Bc5 Nb3 Be7 e4 O-O ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 d4 cxd4 Nxd4 e6 g3 Qb6 Nb3 Ne5 e4 Bb4 ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 d4 cxd4 Nxd4 e6 g3 Qb6 Ndb5 d5 Bg2 d4 ",
	"c4 c5 Nf3 Nf6 Nc3 Nc6 g3 d5 cxd5 Nxd5 Bg2 Nc7 d3 Rb8 Bf4 e6 ",
	"c4 c5 Nf3 Nf6 Nc3 b6 e4 d6 d4 cxd4 Nxd4 Bb7 Bd3 g6 O-O Bg7 ",
	"c4 c5 Nf3 Nf6 Nc3 d5 cxd5 Nxd5 d4 Nxc3 bxc3 g6 e3 Bg7 Bd3 O-O ",
	"c4 c5 Nf3 Nf6 Nc3 d5 cxd5 Nxd5 d4 Nxc3 bxc3 g6 e3 Bg7 Bd3 O-O ",
	"c4 c5 Nf3 Nf6 Nc3 d5 cxd5 Nxd5 d4 cxd4 Qxd4 Nxc3 Qxc3 Nc6 e4 a6 ",
	"c4 c5 Nf3 Nf6 Nc3 d5 cxd5 Nxd5 e3 Nxc3 bxc3 g6 Qa4+ Nd7 Ba3 Qc7 ",
	"c4 c5 Nf3 Nf6 Nc3 d5 cxd5 Nxd5 e3 e6 d4 cxd4 exd4 Be7 Bd3 O-O ",
	"c4 c5 Nf3 Nf6 Nc3 d5 cxd5 Nxd5 e3 e6 d4 cxd4 exd4 Be7 Bd3 O-O ",
	"c4 c5 Nf3 Nf6 Nc3 e6 d4 cxd4 Nxd4 Bb4 Nb5 O-O a3 Bxc3+ Nxc3 d5 ",
	"c4 c5 Nf3 Nf6 Nc3 e6 g3 b6 Bg2 Bb7 O-O Be7 b3 d5 e3 O-O ",
	"c4 c5 Nf3 Nf6 Nc3 e6 g3 b6 Bg2 Bb7 O-O Be7 d4 cxd4 Qxd4 d6 ",
	"c4 c5 Nf3 Nf6 Nc3 e6 g3 b6 Bg2 Bb7 O-O Be7 d4 cxd4 Qxd4 d6 ",
	"c4 c5 Nf3 Nf6 Nc3 e6 g3 b6 Bg2 Bb7 O-O d6 d4 cxd4 Qxd4 a6 ",
	"c4 c5 Nf3 Nf6 Nc3 e6 g3 d5 cxd5 Nxd5 Bg2 Be7 O-O O-O d4 Nc6 ",
	"c4 c5 Nf3 Nf6 Nc3 e6 g3 d5 cxd5 Nxd5 Bg2 Nc6 O-O Be7 d4 O-O ",
	"c4 c5 Nf3 Nf6 d4 cxd4 Nxd4 Nc6 Nc3 e6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"c4 c5 Nf3 Nf6 d4 cxd4 Nxd4 d5 cxd5 Nxd5 e4 Nf6 Nc3 e5 Ndb5 Qxd1+ ",
	"c4 c5 Nf3 Nf6 d4 cxd4 Nxd4 g6 Nc3 d5 Bg5 dxc4 e3 Qa5 Bxf6 exf6 ",
	"c4 c5 Nf3 Nf6 d4 cxd4 Nxd4 g6 Nc3 d5 Bg5 dxc4 e3 Qa5 Bxf6 exf6 ",
	"c4 c5 Nf3 b6 e4 Bb7 Nc3 Nf6 e5 Ng8 d4 cxd4 Qxd4 Bxf3 gxf3 Nc6 ",
	"c4 c5 Nf3 g6 Nc3 Bg7 g3 Nc6 Bg2 e5 a3 a5 O-O Nge7 Ne1 O-O ",
	"c4 c5 Nf3 g6 d4 Bg7 d5 Nf6 Nc3 d6 e4 O-O Bf4 Nh5 Bg5 h6 ",
	"c4 c5 Nf3 g6 d4 cxd4 Nxd4 Bg7 Nc2 Nc6 g3 Nf6 Bg2 O-O Nc3 d6 ",
	"c4 c5 Nf3 g6 d4 cxd4 Nxd4 Bg7 e4 Nc6 Be3 d6 Be2 Qa5+ Nc3 Nf6 ",
	"c4 c5 Nf3 g6 d4 cxd4 Nxd4 Bg7 e4 Nf6 Nc3 Nc6 Be3 Ng4 Qxg4 Nxd4 ",
	"c4 c5 Nf3 g6 d4 cxd4 Nxd4 Nc6 e4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"c4 c5 Nf3 g6 d4 cxd4 Nxd4 Nc6 e4 Nf6 Nc3 Nxd4 Qxd4 d6 c5 Bg7 ",
	"c4 c5 Nf3 g6 d4 cxd4 Nxd4 Nc6 e4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"c4 c5 Nf3 g6 e4 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 Nxd4 Qxd4 d6 Bg5 Bg7 ",
	"c4 c5 b3 Nc6 Bb2 e5 Nc3 d6 g3 g6 Bg2 Bg7 e3 Nge7 d3 h5 ",
	"c4 c5 b3 Nc6 Bb2 e5 g3 d6 Bg2 Be6 Nc3 Qd7 Nf3 Bh3 Bxh3 Qxh3 ",
	"c4 c5 b3 Nf6 Bb2 d5 cxd5 Nxd5 Nf3 Nc6 a3 f6 e3 e5 Qc2 Be6 ",
	"c4 c5 b3 Nf6 Bb2 g6 Bxf6 exf6 Nc3 Bg7 g3 Nc6 Bg2 f5 e3 O-O ",
	"c4 c5 g3 Nc6 Bg2 g6 e3 Bg7 Ne2 d6 d4 cxd4 exd4 Bg4 f3 Bf5 ",
	"c4 c5 g3 e6 Bg2 Nf6 Nf3 d5 cxd5 Nxd5 O-O Be7 d4 O-O Nc3 Nc6 ",
	"c4 c5 g3 g6 Bg2 Bg7 Nc3 Nc6 a3 b6 b4 Rb8 Rb1 Bb7 Nh3 Nh6 ",
	"c4 c5 g3 g6 Bg2 Bg7 e3 Nc6 Ne2 d6 Nbc3 Bd7 b3 a6 Bb2 b5 ",
	"c4 c6 Nc3 d5 cxd5 cxd5 d4 Nf6 Nf3 Nc6 Bf4 Bf5 e3 e6 Bb5 Bb4 ",
	"c4 c6 Nc3 d5 d4 Nf6 e3 e6 Nf3 Nbd7 Be2 Bb4 O-O O-O a3 Ba5 ",
	"c4 c6 Nc3 d5 d4 Nf6 e3 e6 Qc2 Nbd7 Bd2 Be7 Nf3 O-O Bd3 dxc4 ",
	"c4 c6 Nf3 d5 b3 Bg4 Bb2 Nd7 g3 e6 Bg2 Ngf6 O-O Be7 d3 O-O ",
	"c4 c6 Nf3 d5 d4 Nf6 e3 Bf5 cxd5 cxd5 Qb3 Qb6 Qxb6 axb6 Nc3 e6 ",
	"c4 c6 Nf3 d5 e3 Nf6 Nc3 e6 d4 Nbd7 b3 Bd6 Bb2 O-O Qc2 Re8 ",
	"c4 c6 d4 d5 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 Be7 O-O O-O b3 b6 ",
	"c4 c6 d4 d5 Nc3 Nf6 e3 g6 Nf3 Bg7 Qb3 O-O Bd2 e6 Bd3 b6 ",
	"c4 c6 d4 d5 Nc3 e6 e4 dxe4 Nxe4 Bb4+ Bd2 Qxd4 Bxb4 Qxe4+ Be2 Na6 ",
	"c4 c6 d4 d5 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 Be2 O-O O-O dxc4 ",
	"c4 c6 d4 d5 Nf3 Nf6 e3 Bf5 Nc3 e6 Bd3 Bxd3 Qxd3 Nbd7 O-O Be7 ",
	"c4 c6 d4 d5 Nf3 Nf6 e3 Bf5 Nc3 e6 Bd3 Bxd3 Qxd3 Nbd7 O-O Be7 ",
	"c4 c6 d4 d5 e3 Nf6 Nf3 e6 Nbd2 g6 b3 Qa5 Be2 Bg7 O-O O-O ",
	"c4 c6 e4 d5 cxd5 cxd5 exd5 Nf6 Nc3 g6 Qb3 Bg7 g3 b6 Bg2 Bb7 ",
	"c4 c6 e4 d5 exd5 cxd5 d4 Nf6 Nc3 Nc6 Bg5 Qb6 cxd5 Qxb2 Rc1 Nb4 ",
	"c4 c6 e4 d5 exd5 cxd5 d4 Nf6 Nc3 Nc6 Bg5 e6 c5 Be7 Bb5 O-O ",
	"c4 c6 e4 d5 exd5 cxd5 d4 Nf6 Nc3 e6 Nf3 Be7 c5 O-O Bd3 b6 ",
	"c4 c6 e4 e5 Nf3 Nf6 Nc3 Bb4 Nxe5 O-O Nd3 Bxc3 dxc3 Nxe4 Be2 d5 ",
	"c4 c6 e4 e5 d4 Bb4+ Bd2 Bxd2+ Qxd2 d6 Nc3 Nf6 f4 O-O Nf3 exd4 ",
	"c4 c6 e4 e5 d4 Nf6 Nc3 Bb4 dxe5 Nxe4 Qd4 d5 cxd5 Qa5 Qxe4 Bxc3+ ",
	"c4 c6 e4 e6 d4 d5 cxd5 exd5 e5 Na6 Nc3 Nc7 Nge2 Ne7 Nf4 Nf5 ",
	"c4 d6 d4 Nf6 Nc3 Nbd7 Nf3 g6 e4 e5 Be2 Bg7 O-O O-O Re1 c6 ",
	"c4 d6 d4 e5 Nf3 Nd7 Nc3 Ngf6 e4 Be7 Be2 O-O O-O c6 d5 Nc5 ",
	"c4 e5 Nc3 Nc6 Nf3 Nf6 g3 d6 d4 g6 dxe5 Nxe5 Nxe5 dxe5 Qxd8+ Kxd8 ",
	"c4 e5 Nc3 Nc6 Nf3 f5 d4 e4 Ng5 h6 Nh3 g5 Ng1 Bg7 e3 Nf6 ",
	"c4 e5 Nc3 Nc6 e3 Nf6 d4 exd4 exd4 Bb4 Nf3 O-O Be2 d5 O-O dxc4 ",
	"c4 e5 Nc3 Nc6 g3 f5 Bg2 Nf6 e3 Bc5 Nge2 f4 d4 fxg3 dxc5 gxf2+ ",
	"c4 e5 Nc3 Nc6 g3 f5 Bg2 Nf6 e3 e4 d3 Bb4 Ne2 O-O O-O exd3 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 Rb1 Nf6 e3 O-O Nge2 d6 b4 Be6 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 Rb1 d6 b4 a6 e3 f5 Nge2 Nf6 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 Nge7 Bd2 O-O Nf3 Nd4 O-O c6 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 Nge7 Nd5 O-O h4 Nd4 Bg5 f6 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 Nge7 h4 h6 Bd2 d6 Rb1 O-O ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Rb1 Be6 b4 Qd7 b5 Nd8 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 e4 Nge7 Nge2 O-O O-O f5 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 e3 d6 Nge2 Nf6 d3 O-O O-O Rb8 ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 e3 d6 Nge2 Nge7 d4 exd4 exd4 O-O ",
	"c4 e5 Nc3 Nc6 g3 g6 Bg2 Bg7 e3 d6 Rb1 Nge7 b4 a6 d3 Be6 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d3 Bb4 Bd2 O-O e3 Re8 Be2 a5 b3 d5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d3 d5 cxd5 Nxd5 g3 Be7 Bg2 Be6 O-O O-O ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d4 e4 Nd2 Bb4 e3 O-O Be2 Re8 O-O Bxc3 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d4 e4 Nd2 Nxd4 Ndxe4 Nxe4 Nxe4 Ne6 g3 Nc5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d4 exd4 Nxd4 Bb4 Bg5 h6 Bh4 Bxc3+ bxc3 Ne5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d4 exd4 Nxd4 Bb4 Bg5 h6 Bh4 Bxc3+ bxc3 Ne5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d4 exd4 Nxd4 Bb4 Bg5 h6 Bh4 Bxc3+ bxc3 d6 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d4 exd4 Nxd4 Bb4 Nc2 Bxc3+ bxc3 d5 cxd5 Qxd5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Nxc6 bxc6 g3 d5 Bg2 O-O ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Bb4 Qc2 Bxc3 Qxc3 Qe7 a3 a5 b3 d5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Be7 d4 exd4 Nxd4 O-O Be2 Bb4 O-O Bxc3 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 e3 Be7 d4 exd4 Nxd4 O-O Be2 Ne5 Nc2 c6 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 Bb4 Nd5 Nxd5 cxd5 Nd4 Nxd4 exd4 Qc2 Qe7 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 Bb4 Nd5 a5 Bg2 d6 O-O O-O e3 Bc5 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 Bc5 Bg2 d6 O-O O-O d3 h6 a3 a6 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 Nd4 Bg2 Nxf3+ Bxf3 Bb4 Qc2 O-O O-O Re8 ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 Nd4 Bg2 Nxf3+ Bxf3 Bb4 d4 e4 Bg2 O-O ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 d5 cxd5 Nxd5 Bg2 Nb6 O-O Be7 b3 O-O ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 d5 cxd5 Nxd5 d3 Be7 Bg2 Be6 O-O O-O ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 d5 cxd5 Nxd5 d3 Be7 Bg2 Be6 O-O O-O ",
	"c4 e5 Nc3 Nf6 Nf3 Nc6 g3 d6 Bg2 g6 O-O Bg7 d4 O-O d5 Ne7 ",
	"c4 e5 Nc3 Nf6 Nf3 d6 d4 Nbd7 g3 Be7 Bg2 O-O O-O Re8 b3 Bf8 ",
	"c4 e5 Nc3 Nf6 e4 Bc5 g3 Nc6 Bg2 d6 h3 O-O d3 h6 Nf3 a5 ",
	"c4 e5 Nc3 Nf6 g3 Bb4 Bg2 O-O Nf3 Re8 O-O Nc6 Nd5 Bf8 d3 h6 ",
	"c4 e5 Nc3 Nf6 g3 Bb4 Bg2 O-O d3 c6 Qb3 Ba5 Nf3 d5 O-O d4 ",
	"c4 e5 Nc3 Nf6 g3 Nc6 Bg2 g6 d3 Bg7 Bd2 Ne7 Nf3 d6 O-O O-O ",
	"c4 e5 Nc3 Nf6 g3 c6 Nf3 d6 Bg2 Be6 b3 Nbd7 d4 exd4 Nxd4 d5 ",
	"c4 e5 Nc3 Nf6 g3 c6 Nf3 e4 Nd4 d5 cxd5 cxd5 d3 Bc5 Nb3 Bb6 ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Be6 Nf3 Nc6 O-O Be7 d4 exd4 ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Be6 Nf3 Nc6 O-O Nb6 d3 Be7 ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nb6 Nf3 Nc6 O-O Be7 a3 Be6 ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nb6 Nf3 Nc6 O-O Be7 a3 Be6 ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nb6 Nf3 Nc6 O-O Be7 a3 Be6 ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nb6 Nf3 Nc6 O-O Be7 a3 O-O ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nb6 Nf3 Nc6 O-O Be7 a3 O-O ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nb6 Nf3 Nc6 O-O Be7 a3 O-O ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nb6 Nf3 Nc6 O-O Be7 a3 f5 ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nb6 Nf3 Nc6 a3 Be7 d3 O-O ",
	"c4 e5 Nc3 Nf6 g3 d5 cxd5 Nxd5 Bg2 Nb6 Nf3 Nc6 d3 Be7 a3 O-O ",
	"c4 e5 Nc3 c5 g3 Nc6 Bg2 g6 a3 a5 d3 Bg7 Nf3 Nge7 h4 h6 ",
	"c4 e5 Nc3 c5 g3 g6 Bg2 Bg7 a3 a5 e4 Nc6 Nge2 d6 d3 Nge7 ",
	"c4 e5 Nc3 d6 d4 Nd7 e4 Ngf6 Nge2 g6 d5 c6 Ng3 h5 h4 Be7 ",
	"c4 e5 Nc3 d6 d4 Nd7 e4 g6 Nf3 Bg7 Be2 Ngf6 d5 O-O O-O Nc5 ",
	"c4 e5 Nc3 d6 g3 Be6 d3 g6 Bg2 Nc6 e4 Qd7 Nd5 Nd4 Be3 c5 ",
	"c4 e5 Nc3 d6 g3 Nc6 Bg2 Nf6 d3 g6 f4 Bg7 Nf3 O-O O-O exf4 ",
	"c4 e5 Nc3 d6 g3 c5 Bg2 Nc6 a3 g6 b4 Bg7 Rb1 Nge7 e3 O-O ",
	"c4 e5 Nc3 d6 g3 f5 Bg2 Nf6 e3 g6 Nge2 Bg7 O-O O-O d3 c6 ",
	"c4 e5 Nc3 f5 d4 exd4 Qxd4 Nf6 Nd5 Nc6 Nxf6+ Qxf6 Qxf6 gxf6 Bd2 Nb4 ",
	"c4 e5 Nc3 f5 e3 Nf6 d4 e4 Nge2 Be7 Nf4 O-O h4 Ng4 Be2 Nh6 ",
	"c4 e5 Nc3 g6 Nf3 Bg7 d4 exd4 Nxd4 Nc6 Nxc6 bxc6 g3 Rb8 Bg2 Rb4 ",
	"c4 e5 Nc3 g6 Nf3 Bg7 d4 exd4 Nxd4 Nc6 Nxc6 bxc6 g3 Rb8 Bg2 Rb4 ",
	"c4 e5 Nf3 d6 d4 Nd7 e4 Ngf6 Nc3 Be7 g3 O-O Bg2 c6 O-O Qc7 ",
	"c4 e5 Nf3 e4 Nd4 Nc6 Nxc6 dxc6 Nc3 Nf6 e3 Bd6 d4 exd3 Bxd3 Qe7 ",
	"c4 e5 g3 Nc6 Bg2 f5 e3 Nf6 Nc3 Bb4 Nge2 O-O O-O Bxc3 Nxc3 f4 ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 Rb1 a5 d3 d6 e3 f5 Nge2 Nf6 ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 Rb1 d6 d3 f5 e3 Nf6 b4 a6 ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 d3 d6 Rb1 f5 b4 Nf6 b5 Ne7 ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 d3 d6 Rb1 f5 e3 Nf6 Nge2 O-O ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 e3 d6 Nge2 Nge7 d3 Bg4 h3 Be6 ",
	"c4 e5 g3 Nc6 Bg2 g6 Nc3 Bg7 e3 d6 Nge2 h5 h4 Bg4 d3 Rb8 ",
	"c4 e5 g3 Nc6 Nc3 g6 Bg2 Bg7 e3 d6 Nge2 h5 d4 h4 d5 Nce7 ",
	"c4 e5 g3 Nf6 Bg2 Nc6 Nf3 g6 d4 exd4 Nxd4 Bg7 Nc3 O-O O-O Re8 ",
	"c4 e5 g3 Nf6 Bg2 c6 d4 exd4 Qxd4 d5 Nc3 Be6 cxd5 cxd5 Be3 Nc6 ",
	"c4 e5 g3 Nf6 Bg2 c6 d4 exd4 Qxd4 d5 Nc3 dxc4 Qxc4 Be6 Qa4 Be7 ",
	"c4 e5 g3 Nf6 Bg2 c6 d4 exd4 Qxd4 d5 Nf3 Bb4+ Nc3 O-O cxd5 Nxd5 ",
	"c4 e5 g3 Nf6 Bg2 c6 d4 exd4 Qxd4 d5 cxd5 cxd5 Nf3 Nc6 Qa4 Be7 ",
	"c4 e5 g3 Nf6 Bg2 d5 cxd5 Nxd5 Nc3 Nb6 Nf3 Nc6 O-O Be7 Rb1 O-O ",
	"c4 e5 g3 Nf6 Bg2 d5 cxd5 Nxd5 Nc3 Nb6 Nf3 Nc6 O-O Be7 a3 O-O ",
	"c4 e5 g3 Nf6 Bg2 d5 cxd5 Nxd5 Nc3 c6 Nf3 Qc7 d4 exd4 Nxd5 Qa5+ ",
	"c4 e5 g3 c5 Bg2 Nc6 Nc3 g6 a3 a5 e3 Bg7 Nge2 Nge7 O-O d6 ",
	"c4 e5 g3 c5 Bg2 Nc6 Nc3 g6 a3 a5 e3 Bg7 Nge2 Nge7 O-O d6 ",
	"c4 e5 g3 d5 cxd5 Qxd5 Nf3 Nf6 Nc3 Qa5 Bg2 Nc6 d3 e4 dxe4 Nxe4 ",
	"c4 e5 g3 d6 Bg2 Nc6 Nc3 g6 Rb1 a5 a3 Bg7 d3 f5 e3 Nf6 ",
	"c4 e5 g3 d6 Bg2 g6 d4 Nd7 Nf3 Bg7 O-O Ne7 Nc3 O-O e4 exd4 ",
	"c4 e5 g3 g6 d4 d6 Bg2 Nc6 Nf3 Bg7 e3 f5 Nc3 Nh6 dxe5 dxe5 ",
	"c4 e6 Nc3 Bb4 Nf3 Nf6 g3 d5 a3 Be7 Bg2 O-O d4 dxc4 Ne5 c5 ",
	"c4 e6 Nc3 Bb4 Nf3 d5 d4 Ne7 e3 c5 Bd3 Nbc6 O-O dxc4 Bxc4 O-O ",
	"c4 e6 Nc3 Bb4 Qb3 a5 a3 Bxc3 Qxc3 Nf6 d4 O-O Bg5 d6 e3 Qe7 ",
	"c4 e6 Nc3 Bb4 Qc2 Nf6 a3 Bxc3 Qxc3 b6 b4 O-O Bb2 d6 e3 Nbd7 ",
	"c4 e6 Nc3 Bb4 e4 Ne7 a3 Bxc3 dxc3 d6 f4 Nd7 Bd3 b6 Nf3 Bb7 ",
	"c4 e6 Nc3 Bb4 e4 c5 Nb5 Nc6 a3 Ba5 b4 cxb4 Bb2 Kf8 e5 Nge7 ",
	"c4 e6 Nc3 Bb4 e4 c5 f4 d6 Nf3 Nf6 Bd3 O-O O-O Nc6 b3 Bxc3 ",
	"c4 e6 Nc3 Bb4 g3 Ne7 Bg2 O-O Qb3 c5 a3 Ba5 e3 Nbc6 Nge2 Bb6 ",
	"c4 e6 Nc3 Nf6 Nf3 Bb4 Qb3 c5 a3 Ba5 e3 O-O Be2 d5 O-O Nc6 ",
	"c4 e6 Nc3 Nf6 Nf3 b6 e4 Bb7 Qc2 d6 d4 Nbd7 Be2 e5 d5 Be7 ",
	"c4 e6 Nc3 Nf6 Nf3 d5 d4 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Qc2 Nc6 ",
	"c4 e6 Nc3 Nf6 e4 c5 e5 Ng8 Nf3 Nc6 d4 cxd4 Nxd4 Nxe5 Ndb5 a6 ",
	"c4 e6 Nc3 d5 d4 Be7 Nf3 Nf6 Bf4 O-O e3 c5 dxc5 Bxc5 cxd5 Nxd5 ",
	"c4 e6 Nc3 d5 d4 Be7 Nf3 Nf6 Bg5 O-O e3 Nbd7 Qc2 c6 Rd1 b6 ",
	"c4 e6 Nc3 d5 d4 Be7 Nf3 Nf6 Bg5 O-O e3 h6 Bxf6 Bxf6 Qd2 a6 ",
	"c4 e6 Nc3 d5 d4 Be7 Nf3 Nf6 Bg5 h6 Bh4 dxc4 e3 Nd5 Bxe7 Qxe7 ",
	"c4 e6 Nc3 d5 d4 Be7 Nf3 Nf6 cxd5 exd5 Bg5 c6 Qc2 g6 e4 Nxe4 ",
	"c4 e6 Nc3 d5 d4 Be7 cxd5 exd5 Bf4 Nf6 e3 O-O Bd3 b6 Nf3 c5 ",
	"c4 e6 Nc3 d5 d4 Be7 cxd5 exd5 Bf4 c6 Qc2 g6 e3 Bf5 Qd2 Nf6 ",
	"c4 e6 Nc3 d5 d4 Be7 cxd5 exd5 Bf4 c6 Qc2 g6 e3 Bf5 Qd2 Nf6 ",
	"c4 e6 Nc3 d5 d4 Be7 cxd5 exd5 Bf4 c6 e3 Bf5 g4 Be6 h3 Nf6 ",
	"c4 e6 Nc3 d5 d4 Nf6 Bg5 Be7 e3 O-O Nf3 Nbd7 Rc1 c6 Bd3 dxc4 ",
	"c4 e6 Nc3 d5 d4 Nf6 Bg5 Be7 e3 O-O Rc1 h6 Bh4 b6 cxd5 Nxd5 ",
	"c4 e6 Nc3 d5 d4 Nf6 Bg5 Be7 e3 h6 Bxf6 Bxf6 Qc2 c5 O-O-O cxd4 ",
	"c4 e6 Nc3 d5 d4 Nf6 Bg5 Nbd7 e3 Bb4 cxd5 exd5 Bd3 c6 Nf3 Qa5 ",
	"c4 e6 Nc3 d5 d4 Nf6 Bg5 Nbd7 e3 Be7 Nf3 O-O Qc2 c5 cxd5 Nxd5 ",
	"c4 e6 Nc3 d5 d4 Nf6 Nf3 Nbd7 cxd5 exd5 Bf4 c6 e3 Be7 h3 O-O ",
	"c4 e6 Nc3 d5 d4 Nf6 Nf3 Nbd7 cxd5 exd5 Bf4 c6 e3 Be7 h3 O-O ",
	"c4 e6 Nc3 d5 d4 Nf6 cxd5 exd5 Bg5 Be7 e3 Nbd7 Nf3 c6 Bd3 O-O ",
	"c4 e6 Nc3 d5 d4 Nf6 cxd5 exd5 Bg5 Be7 e3 O-O Bd3 Nbd7 Nf3 Re8 ",
	"c4 e6 Nc3 d5 d4 Nf6 cxd5 exd5 Bg5 Be7 e3 O-O Bd3 Nbd7 Nf3 Re8 ",
	"c4 e6 Nc3 d5 d4 Nf6 cxd5 exd5 Bg5 Be7 e3 O-O Bd3 Nbd7 Nge2 Re8 ",
	"c4 e6 Nc3 d5 d4 Nf6 cxd5 exd5 Bg5 Be7 e3 c6 Qc2 Nbd7 Bd3 Nh5 ",
	"c4 e6 Nc3 d5 d4 Nf6 cxd5 exd5 Bg5 c6 e3 Be7 Qc2 O-O Bd3 Nbd7 ",
	"c4 e6 Nc3 d5 d4 Nf6 cxd5 exd5 Bg5 c6 e3 Be7 Qc2 O-O Bd3 Nbd7 ",
	"c4 e6 Nc3 d5 d4 c5 cxd5 exd5 Nf3 Nc6 e3 c4 Be2 Bb4 O-O Nge7 ",
	"c4 e6 Nc3 d5 d4 c6 e3 Nf6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"c4 e6 Nc3 d5 d4 c6 e3 Nf6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"c4 e6 Nc3 d5 d4 c6 e3 Nf6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"c4 e6 Nc3 f5 d4 Nf6 e3 Bb4 Ne2 O-O a3 Be7 Nf4 d6 Be2 c6 ",
	"c4 e6 Nf3 Nf6 Nc3 Bb4 Qb3 c5 g3 Nc6 a3 Ba5 Bg2 a6 O-O O-O ",
	"c4 e6 Nf3 Nf6 Nc3 b6 e4 Bb7 Bd3 d6 Bc2 c5 d4 cxd4 Nxd4 Be7 ",
	"c4 e6 Nf3 Nf6 Nc3 d5 d4 Be7 Bg5 O-O e3 h6 Bh4 b6 Qb3 Bb7 ",
	"c4 e6 Nf3 Nf6 Nc3 d5 d4 Nbd7 e3 a6 c5 c6 Na4 Ne4 Bd3 e5 ",
	"c4 e6 Nf3 Nf6 g3 d5 Bg2 dxc4 Qa4+ Qd7 Qxc4 Qc6 b3 Qxc4 bxc4 Nbd7 ",
	"c4 e6 Nf3 Nf6 g3 d5 b3 Be7 Bg2 O-O O-O b6 Bb2 Bb7 e3 Nbd7 ",
	"c4 e6 Nf3 d5 b3 Nf6 Bb2 Bd6 g3 O-O Bg2 Nbd7 Nc3 c6 Qc2 Qe7 ",
	"c4 e6 Nf3 d5 b3 Nf6 g3 Be7 Bg2 O-O O-O Nbd7 Bb2 c6 d3 b6 ",
	"c4 e6 Nf3 d5 b3 Nf6 g3 c5 Bg2 Be7 O-O Nc6 cxd5 Nxd5 Bb2 O-O ",
	"c4 e6 Nf3 d5 b3 a5 e3 Nf6 Bb2 a4 bxa4 Nbd7 cxd5 Nxd5 Nc3 Nc5 ",
	"c4 e6 Nf3 d5 d4 Nf6 Bg5 Be7 e3 Nbd7 Nbd2 O-O Rc1 b6 cxd5 Nxd5 ",
	"c4 e6 Nf3 d5 d4 Nf6 Bg5 dxc4 Nc3 a6 a4 Bb4 e3 c5 Bxc4 cxd4 ",
	"c4 e6 Nf3 d5 d4 Nf6 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Qc2 Nc6 ",
	"c4 e6 Nf3 d5 d4 Nf6 Nc3 Be7 Bg5 O-O e3 Nbd7 Bd3 c5 O-O cxd4 ",
	"c4 e6 Nf3 d5 d4 Nf6 Nc3 Be7 Bg5 O-O e3 Nbd7 Qc2 c5 O-O-O Qa5 ",
	"c4 e6 Nf3 d5 d4 Nf6 Nc3 Be7 Bg5 O-O e3 h6 Bh4 b6 cxd5 Nxd5 ",
	"c4 e6 Nf3 d5 d4 Nf6 Nc3 c6 Bg5 Be7 e3 Nbd7 Bd3 h6 Bh4 O-O ",
	"c4 e6 Nf3 d5 d4 Nf6 Nc3 dxc4 e3 a6 a4 c5 Bxc4 Nc6 O-O cxd4 ",
	"c4 e6 Nf3 d5 d4 Nf6 g3 Be7 Bg2 O-O Nc3 c6 O-O b6 Ne5 Bb7 ",
	"c4 e6 Nf3 d5 d4 Nf6 g3 Be7 Bg2 O-O O-O b6 Nc3 Bb7 Ne5 Qc8 ",
	"c4 e6 Nf3 d5 g3 Nf6 Bg2 c5 cxd5 Nxd5 Nc3 Nc6 O-O Be7 d4 O-O ",
	"c4 e6 d4 Bb4+ Bd2 Bxd2+ Qxd2 f5 Nc3 Nf6 g3 O-O Bg2 d5 Nf3 Nc6 ",
	"c4 e6 d4 Nf6 Nc3 Bb4 Bg5 h6 Bh4 c5 d5 d6 e3 Bxc3+ bxc3 e5 ",
	"c4 e6 d4 Nf6 Nc3 d5 Bg5 Nbd7 e3 c6 cxd5 exd5 Bd3 Be7 Qc2 O-O ",
	"c4 e6 d4 Nf6 Nf3 b6 g3 Bb7 Bg2 Be7 Nc3 Ne4 Nxe4 Bxe4 O-O O-O ",
	"c4 e6 d4 Nf6 Nf3 d5 g3 dxc4 Bg2 c5 O-O Nc6 Qa4 cxd4 Nxd4 Qxd4 ",
	"c4 e6 d4 d5 Nc3 Be7 Nf3 Nf6 cxd5 exd5 Bg5 c6 Qc2 Na6 e3 Nb4 ",
	"c4 e6 d4 d5 Nc3 Nf6 g3 Bb4 Bg2 c6 Nf3 Nbd7 O-O Bxc3 bxc3 O-O ",
	"c4 e6 d4 d5 Nf3 Be7 Nc3 Nf6 Bg5 O-O e3 h6 Bxf6 Bxf6 Qd2 b6 ",
	"c4 e6 d4 d5 Nf3 Nf6 Bg5 Be7 e3 O-O Nc3 Nbd7 Rc1 b6 cxd5 exd5 ",
	"c4 e6 d4 d5 Nf3 Nf6 Bg5 h6 Bxf6 Qxf6 Nc3 c6 e3 Nd7 Bd3 Bb4 ",
	"c4 e6 g3 Nf6 Bg2 c5 Nf3 Nc6 O-O b6 d4 cxd4 Nxd4 Bb7 Nc3 Bc5 ",
	"c4 e6 g3 Nf6 Bg2 d5 Nf3 Be7 d4 O-O O-O Nbd7 Qc2 c6 b3 b5 ",
	"c4 e6 g3 Nf6 Bg2 d5 Nf3 c5 O-O d4 e3 Nc6 exd4 cxd4 d3 Be7 ",
	"c4 e6 g3 d5 Bg2 Nf6 Nf3 Be7 O-O O-O b3 d4 e3 Nc6 exd4 Nxd4 ",
	"c4 e6 g3 d5 Bg2 Nf6 Nf3 Be7 O-O O-O d4 dxc4 Qc2 a6 Qxc4 b5 ",
	"c4 e6 g3 d5 Bg2 Nf6 Nf3 dxc4 Qa4+ Bd7 Qxc4 Bc6 Qc2 Nbd7 O-O e5 ",
	"c4 e6 g3 d5 Bg2 Nf6 d4 Be7 Nf3 c6 Qc2 O-O O-O Nbd7 b3 b6 ",
	"c4 e6 g3 d5 Bg2 Nf6 d4 Be7 Nf3 c6 Qc2 O-O O-O Nbd7 b3 b6 ",
	"c4 e6 g3 d5 Bg2 dxc4 Na3 Bxa3 bxa3 c6 Bb2 Nf6 Qc2 b5 Nf3 Bb7 ",
	"c4 e6 g3 d5 Bg2 dxc4 Qa4+ Nd7 Qxc4 Ngf6 Nf3 c5 Qb3 Bd6 d3 Rb8 ",
	"c4 e6 g3 d5 Bg2 dxc4 Qa4+ Nd7 Qxc4 c5 Nc3 Ngf6 Qb3 Rb8 d3 a6 ",
	"c4 e6 g3 d5 Bg2 dxc4 Qa4+ Qd7 Qxc4 c5 Na3 Nc6 Qb5 a6 Bxc6 bxc6 ",
	"c4 e6 g3 d5 Bg2 g6 Nf3 Bg7 d4 Ne7 O-O O-O Nc3 Nbc6 cxd5 exd5 ",
	"c4 f5 Nc3 Nf6 d4 d6 d5 g6 g3 Bg7 Bg2 O-O Nh3 h6 O-O c6 ",
	"c4 f5 Nc3 Nf6 d4 g6 g3 Bg7 Bg2 O-O Nf3 d6 O-O Nc6 d5 Na5 ",
	"c4 f5 Nc3 Nf6 g3 e5 Bg2 Be7 e3 c6 Nge2 O-O O-O Kh8 d4 e4 ",
	"c4 f5 Nf3 Nf6 g3 d6 d4 e6 Bg2 Be7 O-O O-O Nc3 c6 Qc2 a5 ",
	"c4 f5 Nf3 Nf6 g3 g6 Bg2 Bg7 Nc3 d6 d4 O-O O-O Nc6 d5 Na5 ",
	"c4 f5 Nf3 Nf6 g3 g6 Bg2 Bg7 d4 d6 Nc3 e6 O-O O-O Qc2 Nc6 ",
	"c4 f5 d4 Nf6 Nc3 e6 e3 b6 Bd3 Bb7 f3 Bb4 Ne2 O-O O-O Nc6 ",
	"c4 f5 d4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O Nh3 Nc6 O-O Nh5 d5 Ne5 ",
	"c4 f5 d4 Nf6 g3 g6 Bg2 Bg7 Nc3 O-O Nh3 Nc6 Nf4 d6 d5 Ne5 ",
	"c4 f5 d4 Nf6 g3 g6 Bg2 Bg7 Nc3 d6 Nf3 O-O O-O c6 b3 Qc7 ",
	"c4 f5 d4 e6 g3 Nf6 Bg2 d5 Nf3 c6 O-O Bd6 b3 Qe7 Nc3 O-O ",
	"c4 f5 d4 e6 g3 Nf6 Bg2 d5 Nf3 c6 O-O Bd6 b3 Qe7 Nc3 O-O ",
	"c4 f5 g3 Nf6 Bg2 g6 d4 Bg7 Nc3 O-O Nh3 Nc6 O-O d6 d5 Ne5 ",
	"c4 g6 Nc3 Bg7 d4 Nf6 e4 O-O Be3 d6 f3 b6 Bd3 Bb7 Nge2 c5 ",
	"c4 g6 Nc3 Bg7 d4 Nf6 e4 O-O Be3 d6 f3 b6 Bd3 Bb7 Nh3 c5 ",
	"c4 g6 Nc3 Bg7 d4 Nf6 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"c4 g6 Nc3 Bg7 d4 Nf6 e4 d6 f3 c6 Be3 a6 Bd3 b5 cxb5 axb5 ",
	"c4 g6 Nc3 Bg7 d4 d6 e4 Nf6 f3 O-O Be3 Nbd7 Bd3 c5 Nge2 a6 ",
	"c4 g6 Nc3 Bg7 d4 d6 e4 Nf6 f3 O-O Be3 a6 Qd2 c6 Bd3 b5 ",
	"c4 g6 Nc3 Bg7 d4 d6 e4 Nf6 f4 c5 d5 e6 Nf3 O-O Be2 exd5 ",
	"c4 g6 Nc3 Bg7 g3 Nf6 Bg2 O-O e4 c5 f4 Nc6 Nf3 b6 O-O Bb7 ",
	"c4 g6 Nc3 Bg7 g3 c5 Bg2 Nc6 a3 Nf6 Rb1 a5 Nf3 e5 O-O O-O ",
	"c4 g6 Nc3 c5 g3 Bg7 Bg2 Nc6 Nf3 e5 d3 d6 Nd2 Nge7 Nf1 O-O ",
	"c4 g6 Nf3 Bg7 Nc3 e5 g3 Ne7 Bg2 O-O d4 exd4 Nxd4 Nbc6 Nxc6 Nxc6 ",
	"c4 g6 Nf3 Bg7 d4 Nf6 g3 O-O Bg2 c6 Nc3 d5 Qb3 e6 O-O Nbd7 ",
	"c4 g6 d4 Bg7 Nc3 Nf6 e4 d6 Be2 O-O Nf3 e5 d5 a5 O-O Na6 ",
	"c4 g6 d4 Bg7 Nc3 Nf6 e4 d6 Nf3 O-O Be2 e5 d5 a5 Bg5 h6 ",
	"c4 g6 d4 Bg7 Nc3 Nf6 e4 d6 f3 O-O Be3 c5 dxc5 dxc5 Qxd8 Rxd8 ",
	"c4 g6 d4 Bg7 Nc3 d6 e4 Nf6 Nf3 O-O Be2 e5 O-O Nc6 Be3 Ng4 ",
	"c4 g6 d4 Bg7 Nf3 Nf6 g3 O-O Bg2 d5 cxd5 Nxd5 O-O Nc6 Nc3 Be6 ",
	"c4 g6 d4 Bg7 Nf3 Nf6 g3 O-O Bg2 d6 Nc3 Nc6 O-O a6 h3 Rb8 ",
	"c4 g6 d4 Bg7 e4 c5 d5 d6 Nc3 Nf6 h3 b5 cxb5 a6 a4 O-O ",
	"c4 g6 d4 Nf6 Nc3 Bg7 e4 d6 f3 c6 Be3 a6 a4 a5 Nge2 O-O ",
	"c4 g6 d4 Nf6 Nc3 c5 d5 d6 Nf3 Bg7 e4 O-O Be2 e6 O-O Re8 ",
	"c4 g6 d4 Nf6 Nc3 d5 Bf4 Bg7 Rc1 dxc4 e4 c5 dxc5 Qa5 Bxc4 O-O ",
	"c4 g6 d4 Nf6 Nc3 d5 Nf3 Bg7 Bg5 Ne4 cxd5 Nxg5 Nxg5 e6 Qd2 h6 ",
	"c4 g6 d4 Nf6 Nc3 d5 Nf3 Bg7 Qa4+ Bd7 Qb3 dxc4 Qxc4 O-O e4 Bg4 ",
	"c4 g6 d4 Nf6 Nc3 d5 Nf3 Bg7 e3 O-O Be2 dxc4 Bxc4 c5 d5 e6 ",
	"c4 g6 d4 Nf6 Nf3 Bg7 g3 c5 Bg2 Qa5+ Nc3 Ne4 Bd2 Nxd2 Qxd2 cxd4 ",
	"c4 g6 e4 Bg7 d4 d6 Nc3 Nf6 f3 O-O Nge2 b6 Bg5 h6 Be3 c5 ",
	"c4 g6 e4 Bg7 d4 d6 Nc3 a6 Be3 Nf6 f3 c6 Bd3 b5 Qd2 bxc4 ",
	"c4 g6 e4 Bg7 d4 d6 Nc3 a6 Be3 Nf6 f3 c6 Bd3 b5 Qd2 bxc4 ",
	"c4 g6 e4 Bg7 d4 d6 Nc3 c6 Nf3 Bg4 Be3 Nd7 Be2 e5 d5 c5 ",
	"c4 g6 e4 e5 d4 Nf6 Nf3 Bb4+ Bd2 Bxd2+ Nbxd2 d6 dxe5 dxe5 Nxe5 Qe7 ",
	"c4 g6 e4 e5 d4 Nf6 dxe5 Nxe4 Nf3 Bc5 Qd5 Bxf2+ Ke2 f5 exf6 Nxf6 ",
	"c4 g6 e4 e5 d4 d6 Nf3 Nd7 Nc3 Bg7 Be2 Nh6 dxe5 dxe5 h3 O-O ",
	"c4 g6 g3 Bg7 Bg2 Nf6 Nf3 O-O O-O d6 d4 Nc6 d5 Na5 Nfd2 c5 ",
	"c4 g6 g3 Bg7 Bg2 c5 Nf3 Nc6 O-O d6 Nc3 h5 d3 Nh6 e4 O-O ",
	"c4 g6 g3 Bg7 Bg2 d6 Nc3 e5 e4 Be6 d3 Nc6 Nge2 Qd7 Nd5 Nce7 ",
	"c4 g6 g3 Bg7 Bg2 e5 Nc3 Ne7 d3 O-O e4 d6 Nge2 f5 O-O Nd7 ",
	"c4 g6 g3 Bg7 Bg2 e5 Nc3 Ne7 d3 c6 e4 d6 Nge2 a6 a4 a5 ",
	"c4 g6 g3 Bg7 Nf3 f5 Bg2 e5 d3 d6 O-O Nc6 Nc3 Nh6 Bg5 Qd7 ",
	"c4 g6 g3 c5 Bg2 Bg7 Nc3 Nc6 Nf3 Nh6 h4 d6 d3 Rb8 h5 Bd7 ",
	"c4 g6 g3 f5 d4 Bg7 Bg2 d6 d5 c5 Nh3 Nf6 Nc3 Na6 O-O Nc7 ",
	"d4 Nc6 c4 d5 Nc3 e5 cxd5 Nxd4 e3 Nf5 e4 Nh4 g3 Ng6 Qb3 a6 ",
	"d4 Nf6 Bg5 Ne4 Bf4 c5 d5 e6 dxe6 fxe6 e3 Qf6 c3 Bd6 Nd2 Nxd2 ",
	"d4 Nf6 Bg5 Ne4 Bf4 c5 f3 Nf6 d5 g6 e4 Bg7 Nc3 O-O Qd2 d6 ",
	"d4 Nf6 Bg5 e6 e4 h6 Bxf6 Qxf6 Nf3 d6 Nc3 c6 Qd2 e5 O-O-O Be7 ",
	"d4 Nf6 Bg5 e6 e4 h6 Bxf6 Qxf6 Nf3 d6 Nc3 g6 Qd2 Qe7 O-O-O a6 ",
	"d4 Nf6 Nc3 d5 Bg5 Bf5 Bxf6 exf6 e3 Bb4 Bd3 Bxd3 Qxd3 Bxc3+ bxc3 c6 ",
	"d4 Nf6 Nc3 d5 Bg5 Bf5 e3 e6 Bd3 Bg6 Nf3 Be7 Ne5 Bxd3 Qxd3 O-O ",
	"d4 Nf6 Nc3 d5 Bg5 Bf5 f3 c6 e3 Qb6 Na4 Qa5+ c3 e6 b4 Qc7 ",
	"d4 Nf6 Nf3 b6 Bf4 Bb7 e3 c5 Nbd2 g6 c3 Bg7 h3 O-O Be2 Nc6 ",
	"d4 Nf6 Nf3 b6 Nbd2 Bb7 e3 c5 Bd3 Nc6 O-O g6 c3 Bg7 a3 O-O ",
	"d4 Nf6 Nf3 b6 c4 e6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 Nf3 b6 c4 e6 g3 Bb7 Bg2 d5 Ne5 Bb4+ Bd2 Bxd2+ Nxd2 O-O ",
	"d4 Nf6 Nf3 b6 e3 Bb7 Bd3 e6 Nbd2 d5 Ne5 Be7 O-O O-O b3 Ne4 ",
	"d4 Nf6 Nf3 b6 g3 Bb7 Bg2 c5 O-O cxd4 Nxd4 Bxg2 Kxg2 d5 c4 e6 ",
	"d4 Nf6 Nf3 b6 g3 Bb7 Bg2 c5 O-O cxd4 b3 Bxf3 Bxf3 Nc6 Bb2 e5 ",
	"d4 Nf6 Nf3 b6 g3 Bb7 c4 e6 Bg2 Be7 Nc3 Ne4 Bd2 d5 cxd5 exd5 ",
	"d4 Nf6 Nf3 c5 c3 g6 Bg5 Qb6 Qb3 Ne4 Bf4 Nc6 d5 Nd8 Nbd2 Nf6 ",
	"d4 Nf6 Nf3 c5 c4 cxd4 Nxd4 b6 Nc3 Bb7 f3 Nc6 e4 e6 Be3 Qb8 ",
	"d4 Nf6 Nf3 c5 c4 cxd4 Nxd4 e6 Nc3 Bb4 Bd2 Nc6 e3 O-O Be2 d5 ",
	"d4 Nf6 Nf3 c5 d5 b5 Bg5 Ne4 Bh4 Qa5+ Nbd2 Bb7 a4 Bxd5 axb5 Qc7 ",
	"d4 Nf6 Nf3 c5 d5 b5 Bg5 Qb6 Nc3 b4 Na4 Qa5 Bxf6 gxf6 b3 d6 ",
	"d4 Nf6 Nf3 c5 d5 b5 Bg5 Qb6 a4 bxa4 Nc3 Qxb2 Bd2 Qb7 e4 g6 ",
	"d4 Nf6 Nf3 c5 d5 b5 c4 Bb7 a4 bxc4 Nc3 e6 e4 Nxe4 Nxe4 exd5 ",
	"d4 Nf6 Nf3 c5 d5 d6 Nc3 e5 dxe6 Bxe6 e4 Be7 Bg5 Nbd7 Be2 O-O ",
	"d4 Nf6 Nf3 c5 d5 d6 Nc3 g6 e4 Bg7 Bb5+ Bd7 a4 O-O O-O Na6 ",
	"d4 Nf6 Nf3 c5 d5 e6 Nc3 exd5 Nxd5 Nxd5 Qxd5 Nc6 e4 d6 Bc4 Be6 ",
	"d4 Nf6 Nf3 c5 d5 g6 Nc3 Bg7 e4 O-O Be2 d6 O-O Na6 Re1 Nc7 ",
	"d4 Nf6 Nf3 c5 d5 g6 Nc3 Bg7 e4 d6 Be2 O-O O-O Na6 Bf4 Nc7 ",
	"d4 Nf6 Nf3 d5 Bf4 c6 e3 Bg4 Nbd2 e6 h3 Bxf3 Nxf3 Qb6 Bd3 c5 ",
	"d4 Nf6 Nf3 d5 Bf4 c6 e3 Bg4 Nbd2 e6 h3 Bxf3 Nxf3 Qb6 Bd3 c5 ",
	"d4 Nf6 Nf3 d5 Bg5 Nbd7 e3 c5 c4 cxd4 exd4 Qb6 cxd5 Qxb2 Nbd2 g6 ",
	"d4 Nf6 Nf3 d5 c4 c6 Nc3 dxc4 a4 Bf5 Ne5 Nbd7 Nxc4 Qc7 g3 e5 ",
	"d4 Nf6 Nf3 d5 c4 c6 Nc3 dxc4 e3 Bg4 Bxc4 e6 h3 Bh5 O-O Be7 ",
	"d4 Nf6 Nf3 d5 c4 c6 e3 Bf5 cxd5 cxd5 Qb3 Qc8 Nc3 e6 Bd2 Nc6 ",
	"d4 Nf6 Nf3 d5 c4 c6 e3 e6 Nbd2 Ne4 Bd3 f5 Ne5 Nd7 Qh5+ g6 ",
	"d4 Nf6 Nf3 d5 c4 c6 e3 e6 Nc3 Ne4 Nxe4 dxe4 Nd2 f5 c5 Nd7 ",
	"d4 Nf6 Nf3 d5 c4 e6 Bg5 Nbd7 Nc3 Be7 e3 c6 Rc1 O-O Bd3 dxc4 ",
	"d4 Nf6 Nf3 d5 c4 e6 Bg5 c5 cxd5 exd5 Nc3 Be6 e3 Nbd7 Bb5 cxd4 ",
	"d4 Nf6 Nf3 d5 c4 e6 Nc3 Be7 g3 O-O Bg2 Nbd7 O-O dxc4 e4 c6 ",
	"d4 Nf6 Nf3 d5 c4 e6 Nc3 Nbd7 Bg5 Be7 e3 O-O Qc2 c5 Rd1 Qa5 ",
	"d4 Nf6 Nf3 d5 c4 e6 Nc3 dxc4 e4 Bb4 Bg5 c5 Bxc4 cxd4 Nxd4 Bxc3+ ",
	"d4 Nf6 Nf3 d5 e3 e6 Bd3 c5 b3 cxd4 exd4 Nc6 O-O Be7 Bb2 O-O ",
	"d4 Nf6 Nf3 d5 g3 Bf5 Bg2 e6 O-O Nbd7 b3 Bd6 Bb2 c6 Nbd2 O-O ",
	"d4 Nf6 Nf3 d6 Bg5 Nbd7 e3 e5 Nc3 c6 Bd3 Be7 Qe2 Qa5 O-O Nf8 ",
	"d4 Nf6 Nf3 d6 Nc3 Bg4 e4 Nbd7 e5 Ng8 h3 Bxf3 Qxf3 c6 Bf4 d5 ",
	"d4 Nf6 Nf3 d6 Nc3 d5 e3 c5 dxc5 Bg4 e4 Bxf3 Qxf3 d4 e5 Nc6 ",
	"d4 Nf6 Nf3 d6 c4 Bf5 g3 Nbd7 Bg2 c6 b3 h6 Bb2 e6 O-O d5 ",
	"d4 Nf6 Nf3 d6 c4 Bg4 Nc3 Bxf3 gxf3 g6 Qb3 Qc8 Bh3 Nfd7 e4 Bg7 ",
	"d4 Nf6 Nf3 d6 c4 Bg4 e3 g6 Nc3 Bg7 Be2 O-O O-O c5 b3 Nc6 ",
	"d4 Nf6 Nf3 d6 c4 Nbd7 Nc3 c6 e4 e5 Be2 Be7 O-O O-O Re1 a6 ",
	"d4 Nf6 Nf3 d6 c4 Nbd7 Nc3 e5 e4 g6 g3 Bg7 d5 Nc5 Qe2 a5 ",
	"d4 Nf6 Nf3 e6 Bf4 b6 c3 Be7 e3 Nh5 Bg3 O-O Nbd2 c5 Bd3 Ba6 ",
	"d4 Nf6 Nf3 e6 Bf4 c5 e3 Qb6 Qc1 Nc6 c3 d5 Nbd2 Bd7 h3 Rc8 ",
	"d4 Nf6 Nf3 e6 Bg5 Be7 Nbd2 d5 e3 O-O Bd3 c5 c3 b6 Ne5 Bb7 ",
	"d4 Nf6 Nf3 e6 Bg5 b6 e4 h6 Bxf6 Qxf6 Bd3 Bb7 Nbd2 d6 Qe2 a6 ",
	"d4 Nf6 Nf3 e6 Bg5 c5 Bxf6 Qxf6 e4 cxd4 Qxd4 Nc6 Qxf6 gxf6 c3 b6 ",
	"d4 Nf6 Nf3 e6 Bg5 c5 c3 cxd4 cxd4 Qa5+ Bd2 Qb6 Nc3 Nc6 e3 d5 ",
	"d4 Nf6 Nf3 e6 Bg5 c5 c3 d5 e3 Nc6 Nbd2 Bd7 g3 h6 Bf4 Be7 ",
	"d4 Nf6 Nf3 e6 Bg5 c5 e3 Be7 Nbd2 d5 c3 Nbd7 Bd3 O-O Ne5 Nxe5 ",
	"d4 Nf6 Nf3 e6 Bg5 c5 e3 Qb6 Nbd2 Qxb2 Bd3 d5 c4 Qc3 Ne5 Nfd7 ",
	"d4 Nf6 Nf3 e6 Bg5 c5 e3 cxd4 exd4 Be7 Nbd2 d6 c3 Nbd7 Bd3 b6 ",
	"d4 Nf6 Nf3 e6 Bg5 h6 Bh4 b6 Nbd2 Bb7 e3 Be7 h3 c5 c3 Nc6 ",
	"d4 Nf6 Nf3 e6 Bg5 h6 Bh4 b6 Nbd2 Bb7 e3 Be7 h3 c5 c3 Nc6 ",
	"d4 Nf6 Nf3 e6 Bg5 h6 Bh4 b6 c4 Bb7 Nc3 Be7 Qc2 d5 cxd5 exd5 ",
	"d4 Nf6 Nf3 e6 Bg5 h6 Bh4 c5 e3 b6 Nbd2 Bb7 Bd3 Be7 c3 O-O ",
	"d4 Nf6 Nf3 e6 Nbd2 c5 e3 Nc6 a3 cxd4 exd4 d5 Bd3 Bd6 O-O O-O ",
	"d4 Nf6 Nf3 e6 Nbd2 d5 e3 c5 a3 cxd4 exd4 Nc6 Bd3 Bd6 O-O Qc7 ",
	"d4 Nf6 Nf3 e6 c4 Bb4+ Bd2 Bxd2+ Nbxd2 d5 g3 O-O Bg2 Nbd7 O-O Qe7 ",
	"d4 Nf6 Nf3 e6 c4 Bb4+ Nbd2 O-O e3 d5 a3 Be7 Bd3 b6 O-O Bb7 ",
	"d4 Nf6 Nf3 e6 c4 Bb4+ Nc3 c5 e3 cxd4 exd4 d5 Bd3 dxc4 Bxc4 Nc6 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb4 Bg5 Bb7 e3 h6 Bh4 Bxc3+ bxc3 d6 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb4 Qb3 a5 g3 Bb7 Bg2 O-O O-O d5 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb7 Bg5 h6 Bh4 Be7 e3 Ne4 Bg3 Bb4 ",
	"d4 Nf6 Nf3 e6 c4 b6 Nc3 Bb7 Bg5 h6 Bh4 Be7 e3 Ne4 Bg3 Bb4 ",
	"d4 Nf6 Nf3 e6 c4 b6 a3 Ba6 Nbd2 Bb7 Qc2 c5 e4 cxd4 e5 Ng4 ",
	"d4 Nf6 Nf3 e6 c4 b6 a3 Bb7 Nc3 Ne4 Nxe4 Bxe4 Nd2 Bb7 e4 Qf6 ",
	"d4 Nf6 Nf3 e6 c4 b6 e3 Bb7 Bd3 Bb4+ Nbd2 O-O a3 Bxd2+ Qxd2 d6 ",
	"d4 Nf6 Nf3 e6 c4 b6 e3 Bb7 Bd3 Be7 O-O O-O b3 c5 Bb2 cxd4 ",
	"d4 Nf6 Nf3 e6 c4 b6 e3 Bb7 Bd3 c5 O-O Be7 Nbd2 O-O b3 d6 ",
	"d4 Nf6 Nf3 e6 c4 b6 e3 Bb7 Nc3 Be7 Bd3 d5 O-O O-O Qe2 c5 ",
	"d4 Nf6 Nf3 e6 c4 b6 g3 Ba6 b3 Bb4+ Bd2 Bxd2+ Qxd2 O-O Bg2 c6 ",
	"d4 Nf6 Nf3 e6 c4 b6 g3 Bb7 Bg2 Bb4+ Bd2 Bxd2+ Qxd2 d6 Nc3 O-O ",
	"d4 Nf6 Nf3 e6 c4 b6 g3 Bb7 Bg2 Bb4+ Bd2 Bxd2+ Qxd2 d6 O-O Nbd7 ",
	"d4 Nf6 Nf3 e6 c4 c5 e3 d5 Nc3 Nc6 cxd5 Nxd5 Bc4 cxd4 exd4 Be7 ",
	"d4 Nf6 Nf3 e6 c4 c5 g3 cxd4 Nxd4 d5 Bg2 e5 Nf3 d4 O-O Nc6 ",
	"d4 Nf6 Nf3 e6 c4 d5 Bg5 Be7 Nc3 O-O e3 h6 Bh4 b6 Bd3 dxc4 ",
	"d4 Nf6 Nf3 e6 c4 d5 Nbd2 c5 e3 Nc6 a3 Bd6 dxc5 Bxc5 b4 Be7 ",
	"d4 Nf6 Nf3 e6 c4 d5 Nc3 Bb4 Bg5 h6 Bxf6 Qxf6 cxd5 exd5 a3 Bxc3+ ",
	"d4 Nf6 Nf3 e6 c4 d5 Nc3 Be7 Bg5 Nbd7 e3 O-O Rc1 a6 cxd5 exd5 ",
	"d4 Nf6 Nf3 e6 c4 d5 Nc3 c5 cxd5 Nxd5 e3 Nc6 Bc4 cxd4 exd4 Bb4 ",
	"d4 Nf6 Nf3 e6 c4 d5 Nc3 c5 cxd5 Nxd5 e3 Nc6 Bd3 Be7 O-O O-O ",
	"d4 Nf6 Nf3 e6 c4 d5 Nc3 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"d4 Nf6 Nf3 e6 e3 b6 Nbd2 Bb7 Bd3 c5 O-O Be7 e4 cxd4 Nxd4 Nc6 ",
	"d4 Nf6 Nf3 e6 e3 c5 Bd3 Nc6 O-O d5 b3 Bd6 Bb2 O-O a3 Qc7 ",
	"d4 Nf6 Nf3 e6 e3 c5 Bd3 b6 Nbd2 Bb7 O-O cxd4 exd4 Be7 c3 O-O ",
	"d4 Nf6 Nf3 e6 e3 d5 Nbd2 c5 a3 Nbd7 dxc5 Bxc5 b4 Be7 Bb2 O-O ",
	"d4 Nf6 Nf3 e6 g3 b5 Bg2 Bb7 Bg5 Be7 O-O Na6 Nbd2 c5 c3 cxd4 ",
	"d4 Nf6 Nf3 e6 g3 b5 Bg2 Bb7 O-O c5 Bg5 Be7 c3 Na6 e3 Rb8 ",
	"d4 Nf6 Nf3 e6 g3 b5 Bg2 Bb7 O-O c5 Nbd2 Na6 e4 cxd4 e5 Ng8 ",
	"d4 Nf6 Nf3 e6 g3 b5 a4 b4 Bg2 Bb7 O-O Be7 c4 O-O b3 Qc8 ",
	"d4 Nf6 Nf3 e6 g3 b6 Bg2 Bb7 O-O d6 c4 Nbd7 Nc3 Ne4 Qc2 Nxc3 ",
	"d4 Nf6 Nf3 e6 g3 b6 Bg2 Bb7 c4 Be7 Nc3 O-O Qc2 c5 d5 exd5 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 Nbd2 O-O h3 b6 e4 Bb7 Bd3 d6 O-O Nbd7 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 Qc1 h6 h3 b6 Nc3 Bb7 Qd2 a6 Rd1 e6 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 O-O Be2 c5 c3 b6 h3 Bb7 Nbd2 d6 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 O-O Be2 d6 h3 b6 O-O c5 c3 Ba6 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 O-O h3 c5 c3 cxd4 exd4 d6 Be2 Qb6 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 O-O h3 c5 c3 cxd4 exd4 d6 Be2 Qb6 ",
	"d4 Nf6 Nf3 g6 Bf4 Bg7 e3 d6 h3 O-O Be2 Nbd7 O-O Qe8 Bh2 e5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 O-O c3 Qe8 e4 d6 Bc4 e5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 O-O c3 d5 e3 Nbd7 b4 Re8 Be2 e5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 O-O c3 d6 e4 Nc6 Be2 h6 Bh4 e5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 c5 e3 b6 c3 O-O e4 d6 Bd3 Nc6 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 O-O Be2 b6 O-O c5 c3 Nc6 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 b6 c3 O-O Be2 Bb7 O-O c5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d5 e3 c5 c3 O-O Bd3 Nc6 O-O Qb6 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 Nbd2 d6 e4 O-O c3 Nbd7 Be2 e5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 c3 O-O Nbd2 d6 e3 b6 Bd3 Bb7 Bxf6 Bxf6 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 c3 O-O Nbd2 d6 e4 Nbd7 Bc4 e5 dxe5 dxe5 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 c3 O-O Nbd2 d6 e4 Nbd7 Bd3 e5 O-O h6 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 e3 c5 Nbd2 b6 c3 Bb7 Qa4 O-O Be2 d6 ",
	"d4 Nf6 Nf3 g6 Bg5 Bg7 e3 c5 c3 b6 Bd3 Bb7 Qe2 O-O Nbd2 d6 ",
	"d4 Nf6 Nf3 g6 Nc3 d5 Bf4 Bg7 e3 O-O h3 c5 dxc5 Qa5 Nd2 Qxc5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O Bg5 h6 Bf4 d6 h3 Nc6 e3 e6 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 O-O e4 d6 Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Rb1 O-O ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Rb1 O-O ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Rb1 O-O ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d5 e3 O-O Bd2 e6 Qc2 Nbd7 Rc1 c6 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d6 Bf4 Nh5 Bg5 h6 Be3 c6 g3 Nd7 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d6 e4 O-O Be2 Nbd7 O-O c6 h3 e5 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d6 e4 O-O Be2 e5 d5 a5 Bg5 h6 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 Nc3 d6 e4 O-O g3 Nc6 d5 Nb8 Bg2 Nbd7 ",
	"d4 Nf6 Nf3 g6 c4 Bg7 g3 O-O Bg2 c6 Nc3 d5 cxd5 cxd5 Ne5 e6 ",
	"d4 Nf6 Nf3 g6 c4 c5 g3 Bg7 Bg2 O-O O-O cxd4 Nxd4 Nc6 Nc3 Nxd4 ",
	"d4 Nf6 Nf3 g6 e3 Bg7 Bd3 d6 Nbd2 Nbd7 b3 O-O Bb2 e5 dxe5 Ng4 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O c5 c4 cxd4 Nxd4 Nc6 Nc3 Nxd4 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 Nc3 c5 e4 cxd4 Nxd4 Nc6 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 b3 Bf5 Bb2 Qc8 Re1 c5 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 O-O O-O d6 c4 Bf5 Nc3 Qc8 Re1 Bh3 ",
	"d4 Nf6 Nf3 g6 g3 Bg7 Bg2 c5 c4 O-O O-O d6 Nc3 Nc6 dxc5 dxc5 ",
	"d4 Nf6 Nf3 g6 g3 c5 Bg2 cxd4 Nxd4 Bg7 c4 Nc6 Nc3 Nxd4 Qxd4 O-O ",
	"d4 Nf6 Nf3 g6 h3 Bg7 Bf4 O-O Nbd2 c5 c3 cxd4 cxd4 Nc6 e3 d6 ",
	"d4 Nf6 Nf3 g6 h3 Bg7 Bf4 O-O Nbd2 d6 e3 Nbd7 c3 c5 Bc4 b6 ",
	"d4 Nf6 c4 Nc6 Nc3 e5 d5 Ne7 h4 Neg8 a3 Bc5 e3 d6 b4 Bb6 ",
	"d4 Nf6 c4 b6 Nc3 Bb7 Qc2 d5 cxd5 Nxd5 Nf3 e6 e4 Nxc3 bxc3 c5 ",
	"d4 Nf6 c4 b6 Nc3 Bb7 Qc2 e6 e4 Bb4 Bd3 Bxc3+ bxc3 d6 Ne2 c5 ",
	"d4 Nf6 c4 b6 Nc3 Bb7 Qc2 e6 e4 Bb4 Bd3 d5 cxd5 Bxc3+ bxc3 exd5 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 b6 Nc3 Bb7 f3 d6 e4 e6 Be2 a6 ",
	"d4 Nf6 c4 c5 Nf3 cxd4 Nxd4 e6 g3 d5 Bg2 e5 Nf3 d4 O-O Nc6 ",
	"d4 Nf6 c4 c5 d5 b5 Bg5 Ne4 Bf4 Qa5+ Nd2 bxc4 Qc2 Nf6 e4 d6 ",
	"d4 Nf6 c4 c5 d5 b5 Nd2 bxc4 e4 d6 Bxc4 g6 b3 Bg7 Bb2 O-O ",
	"d4 Nf6 c4 c5 d5 b5 Nf3 b4 Bg5 d6 Nbd2 e5 dxe6 fxe6 a3 Nc6 ",
	"d4 Nf6 c4 c5 d5 b5 Nf3 bxc4 Nc3 d6 e4 Nbd7 Bxc4 g6 O-O Bg7 ",
	"d4 Nf6 c4 c5 d5 b5 Nf3 bxc4 Nc3 g6 e4 d6 Bxc4 Bg7 O-O O-O ",
	"d4 Nf6 c4 c5 d5 b5 Nf3 g6 Qc2 Bg7 e4 bxc4 Bxc4 d6 O-O O-O ",
	"d4 Nf6 c4 c5 d5 b5 Nf3 g6 cxb5 a6 e3 Bg7 Nc3 O-O a4 Bb7 ",
	"d4 Nf6 c4 c5 d5 b5 a4 bxc4 Nc3 e5 e4 d6 Bxc4 g6 Nge2 Bg7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 Nc3 axb5 e4 Qa5 e5 b4 Nb5 Ne4 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 b6 d6 Nc3 Nbd7 a4 Qxb6 a5 Qb4 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 b6 d6 Nc3 Nbd7 e4 g6 a4 Nxb6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 b6 e6 Nc3 exd5 Nxd5 Nxd5 Qxd5 Nc6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 b6 g6 Nc3 Bg7 e4 O-O e5 Ne8 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 Bxa6 Nc3 d6 Nf3 g6 g3 Nbd7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 Bxa6 Nc3 g6 e4 Bxf1 Kxf1 d6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 Nc3 Bxa6 Nf3 Bg7 e4 Bxf1 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 Nc3 Bxa6 Nf3 d6 g3 Bg7 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 bxa6 g6 Nc3 Bxa6 e4 Bxf1 Kxf1 d6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 Bb7 Nc3 Qa5 bxa6 Nxa6 Bd2 Qb6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 Bb7 Nc3 Qa5 bxa6 Nxa6 Bd2 Qb6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 axb5 Bxb5 Qa5+ Nc3 Bb7 Ne2 e6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 axb5 Bxb5 Qa5+ Nc3 Bb7 e4 Nxe4 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 e3 g6 Nc3 Bg7 Nf3 O-O a4 d6 ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 f3 e6 e4 exd5 e5 Nh5 Qxd5 Qh4+ ",
	"d4 Nf6 c4 c5 d5 b5 cxb5 a6 f3 g6 e4 d6 Nc3 Bg7 Bg5 O-O ",
	"d4 Nf6 c4 c5 d5 b5 f3 bxc4 e4 d6 Bxc4 g6 Ne2 Bg7 O-O O-O ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 Nf3 Bg7 e4 O-O Bf4 a6 a4 Nh5 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 Bd3 O-O Nf3 Bg4 h3 Bxf3 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 Bd3 O-O Nge2 e6 O-O exd5 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 Nf3 O-O Be2 e5 Bg5 h6 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 Nf3 O-O Bg5 h6 Bh4 a6 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 f3 e5 Bg5 h6 Be3 h5 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 f4 O-O Nf3 Nbd7 Be2 Qc7 ",
	"d4 Nf6 c4 c5 d5 d6 Nc3 g6 e4 Bg7 f4 O-O Nf3 a6 Bd3 b5 ",
	"d4 Nf6 c4 c5 d5 e5 Nc3 d6 e4 Bd7 Bd3 Na6 a3 Nc7 f4 Ng4 ",
	"d4 Nf6 c4 c5 d5 e5 Nc3 d6 e4 Be7 Bd3 O-O Nge2 Nbd7 O-O Ne8 ",
	"d4 Nf6 c4 c5 d5 e5 Nc3 d6 e4 Be7 Bd3 O-O Nge2 Ne8 O-O Nd7 ",
	"d4 Nf6 c4 c5 d5 e5 Nc3 d6 e4 Be7 Bd3 O-O Nge2 Nh5 Be3 Bg5 ",
	"d4 Nf6 c4 c5 d5 e5 Nc3 d6 e4 Be7 Be2 O-O Nf3 Ne8 O-O f5 ",
	"d4 Nf6 c4 c5 d5 e5 Nc3 d6 e4 Be7 Nf3 O-O h3 Nbd7 g4 Ne8 ",
	"d4 Nf6 c4 c5 d5 e5 Nc3 d6 e4 g6 Bd3 Bg7 Nge2 Na6 a3 Nc7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 Bd6 Nf3 O-O Bg5 Re8 e3 a6 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Bf4 Bg7 Qa4+ Bd7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Bf4 Bg7 Qa4+ Bd7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Bf4 Bg7 Qa4+ Bd7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Bf4 a6 a4 Bg7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Bf4 a6 e4 Bg7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Bg5 h6 Bh4 g5 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 Nd2 Bg7 Nc4 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 g3 Bg7 Bg2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 Nf3 g6 g3 Bg7 Bg2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Bd3 Bg7 Nge2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Bd3 Bg7 Nge2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Be2 Bg7 Nf3 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Bf4 Bg7 Bb5+ Bd7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Bf4 Bg7 Qa4+ Ke7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Be2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Be2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Be2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Be2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 Nf3 Bg7 Be2 O-O ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 f3 Bg7 Bg5 h6 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 f4 Bg7 Bb5+ Nfd7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 f4 Bg7 Bb5+ Nfd7 ",
	"d4 Nf6 c4 c5 d5 e6 Nc3 exd5 cxd5 d6 e4 g6 f4 Bg7 Bb5+ Nfd7 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 O-O Nf3 d6 Be2 e5 O-O Ne8 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 Bg7 e4 d6 Bd3 O-O Nge2 Nbd7 Bc2 Nb6 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 d6 e4 Bg7 Nf3 O-O Be2 e5 Bg5 h6 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 d6 e4 Bg7 Nf3 O-O h3 e6 Bd3 exd5 ",
	"d4 Nf6 c4 c5 d5 g6 Nc3 d6 e4 Bg7 Nge2 b5 cxb5 a6 Ng3 O-O ",
	"d4 Nf6 c4 c6 Nc3 d5 Nf3 Bf5 Qb3 Qb6 c5 Qxb3 axb3 g6 Bf4 Nbd7 ",
	"d4 Nf6 c4 c6 Nc3 d5 Nf3 g6 Bf4 Bg7 e3 O-O Be2 c5 dxc5 Qa5 ",
	"d4 Nf6 c4 c6 Nc3 d5 cxd5 cxd5 Nf3 Nc6 Bf4 e6 e3 Be7 Bd3 O-O ",
	"d4 Nf6 c4 c6 Nc3 d5 cxd5 cxd5 Nf3 Nc6 Bf4 e6 e3 Be7 Bd3 O-O ",
	"d4 Nf6 c4 c6 Nc3 d5 e3 e6 Bd3 Be7 Nf3 Nbd7 O-O O-O e4 dxe4 ",
	"d4 Nf6 c4 c6 Nc3 d5 e3 g6 Nf3 Bg7 Bd3 Bf5 Bxf5 gxf5 cxd5 Nxd5 ",
	"d4 Nf6 c4 c6 Nc3 d5 e3 g6 Nf3 Bg7 Be2 O-O O-O e6 Rb1 Nbd7 ",
	"d4 Nf6 c4 c6 Nc3 g6 e4 d5 e5 Ne4 Bd3 Nxc3 bxc3 Bg7 Ne2 O-O ",
	"d4 Nf6 c4 c6 Nc3 g6 e4 d5 e5 Ne4 Bd3 Nxc3 bxc3 Bg7 Ne2 O-O ",
	"d4 Nf6 c4 c6 Nf3 d5 e3 Bf5 cxd5 cxd5 Qb3 Qc7 Nc3 e6 Bd2 Nc6 ",
	"d4 Nf6 c4 c6 e3 d5 Bd3 e5 dxe5 dxc4 Be2 Qxd1+ Bxd1 Ng4 f4 Bc5 ",
	"d4 Nf6 c4 d6 Nc3 Bf5 f3 e5 e4 exd4 Qxd4 Be6 f4 g6 Be3 Nc6 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 Nf3 e5 g3 g6 Bg2 Bg7 O-O O-O e4 c6 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 Nf3 g6 Bf4 Bg7 h3 O-O e3 e6 Be2 Qe7 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 Nf3 g6 Bf4 Bg7 h3 O-O e3 e6 Be2 Qe7 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 Nf3 c6 Be2 Be7 O-O O-O d5 a6 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 Nf3 g6 Be2 Bg7 O-O O-O Be3 c6 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 Nge2 c6 g3 g6 Bg2 Bg7 O-O O-O ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 Nge2 exd4 Nxd4 g6 Be2 Bg7 Be3 O-O ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 Nge2 g6 g3 Bg7 Bg2 O-O O-O Re8 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 Nge2 g6 g3 Bg7 Bg2 O-O O-O exd4 ",
	"d4 Nf6 c4 d6 Nc3 Nbd7 e4 e5 d5 Nc5 f3 Be7 Be3 O-O b4 Ncd7 ",
	"d4 Nf6 c4 d6 Nc3 e5 Nf3 Nbd7 Bg5 h6 Bh4 g5 dxe5 gxh4 exf6 Qxf6 ",
	"d4 Nf6 c4 d6 Nc3 e5 Nf3 Nbd7 e4 Be7 Be2 O-O O-O c6 d5 Nc5 ",
	"d4 Nf6 c4 d6 Nc3 e5 Nf3 Nbd7 e4 g6 Be2 Bg7 O-O O-O d5 a5 ",
	"d4 Nf6 c4 d6 Nc3 e5 Nf3 Nbd7 e4 g6 d5 Bg7 h3 O-O Be3 Nh5 ",
	"d4 Nf6 c4 d6 Nc3 e5 Nf3 Nbd7 g3 g6 Bg2 Bg7 O-O O-O e4 Re8 ",
	"d4 Nf6 c4 d6 Nc3 e5 Nf3 Nbd7 g3 g6 Bg2 Bg7 O-O O-O e4 c6 ",
	"d4 Nf6 c4 d6 Nc3 g6 Nf3 Bg7 g3 O-O Bg2 Nbd7 O-O e5 Qc2 Re8 ",
	"d4 Nf6 c4 d6 Nc3 g6 e4 Bg7 Be2 O-O Bg5 c5 d5 a6 a4 Qa5 ",
	"d4 Nf6 c4 d6 Nc3 g6 e4 Bg7 f3 O-O Be3 Nbd7 Qd2 e5 Nge2 Nb6 ",
	"d4 Nf6 c4 d6 Nc3 g6 e4 Bg7 f3 c5 dxc5 dxc5 Qxd8+ Kxd8 Bg5 Nfd7 ",
	"d4 Nf6 c4 d6 Nc3 g6 g3 Bg7 Bg2 Nbd7 e4 O-O Nge2 e5 O-O exd4 ",
	"d4 Nf6 c4 d6 Nf3 Nbd7 Nc3 e5 e4 Be7 Be2 O-O O-O Re8 Qc2 Bf8 ",
	"d4 Nf6 c4 d6 Nf3 g6 Nc3 Bg7 e4 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 d6 Nf3 g6 Nc3 Bg7 e4 O-O Be2 e5 d5 Nh5 g3 a5 ",
	"d4 Nf6 c4 d6 Nf3 g6 g3 Bg7 Bg2 O-O Nc3 Nbd7 O-O e5 e4 c6 ",
	"d4 Nf6 c4 e5 dxe5 Ne4 Nf3 Bb4+ Bd2 Nxd2 Nbxd2 Nc6 a3 Bxd2+ Qxd2 Qe7 ",
	"d4 Nf6 c4 e5 dxe5 Ne4 a3 a5 Qc2 f5 exf6 Nxf6 Bg5 Bc5 e3 O-O ",
	"d4 Nf6 c4 e5 dxe5 Ng4 Bf4 Bb4+ Nd2 Nc6 Nf3 f6 exf6 Qxf6 g3 Qxb2 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 Bf4 Nc6 Nf3 Bb4+ Nbd2 Qe7 a3 Ngxe5 Nxe5 Nxe5 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 Bf4 Nc6 Nf3 Bb4+ Nbd2 Qe7 e3 Ngxe5 Nxe5 Nxe5 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 Nf3 Bc5 e3 Nc6 Be2 Ngxe5 O-O O-O Nc3 d6 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 Nf3 Bc5 e3 Nc6 Be2 O-O O-O Ngxe5 Nc3 d6 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 Nf3 Nc6 Bf4 f6 exf6 Qxf6 Qd2 Bb4 Nc3 Bxc3 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 e4 Nxe5 f4 Nec6 Be3 Bb4+ Nc3 Qh4+ g3 Qe7 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 e4 d6 exd6 Bxd6 Be2 f5 exf5 Qe7 Nf3 Bxf5 ",
	"d4 Nf6 c4 e5 dxe5 Ng4 e4 h5 h3 Nxe5 Be3 Nbc6 Nc3 Bb4 Qd2 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Bg5 d5 Qc2 Nbd7 a3 Bxc3+ Qxc3 h6 Bh4 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 Bxc3+ bxc3 d6 g3 O-O Bg2 Qe7 Ba3 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 Ne4 Qc2 f5 g3 Nc6 Bg2 O-O O-O Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 O-O Bg5 c5 e3 cxd4 exd4 h6 Bh4 d5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 O-O Bg5 d6 e3 Qe7 Be2 e5 Qc2 Re8 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 O-O g3 c5 Bg2 Bxc3+ bxc3 Qa5 Bd2 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 Bg5 Bb7 e3 h6 Bh4 Bxc3+ bxc3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 b6 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 a3 Bxc3+ bxc3 Qa5 Bd2 Ne4 Qc2 Nxd2 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 e3 O-O Be2 d5 O-O Nc6 cxd5 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 e3 O-O Be2 d5 a3 cxd4 axb4 dxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 g3 Ne4 Qd3 Qa5 Qxe4 Bxc3+ Bd2 Bxd2+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 c5 g3 cxd4 Nxd4 O-O Bg2 d5 Qb3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 d5 cxd5 exd5 Bg5 Qd6 Nd2 Nbd7 e3 c6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Nf3 d5 cxd5 exd5 Bg5 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 Bxc3+ Qxc3 Ne4 Qc2 d5 Nf3 O-O e3 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 Nc6 Nf3 d6 d5 Bxc3+ Qxc3 exd5 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 Nc6 e3 d5 Nf3 O-O a3 dxc4 Bxc4 Bd6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 Qe7 Bg5 b6 a3 Bxc3+ Qxc3 Bb7 f3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 c5 dxc5 Bxc5 Nf3 Nc6 Bg5 b6 e4 Nd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 c5 dxc5 Bxc5 Nf3 O-O e3 d5 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 c5 dxc5 Na6 a3 Bxc5 Nf3 O-O Bg5 Be7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 c5 dxc5 Nc6 Bg5 Bxc5 Nf3 h6 Bh4 Qb6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 c5 dxc5 Nc6 Bg5 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qb3 c5 dxc5 Nc6 Bg5 h6 Bxf6 Qxf6 Nf3 Bxc5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 Bxc3+ Qxc3 Ne4 Qc2 d5 e3 c5 dxc5 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 Nc6 Nf3 O-O Bg5 Re8 e3 d6 Be2 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 Nc6 Nf3 d5 a3 Bxc3+ Qxc3 a5 b3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 Nc6 Nf3 d6 Bd2 O-O a3 Bxc3 Bxc3 Re8 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 Nc6 Nf3 d6 Bd2 e5 a3 Bxc3 Bxc3 Qe7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 Nc6 e3 e5 d5 Ne7 Ne2 O-O a3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O Bg5 d6 e3 Nbd7 Bd3 h6 Bh4 c5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O Nf3 c5 dxc5 Na6 g3 Nxc5 Bg2 Nce4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 Qe8 Nf3 d6 g3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 Qe8 g3 d6 Nf3 a5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b5 cxb5 Nd5 Qc2 f5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b6 Bg5 Bb7 e3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b6 Bg5 Bb7 e3 h6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b6 Bg5 Bb7 f3 d5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b6 Bg5 Bb7 f3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b6 Bg5 Bb7 f3 h6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 d6 Bg5 Nbd7 Nf3 h6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 d6 f3 d5 Bg5 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 d6 g3 Qe7 Bg2 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Bxc5 Nf3 Qb6 e3 Qc7 b3 a6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Bxc5 Nf3 b6 Bg5 a6 e3 Bb7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Na6 a3 Bxc3+ Qxc3 Nxc5 b4 Nce4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Na6 a3 Bxc3+ Qxc3 Nxc5 f3 d5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Na6 g3 Nxc5 Bg2 d5 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Nc6 Bg5 b6 Nf3 Bxc5 e3 Bb7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Nc6 Bg5 h6 Bh4 Nd4 Qa4 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Nc6 Nf3 Bxc5 Bf4 d5 e3 Qa5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Nc6 Nf3 Bxc5 Bg5 h6 Bh4 a6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Nc6 a3 Bxc5 b4 Be7 Nf3 Qc7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 O-O Bf4 Na6 Bd6 Re8 a3 Qa5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 O-O a3 Bxc5 Bf4 Nc6 Nf3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Qc7 Nf3 Bxc5 Bg5 Be7 e4 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Qc7 a3 Bxc5 Nf3 a6 Bg5 Be7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c5 dxc5 Qc7 a3 Bxc5 b4 Be7 Nb5 Qc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 c6 e4 d5 e5 Ne4 Bd3 Nxc3 bxc3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 a3 Bxc3+ Qxc3 Ne4 Qc2 c5 dxc5 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 a3 Bxc3+ Qxc3 Ne4 Qc2 c5 dxc5 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 a3 Bxc3+ Qxc3 Ne4 Qc2 c5 dxc5 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 a3 Bxc3+ Qxc3 Ne4 Qc2 c5 dxc5 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 a3 Bxc3+ Qxc3 Ne4 Qc2 c5 dxc5 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 Qxd5 Nf3 O-O Bd2 Bxc3 bxc3 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 Qxd5 Nf3 c5 Bd2 Bxc3 Bxc3 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 Qxd5 Nf3 c5 Bd2 Bxc3 Bxc3 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 Qxd5 a3 Bxc3+ Qxc3 Na6 b4 Bd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 Qd6 e3 Ne4 Bf4 Qg6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 Qd6 e3 Ne4 Bf4 Qg6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 c6 e3 Nbd7 Bd3 h6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bh4 c5 dxc5 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bh4 c5 dxc5 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bh4 c5 dxc5 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bh4 c5 dxc5 g5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bxf6 Qxf6 a3 Ba5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bxf6 Qxf6 a3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bxf6 Qxf6 a3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 Bg5 h6 Bxf6 Qxf6 a3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 cxd5 exd5 e3 O-O Bd3 b6 Ne2 c5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d5 e3 O-O a3 Bxc3+ Qxc3 b6 Nf3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d6 Bd2 Nbd7 a3 Bxc3 Bxc3 O-O e3 Re8 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 Qc2 d6 e3 c5 Bd3 Nc6 Ne2 e5 d5 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 O-O e3 c5 Ne2 Nc6 Ng3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 O-O f3 Ne8 e4 b6 Bd3 Ba6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 O-O f3 Ne8 e4 b6 a4 Ba6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 b6 Bg5 Bb7 f3 h6 Bh4 g5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 b6 f3 Ba6 e4 Nc6 Bd3 Na5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 b6 f3 d5 Bg5 h6 Bh4 Ba6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 e3 Nc6 Bd3 O-O Ne2 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 e3 Nc6 Ne2 d6 Ng3 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 e3 O-O Ne2 Nc6 Ng3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 c5 f3 Nc6 e4 d6 Be3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 d5 f3 b6 Bg5 Bb7 e3 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 d6 Qc2 O-O e4 e5 Bd3 c5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 d6 f3 e5 e4 Nc6 Be3 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 d6 f3 e5 e4 O-O Bg5 Re8 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 Nc6 Ne2 d5 a3 Be7 cxd5 exd5 Nf4 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 Nc6 Nf3 O-O Bd3 d5 O-O dxc4 Bxc4 Bd6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 b6 Ne2 d5 O-O dxc4 Bxc4 Bb7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Ne2 cxd4 exd4 d5 O-O dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 d5 O-O Nc6 a3 Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 d5 O-O cxd4 exd4 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 d5 O-O dxc4 Bxc4 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 Nf3 d5 O-O dxc4 Bxc4 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 c5 a3 Bxc3+ bxc3 Nc6 e4 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 Nc6 O-O h6 h3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 b6 O-O Bb7 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 b6 O-O Bb7 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 c5 O-O Nc6 a3 Ba5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 c5 O-O cxd4 exd4 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 Nf3 dxc4 Bxc4 Nbd7 Qb3 a6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 cxd5 exd5 Ne2 Nbd7 O-O c6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 cxd5 exd5 Ne2 c5 O-O Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 d5 cxd5 exd5 Ne2 c5 O-O Nc6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Be2 c5 Nf3 d5 O-O cxd4 exd4 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Be2 d5 Nf3 b6 a3 Bd6 b4 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 b6 a3 Bxc3+ Nxc3 Bb7 d5 Qe7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 b6 a3 Bxc3+ Nxc3 Bb7 f3 d5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 Nf4 c6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Ne2 d5 a3 Be7 cxd5 exd5 g3 c6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Nf3 d5 Bd3 c5 O-O b6 dxc5 bxc5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O Nf3 d5 Be2 c5 O-O dxc4 Bxc4 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O a3 Bxc3+ bxc3 Re8 Ne2 e5 Ng3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 O-O a3 Bxc3+ bxc3 Re8 Ne2 e5 Ng3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 Qe7 Ne2 b6 a3 Bxc3+ Nxc3 Bb7 d5 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 Ne4 O-O Bxc3 bxc3 Nxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 Ne4 O-O Bxc3 bxc3 f5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 O-O O-O Bxc3 bxc3 Be4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 O-O O-O c5 Na4 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Bd3 Bb7 f3 Nh5 Nh3 f5 Bd2 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 Ng3 Bxc3+ bxc3 d5 Ba3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 Ng3 d5 Qa4+",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 Ng3 h5 h4 Bb7 Qd3 d5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 a3 Be7 Nf4 O-O b4 d5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 a3 Be7 Nf4 d5 b3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 a3 Be7 Nf4 d5 cxd5 Bxf1 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ba6 a3 Be7 Nf4 d5 cxd5 Bxf1 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Bb7 a3 Be7 d5 O-O Ng3 d6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ne4 Bd2 Nxd2 Qxd2 Bb7 a3 Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 b6 Ne2 Ne4 Bd2 Nxd2 Qxd2 O-O a3 Be7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 Nc6 Ne2 cxd4 exd4 d5 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 Nc6 Nf3 Bxc3+ bxc3 d6 Nd2 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 Nc6 a3 Bxc3+ bxc3 d6 Ne2 e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 b6 O-O Bb7 Bd2 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 d5 O-O Nc6 a3 Bxc3 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 d5 O-O dxc4 Bxc4 Nbd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 O-O Nf3 d5 O-O dxc4 Bxc4 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 b6 Ne2 Bb7 O-O cxd4 exd4 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 b6 Ne2 Bb7 O-O cxd4 exd4 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Bd3 d5 Nf3 O-O O-O b6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 Ne4 Qc2 cxd4 exd4 d5 a3 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 b6 a3 Ba5 Rb1 Qe7 Bd2 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 cxd4 exd4 O-O a3 Be7 d5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 cxd4 exd4 O-O a3 Be7 d5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 cxd4 exd4 d5 a3 Be7 c5 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 cxd4 exd4 d5 c5 Ne4 Bd2 Nxd2 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 cxd4 exd4 d5 c5 Ne4 Bd2 Nxd2 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 cxd4 exd4 d5 c5 Ne4 Bd2 Nxd2 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 cxd4 exd4 d5 c5 Ne4 Bd2 Nxd2 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 d5 a3 Bxc3+ Nxc3 b6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Ne2 d5 a3 Bxc3+ Nxc3 cxd4 exd4 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 Nf3 d5 Bd3 O-O O-O Nbd7 a3 cxd4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 c5 a3 Bxc3+ bxc3 O-O Bd3 d5 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 a3 Bd6 Nf3 O-O c5 Be7 b4 Ne4 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 a3 Be7 Nf3 O-O Bd3 b6 O-O c5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 a3 Be7 Nf3 O-O b4 Nbd7 Bb2 c6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 a3 Be7 Nf3 O-O b4 Nbd7 Bb2 c6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 a3 Bxc3+ bxc3 Ne4 Bd3 f5 Ne2 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 a3 Bxc3+ bxc3 c5 cxd5 exd5 Bd3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 a3 Bxc3+ bxc3 c5 cxd5 exd5 Bd3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d5 a3 Bxc3+ bxc3 c5 cxd5 exd5 Bd3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 e3 d6 Bd3 Nc6 Ne2 Bxc3+ Nxc3 O-O O-O e5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 c5 d5 Nh5 Nh3 d6 g4 Nf6 Bg2 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 c5 d5 exd5 cxd5 d6 e4 O-O Bd3 Qc7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 c5 d5 exd5 cxd5 d6 e4 O-O Bd3 a6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 a3 Be7 e4 dxe4 fxe4 e5 d5 Bc5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 a3 Bxc3+ bxc3 O-O cxd5 exd5 e3 Nh5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 a3 Bxc3+ bxc3 b6 cxd5 exd5 e3 Bb7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 a3 Bxc3+ bxc3 c5 cxd5 Nxd5 dxc5 Qa5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 a3 Bxc3+ bxc3 c5 cxd5 Nxd5 dxc5 f5 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 a3 Bxc3+ bxc3 c5 cxd5 exd5 e3 O-O ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 cxd5 exd5 a3 Be7 e4 Be6 e5 Nfd7 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 f3 d5 cxd5 exd5 e3 O-O Bd3 Re8 Ne2 b6 ",
	"d4 Nf6 c4 e6 Nc3 Bb4 g3 c5 Nf3 Ne4 Qd3 Qa5 Qxe4 Bxc3+ Bd2 Bxd2+ ",
	"d4 Nf6 c4 e6 Nc3 b6 e4 Bb7 Bd3 Bb4 Qc2 d6 Qa4+ Nc6 d5 Bxc3+ ",
	"d4 Nf6 c4 e6 Nc3 b6 e4 Bb7 Bd3 d5 cxd5 exd5 e5 Ne4 Nf3 Be7 ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 e4 g6 Bd3 Bg7 Nge2 O-O ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 e4 g6 f3 Bg7 Bg5 a6 ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 e4 g6 f4 Bg7 Bb5+ Nfd7 ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 e4 g6 f4 Bg7 Bb5+ Nfd7 ",
	"d4 Nf6 c4 e6 Nc3 c5 d5 exd5 cxd5 d6 e4 g6 f4 Bg7 Bb5+ Nfd7 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 Nf3 Nbd7 e3 h6 Bf4 O-O c5 c6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 Nf3 O-O Rc1 h6 Bh4 b6 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 Nbd7 Nf3 O-O Rc1 a6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Nf3 Nbd7 Rc1 c6 Bd3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Nf3 Nbd7 Rc1 c6 Bd3 h6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Nf3 Nbd7 cxd5 exd5 Bd3 c6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Nf3 b6 cxd5 exd5 Bd3 Bb7 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Nf3 h6 Bh4 b6 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Rc1 h6 Bh4 b6 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 O-O Rc1 h6 Bh4 b6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 h6 Bh4 O-O Rc1 b6 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Be7 e3 h6 Bh4 O-O Rc1 b6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 Nf3 Be7 e3 O-O Qc2 c5 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 cxd5 exd5 e3 Be7 Bd3 O-O Qc2 c5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 Bb4 cxd5 exd5 Bd3 h6 Bh4 c5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 Be7 Nf3 O-O Rc1 c6 Bd3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 Be7 Nf3 O-O Rc1 c6 Qc2 a6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 c6 Nf3 Be7 Bd3 O-O O-O dxc4 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 c6 Nf3 Qa5 Nd2 Bb4 Qc2 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 c6 Nf3 Qa5 cxd5 Ne4 dxe6 fxe6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 c6 a3 Be7 Nf3 O-O Qc2 a6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 c6 cxd5 exd5 Bd3 Bd6 Nge2 Nf8 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 Nbd7 e3 c6 cxd5 exd5 Bd3 Be7 Nge2 O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 c5 cxd5 cxd4 Qxd4 Be7 e4 Nc6 Qd2 Nxd5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Bg5 c6 e3 Nbd7 cxd5 exd5 Bd3 Be7 Qc2 O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Qc2 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 Be7 Bg5 O-O e3 b6 cxd5 exd5 Bd3 Be6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 Be7 Bg5 O-O e3 h6 Bxf6 Bxf6 Qd2 c6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 Be7 Bg5 h6 Bh4 O-O e3 Ne4 Bxe7 Qxe7 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 Nbd7 Bf4 c6 e3 Be7 Bd3 O-O O-O Nh5 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 Nbd7 Bf4 dxc4 e3 Nd5 Bxc4 Nxf4 exf4 Bd6 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 Nbd7 Bg5 Be7 e3 O-O Rc1 c6 Bd3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 a6 e3 c5 dxc5 Bxc5 a3 O-O b4 Be7 ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 c6 Bg5 Nbd7 e3 Be7 Bd3 h6 Bh4 O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 c6 Bg5 Nbd7 e3 Qa5 Nd2 Bb4 Qc2 O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 c6 e3 Bd6 Qc2 Nbd7 Bd2 Qe7 O-O-O O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 Nf3 c6 e3 Nbd7 Ne5 Bd6 f4 O-O Bd3 dxc4 ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bf4 c6 Qc2 Na6 a3 Nc7 e3 Ne6 ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 Bb4 e3 h6 Bh4 c5 Bd3 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 Bb4 e3 h6 Bh4 c5 Bd3 Nc6 ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 Be7 e3 O-O Bd3 Nbd7 Nge2 Re8 ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 Be7 e3 O-O Bd3 Nbd7 Qc2 Re8 ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 Be7 e3 O-O Bd3 Nbd7 Qc2 Re8 ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 Be7 e3 c6 Bd3 Nbd7 Nf3 O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 Be7 e3 c6 Qc2 Nbd7 Bd3 O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 c6 Qc2 Be7 e3 Nbd7 Bd3 O-O ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 c6 e3 Be7 Bd3 Nbd7 Nge2 Nh5 ",
	"d4 Nf6 c4 e6 Nc3 d5 cxd5 exd5 Bg5 c6 e3 Nbd7 Bd3 Be7 Qc2 O-O ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Bxd2+ Qxd2 O-O Nc3 d5 e3 Nbd7 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Bxd2+ Qxd2 O-O g3 d5 Bg2 Nbd7 O-O c6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Bxd2+ Qxd2 O-O g3 d5 Bg2 Qe7 O-O Rd8 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Bxd2+ Qxd2 O-O g3 d5 Bg2 dxc4 Na3 Bd7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Qe7 g3 Bxd2+ Qxd2 O-O Bg2 d5 O-O dxc4 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Qe7 g3 Nc6 Bg2 Bxd2+ Nbxd2 d5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Qe7 g3 O-O Bg2 Bxd2+ Qxd2 d6 Nc3 e5 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 Qe7 g3 b6 Bg2 Bb7 O-O Bxd2 Nbxd2 d6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 a5 g3 O-O Bg2 b6 O-O Ba6 Bg5 Be7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 a5 g3 b6 Bg2 Bb7 O-O O-O Bg5 Be7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 Qb3 a5 a3 Na6 Nbd2 d6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 Qc2 d5 e3 O-O Bd3 a5 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 g3 O-O Bg2 d6 Nbd2 Qc7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 g3 O-O Bg2 d6 Nbd2 Re8 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 g3 O-O Bg2 d6 O-O Nc6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 g3 b6 Bg2 Bb7 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 O-O a3 Bxd2+ Qxd2 d6 b4 b6 Bb2 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 O-O e3 b6 Bd3 Bb7 O-O d5 a3 Bxd2 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 O-O g3 d5 Bg2 Ne4 O-O Nxd2 Bxd2 Bxd2 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 b6 a3 Bxd2+ Bxd2 Bb7 Bg5 d6 e3 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 b6 a3 Bxd2+ Bxd2 Bb7 Bg5 d6 e3 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 b6 a3 Bxd2+ Bxd2 Bb7 Bg5 d6 e3 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 b6 a3 Bxd2+ Qxd2 Bb7 e3 O-O b4 d6 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 b6 a3 Bxd2+ Qxd2 Bb7 e3 d6 Be2 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 c5 a3 Bxd2+ Bxd2 cxd4 Nxd4 Nc6 Bc3 O-O ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 d5 e3 O-O a3 Be7 Bd3 b6 O-O Bb7 ",
	"d4 Nf6 c4 e6 Nf3 Bb4+ Nbd2 d5 e3 O-O a3 Be7 Bd3 b6 O-O Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 Be7 Nc3 b6 e4 d6 g3 Bb7 d5 Nbd7 Bg2 c6 ",
	"d4 Nf6 c4 e6 Nf3 a6 Nc3 c5 e3 d5 cxd5 exd5 Be2 c4 O-O b5 ",
	"d4 Nf6 c4 e6 Nf3 b6 Bf4 Bb7 e3 Be7 Nc3 Nh5 Bg3 O-O Qc2 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Bf4 Bb7 e3 Be7 Nc3 Nh5 Bg3 O-O Qc2 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Bg5 Bb7 e3 Bxc3+ bxc3 d6 Nd2 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Bg5 Bb7 e3 h6 Bh4 Bxc3+ bxc3 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Bg5 Bb7 e3 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Bg5 h6 Bh4 Bb7 e3 Bxc3+ bxc3 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Qb3 c5 a3 Ba5 Bg5 Bb7 e3 Bxf3 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Qc2 Bb7 Bg5 h6 Bh4 g5 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 Qc2 Bb7 a3 Bxc3+ Qxc3 d6 e3 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 e3 Bb7 Bd3 Ne4 Qc2 f5 O-O Bxc3 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb4 e3 Bb7 Bd3 O-O O-O d5 Bd2 dxc4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 Bb4 e3 h6 Bh4 Bxc3+ bxc3 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 Be7 e3 Ne4 Nxe4 Bxe4 Bf4 c5 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 Be7 e3 c5 Bd3 O-O O-O cxd4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 h6 Bh4 Be7 e3 Ne4 Bg3 Bb4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 Bg5 h6 Bh4 Be7 e3 Ne4 Nxe4 Bxh4 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 Be7 d5 O-O e4 d6 Bd3 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 Be7 d5 exd5 cxd5 O-O g3 a5 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 Be7 e4 Nxc3 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 Nd7 Nxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 Nxc3 Qxc3 Nd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 Nxc3 Qxc3 h6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 Nxc3 bxc3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 c5 e4 Nxc3 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 Qc2 c5 e4 Nxc3 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 e3 Nxc3 bxc3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 Nxd5 e3 Nxc3 bxc3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 exd5 Bg5 Be7 e3 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 exd5 g3 Be7 Qa4+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 Nc3 Bb7 g3 Bb4 Bd2 Nc6 a3 Bxc3 Bxc3 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Ba6 Qc2 Bb7 Nc3 c5 dxc5 bxc5 Bf4 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Ba6 Qc2 Bb7 Nc3 c5 e3 Be7 Bd3 cxd4 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Ba6 Qc2 Bb7 Nc3 c5 e4 cxd4 Nxd4 Bc5 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Ba6 Qc2 Bb7 Nc3 c5 e4 cxd4 Nxd4 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Ba6 Qc2 Bb7 Nc3 c5 e4 cxd4 Nxd4 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Ba6 Qc2 c5 d5 exd5 cxd5 Bb7 e4 Qe7 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 Ne4 Nxe4 Bxe4 Nd2 Bg6 g3 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 Bg5 Be7 e3 Nbd7 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 Qc2 Nbd7 cxd5 Nxd5 Nxd5 Bxd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 Qc2 c5 e4 Nxc3 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 e3 Be7 Bb5+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 e3 Be7 Bb5+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 e3 Be7 Bb5+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 e3 Be7 Bb5+ c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 Nxd5 e3 Nd7 Bd3 N5f6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 exd5 Bf4 Bd6 Bg3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 exd5 Bg5 Be7 Bxf6 Bxf6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 exd5 g3 Bd6 Bg2 O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 exd5 g3 Be7 Bg2 O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 exd5 g3 Nbd7 Bg2 a6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 Be7 Nc3 d5 cxd5 exd5 Bf4 O-O e3 Be6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 c5 d5 Ba6 Qc2 Qe7 Bg5 exd5 Nc3 Bxc4 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 c5 d5 Ba6 Qc2 exd5 cxd5 d6 Nc3 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 c5 d5 Ba6 Qc2 exd5 cxd5 g6 Bf4 d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 c5 d5 Ba6 Qc2 exd5 cxd5 g6 Nc3 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 b6 a3 d5 Nc3 Be7 cxd5 exd5 Bf4 O-O e3 c5 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb4+ Nbd2 c5 a3 Bxd2+ Qxd2 O-O Be2 Ba6 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 Bb4+ Nbd2 O-O a3 Bxd2+ Qxd2 c5 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 Be7 Nc3 d5 O-O O-O b3 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 Be7 O-O O-O b3 d5 Bb2 Nbd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 c5 O-O Be7 Nc3 d5 b3 O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 d5 O-O Bd6 b3 Nbd7 Bb2 O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 e3 Bb7 Bd3 d5 O-O Nbd7 cxd5 exd5 Nc3 Bd6 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 Nbd2 Bb4 Qb3 Nc6 d5 Bxd2+ Bxd2 Ne7 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 Nbd2 Bb7 Bg2 c5 d5 exd5 Nh4 Qc7 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 Nbd2 c5 Bg2 Nc6 e3 Rc8 b3 cxd4 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 Qa4 Bb7 Bg2 c5 dxc5 Bxc5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 Qa4 Bb7 Bg2 c5 dxc5 bxc5 O-O Be7 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Bg2 c6 Bc3 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Bg2 c6 Bc3 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Bg2 c6 Bc3 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Bg2 c6 O-O d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Nc3 Bb7 Bg2 O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Nc3 O-O e4 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Nc3 c6 e4 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Nc3 d5 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Nc3 d5 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Be7 Nc3 d5 cxd5 Nxd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Bxd2+ Qxd2 d5 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 c5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 c5 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 b5 cxb5 Bxb5 Bg2 Bb4+ Bd2 a5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 b5 cxb5 Bxb5 Bg2 Bb4+ Bd2 a5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Ba6 b3 d5 Bg2 dxc4 Ne5 Bb4+ Kf1 Nfd7 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb4+ Bd2 Bxd2+ Qxd2 Ba6 b3 c6 Qf4 d5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb4+ Bd2 a5 Bg2 Ba6 Bxb4 axb4 Ne5 c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb4+ Nbd2 Bb7 Bg2 O-O O-O c5 a3 Bxd2 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Bd2 Bxd2+ Qxd2 O-O Nc3 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Bb4+ Bd2 Bxd2+ Qxd2 O-O O-O d6 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 Nc3 Ne4 Bd2 Bf6 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 Nc3 Ne4 Bd2 Bf6 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 Nc3 Ne4 Bd2 Bf6 O-O O-O ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 Nc3 Ne4 Bd2 O-O d5 f5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 d5 Ne5 Ne4 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O Nc3 d5 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 Be7 O-O O-O d5 exd5 Nh4 c6 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 c5 d5 exd5 Nh4 g6 Nc3 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 b6 g3 Bb7 Bg2 d5 cxd5 Bxd5 O-O Nbd7 Nc3 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 c5 Nc3 Nc6 e3 d5 cxd5 Nxd5 Bc4 Nxc3 bxc3 cxd4 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 Bd6 Nc3 Bc7 Nd2 d6 Nc4 a6 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Bf4 Bg7 Qa4+ Bd7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Bf4 a6 a4 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Bf4 a6 a4 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Bf4 a6 a4 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Bf4 a6 e4 b5 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Nd2 Bg7 Nc4 O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Nd2 Nbd7 e4 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 Nd2 Nbd7 e4 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 e4 Bg7 Be2 O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 e4 Bg7 h3 O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 e4 a6 Bf4 Bg7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 g3 Bg7 Bg2 O-O ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 Nc3 g6 h3 a6 a4 Qe7 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 d6 e4 g6 Nc3 Bg7 Bf4 a6 ",
	"d4 Nf6 c4 e6 Nf3 c5 d5 exd5 cxd5 g6 Nc3 d6 Bf4 a6 e4 b5 ",
	"d4 Nf6 c4 e6 Nf3 c5 e3 cxd4 exd4 b6 Bd3 Bb7 O-O Be7 Nc3 d5 ",
	"d4 Nf6 c4 e6 Nf3 c5 e3 d5 Nc3 Nc6 cxd5 Nxd5 Bc4 cxd4 exd4 Be7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Bb4+ Nc3 Nbd7 e3 c5 Bd3 Qa5 O-O Bxc3 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Bb4+ Nc3 O-O e3 c5 Qb3 Nc6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Be7 e3 O-O Nbd2 Nbd7 Bd3 c5 O-O cxd4 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Be7 e3 O-O Nc3 Nbd7 Bd3 a6 c5 c6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Be7 e3 O-O Nc3 Nbd7 Rc1 c6 Qc2 h6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Nbd7 e3 c6 Nbd2 Be7 Bd3 O-O O-O b6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Bg5 Nbd7 e3 c6 Nbd2 Be7 Bd3 O-O O-O c5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 Bg5 h6 Bh4 dxc4 Qa4+ Nc6 Bxf6 Qxf6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 Bg5 h6 Bh4 dxc4 Qa4+ Nc6 Bxf6 Qxf6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 Bg5 h6 Bxf6 Qxf6 e3 c5 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 cxd5 exd5 Bg5 Nbd7 e3 c5 Bb5 Qb6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 cxd5 exd5 Bg5 Nbd7 e3 c5 Bd3 Qa5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 cxd5 exd5 Bg5 c6 Qc2 Nbd7 e3 Nf8 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 cxd5 exd5 Bg5 h6 Bh4 c5 e3 g5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Bb4 e3 O-O Bd3 c5 O-O Nc6 a3 Ba5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 Qc2 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 a3 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bf4 O-O e3 c5 dxc5 Bxc5 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O Qc2 Ne4 Bxe7 Qxe7 e3 Nxc3 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 Nbd7 Qc2 h6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 Nbd7 Qc2 h6 cxd5 exd5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 Ne4 Bxe7 Qxe7 Rc1 c6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 h6 Bh4 Ne4 Bxe7 Qxe7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 h6 Bh4 b6 Be2 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 h6 Bh4 b6 Be2 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 h6 Bxf6 Bxf6 Qc2 c5 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 O-O e3 h6 Bxf6 Bxf6 Qd2 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bh4 O-O e3 b6 Be2 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bh4 O-O e3 b6 Be2 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bh4 O-O e3 b6 Be2 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bh4 O-O e3 b6 Be2 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bh4 O-O e3 b6 Rc1 Bb7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Qd2 Nc6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Rc1 a6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Rc1 c6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Rc1 c6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Rc1 c6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Rc1 c6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Be7 cxd5 exd5 Bg5 c6 Qc2 g6 e4 dxe4 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Nbd7 Bg5 Be7 e3 O-O Rc1 c6 Qc2 a6 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 Nbd7 cxd5 exd5 Bf4 c6 Qc2 Be7 h3 O-O ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c5 cxd5 Nxd5 e3 Nc6 Bc4 Nxc3 bxc3 Be7 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 Bg5 Nbd7 e3 Qa5 Nd2 Bb4 Qc2 dxc4 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 c6 e3 Nbd7 Be2 Bd6 O-O O-O b3 dxc4 ",
	"d4 Nf6 c4 e6 Nf3 d5 Nc3 dxc4 e3 a6 Bxc4 b5 Bb3 Bb7 O-O c5 ",
	"d4 Nf6 c4 e6 Nf3 d5 g3 Bb4+ Bd2 Be7 Bg2 O-O O-O c6 Qb3 a5 ",
	"d4 Nf6 c4 e6 Nf3 d5 g3 Bb4+ Bd2 Be7 Bg2 c6 Qc2 O-O O-O b6 ",
	"d4 Nf6 c4 e6 Nf3 d5 g3 Be7 Bg2 O-O O-O dxc4 Qc2 a6 Qxc4 b5 ",
	"d4 Nf6 c4 e6 e3 d5 Nc3 c6 Bd3 Nbd7 Nf3 Bb4 O-O O-O Qc2 Qe7 ",
	"d4 Nf6 c4 e6 g3 Bb4+ Bd2 Bxd2+ Qxd2 Ne4 Qc2 f5 Bg2 d5 Nf3 O-O ",
	"d4 Nf6 c4 e6 g3 Bb4+ Bd2 Bxd2+ Qxd2 O-O Bg2 d6 Nc3 Nc6 Nf3 e5 ",
	"d4 Nf6 c4 e6 g3 Bb4+ Bd2 Bxd2+ Qxd2 O-O Bg2 d6 Nf3 Nc6 d5 Ne7 ",
	"d4 Nf6 c4 e6 g3 Bb4+ Bd2 Qe7 Bg2 O-O Nf3 Bxd2+ Qxd2 d6 O-O e5 ",
	"d4 Nf6 c4 e6 g3 Bb4+ Bd2 Qe7 Nf3 Nc6 Nc3 O-O Bg2 Bxc3 Bxc3 Ne4 ",
	"d4 Nf6 c4 e6 g3 Bb4+ Bd2 Qe7 Nf3 Nc6 Nc3 d5 a3 Bxc3 Bxc3 Ne4 ",
	"d4 Nf6 c4 e6 g3 Bb4+ Nd2 O-O Bg2 d5 Qc2 Nbd7 Nf3 c6 O-O Re8 ",
	"d4 Nf6 c4 e6 g3 Bb4+ Nd2 d5 Bg2 Nc6 Nf3 dxc4 Qc2 Bxd2+ Bxd2 Nxd4 ",
	"d4 Nf6 c4 e6 g3 c5 Nf3 cxd4 Nxd4 Bb4+ Nc3 O-O Bg2 d5 O-O dxc4 ",
	"d4 Nf6 c4 e6 g3 c5 d5 exd5 cxd5 b5 Bg2 d6 b4 Na6 bxc5 Nxc5 ",
	"d4 Nf6 c4 e6 g3 c5 d5 exd5 cxd5 b5 Bg2 d6 b4 Na6 bxc5 Nxc5 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 Be7 Nf3 O-O O-O dxc4 Qc2 a6 Qxc4 b5 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 Be7 Nf3 O-O Qc2 dxc4 Qxc4 a6 Bf4 Bd6 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 Bd7 Ne5 Bc6 Nxc6 Nxc6 e3 Nd5 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 Bd7 Qc2 c5 O-O Bc6 Qxc4 Nbd7 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 Bd7 Qc2 c5 O-O Bc6 Qxc4 Nbd7 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 Nbd7 O-O Rb8 a4 b6 Nfd2 e5 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 Nbd7 O-O Rb8 a4 b6 Nfd2 e5 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 c5 O-O Nc6 Ne5 Bd7 Na3 cxd4 ",
	"d4 Nf6 c4 e6 g3 d5 Bg2 dxc4 Nf3 c5 O-O Nc6 Ne5 Bd7 Na3 cxd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Bg5 d6 e3 O-O Be2 Nbd7 Nf3 c6 O-O Qc7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 d5 Bf4 c6 e3 Ne4 cxd5 Nxc3 bxc3 Qxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 d6 Bf4 Nbd7 h3 c5 e3 O-O Be2 b6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 Nf3 d6 g3 Nbd7 Bg2 O-O O-O e5 e4 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Be3 d6 f3 c5 d5 e6 dxe6 Bxe6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Be3 d6 f3 e5 Nge2 c6 Qb3 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Nf3 d6 Be2 Nbd7 Be3 e5 O-O c6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Nf3 d6 Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 O-O Nf3 d6 Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 a6 a4 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 b5 cxb5 a6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 e6 Nf3 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 h6 Be3 e6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 c5 d5 h6 Be3 e6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Bg5 h6 Be3 e5 d5 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 Nbd7 O-O e5 Be3 c6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 Be3 c6 O-O exd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 Be3 h6 O-O Ng4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 Be3 Ng4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 d5 Nbd7 Bg5 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 d5 Nbd7 Bg5 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O Nf3 e5 d5 Nbd7 Bg5 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 O-O g4 c5 d5 e6 g5 Ne8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Be2 c5 Nf3 Nc6 d5 Nb4 O-O Nd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 c5 O-O Bg4 d5 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 Na6 O-O Ng4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 Ng4 Bg5 f6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 Qe7 d5 Ng4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 Qe7 d5 Ng4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 Qe7 dxe5 dxe5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 Be3 h6 h3 exd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nbd7 Re1 c6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 Be3 Ng4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 O-O c6 Re1 exd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 d5 Nbd7 Bg5 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 d5 Nbd7 Bg5 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 d5 Nbd7 Bg5 h6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nf3 O-O Be2 e5 d5 Nh5 g3 Na6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 Nge2 O-O g3 Nbd7 Bg2 e5 O-O Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 Nfd7 Nge2 e5 Be3 Bh6 Bf2 O-O ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nbd7 Nge2 a6 Qd2 c5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nbd7 Nh3 c5 d5 Ne5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nbd7 Qd2 c5 d5 Ne5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nbd7 Qd2 c5 d5 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nbd7 Qd2 c5 d5 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nbd7 Qd2 c5 d5 a6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nbd7 Qd2 e5 d5 Ne8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Nge2 Rb8 Qd2 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Nge2 a6 Nc1 e5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Nge2 a6 Qd2 Rb8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Nge2 a6 h4 h5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Qd2 a6 Bd3 e5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Qd2 a6 Nge2 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 Nc6 Qd2 a6 Nge2 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 a6 Bd3 Nc6 Nge2 Rb8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 a6 Bd3 Nc6 Nge2 Rb8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 a6 Bd3 Nfd7 Qd2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 a6 Qd2 Nc6 Nge2 Rb8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 b6 Bd3 Bb7 Nh3 e5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 b6 Bd3 Nfd7 Nge2 c5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 c6 Bd3 a6 Nge2 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 c6 Bd3 e5 Nge2 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 c6 Bd3 e5 d5 b5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 c6 Bd3 e5 d5 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 Nge2 a6 Qd2 Bd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 Nge2 c6 Qb3 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 Nge2 c6 Qd2 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 Nge2 c6 d5 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 Nge2 c6 d5 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Ne8 Qd2 f5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Ne8 Qd2 f5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Nh5 Qd2 Qh4+ ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Nh5 Qd2 Qh4+ ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Nh5 Qd2 c6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Nh5 Qd2 f5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 Nh5 Qd2 f5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c5 Qd2 Ne8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c5 g4 h5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Bd3 b5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Bd3 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Nge2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Qd2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Qd2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Qd2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Be3 e5 d5 c6 Qd2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Bg5 c5 d5 e6 Nge2 exd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Bg5 c6 Qd2 a6 h4 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Nge2 c5 d5 a6 a4 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Nge2 c6 Bg5 Nbd7 Qd2 Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 O-O Nge2 e5 Be3 exd4 Nxd4 c6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 a6 Be3 c6 c5 b5 cxd6 exd6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 c5 dxc5 dxc5 Qxd8+ Kxd8 e5 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 c6 Be3 Nbd7 Bd3 a6 Nge2 O-O ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 Nge2 O-O Bg5 c6 Qd2 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 Nge2 O-O Bg5 exd4 Nxd4 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 Nge2 O-O Bg5 h6 Be3 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 d5 Nh5 Be3 Na6 Qd2 Qh4+ ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 d5 Nh5 Be3 O-O Qd2 f5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 d5 Nh5 Be3 f5 Qd2 Na6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 d5 O-O Be3 c6 Qd2 cxd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f3 e5 dxe5 dxe5 Qxd8+ Kxd8 Be3 Be6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f4 O-O Nf3 c5 Be2 cxd4 Nxd4 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f4 O-O Nf3 c5 d5 e6 Be2 exd5 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 f4 c5 dxc5 Qa5 Bd3 Qxc5 Nf3 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 g3 Nbd7 Bg2 e5 Nge2 O-O O-O Re8 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 g3 O-O Bg2 Nbd7 Nge2 c5 O-O cxd4 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 g3 O-O Bg2 Nc6 Nge2 Bg4 f3 Bd7 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 e4 d6 g3 O-O Bg2 e5 Nge2 Bg4 f3 Be6 ",
	"d4 Nf6 c4 g6 Nc3 Bg7 g3 O-O Bg2 d6 Nf3 Nbd7 O-O e5 h3 a6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 Nf3 O-O Rc1 c6 e3 Be6 Ng5 Bf5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 Rc1 Nh5 Bg5 h6 Bh4 c5 Nxd5 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 Rc1 O-O e3 c6 Nf3 Be6 Ng5 Bf5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 O-O Qb3 c5 dxc5 Ne4 cxd5 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 O-O Qb3 dxc4 Bxc4 Nbd7 Nf3 Nb6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 O-O cxd5 Nxd5 Nxd5 Qxd5 Bxc7 Bf5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 O-O cxd5 Nxd5 Nxd5 Qxd5 Bxc7 Na6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 O-O cxd5 Nxd5 Nxd5 Qxd5 Bxc7 Na6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 c5 dxc5 Qa5 Rc1 Ne4 cxd5 Nxc3 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 c5 dxc5 Qa5 Rc1 Ne4 cxd5 Nxc3 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 c5 dxc5 Qa5 Rc1 Ne4 cxd5 Nxc3 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 c5 dxc5 Qa5 Rc1 Ne4 cxd5 Nxc3 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 c5 dxc5 Qa5 Rc1 dxc4 Bxc4 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 Bf4 Bg7 e3 c6 Qb3 O-O Nf3 Qa5 Rc1 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bg5 Ne4 Bh4 Nxc3 bxc3 dxc4 e3 Be6 Be2 Bg7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bg5 Ne4 Bh4 Nxc3 bxc3 dxc4 e3 Be6 Be2 Bg7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bg5 Ne4 Bh4 c5 e3 Bg7 Nf3 Nxc3 bxc3 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bg5 Ne4 Bh4 c5 e3 Bg7 cxd5 Nxc3 bxc3 Qxd5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Bg5 Ne4 cxd5 Nxg5 h4 Ne4 Nxe4 Qxd5 Nc3 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bf4 O-O Rc1 c5 dxc5 dxc4 Qxd8 Rxd8 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bf4 O-O e3 c5 dxc5 Qa5 Rc1 Ne4 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bg5 Ne4 Bh4 Nxc3 bxc3 c5 cxd5 Qxd5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bg5 Ne4 Bh4 Nxc3 bxc3 c5 cxd5 Qxd5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bg5 Ne4 cxd5 Nxg5 Nxg5 e6 Nf3 exd5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Bg5 Ne4 cxd5 Nxg5 Nxg5 e6 Nf3 exd5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qa4+ Bd7 Qb3 dxc4 Qxc4 O-O Bf4 c6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qa4+ c6 cxd5 Nxd5 e4 Nb6 Qd1 Bg4 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 c6 Bf4 O-O e3 dxc4 Bxc4 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 c6 Bf4 dxc4 Qxc4 Be6 Qd3 Nd5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be2 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Bg4 Be3 Nfd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Na6 Be2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Na6 Be2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 Nc6 Be2 Bg4 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 a6 Be2 b5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 a6 Be2 b5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 a6 Qb3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 a6 Qb3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 c5 Qxc5 Bg4 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 c6 Be2 b5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 Qb3 dxc4 Qxc4 O-O e4 c6 Qb3 Qb6 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 cxd5 Nxd5 Bd2 c5 Rc1 Nxc3 Bxc3 cxd4 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 cxd5 Nxd5 g3 Nxc3 bxc3 c5 Bg2 cxd4 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 e3 O-O Bd2 e6 Rc1 Qe7 Be2 Rd8 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 e3 O-O cxd5 Nxd5 Bc4 Nb6 Bb3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 e3 O-O cxd5 Nxd5 Bc4 Nxc3 bxc3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 Nf3 Bg7 e3 c6 Bd3 O-O O-O e6 b3 Nbd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 Qb3 dxc4 Qxc4 Bg7 e4 O-O Be2 Nc6 Nf3 Nd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nb6 h3 Bg7 Nf3 O-O Be2 a5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bb5+ Nd7 Nf3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Be3 b6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Be3 b6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Be3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 Qd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 O-O Ne2 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 b6 Nf3 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 Nc6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Bc4 c5 Ne2 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Be3 c5 Qd2 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Nf3 b6 Bb5+ c6 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Nf3 c5 Bb5+ Bd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Nf3 c5 Bb5+ Bd7 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Nf3 c5 Be3 Qa5 ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Nf3 c5 Rb1 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Nf3 c5 Rb1 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Nf3 c5 Rb1 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 Bg7 Qa4+ Nd7 Nf3 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Bc4 Bg7 Ne2 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 e4 Nxc3 bxc3 c5 Bc4 Bg7 Ne2 O-O ",
	"d4 Nf6 c4 g6 Nc3 d5 cxd5 Nxd5 g3 Bg7 Bg2 Nxc3 bxc3 O-O e3 c5 ",
	"d4 Nf6 c4 g6 Nc3 d5 e3 Bg7 Nf3 O-O Be2 b6 O-O Bb7 Ne5 dxc4 ",
	"d4 Nf6 c4 g6 Nc3 d6 e4 Bg7 f3 O-O Be3 e5 Nge2 Ne8 Qd2 f5 ",
	"d4 Nf6 c4 g6 Nc3 d6 g3 Bg7 Bg2 O-O Nf3 c5 d5 e5 O-O Na6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 Nc3 d5 e3 O-O cxd5 Nxd5 Bc4 Nxc3 bxc3 c5 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 c6 Nc3 d6 O-O Qa5 h3 Be6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d5 O-O Nc6 cxd5 Nxd5 Nc3 Nb6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d5 cxd5 Nxd5 O-O Nb6 Nc3 Nc6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d5 cxd5 Nxd5 O-O c5 e4 Nb6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d5 cxd5 Nxd5 O-O c5 e4 Nf6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d5 cxd5 Nxd5 O-O c5 e4 Nf6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d6 Nc3 Bg4 h3 Bxf3 Bxf3 Nc6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d6 Nc3 Nbd7 O-O e5 e4 c6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d6 Nc3 c6 O-O Qa5 h3 e5 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d6 O-O Nbd7 Nc3 e5 e4 Re8 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d6 O-O Nbd7 Nc3 e5 e4 c6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 O-O Bg2 d6 O-O Nc6 Nc3 a6 Bg5 Rb8 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 c5 d5 b5 Bg2 bxc4 Ne5 d6 Nxc4 O-O ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 c6 Bg2 d5 cxd5 Nxd5 O-O O-O Nc3 Nxc3 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 c6 Bg2 d5 cxd5 cxd5 Nc3 O-O Ne5 e6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 c6 Bg2 d5 cxd5 cxd5 Nc3 O-O Ne5 e6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 c6 Bg2 d5 cxd5 cxd5 Nc3 O-O Ne5 e6 ",
	"d4 Nf6 c4 g6 Nf3 Bg7 g3 d6 Bg2 O-O O-O Nc6 Nc3 a6 d5 Na5 ",
	"d4 Nf6 c4 g6 f3 Bg7 e4 d6 Nc3 O-O Be3 e5 Nge2 Nc6 Qd2 Nd7 ",
	"d4 Nf6 c4 g6 f3 d5 cxd5 Nxd5 e4 Nb6 Nc3 Bg7 Be3 O-O Qd2 Nc6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 c5 Nf3 Nc6 O-O d6 e3 Bf5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nbd7 O-O e5 e4 c6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nc6 O-O Bg4 d5 Na5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nc6 O-O a6 e3 Rb8 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nc6 d5 Na5 Nd2 c5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nc6 d5 Na5 Nd2 c5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 Nc6 h3 e5 O-O exd4 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 Nf3 c5 d5 Na6 O-O Nc7 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 e3 Nbd7 Nge2 e5 b3 Re8 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nc3 d6 e3 Nbd7 Nge2 e5 b3 Re8 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nf3 c5 d5 e6 Nc3 d6 O-O exd5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nf3 d6 O-O Nc6 Nc3 a6 Nd5 e6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 O-O Nf3 d6 O-O c5 Nc3 Nc6 d5 Na5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 Nc3 Nb6 e3 O-O Nge2 a5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 Nf3 O-O O-O Nc6 e4 Nb6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 Nf3 O-O O-O c5 e4 Nf6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 Nf3 O-O O-O c5 e4 Nf6 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 e4 Nb4 a3 N4c6 d5 Nd4 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 e4 Nb4 d5 c6 a3 Qa5 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d5 cxd5 Nxd5 e4 Nb6 Ne2 Nc6 d5 Nb8 ",
	"d4 Nf6 c4 g6 g3 Bg7 Bg2 d6 Nf3 O-O O-O Nbd7 Nc3 e5 e4 exd4 ",
	"d4 Nf6 c4 g6 g3 c6 Bg2 d5 cxd5 cxd5 Nc3 Bg7 Nh3 Bxh3 Bxh3 Nc6 ",
	"d4 Nf6 c4 g6 g3 c6 d5 Bg7 Bg2 d6 Nc3 O-O e4 e5 Nge2 c5 ",
	"d4 Nf6 c4 g6 g3 d5 cxd5 Nxd5 e4 Nb6 Bg2 Bg7 Ne2 O-O Nbc3 Nc6 ",
	"d4 Nf6 g3 d5 Bg2 c6 Nf3 Bg4 O-O Nbd7 Nbd2 e6 c3 Bd6 Qc2 O-O ",
	"d4 a6 e4 d5 exd5 Qxd5 Nc3 Qa5 Nf3 e6 Bd3 c6 O-O Nf6 Qe2 Be7 ",
	"d4 b5 e4 Bb7 f3 a6 Be3 e6 Nd2 Nf6 c3 Be7 Bd3 d6 a4 c6 ",
	"d4 b5 e4 Bb7 f3 a6 c4 bxc4 Bxc4 e6 Nc3 d5 Qb3 Nc6 exd5 Nxd4 ",
	"d4 c5 d5 d6 c4 e5 dxe6 Bxe6 e4 Nf6 Nc3 Nc6 Nf3 Be7 Be2 O-O ",
	"d4 c5 d5 d6 c4 e5 e4 Be7 Nf3 Bg4 Nbd2 Na6 Be2 Nf6 a3 O-O ",
	"d4 c5 d5 d6 c4 g6 Nc3 Bg7 e4 Nf6 Nf3 O-O Be2 e6 O-O Re8 ",
	"d4 c5 d5 d6 c4 g6 g3 Bg7 Bg2 Nf6 e4 O-O Ne2 Nbd7 f4 Nb6 ",
	"d4 c5 d5 d6 e4 g6 Nf3 Bg7 Bb5+ Nd7 O-O Nf6 Re1 O-O a4 a6 ",
	"d4 c5 d5 d6 e4 g6 Nf3 Bg7 Be2 Nf6 Nc3 Na6 O-O Nc7 a4 a6 ",
	"d4 c5 d5 e5 e4 d6 f4 exf4 Bxf4 Ne7 Bb5+ Bd7 Bxd7+ Nxd7 Bxd6 Qb6 ",
	"d4 c5 e4 cxd4 Nf3 Nf6 e5 Ne4 Qxd4 d5 Nbd2 Nc6 Bb5 Bf5 O-O a6 ",
	"d4 c6 c4 Nf6 Nc3 d5 Nf3 g6 cxd5 cxd5 Bf4 Nc6 e3 Bg7 Be2 O-O ",
	"d4 c6 c4 d5 Nf3 Nf6 Nc3 dxc4 e4 b5 e5 Nd5 a4 Nxc3 bxc3 a6 ",
	"d4 c6 e4 d5 e5 Bf5 Nf3 e6 Be2 c5 O-O Nc6 c3 cxd4 cxd4 Nge7 ",
	"d4 d5 Bf4 e6 e3 Bd6 Bg3 Nf6 Nd2 c5 c3 Nc6 Ngf3 Qe7 Ne5 Bxe5 ",
	"d4 d5 Bf4 e6 e3 Nf6 Nd2 Bd6 Ngf3 b6 Bd3 Bb7 O-O O-O c3 c5 ",
	"d4 d5 Bf4 e6 e3 c5 c3 Nc6 Nf3 Bd6 Bg3 Nf6 Nbd2 Qe7 Ne5 Bxe5 ",
	"d4 d5 Bg5 c6 e3 h6 Bh4 Qb6 Qc1 e5 c3 Nd7 Nf3 e4 Nfd2 f5 ",
	"d4 d5 Nc3 Nf6 Bg5 Bf5 e3 Nbd7 Bd3 Bxd3 Qxd3 c6 Nf3 e6 e4 dxe4 ",
	"d4 d5 Nc3 Nf6 Bg5 c6 Nf3 Nbd7 e3 g6 Bd3 Bg7 O-O O-O Re1 Re8 ",
	"d4 d5 Nf3 Bf5 c4 e6 cxd5 exd5 Qb3 Nc6 Bg5 Be7 Bxe7 Ngxe7 e3 Qd6 ",
	"d4 d5 Nf3 Bf5 c4 e6 cxd5 exd5 Qb3 Nc6 Bg5 Be7 Bxe7 Ngxe7 e3 Qd6 ",
	"d4 d5 Nf3 Bg4 Ne5 Bf5 c4 f6 Nf3 e6 Qb3 b6 Nc3 c6 a4 Na6 ",
	"d4 d5 Nf3 Bg4 e3 e6 c4 Nc6 Nc3 Bb4 Qb3 Nge7 Bd2 O-O cxd5 Nxd5 ",
	"d4 d5 Nf3 Nc6 b3 g6 Bb2 Bg7 Nbd2 Nf6 g3 Bg4 Bg2 Qc8 h3 Bf5 ",
	"d4 d5 Nf3 Nf6 Bf4 Nbd7 Nc3 c6 e3 e6 Bd3 Bb4 O-O h6 Qe2 O-O ",
	"d4 d5 Nf3 Nf6 Bf4 e6 e3 c5 c3 Nc6 Bd3 Bd6 Bxd6 Qxd6 Nbd2 e5 ",
	"d4 d5 Nf3 Nf6 Bg5 e6 Nbd2 Be7 e3 Nbd7 Bd3 h6 Bh4 O-O Qe2 c5 ",
	"d4 d5 Nf3 Nf6 Bg5 e6 Nbd2 Be7 e3 O-O Bd3 Nbd7 c3 c5 Ne5 h6 ",
	"d4 d5 Nf3 Nf6 Bg5 e6 Nbd2 Be7 e3 b6 c3 Bb7 Ne5 O-O Bd3 Nbd7 ",
	"d4 d5 Nf3 Nf6 Bg5 e6 e3 c5 Nbd2 Nbd7 c3 Be7 Bd3 b6 Ne5 Bb7 ",
	"d4 d5 Nf3 Nf6 c4 Bf5 cxd5 Nxd5 Nbd2 Nf6 Qb3 Qc8 g3 g6 Bg2 c6 ",
	"d4 d5 Nf3 Nf6 c4 c5 cxd5 cxd4 Nxd4 Nxd5 e4 Nb4 Be3 a6 Qa4+ N4c6 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 Bf5 cxd5 Nxd5 Nd2 Bg6 e4 Nf6 e5 Nd5 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 Nbd7 cxd5 cxd5 Bf4 e6 e3 Bb4 Bd3 Ne4 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 Qb6 Qc2 Bg4 Bg5 Nbd7 e3 Ne4 Bf4 e6 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 dxc4 a4 Bf5 Nh4 Bc8 Nf3 Bf5 e3 e6 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 e6 Bg5 Nbd7 e3 Qa5 Nd2 Bb4 Qc2 e5 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 e6 Bg5 Nbd7 e3 Qa5 cxd5 Nxd5 Qd2 Bb4 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 e6 Bg5 Nbd7 e3 Qa5 cxd5 Nxd5 Qd2 Bb4 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 e6 Bg5 Nbd7 e3 Qa5 cxd5 Nxd5 Qd2 Bb4 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 e6 Bg5 Nbd7 e3 Qa5 cxd5 Nxd5 Qd2 Bb4 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 e6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 Nf3 Nf6 c4 c6 Nc3 e6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 Nf3 Nf6 c4 c6 Qb3 dxc4 Qxc4 Bf5 g3 e6 Bg2 Nbd7 Nc3 Be7 ",
	"d4 d5 Nf3 Nf6 c4 c6 Qb3 e6 g3 Be7 Bg2 Qa5+ Nbd2 O-O O-O c5 ",
	"d4 d5 Nf3 Nf6 c4 c6 cxd5 cxd5 Nc3 Nc6 Bf4 Qa5 e3 Ne4 Qb3 e6 ",
	"d4 d5 Nf3 Nf6 c4 c6 cxd5 cxd5 Nc3 Nc6 Bf4 e6 e3 Be7 Bd3 O-O ",
	"d4 d5 Nf3 Nf6 c4 c6 cxd5 cxd5 Nc3 Nc6 Bf4 e6 e3 Be7 Bd3 O-O ",
	"d4 d5 Nf3 Nf6 c4 c6 e3 Bf5 Nc3 e6 Be2 Ne4 O-O Be7 Qb3 Qb6 ",
	"d4 d5 Nf3 Nf6 c4 c6 e3 e6 Nc3 Nbd7 Ne5 Nxe5 dxe5 Nd7 f4 Bb4 ",
	"d4 d5 Nf3 Nf6 c4 c6 e3 g6 Nc3 Bg7 Bd3 O-O O-O Bg4 h3 Bxf3 ",
	"d4 d5 Nf3 Nf6 c4 c6 e3 g6 Nc3 Bg7 Be2 O-O O-O e6 b4 b6 ",
	"d4 d5 Nf3 Nf6 c4 dxc4 Qa4+ Nbd7 Qxc4 e6 g3 a6 Bg2 b5 Qc6 Ra7 ",
	"d4 d5 Nf3 Nf6 c4 dxc4 e3 c5 Bxc4 e6 Nc3 a6 O-O b5 Bd3 Bb7 ",
	"d4 d5 Nf3 Nf6 c4 dxc4 e3 e6 Bxc4 Be7 O-O O-O Nc3 b6 Qe2 Bb7 ",
	"d4 d5 Nf3 Nf6 c4 dxc4 e3 e6 Bxc4 a6 O-O c5 a4 b6 Qe2 Bb7 ",
	"d4 d5 Nf3 Nf6 c4 dxc4 e3 e6 Bxc4 c5 O-O Nc6 Qe2 cxd4 Rd1 a6 ",
	"d4 d5 Nf3 Nf6 c4 dxc4 e3 e6 Bxc4 c5 O-O a6 a4 cxd4 exd4 Be7 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 Be7 Nc3 c5 dxc5 Qa5 cxd5 exd5 e3 Nc6 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 Be7 Nc3 dxc4 e3 a6 Bxc4 b5 Bd3 Bb7 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 Be7 e3 Nbd7 Nc3 O-O Rc1 c6 Qc2 b6 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 Be7 e3 O-O Nc3 Nbd7 Qc2 c5 Rd1 Qa5 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 Nbd7 e3 Be7 Nc3 O-O Rc1 Re8 Qc2 a6 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 Nbd7 e3 Be7 Nc3 O-O Rc1 Re8 a3 a6 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 Nbd7 e3 Be7 Nc3 O-O Rc1 b6 cxd5 exd5 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 Nbd7 e3 Be7 Nc3 O-O Rc1 b6 cxd5 exd5 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 Nbd7 e3 c6 Nbd2 Be7 Bd3 dxc4 Nxc4 O-O ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 c5 cxd5 exd5 Nc3 cxd4 Nxd4 Nc6 e3 Be7 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 c5 cxd5 exd5 Nc3 cxd4 Nxd4 Nc6 e3 Be7 ",
	"d4 d5 Nf3 Nf6 c4 e6 Bg5 h6 Bh4 dxc4 e3 b5 a4 c6 Be2 Bb4+ ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Bb4 e3 O-O Bd3 Nc6 a3 Bxc3+ bxc3 Na5 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Be7 Bf4 O-O c5 b6 b4 a5 a3 Ne4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Be7 Bf4 O-O e3 Nbd7 Bd3 c6 Qc2 dxc4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Be7 Bg5 Nbd7 e3 O-O Rc1 a6 c5 Ne4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Be7 Bg5 Nbd7 e3 O-O Rc1 c6 Qc2 dxc4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Be7 Bg5 O-O e3 Nbd7 Rc1 c6 Bd3 dxc4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bf4 Bb4 e3 O-O Qb3 c5 Nd2 Re8 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bg5 Be7 e3 O-O Bd3 c6 O-O a6 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bg5 Be7 e3 O-O Qc2 Re8 Rc1 c6 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bg5 Be7 e3 O-O Rc1 Re8 Bd3 dxc4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bg5 Be7 e3 O-O Rc1 b6 cxd5 exd5 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bg5 Be7 e3 O-O Rc1 c6 Bd3 h6 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 Nbd7 Bg5 Be7 e3 c6 Bd3 dxc4 Bxc4 b5 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 c5 cxd5 Nxd5 e3 Nc6 Bc4 Nxc3 bxc3 cxd4 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Bb4+ ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 c5 cxd5 exd5 g3 Nc6 Bg2 Be6 O-O Be7 ",
	"d4 d5 Nf3 Nf6 c4 e6 Nc3 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 Nf3 Nf6 c4 e6 cxd5 exd5 Nc3 Bd6 Bg5 c6 Qc2 O-O e3 Re8 ",
	"d4 d5 Nf3 Nf6 c4 e6 g3 Be7 Bg2 O-O O-O Nbd7 Qc2 c6 Rd1 Ne4 ",
	"d4 d5 Nf3 Nf6 c4 e6 g3 dxc4 Bg2 Bd7 Nbd2 Bb4 Qc2 Bb5 O-O Bxd2 ",
	"d4 d5 Nf3 Nf6 c4 e6 g3 dxc4 Bg2 Be7 Nbd2 Nbd7 O-O O-O Nxc4 Nb6 ",
	"d4 d5 Nf3 Nf6 c4 e6 g3 dxc4 Qa4+ Qd7 Qxc4 Qc6 Nbd2 Qxc4 Nxc4 Bb4+ ",
	"d4 d5 Nf3 Nf6 e3 Bf5 c4 c6 Nc3 e6 Bd3 Bxd3 Qxd3 Bd6 e4 dxe4 ",
	"d4 d5 Nf3 Nf6 e3 Bf5 c4 e6 Qb3 Nc6 c5 Rb8 Bb5 Be7 Ne5 O-O ",
	"d4 d5 Nf3 Nf6 e3 Nbd7 Bd3 e6 b3 Bd6 Bb2 c5 Ne5 Qc7 f4 b6 ",
	"d4 d5 Nf3 Nf6 e3 c6 c4 e6 Nc3 Nbd7 Bd3 Bd6 O-O O-O e4 dxe4 ",
	"d4 d5 Nf3 Nf6 e3 e6 Bd3 c5 b3 Nc6 Bb2 cxd4 exd4 Bd6 O-O O-O ",
	"d4 d5 Nf3 Nf6 e3 e6 Bd3 c5 b3 Nc6 O-O Bd6 Bb2 Qe7 Ne5 cxd4 ",
	"d4 d5 Nf3 Nf6 e3 e6 Bd3 c5 b3 cxd4 exd4 Nc6 O-O Bd6 a3 Qc7 ",
	"d4 d5 Nf3 Nf6 g3 Bf5 Bg2 h6 c4 c6 cxd5 cxd5 Qb3 Qb6 Qxb6 axb6 ",
	"d4 d5 Nf3 c5 c3 Nf6 e3 Nc6 dxc5 e5 b4 Qc7 Bb2 Be6 Nbd2 Be7 ",
	"d4 d5 Nf3 c5 c3 e6 Bf4 Nc6 e3 Bd6 Bg3 Bxg3 hxg3 Qd6 Nbd2 Nf6 ",
	"d4 d5 Nf3 c5 c4 Nf6 cxd5 cxd4 Nxd4 Nxd5 e4 Nf6 Nc3 e5 Bb5+ Bd7 ",
	"d4 d5 Nf3 c5 c4 dxc4 Nc3 cxd4 Qxd4 Qxd4 Nxd4 Bd7 Ndb5 Na6 e4 Nf6 ",
	"d4 d5 Nf3 c5 c4 dxc4 e3 Nf6 Bxc4 e6 O-O a6 Qe2 b5 Bb3 Bb7 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 Nc3 Nc6 Bf4 cxd4 Nxd4 Bb4 e3 Bxc3+ ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 Nc3 Nc6 g3 Be6 Bg2 Be7 O-O Rc8 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 Nc3 Nc6 g3 Be6 Bg2 Be7 O-O Rc8 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 Nc3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 Nc3 Nc6 g3 Nf6 Bg2 Ne4 O-O Be7 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 Nc3 Nc6 g3 Nf6 Bg2 cxd4 Nxd4 Bc5 ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 g3 Nc6 Bg2 Nf6 Nc3 Be7 O-O O-O ",
	"d4 d5 Nf3 c5 c4 e6 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 dxc5 Bxc5 ",
	"d4 d5 Nf3 c5 dxc5 e6 Bg5 f6 Bd2 Bxc5 c4 Ne7 e3 O-O Nc3 Nbc6 ",
	"d4 d5 Nf3 c5 dxc5 e6 e4 Bxc5 exd5 exd5 Bb5+ Nc6 O-O Ne7 Nbd2 O-O ",
	"d4 d5 Nf3 c5 dxc5 e6 e4 Bxc5 exd5 exd5 Bb5+ Nc6 O-O Ne7 Nbd2 O-O ",
	"d4 d5 Nf3 c5 e3 Nc6 a3 f5 dxc5 e6 b4 Nf6 Bb2 Be7 Nbd2 O-O ",
	"d4 d5 Nf3 c5 e3 Nc6 b3 e6 Bb2 Nf6 Nbd2 cxd4 exd4 Bd6 Bd3 O-O ",
	"d4 d5 Nf3 c5 e3 Nc6 c4 cxd4 cxd5 Qxd5 Nc3 Qa5 Nxd4 Nxd4 Qxd4 e5 ",
	"d4 d5 Nf3 c5 e3 c4 Nc3 f5 Ne5 Nf6 b3 cxb3 axb3 e6 Bb5+ Bd7 ",
	"d4 d5 Nf3 c5 e3 e6 Bd3 Nf6 O-O Bd6 b3 O-O Bb2 Nc6 Nbd2 b6 ",
	"d4 d5 Nf3 c5 e3 e6 Bd3 Nf6 b3 Nc6 Bb2 cxd4 exd4 Bd6 O-O O-O ",
	"d4 d5 Nf3 c5 e3 e6 b3 Nc6 Bb2 Nf6 Bd3 Bd6 O-O O-O Nbd2 Re8 ",
	"d4 d5 Nf3 c5 e3 e6 b3 Nf6 Bd3 Nbd7 O-O Bd6 Bb2 O-O Nbd2 Qc7 ",
	"d4 d5 Nf3 c6 c4 dxc4 e3 b5 a4 Bb7 b3 cxb3 axb5 e6 Qxb3 Bd6 ",
	"d4 d5 Nf3 e6 Bf4 Bd6 Bg3 Nf6 e3 O-O Nbd2 c5 c3 Nc6 Bd3 Ng4 ",
	"d4 d5 Nf3 e6 c4 Be7 cxd5 exd5 Nc3 Nf6 Bg5 O-O Qc2 c6 e3 Re8 ",
	"d4 d5 Nf3 e6 c4 Nd7 Nc3 Ngf6 Bg5 Bb4 cxd5 exd5 Qa4 Bxc3+ bxc3 O-O ",
	"d4 d5 Nf3 e6 c4 Nf6 Bg5 Be7 Nc3 Nbd7 e3 O-O Qc2 b6 cxd5 exd5 ",
	"d4 d5 Nf3 e6 c4 Nf6 Bg5 Be7 Nc3 Nbd7 e3 c6 Bd3 dxc4 Bxc4 Nd5 ",
	"d4 d5 Nf3 e6 c4 Nf6 Bg5 Nbd7 e3 Be7 Nc3 O-O Rc1 Re8 Qc2 c6 ",
	"d4 d5 Nf3 e6 c4 Nf6 Nc3 Be7 Bf4 O-O Qc2 c6 e3 b6 a3 Bb7 ",
	"d4 d5 Nf3 e6 c4 Nf6 Nc3 Be7 e3 b6 Bd3 O-O O-O Bb7 Qe2 Nbd7 ",
	"d4 d5 Nf3 e6 c4 Nf6 Nc3 Nbd7 Bg5 Be7 e3 O-O Rc1 a6 Qc2 Re8 ",
	"d4 d5 Nf3 e6 c4 a6 cxd5 exd5 Nc3 Be7 Bf4 Nf6 e3 O-O Bd3 Nbd7 ",
	"d4 d5 Nf3 e6 c4 c6 e3 Nd7 Nc3 f5 Ne5 Ngf6 f4 Bd6 Be2 O-O ",
	"d4 d5 Nf3 e6 e3 Nf6 Bd3 Nbd7 O-O b6 Nbd2 Bd6 e4 dxe4 Nxe4 Bb7 ",
	"d4 d5 Nf3 e6 e3 Nf6 Bd3 c5 O-O Nc6 b3 Be7 Bb2 cxd4 exd4 Qc7 ",
	"d4 d5 Nf3 e6 e3 Nf6 Bd3 c5 b3 Nc6 O-O Be7 Bb2 O-O Nbd2 Re8 ",
	"d4 d5 Nf3 e6 e3 Nf6 Bd3 c5 b3 Nc6 O-O a6 Bb2 cxd4 exd4 Bd6 ",
	"d4 d5 c4 Bf5 cxd5 Bxb1 Qa4+ Qd7 Qxd7+ Nxd7 Rxb1 Ngf6 e3 Nb6 Nf3 Nbxd5 ",
	"d4 d5 c4 Nc6 Nc3 Nf6 Nf3 Bg4 cxd5 Nxd5 e4 Bxf3 gxf3 Nb6 d5 Nb8 ",
	"d4 d5 c4 Nc6 e3 e5 cxd5 Qxd5 Nc3 Bb4 Bd2 Bxc3 bxc3 exd4 cxd4 Nf6 ",
	"d4 d5 c4 c5 dxc5 d4 a3 a5 Nf3 Nc6 e3 e5 exd4 e4 Ng5 Qxd4 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 dxc4 a4 Bg4 e3 e6 Bxc4 Nbd7 h3 Bh5 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 e6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 e6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 e6 Bg5 h6 Bxf6 Qxf6 e3 Nd7 Bd3 g6 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 e6 e3 Nbd7 Qc2 Bd6 Be2 O-O O-O dxc4 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 e6 e3 Nbd7 Qc2 Bd6 Be2 O-O O-O dxc4 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 g6 Bf4 Bg7 e3 Qa5 Be2 Nbd7 O-O Nh5 ",
	"d4 d5 c4 c6 Nc3 Nf6 Nf3 g6 e3 Bg7 Bd3 O-O O-O c5 dxc5 dxc4 ",
	"d4 d5 c4 c6 Nc3 Nf6 cxd5 cxd5 Bf4 Nc6 e3 a6 Bd3 Bg4 Nge2 e6 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 Bb4 a3 Ba5 O-O O-O ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 Bb4 a3 Ba5 O-O O-O ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 Bb4 a3 Bd6 e4 dxe4 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 Bd6 e4 dxe4 Nxe4 Nxe4 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bb3 b4 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Be2 Bd6 O-O O-O Qc2 Re8 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Qc2 Bd6 Be2 O-O O-O Re8 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Qc2 Bd6 Be2 O-O O-O dxc4 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Qc2 Bd6 Be2 O-O O-O dxc4 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 Nbd7 Qc2 Bd6 b3 O-O Be2 b6 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 e6 Nf3 a6 b3 Bb4 Bd2 Nbd7 Bd3 O-O ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Bd3 O-O O-O Be6 b3 Nbd7 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Bd3 O-O O-O Bg4 h3 Bxf3 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Be2 O-O O-O Nbd7 Bd2 dxc4 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Be2 O-O O-O Nbd7 b4 e6 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Be2 O-O O-O Nbd7 cxd5 Nxd5 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Be2 O-O O-O Nbd7 cxd5 cxd5 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Be2 O-O O-O b6 b3 Bb7 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Be2 O-O O-O dxc4 Bxc4 Bg4 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Be2 O-O O-O dxc4 Bxc4 Bg4 ",
	"d4 d5 c4 c6 Nc3 Nf6 e3 g6 Nf3 Bg7 Be2 O-O O-O e6 b4 Nbd7 ",
	"d4 d5 c4 c6 Nc3 dxc4 e4 e5 Nf3 exd4 Qxd4 Qxd4 Nxd4 Bc5 Be3 Nf6 ",
	"d4 d5 c4 c6 Nc3 dxc4 e4 e5 Nf3 exd4 Qxd4 Qxd4 Nxd4 Bc5 Be3 Nf6 ",
	"d4 d5 c4 c6 Nc3 dxc4 e4 e5 dxe5 Qxd1+ Kxd1 b5 Be3 Nd7 f4 Bc5 ",
	"d4 d5 c4 c6 Nc3 e5 dxe5 d4 Ne4 Qa5+ Bd2 Qxe5 Ng3 Qd6 Nf3 Nf6 ",
	"d4 d5 c4 c6 Nc3 e6 Nf3 Nf6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 Bf5 e3 e6 Bd3 Nbd7 Bxf5 exf5 cxd5 cxd5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 a6 e3 b5 b3 Bg4 h3 Bxf3 Qxf3 e6 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 Ne5 b5 g3 Bb7 Bg2 a6 a4 e6 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 Ne5 Nbd7 Nxc4 Qc7 g3 e5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 Ne5 Nbd7 Nxc4 Qc7 g3 e5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 Ne5 e6 f3 Bb4 Nxc4 O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 Ne5 e6 f3 Bb4 e4 Bxe4 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bf5 e3 e6 Bxc4 Bb4 O-O Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Bg4 Ne5 Bh5 f3 Nfd7 Nxc4 e5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 a4 Na6 e4 Bg4 Bxc4 e6 Be3 Bb4 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 e4 Bg4 Bxc4 e6 O-O Be7 Be3 O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 e4 b5 e5 Nd5 a4 e6 axb5 Nxc3 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 dxc4 e4 b5 e5 Nd5 a4 e6 axb5 Nxc3 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 Bg5 dxc4 e4 b5 e5 h6 Bh4 g5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 cxd5 exd5 Bg5 Be7 Qc2 g6 e4 O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 cxd5 exd5 Bg5 Be7 Qc2 g6 e4 O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 Bd2 O-O O-O-O c5 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 Be2 O-O O-O Re8 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 Be2 O-O O-O dxc4 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 Be2 O-O O-O dxc4 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 e3 Nbd7 Qc2 Bd6 b3 O-O Be2 dxc4 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 e6 g3 Nbd7 Bg2 dxc4 a4 Bb4 O-O O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 g6 Bf4 Bg7 e3 O-O Qb3 dxc4 Bxc4 Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 g6 Bf4 dxc4 a4 Bg7 e3 Nd5 Be5 f6 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 g6 e3 Bg7 Bd3 O-O O-O Bg4 h3 Bxf3 ",
	"d4 d5 c4 c6 Nf3 Nf6 Nc3 g6 e3 Bg7 Bd3 O-O O-O c5 dxc5 dxc4 ",
	"d4 d5 c4 c6 Nf3 Nf6 Qb3 Qb6 Nc3 Bg4 c5 Qc7 Bf4 Qc8 Ne5 Nbd7 ",
	"d4 d5 c4 c6 Nf3 Nf6 Qc2 g6 Bf4 dxc4 Qxc4 Bg7 Nbd2 Bf5 e3 O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Qc2 g6 Bf4 dxc4 Qxc4 Bg7 Nbd2 Bf5 e3 O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Qc2 g6 Bf4 dxc4 Qxc4 Bg7 Nbd2 Bf5 e3 O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 Qc2 g6 Bf4 dxc4 Qxc4 Bg7 Nbd2 Bf5 e3 O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 cxd5 cxd5 Nc3 Nc6 Bf4 Bf5 e3 Qb6 Bb5 Bg4 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 Bf5 Bd3 Bxd3 Qxd3 e6 O-O Nbd7 Nc3 Be7 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 Bf5 Bd3 Bxd3 Qxd3 e6 O-O Nbd7 Nc3 Be7 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 Bf5 Bd3 e6 cxd5 Bxd3 Qxd3 exd5 Nc3 Bd6 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 e6 Bd3 Nbd7 O-O Bd6 Nbd2 e5 e4 O-O ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 e6 Nbd2 Nbd7 Bd3 Bd6 O-O O-O e4 dxe4 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 e6 Nbd2 Nbd7 Bd3 Bd6 O-O O-O e4 dxe4 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 e6 Nc3 Nbd7 Bd3 dxc4 Bxc4 a6 e4 c5 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 e6 Nc3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 g6 Nc3 Bg7 Bd3 O-O Qc2 Na6 a3 dxc4 ",
	"d4 d5 c4 c6 Nf3 Nf6 e3 g6 Nc3 Bg7 Qb3 O-O Ne5 e6 f4 Nbd7 ",
	"d4 d5 c4 c6 Nf3 e6 Bg5 Be7 Bxe7 Qxe7 Nbd2 f5 e3 Nd7 Bd3 Nh6 ",
	"d4 d5 c4 c6 Nf3 e6 Nc3 Nf6 Bg5 h6 Bxf6 Qxf6 Qb3 Nd7 e4 dxe4 ",
	"d4 d5 c4 c6 cxd5 cxd5 Nc3 Nf6 Nf3 Bf5 Qb3 Qb6 Qxb6 axb6 e3 h6 ",
	"d4 d5 c4 c6 cxd5 cxd5 Nc3 Nf6 Nf3 Nc6 Bf4 Bf5 e3 e6 Bb5 Bd6 ",
	"d4 d5 c4 c6 cxd5 cxd5 Nc3 Nf6 Nf3 Nc6 Bf4 g6 e3 Qa5 Qb3 Bg7 ",
	"d4 d5 c4 c6 e3 Nf6 Nc3 Bf5 cxd5 cxd5 Qb3 Bc8 Nf3 e6 Bd2 Be7 ",
	"d4 d5 c4 c6 e3 Nf6 Nc3 e6 f4 Bb4 Nf3 Ne4 Bd2 Nxd2 Qxd2 Nd7 ",
	"d4 d5 c4 c6 e3 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bf5 cxd5 Nxd5 ",
	"d4 d5 c4 c6 e3 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Nbd7 cxd5 Nxd5 ",
	"d4 d5 c4 c6 e3 Nf6 Nf3 e6 Nbd2 Nbd7 Bd3 Be7 O-O O-O Qc2 dxc4 ",
	"d4 d5 c4 dxc4 Nc3 e6 e4 c5 d5 exd5 Nxd5 Nf6 Bxc4 Nxd5 Bxd5 Bd6 ",
	"d4 d5 c4 dxc4 Nf3 Bg4 Ne5 Bh5 Nc3 Nd7 Nxc4 c6 g3 e6 Bg2 Ngf6 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 Qa4+ Qd7 Qxc4 Qc6 Nbd2 Be6 Qd3 Na6 a3 O-O-O ",
	"d4 d5 c4 dxc4 Nf3 Nf6 Qa4+ c6 Qxc4 Bf5 Nc3 Nbd7 g3 Ne4 Bg2 Nd6 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 e6 Bxc4 Bb4+ Nc3 a6 Qc2 Nfd7 e4 Nc6 ",
	"d4 d5 c4 dxc4 Nf3 Nf6 e3 e6 Bxc4 c5 O-O a6 dxc5 Qxd1 Rxd1 Bxc5 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 Bg4 Bxc4 e6 Qb3 Bxf3 gxf3 Ra7 Bd2 Nf6 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 Bg4 Bxc4 e6 Qb3 Bxf3 gxf3 b5 Be2 Nd7 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 Bg4 Bxc4 e6 Qb3 Bxf3 gxf3 b5 Be2 Nd7 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 Nf6 Bxc4 e6 Qe2 c5 dxc5 Bxc5 O-O b5 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 b5 a4 Bb7 axb5 axb5 Rxa8 Bxa8 b3 e6 ",
	"d4 d5 c4 dxc4 Nf3 a6 e3 e6 Bxc4 Nf6 O-O c5 Qe2 Nc6 Rd1 b5 ",
	"d4 d5 c4 dxc4 Nf3 c5 Nc3 e6 e4 cxd4 Qxd4 Bd7 Ne5 Nf6 Nxc4 Nc6 ",
	"d4 d5 c4 dxc4 Nf3 c5 e3 cxd4 Bxc4 e6 exd4 Nf6 O-O Be7 Qe2 Nbd7 ",
	"d4 d5 c4 dxc4 Nf3 e6 e3 Nf6 Bxc4 Be7 Nc3 O-O O-O Nbd7 Qe2 c6 ",
	"d4 d5 c4 dxc4 e3 Nf6 Bxc4 e6 Nf3 c5 O-O a6 Bd3 Nc6 Nc3 Qc7 ",
	"d4 d5 c4 dxc4 e3 Nf6 Bxc4 e6 Nf3 c5 O-O a6 Qe2 b5 Bd3 Nc6 ",
	"d4 d5 c4 dxc4 e3 e5 Bxc4 exd4 exd4 Nf6 Nc3 Bb4 Nf3 O-O O-O Bg4 ",
	"d4 d5 c4 dxc4 e4 Nc6 Nf3 Bg4 d5 Ne5 Nc3 c6 Bf4 Ng6 Be3 cxd5 ",
	"d4 d5 c4 dxc4 e4 Nf6 e5 Nd5 Bxc4 Nb6 Bb3 Bf5 Nc3 e6 Nge2 Nc6 ",
	"d4 d5 c4 dxc4 e4 Nf6 e5 Nd5 Bxc4 Nb6 Bb3 Nc6 Be3 Bf5 Ne2 e6 ",
	"d4 d5 c4 dxc4 e4 Nf6 e5 Nd5 Bxc4 Nb6 Bb3 Nc6 Nf3 Bg4 Bxf7+ Kxf7 ",
	"d4 d5 c4 dxc4 e4 Nf6 e5 Nd5 Bxc4 Nb6 Bd3 Nc6 Ne2 Bg4 Be3 Bxe2 ",
	"d4 d5 c4 dxc4 e4 Nf6 e5 Nd5 Bxc4 Nc6 Nc3 Nb6 Bb5 Bd7 Nf3 e6 ",
	"d4 d5 c4 dxc4 e4 Nf6 e5 Nd5 Bxc4 Nc6 Ne2 Nb6 Bd3 Be6 Nbc3 Qd7 ",
	"d4 d5 c4 dxc4 e4 c5 d5 Nf6 Nc3 e6 Nf3 exd5 e5 Nfd7 Bg5 Be7 ",
	"d4 d5 c4 dxc4 e4 c5 d5 Nf6 Nc3 e6 Nf3 exd5 e5 Nfd7 Bg5 Be7 ",
	"d4 d5 c4 dxc4 e4 c5 d5 Nf6 Nc3 e6 Nf3 exd5 e5 Nfd7 Bg5 Be7 ",
	"d4 d5 c4 dxc4 e4 c5 d5 Nf6 Nc3 e6 Nf3 exd5 e5 Nfd7 Qxd5 Nb6 ",
	"d4 d5 c4 dxc4 e4 e5 Nf3 Bb4+ Bd2 Bxd2+ Qxd2 exd4 Qxd4 Qxd4 Nxd4 Bd7 ",
	"d4 d5 c4 dxc4 e4 e5 Nf3 Bb4+ Nc3 exd4 Nxd4 Ne7 Bxc4 Nbc6 Be3 O-O ",
	"d4 d5 c4 dxc4 e4 e5 Nf3 Nf6 Nxe5 Nxe4 Bxc4 Bb4+ Nc3 O-O O-O Nd6 ",
	"d4 d5 c4 dxc4 e4 e5 Nf3 exd4 Bxc4 Bb4+ Nbd2 Nc6 O-O Nf6 e5 Nd5 ",
	"d4 d5 c4 dxc4 e4 e5 Nf3 exd4 Bxc4 Bb4+ Nbd2 Nc6 O-O Nh6 Nb3 Bg4 ",
	"d4 d5 c4 dxc4 e4 e5 Nf3 exd4 Bxc4 Bb4+ Nbd2 Nc6 O-O Qf6 e5 Qg6 ",
	"d4 d5 c4 e5 dxe5 d4 Nf3 Nc6 Nbd2 Be6 g3 Qd7 Bg2 Nge7 O-O Ng6 ",
	"d4 d5 c4 e5 dxe5 d4 Nf3 Nc6 Nbd2 f6 exf6 Qxf6 g3 Bf5 Bg2 O-O-O ",
	"d4 d5 c4 e5 dxe5 d4 Nf3 Nc6 a3 Bg4 Nbd2 Qe7 h3 Bxf3 Nxf3 O-O-O ",
	"d4 d5 c4 e5 dxe5 d4 Nf3 Nc6 g3 Bc5 Bg2 Nge7 Nbd2 Ng6 Nb3 Bb4+ ",
	"d4 d5 c4 e5 dxe5 dxc4 Qxd8+ Kxd8 Nc3 Nc6 Bg5+ Be7 O-O-O+ Bd7 Bf4 a6 ",
	"d4 d5 c4 e6 Nc3 Bb4 Nf3 Nf6 Qa4+ Nc6 Ne5 Bd7 Nxd7 Qxd7 e3 Ne4 ",
	"d4 d5 c4 e6 Nc3 Bb4 a3 Bxc3+ bxc3 dxc4 e4 Nf6 e5 Nd5 Qa4+ Nd7 ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 Bg5 O-O Rc1 Nbd7 e3 a6 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 Bg5 O-O Rc1 h6 Bh4 b6 cxd5 Nxd5 ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 Bg5 O-O e3 Nbd7 Rc1 a6 c5 c6 ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 Bg5 O-O e3 Nbd7 Rc1 a6 c5 c6 ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 Bg5 h6 Bxf6 Bxf6 e3 O-O Qc2 Na6 ",
	"d4 d5 c4 e6 Nc3 Be7 Nf3 Nf6 Bg5 h6 Bxf6 Bxf6 e3 O-O Qc2 Na6 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 Nf6 e3 O-O Bd3 c5 Nf3 Nc6 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 Nf6 e3 O-O Nf3 Bf5 h3 c6 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 Nf6 e3 O-O Nf3 Bf5 h3 c6 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 c6 Qc2 Bg4 e3 Bh5 Nf3 Nd7 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 c6 Qc2 g6 O-O-O Nf6 f3 Na6 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 c6 e3 Bf5 Nge2 Nd7 Ng3 Bg6 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 c6 e3 Bf5 g4 Be6 h3 Nf6 ",
	"d4 d5 c4 e6 Nc3 Be7 cxd5 exd5 Bf4 c6 e3 Bf5 g4 Bg6 h4 h5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bf4 Be7 e3 O-O Nf3 b6 Bd3 c5 dxc5 bxc5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 Nf3 Nbd7 Rc1 O-O e3 b6 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 Nf3 Nbd7 e3 O-O Rc1 b6 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 Nf3 O-O e3 b6 Rc1 Bb7 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 Nf3 b6 e3 Bb7 Rc1 dxc4 Bxc4 Nbd7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Nbd7 Nf3 O-O Bd3 dxc4 Bxc4 c6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Nbd7 Nf3 O-O Qc2 b6 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Nbd7 Nf3 O-O Rc1 c6 Bd3 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Nbd7 Nf3 c6 Bd3 dxc4 Bxc4 Nd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Nbd7 Nf3 h6 Bh4 Ne4 Bxe7 Qxe7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 Ne4 Bxe7 Qxe7 Bd3 Nxc3 bxc3 Nd7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 Nbd7 Bd3 dxc4 Bxc4 c5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 Nbd7 Qc2 c6 Rd1 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 Nbd7 Rc1 c6 a3 h6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 b6 Bd3 Bb7 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 b6 Bd3 Bb7 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 b6 Rc1 Bb7 Bd3 Nbd7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 h6 Bh4 b6 Be2 Bb7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 h6 Bh4 b6 Qc2 Bb7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 O-O Nf3 h6 Bh4 b6 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 a6 c5 O-O Bd3 Nbd7 f4 Ne8 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 b6 Nf3 Bb7 cxd5 exd5 Bd3 O-O ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 h6 Bh4 O-O Rc1 b6 Bxf6 Bxf6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Be7 e3 h6 Bh4 O-O Rc1 c5 dxc5 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 Nf3 Be7 Rc1 O-O e3 Re8 a3 a6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 Nf3 Be7 e3 O-O Rc1 b6 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 cxd5 exd5 e3 c6 Bd3 Be7 Qc2 Nf8 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Bb4 Nf3 O-O Bd3 dxc4 Bxc4 c5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Be7 Nf3 O-O Qc2 c5 Rd1 Qa5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Be7 Nf3 O-O Rc1 Re8 a3 a6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Be7 Nf3 O-O cxd5 exd5 Bd3 Re8 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Be7 Nf3 h6 Bh4 c6 Qc2 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 Be7 Nf3 h6 Bxf6 Nxf6 Bd3 Bd6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 c6 Nf3 Qa5 Nd2 Bb4 Qc2 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 c6 Nf3 Qa5 cxd5 Nxd5 Qb3 Bb4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 c6 a3 Be7 Nf3 O-O Bd3 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 c6 cxd5 exd5 Bd3 Be7 Qc2 Nh5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 c6 cxd5 exd5 Bd3 Be7 Qc2 h6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 Nbd7 e3 h6 Bh4 c6 Bg3 Be7 Bd3 Nb6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 c5 cxd5 cxd4 Qxd4 Be7 e4 Nc6 Qd2 Nxe4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 c6 e3 Nbd7 cxd5 exd5 Bd3 Bd6 Qc2 h6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 c6 e3 Nbd7 cxd5 exd5 Bd3 Be7 Nf3 O-O ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 c6 e3 Nbd7 cxd5 exd5 Bd3 Be7 Nf3 O-O ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 c6 e3 Nbd7 cxd5 exd5 Bd3 Be7 Nf3 O-O ",
	"d4 d5 c4 e6 Nc3 Nf6 Bg5 c6 e4 dxe4 Nxe4 Bb4+ Nc3 c5 a3 Bxc3+ ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Be7 Bg5 Nbd7 e3 O-O Rc1 c6 Bd3 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Be7 Bg5 Ne4 Bxe7 Qxe7 Qc2 Nxc3 Qxc3 O-O ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Be7 Bg5 O-O e3 h6 Bh4 b6 Bd3 Nbd7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Be7 Bg5 O-O e3 h6 Bh4 b6 Be2 Bb7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Be7 Bg5 O-O e3 h6 Bxf6 Bxf6 Rc1 c6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Be7 e3 O-O Bd3 b6 cxd5 exd5 O-O Bb7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Be7 e3 b6 Bd3 O-O O-O dxc4 Bxc4 Bb7 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Nbd7 Bf4 Bb4 e3 O-O Qb3 c5 a3 Qa5 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Nbd7 Bg5 Be7 e3 c6 Bd3 O-O O-O dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Nbd7 Bg5 h6 Bh4 Be7 e3 O-O Rc1 b6 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Nbd7 cxd5 exd5 Bf4 c6 e3 Be7 Bd3 Nf8 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 Nbd7 cxd5 exd5 Bg5 Be7 e3 c6 Bd3 O-O ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 c5 Bg5 cxd4 Qxd4 Nc6 Bxf6 gxf6 Qh4 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 c5 Bg5 cxd4 Qxd4 Nc6 Bxf6 gxf6 Qh4 dxc4 ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 c5 cxd5 Nxd5 e3 Nc6 Bd3 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 Nf6 Nf3 dxc4 e3 c5 Bxc4 a6 a4 Nc6 O-O cxd4 ",
	"d4 d5 c4 e6 Nc3 Nf6 cxd5 Nxd5 g3 Nxc3 bxc3 c5 Bg2 cxd4 cxd4 Bb4+ ",
	"d4 d5 c4 e6 Nc3 Nf6 cxd5 exd5 Bg5 Be7 e3 O-O Bd3 Re8 Nf3 Nbd7 ",
	"d4 d5 c4 e6 Nc3 Nf6 cxd5 exd5 Bg5 Be7 e3 c6 Qc2 Ne4 Bxe7 Qxe7 ",
	"d4 d5 c4 e6 Nc3 Nf6 cxd5 exd5 Bg5 Be7 e3 c6 Qc2 O-O Bd3 Nbd7 ",
	"d4 d5 c4 e6 Nc3 Nf6 cxd5 exd5 Bg5 Be7 e3 h6 Bh4 O-O Bd3 b6 ",
	"d4 d5 c4 e6 Nc3 a6 Nf3 dxc4 e3 c5 Bxc4 cxd4 exd4 Nf6 O-O Nc6 ",
	"d4 d5 c4 e6 Nc3 a6 cxd5 exd5 Qb3 c6 Nf3 Bd6 Bg5 Be7 Bf4 Nf6 ",
	"d4 d5 c4 e6 Nc3 b6 Nf3 Bb7 cxd5 exd5 e4 dxe4 Ne5 Bd6 Qg4 Kf8 ",
	"d4 d5 c4 e6 Nc3 c5 Nf3 Nc6 Bf4 cxd4 Nxd4 Bb4 e3 Nge7 Be2 O-O ",
	"d4 d5 c4 e6 Nc3 c5 Nf3 Nf6 cxd5 exd5 Bg5 Be6 e3 Nc6 Be2 Be7 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 cxd4 Qa4+ Bd7 Qxd4 exd5 Qxd5 Nc6 e3 Nf6 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 cxd4 Qxd4 Nc6 Qd1 exd5 Nxd5 Be6 Nc3 Qxd1+ ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Be6 Bg5 Nf6 e3 Be7 Bxf6 Bxf6 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O Be6 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 Nf6 Bg2 Bg4 Ne5 cxd4 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 c4 Bg2 Bb4 O-O Nge7 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 c4 Bg2 Bb4 O-O Nge7 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nc6 g3 c4 Bg2 Bb4 O-O Nge7 ",
	"d4 d5 c4 e6 Nc3 c5 cxd5 exd5 Nf3 Nf6 g3 Nc6 Bg2 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 Nf6 Bg5 h6 Bxf6 Qxf6 Qb3 a5 cxd5 exd5 ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 Nf6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 e6 Nc3 c6 Nf3 dxc4 a4 Bb4 Bd2 c5 e3 Nc6 dxc5 Nf6 ",
	"d4 d5 c4 e6 Nc3 c6 cxd5 exd5 Qc2 Ne7 Bg5 f6 Bf4 Bf5 Qd2 Nd7 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Bd3 Bd6 O-O O-O e4 dxe4 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Bd3 Be7 O-O O-O b3 b6 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Bd3 a6 O-O dxc4 Bxc4 b5 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Bd3 dxc4 Bxc4 a6 a4 c5 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 Nbd7 Qc2 Bd6 b3 O-O Be2 dxc4 ",
	"d4 d5 c4 e6 Nc3 c6 e3 Nf6 Nf3 a6 Qc2 c5 a3 dxc4 Bxc4 Nbd7 ",
	"d4 d5 c4 e6 Nc3 c6 e4 dxe4 Nxe4 Bb4+ Bd2 Qxd4 Bxb4 Qxe4+ Be2 Na6 ",
	"d4 d5 c4 e6 Nc3 c6 e4 dxe4 Nxe4 Bb4+ Bd2 Qxd4 Bxb4 Qxe4+ Be2 Na6 ",
	"d4 d5 c4 e6 Nc3 c6 e4 dxe4 Nxe4 e5 dxe5 Qa5+ Bd2 Qxe5 Bd3 Na6 ",
	"d4 d5 c4 e6 Nc3 dxc4 e3 c5 Bxc4 Nf6 Nf3 a6 O-O b5 Bd3 Bb7 ",
	"d4 d5 c4 e6 Nc3 dxc4 e4 a6 Bxc4 b5 Bd3 Bb7 Nf3 c5 O-O cxd4 ",
	"d4 d5 c4 e6 Nf3 Nc6 cxd5 exd5 Nc3 Bb4 Bd2 Nf6 e3 Ne4 Nxe4 dxe4 ",
	"d4 d5 c4 e6 Nf3 Nd7 Nc3 Ngf6 Bf4 dxc4 e3 Nd5 Bxc4 Nxf4 exf4 Bd6 ",
	"d4 d5 c4 e6 Nf3 Nd7 Nc3 Ngf6 Bg5 c6 e3 Qa5 Nd2 Bb4 Qc2 O-O ",
	"d4 d5 c4 e6 Nf3 Nf6 Bg5 Be7 e3 Nbd7 Nbd2 h6 Bh4 O-O Rc1 c5 ",
	"d4 d5 c4 e6 Nf3 Nf6 Bg5 Be7 e3 Nbd7 Nc3 O-O Bd3 c6 O-O a6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Bg5 Nbd7 e3 Bb4+ Nbd2 c5 a3 Bxd2+ Qxd2 Ne4 ",
	"d4 d5 c4 e6 Nf3 Nf6 Bg5 Nbd7 e3 Be7 Nc3 O-O Rc1 c6 Bd3 dxc4 ",
	"d4 d5 c4 e6 Nf3 Nf6 Bg5 Nbd7 e3 c6 Nbd2 Qa5 cxd5 exd5 Bd3 Ne4 ",
	"d4 d5 c4 e6 Nf3 Nf6 Bg5 c6 Nbd2 Nbd7 e3 Be7 Bd3 O-O O-O dxc4 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 Be7 Bg5 Nbd7 e3 O-O Rc1 c6 Qc2 a6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 Be7 Bg5 Nbd7 e3 c6 Bd3 O-O O-O dxc4 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 Be7 e3 O-O Bd3 dxc4 Bxc4 c5 O-O a6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 Nbd7 Bf4 dxc4 e3 Nd5 Bxc4 Nxf4 exf4 Bd6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c5 cxd5 Nxd5 e4 Nxc3 bxc3 cxd4 cxd4 Nc6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c5 cxd5 exd5 Bg5 Be6 e4 cxd4 Qxd4 Nc6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c6 Bg5 Nbd7 e3 Qa5 Nd2 dxc4 Bxf6 Nxf6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c6 Qb3 dxc4 Qxc4 b5 Qd3 Ba6 Qc2 Qa5 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c6 e3 Nbd7 Bd3 Bb4 O-O O-O Bd2 Qe7 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c6 e3 Nbd7 Bd3 Bb4 O-O O-O Qc2 Bd6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c6 e3 Nbd7 Bd3 Bb4 a3 Ba5 Qc2 Qe7 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c6 e3 Nbd7 Bd3 Be7 O-O O-O b3 b6 ",
	"d4 d5 c4 e6 Nf3 Nf6 Nc3 c6 e3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 Bb7 ",
	"d4 d5 c4 e6 Nf3 Nf6 g3 Be7 Bg2 O-O Nc3 dxc4 Ne5 c5 dxc5 Qc7 ",
	"d4 d5 c4 e6 Nf3 Nf6 g3 dxc4 Bg2 Nbd7 O-O c5 Na3 cxd4 Nxc4 Bc5 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 Nc3 Nf6 g3 Be6 Bg2 Nc6 O-O Be7 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nc6 Bg2 Nf6 Nc3 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nc6 Bg2 Nf6 Nc3 Be7 O-O O-O ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nc6 Bg2 Nf6 O-O Be7 dxc5 Bxc5 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nf6 Bg2 Be7 O-O O-O Nc3 Nc6 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nf6 Bg2 Be7 O-O O-O Nc3 Nc6 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nf6 Bg2 Be7 O-O O-O Nc3 Nc6 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nf6 Bg2 Be7 O-O O-O Nc3 Nc6 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nf6 Bg2 Be7 O-O O-O Nc3 Nc6 ",
	"d4 d5 c4 e6 Nf3 c5 cxd5 exd5 g3 Nf6 Bg2 Be7 O-O O-O Nc3 Nc6 ",
	"d4 d5 c4 e6 Nf3 c6 g3 f5 Bg2 Nf6 O-O Be7 b3 O-O Ba3 b6 ",
	"d4 d5 c4 e6 Nf3 dxc4 e3 Nf6 Bxc4 c5 O-O a6 Qe2 Nc6 Nc3 Be7 ",
	"d4 d5 c4 e6 Nf3 dxc4 e4 c5 Bxc4 cxd4 Nxd4 Nf6 Nc3 Bc5 Be3 Nbd7 ",
	"d4 d5 c4 e6 Nf3 dxc4 e4 c5 Bxc4 cxd4 Nxd4 Nf6 Nc3 a6 O-O Bc5 ",
	"d4 d5 c4 e6 Nf3 dxc4 e4 c5 d5 exd5 exd5 Nf6 Bxc4 Bd6 O-O O-O ",
	"d4 d5 c4 e6 cxd5 exd5 Nc3 c6 Bf4 Bf5 e3 Nd7 g4 Be6 Bd3 g5 ",
	"d4 d5 e3 Nf6 Bd3 c5 b3 Nc6 Bb2 Bg4 f3 Bh5 Ne2 cxd4 exd4 e6 ",
	"d4 d5 e3 Nf6 Nd2 c5 c3 Nc6 Ngf3 Bg4 Be2 e6 O-O Rc8 Re1 Qc7 ",
	"d4 d5 e3 Nf6 Nf3 c5 c4 e6 Nc3 Be7 dxc5 O-O a3 Bxc5 b4 Be7 ",
	"d4 d6 Nf3 Bg4 c4 Bxf3 exf3 g6 Nc3 Bg7 d5 Nf6 g3 O-O Bg2 e6 ",
	"d4 d6 Nf3 Bg4 c4 Bxf3 exf3 g6 Qb3 Qc8 Be3 Bg7 Nc3 Nf6 h4 c5 ",
	"d4 d6 Nf3 Bg4 c4 Nd7 e4 e5 Be2 Ngf6 Nc3 Be7 Be3 O-O O-O Bh5 ",
	"d4 d6 Nf3 Bg4 e4 Nf6 Nbd2 e6 Be2 Nc6 c3 d5 e5 Nd7 Nf1 f6 ",
	"d4 d6 Nf3 Nf6 c4 g6 Nc3 Bg7 e4 O-O Be2 e5 Be3 exd4 Nxd4 Re8 ",
	"d4 d6 Nf3 Nf6 c4 g6 Nc3 Bg7 e4 O-O Be2 e5 Be3 exd4 Nxd4 Re8 ",
	"d4 d6 Nf3 Nf6 g3 Nbd7 Bg2 e5 c4 c6 Nc3 e4 Nd2 d5 f3 exf3 ",
	"d4 d6 Nf3 g6 g3 Bg7 Bg2 Bg4 c3 c6 Qb3 Qb6 Nbd2 Nf6 O-O O-O ",
	"d4 d6 c4 e5 Nf3 e4 Nfd2 f5 e3 Nf6 Nc3 g6 b4 Bg7 Bb2 O-O ",
	"d4 d6 c4 e5 Nf3 exd4 Nxd4 g6 Nc3 Bg7 e4 Nc6 Be3 Nge7 Be2 O-O ",
	"d4 d6 c4 e5 Nf3 exd4 Nxd4 g6 Nc3 Bg7 e4 Ne7 Bg5 O-O Be2 Nbc6 ",
	"d4 d6 c4 e5 d5 Be7 Nc3 Nf6 e4 O-O Bd3 Nbd7 Be3 c6 h3 a6 ",
	"d4 d6 e4 Nd7 Nf3 c6 Bc4 b5 Bd3 Bb7 Bf4 a6 c3 c5 Nbd2 Qc7 ",
	"d4 d6 e4 Nf6 Nc3 c6 Nf3 Bg4 h3 Bh5 g4 Bg6 Bd3 e6 Qe2 Nbd7 ",
	"d4 d6 e4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O c6 Bf4 Nbd7 Re1 Qb6 ",
	"d4 d6 e4 Nf6 Nc3 g6 f4 Bg7 Nf3 c5 Bb5+ Bd7 e5 Ng4 e6 Bxb5 ",
	"d4 d6 e4 g6 Nc3 Bg7 f4 Nf6 Nf3 O-O Bd3 Nc6 e5 dxe5 fxe5 Nd5 ",
	"d4 d6 e4 g6 c4 Bg7 Nc3 f5 exf5 Bxf5 Nf3 Nh6 Be2 O-O O-O Nf7 ",
	"d4 d6 e4 g6 c4 e5 Nf3 exd4 Nxd4 Bg7 Nc3 Nc6 Be3 Nge7 h4 h6 ",
	"d4 e6 Nf3 Nf6 c4 c5 d5 exd5 cxd5 d6 Nc3 g6 g3 Bg7 Bg2 O-O ",
	"d4 e6 Nf3 Nf6 c4 d5 Nc3 Be7 Bg5 O-O e3 h6 Bh4 b6 Bd3 Bb7 ",
	"d4 e6 Nf3 Nf6 c4 d5 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Rc1 c6 ",
	"d4 e6 Nf3 Nf6 c4 d5 Nc3 Be7 Bg5 h6 Bxf6 Bxf6 e3 O-O Rc1 c6 ",
	"d4 e6 Nf3 Nf6 c4 d5 Nc3 Nbd7 cxd5 exd5 Bf4 c6 e3 Be7 Qc2 O-O ",
	"d4 e6 Nf3 Nf6 e3 c5 Bd3 Nc6 O-O d5 b3 Bd6 Bb2 O-O Nbd2 Nb4 ",
	"d4 e6 Nf3 c5 c3 Nc6 e3 Nf6 Nbd2 d5 Bd3 b6 O-O Be7 Ne5 Nxe5 ",
	"d4 e6 Nf3 c5 c3 Nc6 e4 d5 e5 Qb6 a3 Bd7 Be2 cxd4 cxd4 Rc8 ",
	"d4 e6 Nf3 c5 g3 Nf6 Bg2 Qc7 O-O cxd4 Nxd4 a6 e4 Nc6 Nxc6 dxc6 ",
	"d4 e6 Nf3 c5 g3 Qa5+ Nc3 Nf6 Bd2 cxd4 Nxd4 Qb6 Nb3 Qc6 Rg1 d5 ",
	"d4 e6 Nf3 d5 c4 Nf6 Nc3 c6 e3 Nbd7 Bd3 Bd6 e4 dxe4 Nxe4 Nxe4 ",
	"d4 e6 Nf3 f5 Bf4 Nf6 e3 b6 Nbd2 Bb7 c3 Be7 Bd3 c5 h3 cxd4 ",
	"d4 e6 Nf3 f5 c4 Nf6 Bg5 Be7 Nc3 O-O e3 b6 Bd3 Bb7 O-O Qe8 ",
	"d4 e6 Nf3 f5 g3 Nf6 Bg2 Be7 O-O O-O c4 Ne4 Qb3 Bf6 Rd1 Qe8 ",
	"d4 e6 Nf3 f5 g3 Nf6 Bg2 b5 Ne5 c6 Nd2 Qb6 e4 Qxd4 Nef3 Qc5 ",
	"d4 e6 Nf3 f5 g3 Nf6 Bg2 d5 O-O Bd6 c4 c6 b3 O-O Ba3 Bxa3 ",
	"d4 e6 Nf3 f5 g3 Nf6 Bg2 d5 O-O Bd6 c4 c6 b3 O-O Ba3 Bxa3 ",
	"d4 e6 Nf3 f5 g3 Nf6 Bg2 d5 O-O Bd6 c4 c6 b3 O-O Ba3 Bxa3 ",
	"d4 e6 Nf3 f5 g3 Nf6 Bg2 d5 c4 c6 O-O Bd6 b3 Qe7 a4 O-O ",
	"d4 e6 Nf3 f5 g3 Nf6 Bg2 d5 c4 c6 O-O Bd6 b3 Qe7 a4 O-O ",
	"d4 e6 c4 Bb4+ Bd2 Bxd2+ Qxd2 Nf6 Nc3 d6 e4 Qe7 Nge2 e5 f3 O-O ",
	"d4 e6 c4 Bb4+ Bd2 Bxd2+ Qxd2 b6 Nc3 Bb7 e4 Nh6 f4 f5 e5 Nf7 ",
	"d4 e6 c4 Bb4+ Bd2 a5 Nf3 d6 g3 Nc6 Bg2 e5 d5 Nce7 Bxb4 axb4 ",
	"d4 e6 c4 Bb4+ Bd2 a5 g3 d5 Nf3 Nc6 a3 Bxd2+ Nbxd2 Qf6 e3 Nge7 ",
	"d4 e6 c4 Bb4+ Nc3 f5 g3 Nf6 Bg2 O-O Nf3 b6 Nd2 d5 a3 Be7 ",
	"d4 e6 c4 Bb4+ Nd2 b6 Nf3 Bb7 a3 Bxd2+ Bxd2 Nf6 g3 d6 Bg2 O-O ",
	"d4 e6 c4 Bb4+ Nd2 f5 g3 Nf6 Bg2 O-O Nf3 d6 O-O Bxd2 Bxd2 Qe7 ",
	"d4 e6 c4 Bb4+ Nd2 f5 g3 Nf6 Bg2 O-O Nf3 d6 O-O Bxd2 Bxd2 Qe7 ",
	"d4 e6 c4 Bb4+ Nd2 f5 g3 Nf6 Bg2 O-O Nf3 d6 O-O Bxd2 Bxd2 Qe7 ",
	"d4 e6 c4 Nf6 Nc3 Bb4 Qb3 c5 dxc5 Nc6 Bg5 Qa5 Bxf6 gxf6 Nf3 Qxc5 ",
	"d4 e6 c4 Nf6 Nc3 Bb4 Qc2 O-O a3 Bxc3+ Qxc3 b6 Bg5 Bb7 f3 d6 ",
	"d4 e6 c4 Nf6 Nc3 Bb4 e3 b6 Bd3 Bb7 Nf3 O-O O-O c5 Na4 cxd4 ",
	"d4 e6 c4 Nf6 Nc3 Bb4 e3 c5 Nf3 O-O Bd3 d5 O-O dxc4 Bxc4 Nbd7 ",
	"d4 e6 c4 Nf6 Nc3 d5 Nf3 Be7 e3 O-O a3 a6 b4 b6 Bb2 c5 ",
	"d4 e6 c4 Nf6 Nf3 Bb4+ Bd2 c5 Bxb4 cxb4 g3 b6 Bg2 Bb7 O-O O-O ",
	"d4 e6 c4 Nf6 Nf3 b6 Nc3 Bb7 a3 d5 cxd5 exd5 g3 Be7 Qa4+ c6 ",
	"d4 e6 c4 Nf6 Nf3 b6 a3 Bb7 Nc3 d5 cxd5 exd5 g3 Be7 Qa4+ Nbd7 ",
	"d4 e6 c4 Nf6 Nf3 b6 g3 Ba6 b3 Bb4+ Bd2 Bxd2+ Qxd2 O-O Nc3 d5 ",
	"d4 e6 c4 Nf6 Nf3 b6 g3 Ba6 b3 Bb7 Bg2 Bb4+ Bd2 a5 O-O O-O ",
	"d4 e6 c4 Nf6 Nf3 c5 d5 d6 Nc3 exd5 cxd5 g6 e4 Bg7 Nd2 O-O ",
	"d4 e6 c4 c5 d5 exd5 cxd5 d6 Nc3 g6 Nf3 Bg7 Bf4 Nf6 Qa4+ Bd7 ",
	"d4 e6 c4 d5 Nc3 c6 e3 Nf6 Nf3 Nbd7 Bd3 dxc4 Bxc4 b5 Bd3 a6 ",
	"d4 e6 c4 d5 Nc3 c6 e3 Nf6 Nf3 Nbd7 Qc2 Bd6 b3 O-O Be2 Re8 ",
	"d4 e6 c4 d5 Nf3 Be7 Nc3 Nf6 Bg5 O-O e3 a6 cxd5 exd5 Bd3 c6 ",
	"d4 e6 c4 d5 Nf3 Nf6 Bf4 a6 e3 c5 Nc3 Nc6 a3 cxd4 exd4 dxc4 ",
	"d4 e6 c4 d5 Nf3 Nf6 g3 dxc4 Bg2 Bd7 Ne5 Bc6 Nxc6 Nxc6 O-O Nxd4 ",
	"d4 e6 c4 f5 Nc3 Nf6 Nf3 Bb4 Qb3 Bxc3+ bxc3 b6 e3 O-O Ba3 Re8 ",
	"d4 e6 c4 f5 Nc3 Nf6 Nf3 Be7 Bf4 O-O e3 d6 h3 Qe8 Qc2 Nc6 ",
	"d4 e6 c4 f5 Nc3 Nf6 e3 Bb4 Bd2 Bxc3 Bxc3 Ne4 Bb4 d6 f3 Nf6 ",
	"d4 e6 c4 f5 Nc3 Nf6 e3 Bb4 Bd2 O-O Bd3 Bxc3 Bxc3 Ne4 Bxe4 fxe4 ",
	"d4 e6 c4 f5 Nc3 Nf6 e3 Bb4 Bd2 O-O Bd3 d6 Qc2 Nbd7 Nge2 b6 ",
	"d4 e6 c4 f5 Nf3 Bb4+ Bd2 Qe7 g3 Nf6 Bg2 O-O O-O Bxd2 Qxd2 d6 ",
	"d4 e6 c4 f5 Nf3 Nf6 g3 b6 Bg2 Bb7 O-O Be7 d5 O-O Nd4 c5 ",
	"d4 e6 c4 f5 e3 Nf6 Bd3 b6 Nc3 Bb7 Nf3 Bb4 O-O Bxc3 bxc3 O-O ",
	"d4 e6 c4 f5 e3 Nf6 f4 Ne4 Nf3 Bb4+ Nbd2 b6 Bd3 Bxd2+ Bxd2 Nxd2 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Bb4+ Bd2 Qe7 Nf3 Nc6 O-O Bxd2 Qxd2 Ne4 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Be7 Nc3 O-O e3 d5 Nge2 c6 b3 Ne4 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Be7 Nf3 O-O O-O d5 b3 c6 Ba3 Bd7 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Be7 Nf3 d5 O-O O-O b3 Bd7 Ba3 Nc6 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 Be7 Nf3 d6 O-O O-O b3 Qe8 Qc2 Qh5 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 d5 Nf3 Be7 O-O O-O b3 c6 Qc2 Bd7 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 d5 Nf3 Be7 O-O O-O b3 c6 Qc2 Bd7 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 d5 Nf3 c6 Nc3 Bd6 Bf4 O-O e3 b6 ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 d5 Nf3 c6 O-O Bd6 b3 Qe7 Ne5 O-O ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 d5 Nh3 c6 Qc2 Bd6 Bf4 Be7 O-O O-O ",
	"d4 e6 c4 f5 g3 Nf6 Bg2 d5 Nh3 c6 Qc2 Bd6 O-O O-O b3 Bd7 ",
	"d4 e6 c4 f5 g3 c5 Nf3 cxd4 Nxd4 Nf6 Bg2 Nc6 O-O Bc5 e3 O-O ",
	"d4 e6 e4 c5 d5 Qc7 Nc3 a6 a4 Nf6 Nf3 b6 Bc4 Bd6 O-O Ng4 ",
	"d4 e6 e4 d5 Nc3 Nf6 Bg5 Bb4 Ne2 dxe4 a3 Be7 g3 Bd7 Bg2 Bc6 ",
	"d4 e6 e4 d5 Nc3 Nf6 Bg5 Bb4 exd5 Qxd5 Bxf6 gxf6 Qd2 Qa5 Nge2 Nd7 ",
	"d4 e6 e4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 Qd2 O-O f4 c5 ",
	"d4 e6 e4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 f4 O-O Nf3 c5 ",
	"d4 e6 e4 d5 Nc3 Nf6 Bg5 h6 Bxf6 Qxf6 exd5 Bb4 Bb5+ c6 dxc6 Nxc6 ",
	"d4 e6 e4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 cxd4 Nxd4 Bc5 ",
	"d4 e6 e4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Bg5 Be7 Nxf6+ Nxf6 Bd3 c5 ",
	"d4 e6 e4 d5 Nd2 Nf6 e5 Nfd7 f4 c5 c3 Nc6 Ndf3 Qb6 g3 cxd4 ",
	"d4 e6 e4 d5 Nd2 Nf6 e5 Nfd7 f4 c5 c3 Nc6 Ndf3 Qb6 g3 cxd4 ",
	"d4 e6 e4 d5 Nd2 b6 Ngf3 Bb7 Bb5+ c6 Bd3 Be7 O-O dxe4 Nxe4 Nf6 ",
	"d4 e6 e4 d5 Nd2 c5 exd5 exd5 Bb5+ Nc6 Ngf3 a6 Bxc6+ bxc6 O-O cxd4 ",
	"d4 e6 e4 d5 e5 c5 Qg4 cxd4 Nf3 Nc6 Bd3 f5 Qh5+ g6 Qh3 Bg7 ",
	"d4 e6 e4 d5 e5 c5 c3 Nc6 Nf3 Bd7 Be2 f6 O-O Qb6 dxc5 Bxc5 ",
	"d4 e6 g3 c5 Nf3 cxd4 Bg2 e5 O-O d6 c3 dxc3 Nxc3 Nf6 Bg5 Be7 ",
	"d4 e6 g3 f5 Bg2 Nf6 Nf3 Be7 c4 d5 O-O O-O Nbd2 c6 Ne5 Nbd7 ",
	"d4 e6 g3 f5 Bg2 Nf6 Nf3 Be7 c4 d5 O-O O-O Nbd2 c6 Ne5 Nbd7 ",
	"d4 f5 Bf4 Nf6 e3 d6 Nc3 c6 Nf3 Qa5 Qd2 Nbd7 Ne4 Qxd2+ Nexd2 Ne4 ",
	"d4 f5 Nf3 Nf6 Bg5 e6 Nbd2 Be7 Bxf6 Bxf6 e4 fxe4 Nxe4 d5 Nxf6+ Qxf6 ",
	"d4 f5 c4 Nf6 Nc3 d6 Nf3 g6 g3 Bg7 Bg2 O-O O-O a5 Bg5 Nc6 ",
	"d4 f5 c4 c5 dxc5 Qa5+ Nc3 Qxc5 e4 fxe4 Nxe4 Qc7 Nh3 g6 Nf4 Bg7 ",
	"d4 f5 c4 e6 Nc3 Bb4 Nf3 Nf6 Qb3 c5 dxc5 Nc6 a3 Bxc5 e3 d6 ",
	"d4 f5 e4 d6 exf5 Bxf5 Qf3 Qc8 Bd3 Bxd3 Qxd3 Nc6 Nf3 e6 O-O Qd7 ",
	"d4 f5 e4 fxe4 Nc3 Nf6 Bg5 c6 Bxf6 exf6 Nxe4 d5 Ng3 Qe7+ Qe2 Qxe2+ ",
	"d4 f5 e4 fxe4 Nc3 Nf6 Bg5 c6 f3 exf3 Nxf3 d5 Bd3 Bg4 h3 Bxf3 ",
	"d4 f5 e4 fxe4 Nc3 Nf6 Bg5 c6 f3 exf3 Nxf3 d6 Bc4 Bg4 h3 Bh5 ",
	"d4 f5 e4 fxe4 Nc3 Nf6 Bg5 c6 f3 exf3 Nxf3 e6 Bd3 Be7 Ne5 O-O ",
	"d4 f5 e4 fxe4 Nc3 Nf6 Bg5 g6 h4 h6 Bxf6 exf6 Qg4 Kf7 h5 g5 ",
	"d4 f5 e4 fxe4 Nc3 Nf6 f3 d5 fxe4 dxe4 Bc4 Bf5 Nge2 Nc6 O-O e6 ",
	"d4 f5 e4 fxe4 Nc3 Nf6 g4 d5 g5 Ng8 f3 exf3 Qxf3 e6 Bd3 g6 ",
	"d4 f5 e4 fxe4 Nc3 e6 Nxe4 Nf6 Nxf6+ gxf6 Qh5+ Ke7 Bd3 Qe8 Qh4 Nc6 ",
	"d4 f5 g3 Nf6 Bg2 e6 Nf3 Be7 O-O O-O c4 d6 Nc3 Qe8 Re1 d5 ",
	"d4 f5 g3 Nf6 Bg2 e6 Nf3 d5 O-O Bd6 c4 c6 Nc3 Nbd7 Qc2 Ne4 ",
	"d4 f5 g3 Nf6 Bg2 e6 Nh3 Be7 O-O O-O c4 d6 Nc3 Qe8 Nf4 g5 ",
	"d4 f5 g3 Nf6 Bg2 e6 e3 Be7 Ne2 O-O O-O d6 b3 e5 dxe5 dxe5 ",
	"d4 f5 g3 Nf6 Bg2 g6 Nf3 Bg7 O-O O-O b3 c6 Bb2 Qe8 Nbd2 h6 ",
	"d4 f5 g3 Nf6 Bg2 g6 Nf3 Bg7 O-O O-O b3 d6 Bb2 a5 a3 c6 ",
	"d4 f5 g3 Nf6 Bg2 g6 Nh3 d6 Nc3 Bg7 Nf4 c6 d5 e5 dxe6 d5 ",
	"d4 f5 g3 Nf6 Bg2 g6 c4 Bg7 Nf3 d6 O-O O-O Nc3 Qe8 b3 Na6 ",
	"d4 f5 g3 e6 Bg2 Nf6 Nf3 Be7 O-O O-O c4 d6 Nc3 Qe8 Re1 Qh5 ",
	"d4 f5 g3 e6 Bg2 Nf6 Nf3 d5 O-O Nbd7 c4 c6 Qc2 Ne4 Nc3 Be7 ",
	"d4 f5 g3 e6 Bg2 Nf6 Nh3 d5 O-O Bd6 c4 c6 Nc3 Nbd7 Qd3 Ne4 ",
	"d4 f5 g3 e6 Bg2 Nf6 Nh3 d5 O-O c6 f3 Be7 e4 fxe4 fxe4 dxe4 ",
	"d4 f5 g3 e6 Bg2 Nf6 c4 Bb4+ Nd2 O-O Nf3 Ne4 Qb3 c5 dxc5 Na6 ",
	"d4 f5 g3 e6 Bg2 Nf6 c4 d5 Nd2 c6 Nh3 Bd6 Qc2 b6 Nf3 O-O ",
	"d4 g6 c4 Bg7 Nc3 d6 e4 Nc6 d5 Nd4 Be3 c5 Nge2 Qb6 Na4 Qa5+ ",
	"d4 g6 c4 Bg7 Nc3 d6 e4 Nd7 Be3 e5 d5 Ne7 Bd3 O-O Nge2 f5 ",
	"d4 g6 c4 Bg7 Nc3 d6 e4 Nf6 Nf3 O-O Be2 e5 O-O Nc6 d5 Ne7 ",
	"d4 g6 e4 Bg7 Nc3 d6 Be3 a6 Qd2 b5 a4 b4 Nce2 a5 c3 Nf6 ",
	"d4 g6 e4 Bg7 Nc3 d6 Bg5 c5 dxc5 Qa5 Qd2 Qxc5 Nd5 Be6 c4 Nd7 ",
	"d4 g6 e4 Bg7 Nc3 d6 Nf3 Nf6 Bc4 O-O O-O Nbd7 Qe2 e5 dxe5 dxe5 ",
	"d4 g6 e4 Bg7 Nc3 d6 f4 Nf6 e5 Nfd7 Be3 c5 Bb5 O-O Nf3 cxd4 ",
	"d4 g6 e4 Bg7 Nf3 d6 Bc4 c5 dxc5 Qa5+ c3 Qxc5 Qb3 e6 Be3 Qc7 ",
	"d4 g6 e4 Bg7 c3 d6 Bg5 Nf6 Nd2 h6 Bh4 c6 f4 Qc7 Bd3 e5 ",
	"d4 g6 e4 Bg7 c4 d6 Nc3 Nc6 Be3 e5 d5 Nd4 Nge2 Nxe2 Bxe2 f5 ",
	"d4 g6 e4 Bg7 f4 d6 Nf3 Nf6 Nc3 O-O Be3 Bg4 Qd2 c6 h3 Bxf3 ",
	"d4 g6 e4 d6 c4 Bg7 Nc3 Nf6 Be2 O-O Nf3 e5 Bg5 h6 Bh4 g5 ",
	"e4 Nc6 Nc3 d6 d4 e5 d5 Nce7 Nge2 Ng6 Ng3 Be7 Nf5 Bxf5 exf5 Nh4 ",
	"e4 Nc6 Nf3 d5 exd5 Qxd5 Nc3 Qa5 Bb5 a6 Bxc6+ bxc6 Qe2 Nf6 Ne5 e6 ",
	"e4 Nc6 Nf3 e5 Bb5 a6 Ba4 b5 Bb3 Na5 O-O d6 d4 Nxb3 axb3 f6 ",
	"e4 Nc6 d4 d5 exd5 Qxd5 Nf3 e5 Nc3 Bb4 Be3 Bg4 Be2 O-O-O O-O Qa5 ",
	"e4 Nf6 Nc3 c5 e5 Ng8 f4 d5 Nf3 Bg4 h3 Bxf3 Qxf3 e6 Bb5+ Nc6 ",
	"e4 Nf6 Nc3 d5 e5 Nfd7 Nxd5 Nxe5 Ne3 c5 Nf3 Ng6 b3 e5 Bb2 f6 ",
	"e4 Nf6 Nc3 d5 e5 d4 Nce2 Ng4 f4 Nc6 Nf3 f6 h3 Nh6 c3 fxe5 ",
	"e4 Nf6 Nc3 d5 exd5 Nxd5 g3 b6 Bg2 Bb7 Nf3 e6 O-O Be7 Re1 O-O ",
	"e4 Nf6 Nc3 d6 d4 g6 f4 e6 Nf3 Bg7 Bd3 Nc6 e5 dxe5 fxe5 Nd5 ",
	"e4 Nf6 e5 Nd5 Nc3 Nxc3 bxc3 d5 Ba3 Bf5 Nf3 Nd7 Nd4 e6 Bxf8 Nxf8 ",
	"e4 Nf6 e5 Nd5 Nc3 Nxc3 bxc3 d6 f4 dxe5 fxe5 Bf5 Qf3 Qc8 Bc4 e6 ",
	"e4 Nf6 e5 Nd5 Nc3 Nxc3 bxc3 d6 f4 dxe5 fxe5 Qd5 d4 c5 Nf3 Nc6 ",
	"e4 Nf6 e5 Nd5 Nc3 Nxc3 dxc3 d6 Nf3 Nc6 Bb5 Bd7 Qe2 Nxe5 Nxe5 dxe5 ",
	"e4 Nf6 e5 Nd5 Nf3 d6 Bc4 e6 O-O Nb6 Bb3 c5 c3 Nc6 exd6 Bxd6 ",
	"e4 Nf6 e5 Nd5 c4 Nb6 d4 d6 exd6 exd6 Nc3 Be7 Qf3 Nc6 Be3 O-O ",
	"e4 Nf6 e5 Nd5 c4 Nb6 d4 d6 exd6 exd6 Nc3 Nc6 a3 Bf5 Be3 g6 ",
	"e4 Nf6 e5 Nd5 c4 Nb6 d4 d6 f4 dxe5 fxe5 Nc6 Be3 Bf5 Nc3 e6 ",
	"e4 Nf6 e5 Nd5 d4 Nb6 a4 a5 Bb5 c6 Bd3 d5 Bg5 g6 h4 h6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 Nc6 exd6 exd6 c4 Nf6 O-O Be7 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 c6 Ng5 Bf5 Bg4 Bxg4 Qxg4 h6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 c6 O-O dxe5 Nxe5 Bxe2 Qxe2 Nd7 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 c4 Nb6 Nc3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 c4 Nb6 Nc3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 c4 Nb6 Nc3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 c4 Nb6 exd6 cxd6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Be7 h3 Bh5 c4 Nb6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Nc6 c4 Nb6 exd6 cxd6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 O-O Nc6 c4 Nb6 exd6 cxd6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 c4 Nb6 exd6 cxd6 O-O Be7 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Bg4 Be2 e6 h3 Bh5 O-O Be7 c4 Nb6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 Nc6 c4 Nb6 e6 fxe6 Ng5 g6 d5 exd5 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 c6 Be2 g6 c4 Nc7 exd6 Qxd6 Nc3 Bg7 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 c6 c4 Nc7 h3 dxe5 Nxe5 Nd7 Nf3 g6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 dxe5 Nxe5 Nd7 Bc4 Nxe5 dxe5 Be6 O-O g6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 dxe5 Nxe5 e6 Qf3 Qf6 Qg3 h6 Nc3 Nb4 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 dxe5 Nxe5 e6 Qf3 Qf6 Qg3 h6 Nc3 Nb4 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 dxe5 Nxe5 g6 Bc4 Be6 O-O Bg7 Re1 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 dxe5 Nxe5 g6 Bc4 c6 O-O Bg7 Nd2 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 dxe5 Nxe5 g6 Bc4 c6 O-O Bg7 Re1 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 dxe5 Nxe5 g6 Be2 Bg7 O-O Nd7 Nf3 c6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 dxe5 Nxe5 g6 c4 Nb6 Nc3 Bg7 Be3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 Ng5 d5 O-O Nc6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 Ng5 d5 O-O O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 Ng5 d5 f4 Nc6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 Ng5 e6 Qf3 Qe7 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 a4 a5 O-O O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 a4 a5 O-O O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 a4 a5 exd6 cxd6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 a4 d5 a5 Nc4 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 a4 d5 a5 Nc4 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 Bg7 exd6 cxd6 O-O O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 Nb6 Bb3 a5 a4 Bg7 Ng5 e6 ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 c6 O-O Bg7 exd6 Qxd6 Re1 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 Bc4 c6 O-O Bg7 exd6 Qxd6 h3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 c4 Nb6 exd6 cxd6 Nc3 Bg7 h3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 c4 Nb6 exd6 cxd6 h3 Bg7 Nc3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 Nf3 g6 c4 Nb6 exd6 cxd6 h3 Bg7 Nc3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 cxd6 Nc3 g6 Bd3 Bg7 Nge2 Nc6 ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 cxd6 Nc3 g6 Bd3 Bg7 Nge2 Nc6 ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 cxd6 Nc3 g6 Be3 Bg7 Bd3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 cxd6 Nc3 g6 Nf3 Bg7 h3 O-O ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 exd6 cxd6 Nc3 g6 h4 h6 Bd3 Bg7 ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 f4 Bf5 Nc3 e6 Nf3 dxe5 fxe5 Bb4 ",
	"e4 Nf6 e5 Nd5 d4 d6 c4 Nb6 f4 dxe5 fxe5 c5 d5 e6 Nc3 exd5 ",
	"e4 a6 d4 b5 a4 b4 Nf3 Bb7 Bd3 e6 O-O c5 Nbd2 cxd4 Nxd4 Nf6 ",
	"e4 b6 d4 Bb7 Bd3 e6 Nh3 d5 e5 Ne7 O-O Ng6 f4 Be7 f5 exf5 ",
	"e4 b6 d4 Bb7 Bd3 g6 f4 Bg7 Nf3 d6 O-O Nd7 c3 e6 Qe1 Qe7 ",
	"e4 c5 Nc3 Nc6 Nf3 e5 Bc4 d6 d3 Be7 Ng5 Bxg5 Qh5 Be7 Qxf7+ Kd7 ",
	"e4 c5 Nc3 Nc6 Nf3 g6 d4 cxd4 Nxd4 Bg7 Be3 d6 h3 Nf6 g4 O-O ",
	"e4 c5 Nc3 Nc6 Nge2 d6 d4 cxd4 Nxd4 e6 Bc4 a6 Be3 Qc7 Qe2 Nf6 ",
	"e4 c5 Nc3 Nc6 Nge2 d6 d4 cxd4 Nxd4 e6 Be3 Nf6 Qd2 Be7 f3 a6 ",
	"e4 c5 Nc3 Nc6 Nge2 e5 Nd5 a6 a4 Nf6 Nec3 Nb4 Bc4 Nbxd5 Nxd5 d6 ",
	"e4 c5 Nc3 Nc6 Nge2 e6 d4 cxd4 Nxd4 Nf6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nc3 Nc6 Nge2 e6 d4 cxd4 Nxd4 Qc7 Be3 a6 Bd3 Nf6 O-O Bd6 ",
	"e4 c5 Nc3 Nc6 Nge2 e6 d4 cxd4 Nxd4 Qc7 f4 a6 Be3 Bb4 Nxc6 Qxc6 ",
	"e4 c5 Nc3 Nc6 Nge2 e6 g3 d5 exd5 exd5 Bg2 Nf6 d4 cxd4 Nxd4 Bg4 ",
	"e4 c5 Nc3 Nc6 Nge2 e6 g3 d5 exd5 exd5 Bg2 d4 Nd5 Nf6 Nef4 Nxd5 ",
	"e4 c5 Nc3 Nc6 f4 e6 Be2 d5 d3 Nge7 Nf3 Nd4 O-O Nec6 Qd2 Be7 ",
	"e4 c5 Nc3 Nc6 f4 g6 Nf3 Bg7 Bb5 e6 Bxc6 bxc6 e5 d5 exd6 Qxd6 ",
	"e4 c5 Nc3 Nc6 g3 d6 Bg2 Nf6 Nge2 g6 d3 Bg7 O-O h5 h3 Bd7 ",
	"e4 c5 Nc3 Nc6 g3 e6 Bg2 Nge7 Nge2 d5 exd5 Nxd5 Nxd5 exd5 d4 Bg4 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 Rb8 O-O e6 f4 d6 g4 h5 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 d6 O-O Nf6 d3 O-O h3 Bd7 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 d6 O-O e5 d3 Nge7 f4 O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 d6 O-O e5 f4 Nge7 d3 Be6 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 e6 d3 Nge7 Be3 Nd4 O-O O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 e6 d3 Nge7 Be3 Nd4 Qd2 Nec6 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 e6 d3 Nge7 O-O O-O Be3 Nd4 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 Nge2 e6 d3 d6 Be3 Nd4 O-O Ne7 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 Nf6 Be3 d6 h3 Nd4 Nce2 Qb6 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Be3 Nh6 Qc1 Ng4 Bd2 Nd4 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nge2 Qd7 Be3 b6 f4 Bb7 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nge2 Rb8 a4 Nh6 O-O O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nge2 e5 Nd5 Nge7 Ne3 Be6 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nge2 e5 O-O Nge7 Be3 O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 Nh3 h5 f4 Bg4 Qd2 Nd4 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 f4 Nf6 Nf3 O-O O-O Ne8 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 f4 e5 Nf3 Nge7 O-O O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 d6 f4 e5 Nf3 Nge7 O-O O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 e6 Be3 Nd4 Nce2 Ne7 c3 Nxe2 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 e6 Be3 Nd4 Nce2 d6 c3 Nc6 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 e6 Be3 d6 Qd2 Bd7 Nf3 Nd4 ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Bg7 d3 e6 f4 d6 Nf3 Nge7 O-O O-O ",
	"e4 c5 Nc3 Nc6 g3 g6 Bg2 Rb8 d3 b5 Be3 b4 Nce2 Bg7 Qc1 d6 ",
	"e4 c5 Nc3 d6 Nf3 Nf6 d4 cxd4 Nxd4 a6 Be3 e5 Nf3 Be7 Bc4 O-O ",
	"e4 c5 Nc3 d6 Nge2 Nf6 d4 cxd4 Nxd4 a6 f4 e6 Qf3 Qb6 a3 g6 ",
	"e4 c5 Nc3 d6 f4 Nc6 Nf3 g6 Bb5 Bd7 O-O Bg7 d3 a6 Bxc6 Bxc6 ",
	"e4 c5 Nc3 e6 Nf3 Nc6 Bb5 Nd4 Bd3 Nxf3+ Qxf3 Bd6 Qe3 e5 Nb5 Qe7 ",
	"e4 c5 Nc3 e6 Nf3 Nc6 d4 cxd4 Nxd4 d6 Be3 Nf6 Bc4 Na5 Bd3 a6 ",
	"e4 c5 Nc3 e6 Nf3 a6 d4 cxd4 Nxd4 Qc7 Be2 Nf6 O-O d6 a4 Nc6 ",
	"e4 c5 Nc3 e6 Nf3 d6 d4 cxd4 Nxd4 Nf6 f4 a6 Qf3 Qc7 g4 b5 ",
	"e4 c5 Nc3 e6 Nge2 d6 g3 Nf6 Bg2 Nc6 O-O a6 d3 Be7 h3 Qc7 ",
	"e4 c5 Nc3 e6 f4 d5 Nf3 Nf6 Bb5+ Nc6 d3 Be7 Bxc6+ bxc6 O-O Ba6 ",
	"e4 c5 Nc3 e6 g3 Nc6 Bg2 Nf6 Nge2 d5 exd5 exd5 d4 c4 Bg5 Bb4 ",
	"e4 c5 Ne2 Nc6 Nbc3 g6 d4 cxd4 Nxd4 Bg7 Be3 Nf6 Bc4 O-O Bb3 a5 ",
	"e4 c5 Ne2 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e5 Nf3 h6 O-O Be6 ",
	"e4 c5 Ne2 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Ne2 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Ne2 Nc6 d4 cxd4 Nxd4 Qb6 Nb3 Nf6 Nc3 e6 Qe2 d6 g4 h6 ",
	"e4 c5 Ne2 Nf6 Nbc3 Nc6 g3 d5 exd5 Nxd5 Bg2 Nxc3 bxc3 e6 O-O Be7 ",
	"e4 c5 Ne2 Nf6 Nbc3 e6 g3 Nc6 Bg2 Be7 O-O d6 d3 a6 a3 Qc7 ",
	"e4 c5 Ne2 d6 c4 e5 Nbc3 g6 g3 h5 h4 Nc6 Bg2 Bh6 a3 Bg4 ",
	"e4 c5 Ne2 d6 d4 cxd4 Nxd4 g6 c4 Bg7 Nc3 Nf6 Be2 O-O O-O Nbd7 ",
	"e4 c5 Ne2 d6 g3 Nc6 Bg2 g6 c3 Bg7 d4 e5 dxc5 dxc5 O-O Be6 ",
	"e4 c5 Ne2 d6 g3 b5 Bg2 Bb7 d4 cxd4 Nxd4 a6 O-O Nf6 Re1 Qc7 ",
	"e4 c5 Ne2 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 Nc6 g5 Nxd4 Qxd4 Nd7 ",
	"e4 c5 Nf3 Nc6 Bb5 Nf6 Nc3 g6 e5 Ng4 Bxc6 dxc6 h3 Nh6 g4 f5 ",
	"e4 c5 Nf3 Nc6 Bb5 Nf6 e5 Ng4 Bxc6 dxc6 O-O g6 Re1 Bg7 h3 Nh6 ",
	"e4 c5 Nf3 Nc6 Bb5 Qb6 Bxc6 Qxc6 O-O d6 d4 cxd4 Nxd4 Qxe4 Nc3 Qg4 ",
	"e4 c5 Nf3 Nc6 Bb5 Qb6 Nc3 e6 O-O Nd4 Ba4 Qa5 a3 b5 b4 Qb6 ",
	"e4 c5 Nf3 Nc6 Bb5 Qb6 a4 a6 Bxc6 Qxc6 Nc3 e6 O-O d6 d4 cxd4 ",
	"e4 c5 Nf3 Nc6 Bb5 b6 O-O Bb7 c3 d5 Qa4 Rc8 Qxa7 Rc7 Ne5 e6 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 Bxc6 bxc6 O-O d5 d3 Ba6 Nbd2 c4 exd5 cxd5 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 O-O Nge7 Re1 Ng6 Nc3 Be7 d4 cxd4 Nxd4 O-O ",
	"e4 c5 Nf3 Nc6 Bb5 e6 O-O Nge7 Re1 a6 Bf1 b6 c3 d5 exd5 Qxd5 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 O-O Nge7 Re1 a6 Bxc6 bxc6 e5 Ng6 b3 Be7 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 O-O Nge7 c3 a6 Ba4 b5 Bc2 Bb7 Re1 d5 ",
	"e4 c5 Nf3 Nc6 Bb5 e6 O-O Nge7 c3 d5 exd5 Qxd5 Re1 g6 b4 Bg7 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 Bxc6 bxc6 O-O Bg7 Re1 Nf6 e5 Nd5 c4 Nc7 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 Bxc6 bxc6 O-O Bg7 Re1 e5 b4 cxb4 a3 c5 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 Re1 Nf6 e5 Nd5 Nc3 Nc7 Bxc6 dxc6 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 Re1 e5 c3 Nge7 a3 O-O b4 cxb4 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 Re1 e5 c3 Nge7 a3 O-O b4 d5 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 Nf6 Re1 O-O d4 cxd4 cxd4 d5 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 Nf6 Re1 O-O h3 a6 Bf1 b5 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 e5 d4 exd4 cxd4 Nxd4 Nxd4 cxd4 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 c3 Bg7 d4 Qb6 a4 cxd4 O-O a6 Bxc6 Qxc6 ",
	"e4 c5 Nf3 Nc6 Bb5 g6 c3 Bg7 d4 cxd4 cxd4 Qb6 Nc3 Nxd4 Nd5 Nxf3+ ",
	"e4 c5 Nf3 Nc6 Nc3 g6 d4 cxd4 Nxd4 Bg7 Be3 Nf6 Bc4 d6 f3 Bd7 ",
	"e4 c5 Nf3 Nc6 d3 e6 g3 g6 Bg2 Bg7 O-O Nge7 Nbd2 O-O Re1 b6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Bd7 Bb3 e6 O-O Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Bd7 Bb3 g6 f3 Na5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Bd7 Bb3 g6 f3 Na5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Bd7 h3 Nxd4 Qxd4 g6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Qb6 Nb3 e6 Be3 Qc7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Qb6 Nb3 e6 O-O Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Qb6 Nde2 e6 O-O Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 Qb6 Nxc6 bxc6 O-O e6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Bb3 Be7 Be3 a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Bb3 Be7 O-O Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Bb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Bb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Bb3 Be7 f4 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bc4 e6 Be3 a6 Bb3 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Ng4 Bg5 Qb6 Bb5 Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Kh1 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Kh1 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Kh1 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Kh1 a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 Kh1 a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O Be7 b3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 e6 O-O a6 Be3 Qc7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 g6 Be3 Bg7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 g6 Be3 Bg7 h4 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 g6 Be3 Bg7 h4 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 g6 O-O Bd7 Be3 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 g6 O-O Bg7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 Ng4 Bg5 Qb6 Bb5 Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 Ng4 Bg5 Qb6 Bb5 Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 e5 Nf3 Be7 Bc4 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 e5 Nf3 Be7 h3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 e6 Qd2 Be7 f3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 g6 h3 Bg7 Qd2 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 Bd7 Qd2 Nxd4 Qxd4 Qa5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 Bd7 Qd2 Nxd4 Qxd4 Qa5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 Bd7 Qd2 Rc8 O-O-O Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 Qa5 Bxf6 gxf6 Nb3 Qg5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 O-O-O a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 h6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd2 h6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 e6 Qd3 Be7 O-O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 g6 Bxf6 exf6 Bc4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g3 g6 Bg2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Nb3 Bb4 Bc4 O-O O-O Bxc3 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Be3 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Bxf6 gxf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Bg5 a6 Na3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Nd5 Nxd5 exd5 Nb8 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Nd5 Nxd5 exd5 Nb8 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Ndb5 d6 Nd5 Nxd5 exd5 Ne7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Ndb5 Bb4 Bf4 Nxe4 Qf3 d5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Ndb5 Bb4 a3 Bxc3+ Nxc3 d5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Ndb5 Bb4 a3 Bxc3+ Nxc3 d5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Bc4 Qa5 O-O Bg7 Nb3 Qc7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 Bc4 Na5 Be2 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Nxc6 bxc6 e5 Ng8 Bc4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Nxc6 bxc6 e5 Ng8 Bc4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Nxc6 bxc6 e5 Ng8 Bc4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qb6 Nb3 Nf6 Nc3 e6 Bd3 Be7 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qb6 Nb3 Nf6 Nc3 e6 Bd3 a6 O-O d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qb6 Nb5 a6 Be3 Qa5+ N5c3 e6 Bd3 b5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nb5 Qb8 c4 Nf6 N5c3 e6 Be3 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nb5 Qb8 c4 b6 Be3 Nf6 Nd2 g6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 Nf6 Ndb5 Qb8 Nd5 Nxd5 exd5 Nd8 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 Be3 a6 Bd3 Nf6 O-O Ne5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 Be3 a6 Bd3 Nf6 O-O Ne5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 Be3 a6 Bd3 b5 Nxc6 Qxc6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 g3 a6 Bg2 Nf6 O-O Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 Nc3 e6 g3 d6 Bg2 Nxd4 Qxd4 Nf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 c4 e6 Nc3 Nf6 Be3 b6 Rc1 Bb7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 Qc7 c4 e6 Nc3 Nf6 Be3 b6 Rc1 Bb7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 d6 Nc3 e6 Be3 Nf6 f4 Be7 Qf3 e5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 d6 Nc3 g6 Be3 Bg7 Qd2 Bd7 O-O-O a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 a6 Nd6+ Bxd6 Qxd6 Qe7 Qd1 Nf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 a6 Nd6+ Bxd6 Qxd6 Qf6 Qc7 Nge7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 a6 Nd6+ Bxd6 Qxd6 Qf6 Qd1 Qg6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 a6 Nd6+ Bxd6 Qxd6 Qf6 Qd1 Qg6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 N1c3 a6 Na3 Be6 Nc4 Rc8 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 N1c3 a6 Na3 b5 Nd5 Nf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 a4 Be6 N1c3 a6 Na3 Nf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 c4 Be7 Bd3 Be6 O-O a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 c4 Be7 Be2 Be6 O-O Nf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 c4 Be7 Be2 Be6 O-O a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 c4 Be7 N1c3 Be6 Be2 a6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 c4 Be7 N1c3 a6 Na3 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 g3 Nf6 Bg2 Bg4 Bf3 h5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e5 Nb5 d6 g3 h5 N1c3 a6 Na3 h4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Be3 Be7 Nc3 h6 Bd3 d5 Bb5 Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Be3 Nf6 Bd3 e5 Nxc6 bxc6 O-O d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nb5 d6 Bf4 e5 Be3 Nf6 Bg5 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nb5 d6 Bf4 e5 Be3 Nf6 Bg5 Be6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nb5 d6 Bf4 e5 Be3 Nf6 Bg5 Qa5+ ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nb5 d6 c4 Nf6 N5c3 Be7 g3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nb5 d6 c4 a6 N5c3 Nf6 Be2 Be7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 Qc7 Be3 a6 a3 Nf6 f4 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 Qc7 Be3 a6 a3 Nf6 f4 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 Qc7 g3 Nf6 Ndb5 Qb8 Bf4 Ne5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 Qc7 g3 Nf6 Ndb5 Qb8 Bf4 Ne5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 Qc7 g3 a6 Bg2 Nf6 O-O d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 a6 Be2 Qc7 O-O Nf6 Be3 Bb4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 a6 Nxc6 bxc6 Bd3 d6 O-O Nf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 a6 Nxc6 bxc6 Bd3 d6 O-O Nf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 a6 Nxc6 bxc6 Bd3 d6 O-O Nf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 a6 Nxc6 bxc6 Bd3 d6 O-O Nf6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 d6 Bc4 Nf6 Be3 a6 Qe2 Qc7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 d6 Be3 Nf6 Bc4 Be7 Qe2 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 d6 Be3 Nf6 f4 Be7 Qf3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 e6 Nc3 d6 f4 Nf6 Nf3 Be7 Bd3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Bc4 Bg7 c3 Nf6 Nxc6 bxc6 e5 Ng8 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Be3 Bg7 c4 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Be3 Bg7 c4 d6 Nc3 Nf6 Be2 Bd7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Be3 Nf6 Nc3 Bg7 Bc4 O-O Bb3 Na5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Be3 Nf6 Nc3 Bg7 Bc4 O-O Bb3 Qa5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Be3 Nf6 Nc3 Bg7 Bc4 O-O Bb3 Qa5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 Na5 Bb3 Nxb3 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 a5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 O-O Bb3 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 Qa5 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 Qa5 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Bc4 Qa5 O-O O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Be2 O-O O-O d5 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 Be2 O-O f4 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 O-O Be2 b6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 O-O Be2 b6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 O-O Be2 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Be3 Nf6 Nc3 O-O Be2 d6 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Bg7 Nc2 b6 Be2 Ba6 O-O Rc8 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 Nxd4 Qxd4 d6 Be2 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 Nxd4 Qxd4 d6 Be2 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 Nxd4 Qxd4 d6 Be2 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 Nxd4 Qxd4 d6 Be2 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 Nxd4 Qxd4 d6 Be2 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 Nxd4 Qxd4 d6 Bg5 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 Nxd4 Qxd4 d6 Qd2 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 Nxd4 Qxd4 d6 b3 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Bg7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Bg7 Be3 O-O ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nc6 d4 cxd4 Nxd4 g6 c4 Nf6 Nc3 d6 Be2 Nxd4 Qxd4 Bg7 ",
	"e4 c5 Nf3 Nf6 Nc3 Nc6 Bb5 Nd4 e5 Nxb5 Nxb5 Nd5 Ng5 f6 Ne4 f5 ",
	"e4 c5 Nf3 Nf6 Nc3 Nc6 d4 cxd4 Nxd4 e6 Be2 Be7 O-O a6 Be3 Qc7 ",
	"e4 c5 Nf3 Nf6 Nc3 d5 Bb5+ Bd7 e5 d4 exf6 dxc3 fxg7 cxd2+ Qxd2 Bxg7 ",
	"e4 c5 Nf3 Nf6 Nc3 d5 exd5 Nxd5 Bb5+ Bd7 Qe2 Nf6 d4 cxd4 Nxd4 g6 ",
	"e4 c5 Nf3 Nf6 Nc3 d6 d4 cxd4 Nxd4 Nc6 Be3 e5 Nf3 Be7 Bc4 Be6 ",
	"e4 c5 Nf3 Nf6 e5 Nd5 Nc3 Nxc3 dxc3 b6 e6 dxe6 Qxd8+ Kxd8 Ne5 Ke8 ",
	"e4 c5 Nf3 Nf6 e5 Nd5 Nc3 e6 Nxd5 exd5 d4 Nc6 dxc5 Bxc5 Qxd5 d6 ",
	"e4 c5 Nf3 Nf6 e5 Nd5 Nc3 e6 Nxd5 exd5 d4 d6 Bg5 Qa5+ c3 cxd4 ",
	"e4 c5 Nf3 a6 Nc3 b5 d4 cxd4 Nxd4 Bb7 Bg5 Qc7 Bd3 e6 O-O Nc6 ",
	"e4 c5 Nf3 a6 c3 Nf6 e5 Nd5 d4 cxd4 Qxd4 e6 Bc4 d6 Qe4 dxe5 ",
	"e4 c5 Nf3 a6 c3 d5 exd5 Qxd5 d4 e6 Be3 cxd4 cxd4 Nf6 Nc3 Qa5 ",
	"e4 c5 Nf3 a6 c3 d6 d4 Nd7 Bd3 e6 O-O Qc7 Bf4 Ne7 Nbd2 Ng6 ",
	"e4 c5 Nf3 a6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Nf3 Bb4 Bg5 Qa5 Bd2 Qc7 ",
	"e4 c5 Nf3 a6 d4 cxd4 Qxd4 Nc6 Qd1 Nf6 Nc3 d6 Bg5 e6 Qd2 Be7 ",
	"e4 c5 Nf3 d5 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 a6 g5 Nfd7 a4 Nc6 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Nxd7 O-O Ngf6 Qe2 e6 b3 Be7 Bb2 O-O ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Nxd7 O-O Ngf6 Qe2 e6 b3 Be7 Bb2 O-O ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Nxd7 O-O Ngf6 Qe2 e6 c3 Rc8 d4 cxd4 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Qxd7 O-O Nc6 Qe2 g6 c3 Bg7 Rd1 e5 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Qxd7 O-O Nf6 e5 dxe5 Nxe5 Qc8 d4 e6 ",
	"e4 c5 Nf3 d6 Bb5+ Bd7 Bxd7+ Qxd7 c4 e5 Nc3 Nc6 O-O Nge7 Nd5 Nxd5 ",
	"e4 c5 Nf3 d6 Bb5+ Nd7 d4 Nf6 O-O cxd4 Qxd4 a6 Bxd7+ Bxd7 Bg5 h6 ",
	"e4 c5 Nf3 d6 Nc3 Bg4 h3 Bxf3 Qxf3 Nc6 g3 g6 Bg2 Bg7 O-O h5 ",
	"e4 c5 Nf3 d6 Nc3 Nc6 d4 cxd4 Nxd4 Nf6 f4 g6 Nxc6 bxc6 e5 Nd7 ",
	"e4 c5 Nf3 d6 Nc3 Nf6 d4 cxd4 Nxd4 a6 g3 e5 Nde2 Be7 Bg2 Nbd7 ",
	"e4 c5 Nf3 d6 Nc3 Nf6 e5 dxe5 Nxe5 Nbd7 Nc4 Nb6 Qf3 e6 b3 Be7 ",
	"e4 c5 Nf3 d6 Nc3 Nf6 e5 dxe5 Nxe5 a6 Be2 g6 O-O Bg7 Bf3 O-O ",
	"e4 c5 Nf3 d6 Nc3 a6 d4 cxd4 Nxd4 Nf6 Bg5 e6 f4 Qb6 Nb3 Be7 ",
	"e4 c5 Nf3 d6 Nc3 a6 g3 Nc6 Bg2 g6 d4 Bg4 dxc5 dxc5 Be3 Qa5 ",
	"e4 c5 Nf3 d6 Nc3 g6 d4 cxd4 Nxd4 Nf6 Be3 Bg7 Bc4 Nc6 f3 O-O ",
	"e4 c5 Nf3 d6 b3 e5 Bb5+ Bd7 Bxd7+ Qxd7 O-O Nc6 c4 g6 d3 Bg7 ",
	"e4 c5 Nf3 d6 b4 cxb4 d4 Nf6 Bd3 d5 Nbd2 dxe4 Nxe4 Nbd7 Neg5 Qc7 ",
	"e4 c5 Nf3 d6 c3 Nf6 Bd3 Nc6 O-O g6 Bc2 Bg7 h3 O-O Re1 Ne8 ",
	"e4 c5 Nf3 d6 c3 Nf6 Be2 Nc6 d4 cxd4 cxd4 Nxe4 d5 Qa5+ Nc3 Nxc3 ",
	"e4 c5 Nf3 d6 d3 Nc6 g3 g6 Bg2 Bg7 O-O e5 c3 Nge7 Nh4 O-O ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 Nc6 Bc4 e6 Be3 Be7 Bb3 O-O ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 a6 Be2 e6 a4 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 a6 Be2 e6 f4 Nbd7 Bf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 a6 Be2 e6 f4 Qc7 O-O b5 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 a6 a4 e6 Be2 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 e6 Be2 a6 O-O Be7 Be3 Qc7 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 e6 g4 h6 Bg2 Nc6 Nb3 a6 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 e6 g4 h6 Rg1 Nc6 h4 h5 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 g6 Be3 Bg7 Be2 O-O O-O Nc6 ",
	"e4 c5 Nf3 d6 d4 Nf6 Nc3 cxd4 Nxd4 g6 Be3 Bg7 f3 Nc6 Qd2 Bd7 ",
	"e4 c5 Nf3 d6 d4 Nf6 dxc5 Nxe4 cxd6 Nxd6 Nc3 Nc6 Bf4 Bg4 h3 Bh5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nc6 Nc3 Nf6 Bc4 Qb6 Nb3 e6 Be3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nc6 Nc3 Nf6 Be3 e5 Nf3 Be7 Bc4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Be3 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nbd7 g4 Nc5 f3 g6 Be3 Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 Bd7 Be3 g6 O-O Bg7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 Qb6 Nb3 e6 Be3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 Qb6 Nb3 e6 Be3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 a6 Bb3 e6 Be3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 Bb3 a6 f4 Qa5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bc4 e6 O-O Be7 Bb3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be2 g6 Be3 Bg7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 Bd7 Be2 Nxd4 Bxd4 Bc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 Ng4 Bb5 Nxe3 fxe3 Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 Ng4 Bg5 h6 Bh4 g5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 e5 Nf3 Be6 Ng5 Rc8 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 e5 Nf3 Be7 Bc4 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 e5 Nf3 Be7 Bc4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 e5 Nf3 Be7 Bc4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 e5 Nf3 Be7 Bc4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Be3 g6 f3 Bg7 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 Bd7 Nb3 a6 f4 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 Bd7 Qd2 Rc8 Nb3 a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 Bd7 Qd2 Rc8 f4 Nxd4 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Be7 O-O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 Nxd4 Qxd4 Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Bg5 e6 Qd2 a6 O-O-O h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 g3 Bg4 f3 Bd7 Be3 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Be7 f4 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Nbd7 Be3 Nc5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Nbd7 Bg5 Nc5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Nbd7 O-O Nc5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Nbd7 O-O Nc5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Nbd7 f4 Nc5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 Nc6 f4 Na5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 O-O Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 O-O Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 Bb3 b5 f4 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 O-O Bd7 Bb3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 O-O Bd7 Bb3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 O-O Be7 a3 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 O-O b5 Bb3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 O-O b5 Bb3 b4 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 a3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bc4 e6 b3 Be7 O-O Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bd3 e5 Nde2 Be7 O-O Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 Qc7 Bg5 Nbd7 O-O e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be6 O-O Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be6 f4 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be6 f4 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be6 f4 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be6 f4 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 Bg5 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 Bg5 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 Bg5 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 Bg5 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 Bg5 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nb3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e5 Nf3 h6 O-O Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 a4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Be7 f4 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Qc7 f4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O Qc7 f4 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 O-O b5 Bf3 Ra7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 a4 Nc6 O-O Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 e6 f4 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 g6 O-O Bg7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be2 g6 O-O Bg7 a4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 Ng4 Bg5 h6 Bh4 g5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nb3 Be6 Nd5 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nb3 Be6 Qd2 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nb3 Be6 Qd2 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nb3 Be6 f3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nb3 Be7 f3 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nf3 Be7 Bc4 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nf3 Qc7 Be2 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nf3 Qc7 a4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e5 Nf3 Qc7 a4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Be2 Qc7 f4 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 Be7 f3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 Be7 f3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 Be7 f3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 Be7 f3 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 Qc7 f3 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 b5 f3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 b5 f3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 b5 f3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 b5 f3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 b5 f3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 Qd2 b5 f3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 a4 Nc6 Be2 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 f3 Be7 Qd2 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 f3 Nbd7 g4 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 f3 Nc6 g4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 f3 b5 g4 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 f4 b5 Qf3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Be3 e6 g4 e5 Nf5 g6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 Qa5 Qd2 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 Nbd7 Bc4 h6 Bxf6 Nxf6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e5 Bxf6 Qxf6 Nd5 Qd8 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Bd7 Qf3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Bd7 Qf3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Be7 Qf3 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Nbd7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Nbd7 Qf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Nb3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Nb3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Nb3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qb6 Qd2 Qxb2 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qc7 Bxf6 gxf6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 Qc7 Qf3 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 b5 e5 h6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 h6 Bh4 Qb6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 h6 Bh4 Qb6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 Bg5 e6 f4 h6 Bh4 Qb6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 Nc6 Be2 e5 Nb3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 Nc6 Be2 e5 Nxc6 bxc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 Nc6 Be2 e6 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 e5 Nf3 Qa5 Nd2 Be6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 e5 Nf3 Qc7 Bg5 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 e6 f4 Be7 Be2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 a4 g6 Be2 Bg7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Nbd7 Be2 e5 fxe5 Nxe5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Nbd7 Be2 e5 fxe5 Nxe5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Nbd7 Be2 g6 Nf3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Nbd7 Qf3 e5 Nf5 g6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Nbd7 a4 g6 Bd3 Bg7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Nc6 Nf3 Bg4 h3 Bxf3 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Bd3 e5 Nf3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Bd3 e6 O-O Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Bd3 g6 O-O Bg7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Bd3 g6 a4 Bg7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Be2 e6 g4 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 Nf3 Nbd7 a4 g6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 Qc7 a4 g6 Nf3 Bg4 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Nbd7 Bc4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Nbd7 Bd3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Nbd7 Bd3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Nbd7 a4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Nbd7 a4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Nbd7 a4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e5 Nf3 Nbd7 a4 d5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Bd3 Nbd7 O-O Qb6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Bd3 Nbd7 O-O Qb6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Bd3 b5 Qf3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Bd3 b5 Qf3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Bd3 b5 Qf3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Be2 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Be2 Qc7 O-O Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Qf3 Qb6 a3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Qf3 Qb6 a3 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Qf3 Qb6 a3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Qf3 Qb6 a3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 f4 e6 Qf3 Qc7 g4 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 g3 e5 Nde2 Be7 Bg2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 g3 e5 Nde2 Be7 Bg2 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 h3 Nc6 g4 Nxd4 Qxd4 e5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 h3 b5 Nd5 Bb7 Nxf6+ gxf6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 a6 h3 g6 g4 Bg7 g5 Nh5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e5 Bb5+ Bd7 Bxd7+ Qxd7 Nf5 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Bc4 a6 Bb3 b5 O-O Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 Be7 O-O O-O f4 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 Be7 O-O O-O f4 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 Be7 O-O O-O f4 a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 Nc6 Be3 Be7 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 a6 O-O Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 a6 O-O Be7 f4 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 a6 O-O Nbd7 f4 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 a6 O-O Nbd7 f4 b5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 a6 O-O Qc7 f4 Nbd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be2 a6 a4 Be7 Be3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be3 a6 f4 Qc7 g4 d5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be3 a6 f4 b5 Qf3 Bb7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 Be3 a6 g4 Nc6 g5 Nd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 f4 Be7 Bd3 O-O O-O Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 f4 a6 Be2 Be7 O-O Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 f4 a6 Be3 Nbd7 g4 Nc5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 f4 a6 Qf3 Qb6 Nb3 Qc7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 f4 a6 Qf3 Qb6 a3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g3 Be7 Bg2 O-O O-O Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g3 Be7 Bg2 O-O O-O a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g3 Be7 Bg2 O-O O-O a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 Be7 g5 Nfd7 h4 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 Be7 g5 Nfd7 h4 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 Nc6 g5 Nd7 Be3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 Nc6 g5 Nd7 Be3 a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 Nc6 g5 Nd7 Ndb5 Nb6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 Nc6 g5 Nd7 Ndb5 Nc5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 d5 exd5 Nxd5 Bb5+ Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 e5 Bb5+ Bd7 Bxd7+ Qxd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 h6 g5 hxg5 Bxg5 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 h6 g5 hxg5 Bxg5 a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 h6 g5 hxg5 Bxg5 a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 e6 g4 h6 h4 Nc6 Rg1 h5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Bc4 Bg7 O-O O-O Be3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Bc4 Bg7 O-O O-O h3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Bc4 Bg7 h3 O-O O-O Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Bc4 Bg7 h3 a6 O-O O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be2 Bg7 Be3 Nc6 h4 h5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be2 Bg7 O-O Nc6 Nb3 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be2 Bg7 O-O O-O Be3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be2 Bg7 O-O O-O Nb3 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 Be2 O-O h4 d5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 Nc6 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Bc4 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Bg7 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Nc6 f3 Bg7 Qd2 Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Nc6 f3 Bg7 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Be3 Nc6 f3 Bg7 Qd2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 Bg5 Bg7 Qd2 Nc6 Nb3 a5 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 f4 Bg7 e5 dxe5 fxe5 Nfd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 f4 Nc6 Be3 Bg7 Be2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 f4 Nc6 Nb3 Bg7 Be2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 f4 Nc6 Nxc6 bxc6 e5 Nd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 f4 Nc6 Nxc6 bxc6 e5 Nd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O O-O a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 g3 Nc6 Nde2 Bd7 Bg2 Qc8 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 g3 Nc6 Nde2 Bg7 Bg2 Bd7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 Nf6 Nc3 g6 g3 Nc6 Nde2 Bg7 Bg2 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 a6 Nc3 Nf6 Bc4 e6 Bb3 Be7 f4 O-O ",
	"e4 c5 Nf3 d6 d4 cxd4 Nxd4 g6 Nc3 Bg7 Be3 Nf6 f3 O-O Qd2 Nc6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Bd7 c4 Nc6 Qd2 Nf6 Nc3 g6 b3 Bg7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 Nc3 Nf6 Bg5 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 Nc3 Nf6 Bg5 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 Nc3 Nf6 Bg5 e6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Nc6 Bb5 Qd7 Bxc6 bxc6 O-O e5 Qd3 Be7 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 Nc6 Bb5 e6 Be3 Bd7 Qd2 Nf6 Nc3 a6 ",
	"e4 c5 Nf3 d6 d4 cxd4 Qxd4 a6 Bg5 Nc6 Qd2 Nf6 Bd3 e6 c4 h6 ",
	"e4 c5 Nf3 d6 g3 Nf6 d3 Nc6 Bg2 g6 O-O Bg7 Re1 O-O c3 Ne8 ",
	"e4 c5 Nf3 e6 Nc3 Nc6 Bb5 Nge7 O-O Ng6 d4 cxd4 Nxd4 Be7 Be3 O-O ",
	"e4 c5 Nf3 e6 Nc3 Nc6 Bb5 Nge7 O-O a6 Bxc6 Nxc6 d4 cxd4 Nxd4 Qc7 ",
	"e4 c5 Nf3 e6 Nc3 Nc6 d4 cxd4 Nxd4 Qc7 Be3 a6 Bd3 Nf6 Qd2 Bd6 ",
	"e4 c5 Nf3 e6 Nc3 Nc6 d4 cxd4 Nxd4 Qc7 g3 a6 Bg2 Nf6 O-O Be7 ",
	"e4 c5 Nf3 e6 Nc3 Nc6 d4 cxd4 Nxd4 a6 Be2 Nge7 O-O Nxd4 Qxd4 Nc6 ",
	"e4 c5 Nf3 e6 Nc3 a6 d4 cxd4 Nxd4 Qc7 Bd3 Nc6 Be3 Nf6 O-O Bd6 ",
	"e4 c5 Nf3 e6 Nc3 a6 d4 cxd4 Nxd4 Qc7 Bd3 Nc6 Be3 Nf6 O-O Ne5 ",
	"e4 c5 Nf3 e6 Nc3 a6 g3 b5 Bg2 Bb7 d3 d6 O-O Be7 e5 d5 ",
	"e4 c5 Nf3 e6 Nc3 a6 g3 b5 d4 cxd4 Nxd4 Bb7 Bg2 Nf6 O-O Bb4 ",
	"e4 c5 Nf3 e6 Nc3 d5 exd5 exd5 d4 Nf6 Bg5 Be6 Bxf6 gxf6 dxc5 Bxc5 ",
	"e4 c5 Nf3 e6 Nc3 d6 g3 Nc6 Bg2 Nf6 O-O Bd7 d3 Be7 Bf4 O-O ",
	"e4 c5 Nf3 e6 b3 b6 c4 Bb7 Nc3 Nc6 Bb2 Nf6 Bd3 d6 O-O Be7 ",
	"e4 c5 Nf3 e6 c3 Nf6 e5 Nd5 d4 cxd4 cxd4 d6 Nc3 Nc6 Bd3 dxe5 ",
	"e4 c5 Nf3 e6 c3 Nf6 e5 Nd5 d4 cxd4 cxd4 d6 a3 Nc6 Bd3 Qc7 ",
	"e4 c5 Nf3 e6 c3 d5 exd5 exd5 Bb5+ Nc6 O-O Bd6 d4 cxd4 Nxd4 Qc7 ",
	"e4 c5 Nf3 e6 c3 d5 exd5 exd5 d4 Bd6 dxc5 Bxc5 Be2 Nc6 O-O Nge7 ",
	"e4 c5 Nf3 e6 c3 d5 exd5 exd5 d4 a6 Be2 c4 Bf4 Bd6 Bxd6 Qxd6 ",
	"e4 c5 Nf3 e6 d3 Nc6 g3 Nf6 Bg2 Be7 O-O O-O Nbd2 Rb8 Re1 d6 ",
	"e4 c5 Nf3 e6 d3 Nc6 g3 d5 Nbd2 Bd6 Bg2 Nge7 O-O O-O Nh4 b6 ",
	"e4 c5 Nf3 e6 d3 Nc6 g3 g6 Bg2 Bg7 O-O Nge7 Re1 O-O c3 d5 ",
	"e4 c5 Nf3 e6 d3 Nc6 g3 g6 Bg2 Bg7 O-O Nge7 Re1 d6 c3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Bc5 Be3 Qb6 Nb5 Nf6 Bxc5 Qxc5 Nd6+ Ke7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Bc5 Be3 Qb6 Nc3 Qxb2 Ndb5 Bxe3 Rb1 Qxb1 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Bc5 Nb3 Bb6 Nc3 Ne7 Bf4 O-O Bd6 f5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Bc5 Nc3 Qb6 Be3 Nc6 Na4 Qa5+ c3 Bxd4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Be3 Nf6 Bd3 Bb4+ c3 Ba5 O-O Bb6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 a6 Nd6+ Bxd6 Qxd6 Qe7 Qg3 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 Bf4 e5 Be3 Nf6 Bg5 Be6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 Bf4 e5 Be3 Nf6 Bg5 Be6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 Bf4 e5 Be3 Nf6 Bg5 Be6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 Bf4 e5 Be3 Nf6 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 Bf4 e5 Be3 Nf6 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 Bf4 e5 Be3 Nf6 N1c3 Be6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N1c3 a6 Na3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nb5 d6 c4 Nf6 N5c3 Be7 Be2 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Nf6 Nxc6 bxc6 e5 Nd5 Ne4 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 Nf6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 Nf6 O-O a6 Kh1 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Bc5 Nb3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Be3 Bb4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Be3 Bb4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Be3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Be3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 O-O Nf6 Kh1 Nxd4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be2 a6 f4 Nxd4 Qxd4 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be3 Nf6 Bd3 Nxd4 Bxd4 Bc5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be3 Nf6 Bd3 Nxd4 Bxd4 Bc5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 Be3 a6 Bd3 Nf6 O-O Ne5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 f4 a6 Be2 Nxd4 Qxd4 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 f4 a6 Nf3 Bc5 Bd3 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 f4 a6 Nf3 Bc5 Bd3 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 f4 a6 Nf3 b5 Bd3 Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 f4 a6 Nf3 b5 Bd3 Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 f4 a6 Nxc6 Qxc6 Bd3 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 f4 a6 Nxc6 bxc6 Bd3 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 g3 a6 Bg2 d6 O-O Bd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 g3 a6 Bg2 d6 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 Qc7 g3 d6 Bg2 Nxd4 Qxd4 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 Nge7 O-O Nxd4 Qxd4 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 Nge7 f4 Nxd4 Qxd4 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 Qc7 O-O Nf6 Be3 Bb4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 Qc7 O-O Nf6 Kh1 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 d6 Be3 Nf6 f4 Bd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 d6 O-O Nf6 Be3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Be2 d6 O-O Nf6 Be3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Nxc6 bxc6 Bd3 d6 O-O Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 Nxc6 bxc6 Bd3 d6 O-O Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 g3 Qc7 Bg2 Nf6 O-O h6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 a6 g3 d6 Bg2 Bd7 O-O Rc8 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be2 Be7 O-O Nf6 Be3 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be2 Nf6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be2 Nf6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be2 Nf6 O-O Be7 Be3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be2 Nf6 O-O Be7 Kh1 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be3 Nf6 Bc4 Be7 Qe2 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be3 Nf6 Be2 Be7 O-O O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nc3 d6 Be3 Nf6 f4 e5 Nf3 Ng4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nxc6 bxc6 Bd3 Nf6 O-O d5 Nd2 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 Nxc6 bxc6 c4 Nf6 Bd3 Be7 O-O d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nc6 g3 Nf6 Bg2 Qc7 Nb5 Qb8 Bf4 e5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Bd3 Nc6 Nxc6 bxc6 O-O Be7 e5 Nd5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Bb4 e5 Nd5 Bd2 Bxc3 bxc3 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 Bb4 a3 Bxc3+ Nxc3 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 Bb4 a3 Bxc3+ Nxc3 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 Bb4 a3 Bxc3+ Nxc3 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Be3 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Ndb5 d6 Bf4 e5 Bg5 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 Nc6 Nxc6 bxc6 e5 Nd5 Ne4 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O Nc6 Be3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O Nc6 Be3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O Be3 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O Be3 a6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O f4 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O f4 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O f4 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 Be7 O-O O-O f4 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 Be3 Qc7 a4 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 O-O Be7 Be3 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 O-O Nbd7 f4 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 a4 Be7 O-O Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 a4 Qc7 Be3 b6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be2 a6 a4 Qc7 f4 Nbd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 a6 f3 Nbd7 g4 h6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Be3 a6 f3 Nbd7 g4 h6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 Bg5 Be7 Qf3 h6 Bxf6 Bxf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 f4 Nc6 Be3 Qc7 Qf3 Bd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 f4 Nc6 Be3 e5 Nf3 Ng4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 f4 a6 Qf3 Qb6 Nb3 Qc7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g3 Nc6 Bg2 Bd7 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g3 a6 Bg2 Qc7 O-O Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 Nc6 g5 Nd7 Be3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 Nc6 g5 Nd7 Be3 Nc5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 a6 g5 Nfd7 Bc4 Ne5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 a6 g5 Nfd7 Be3 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 a6 g5 Nfd7 Be3 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 a6 g5 Nfd7 h4 b5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 Bg2 Nc6 h3 Bd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 Bg2 Nc6 h3 Be7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 Rg1 Be7 Be3 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 Rg1 Nc6 Be3 g5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 Rg1 Nc6 Be3 g5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 Rg1 a6 h4 Qa5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 g5 hxg5 Bxg5 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 h4 Be7 Bg2 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 h4 Nc6 Rg1 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 h4 Nc6 Rg1 h5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 h4 Nc6 Rg1 h5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Nf6 Nc3 d6 g4 h6 h4 a6 Rg1 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Qb6 Nb3 Qc7 c4 Nf6 Nc3 Bb4 Bd2 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 Qb6 Nb3 Qc7 g3 Nc6 Bg2 Nf6 Bf4 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Bc5 Nb3 Ba7 O-O Nc6 Qe2 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Bc5 Nb3 Ba7 O-O Nc6 Qg4 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Bc5 Nb3 Bb6 O-O Ne7 Qe2 Nbc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nc6 Be3 Nf6 O-O Qc7 Nc3 Bd6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nc6 Nxc6 bxc6 O-O d5 Nd2 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nc6 Nxc6 bxc6 O-O d5 c4 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nc6 Nxc6 bxc6 O-O d5 c4 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O Qc7 Nd2 Nc6 Nxc6 bxc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O Qc7 Qe2 d6 c4 g6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O Qc7 f4 d6 Kh1 Nbd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O d6 Be3 Be7 c4 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O d6 c4 Bd7 Nc3 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O d6 c4 Be7 Nc3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Nf6 O-O d6 c4 g6 Nc3 Bg7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Qc7 O-O Nc6 Nxc6 bxc6 f4 d5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Qc7 O-O Nc6 Nxc6 dxc6 a4 a5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 Qc7 O-O Nf6 Qe2 d6 c4 g6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 b6 O-O Bb7 Qe2 d6 f4 Nd7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 d6 O-O Nd7 c4 Ne5 Be2 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 d6 O-O Nf6 c4 Be7 Nc3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 d6 O-O Nf6 c4 Be7 Nc3 O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Bd3 d6 O-O g6 Be3 Bg7 f4 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Bd3 Nc6 Be3 Nf6 O-O Ne5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Bd3 Nc6 Be3 Nf6 O-O Ne5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Bd3 Nc6 Nb3 Nf6 Be3 d6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Be2 Nf6 O-O Bb4 Bg5 Bxc3 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Be2 b5 Bf3 Bb7 O-O Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 Be2 b5 f4 b4 Na4 Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 g3 Bb4 Bd2 Nc6 Nxc6 dxc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 g3 Bb4 Ne2 Nc6 Bg2 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 g3 Nf6 Bg2 Be7 O-O O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 g3 Nf6 Bg2 Be7 O-O O-O ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 Qc7 g3 b5 Bg2 Bb7 O-O Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 b5 Bd3 Bb7 O-O Qc7 Re1 Bd6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 b5 Bd3 Bb7 O-O Qc7 Re1 Nc6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 d6 Be3 b5 a4 b4 Na2 Nf6 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 d6 a4 Nf6 Be2 Nbd7 O-O Nc5 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 Nc3 g6 Be2 Bg7 O-O b5 a3 Bb7 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 c4 Qc7 Nc3 Nf6 Bd3 Nc6 Be3 Nxd4 ",
	"e4 c5 Nf3 e6 d4 cxd4 Nxd4 a6 g3 d5 Bg2 dxe4 Bxe4 Bc5 Be3 Nf6 ",
	"e4 c5 Nf3 e6 g3 Nf6 d3 d5 Nbd2 Be7 Bg2 O-O O-O Nc6 Re1 Qc7 ",
	"e4 c5 Nf3 g6 c3 Bg7 d4 cxd4 cxd4 d5 e5 Nc6 h3 Nh6 Nc3 O-O ",
	"e4 c5 Nf3 g6 c3 Bg7 d4 cxd4 cxd4 d5 e5 Nc6 h3 Nh6 Nc3 O-O ",
	"e4 c5 Nf3 g6 c4 Bg7 d4 cxd4 Nxd4 Nc6 Be3 Nf6 Nc3 Ng4 Qxg4 Nxd4 ",
	"e4 c5 Nf3 g6 c4 Bg7 d4 cxd4 Nxd4 Nc6 Be3 Nf6 Nc3 O-O Be2 d6 ",
	"e4 c5 Nf3 g6 c4 Bg7 d4 d6 Nc3 Nc6 Be3 Bg4 dxc5 dxc5 Qxd8+ Rxd8 ",
	"e4 c5 Nf3 g6 c4 Bg7 d4 d6 Nc3 Nc6 Be3 Bg4 dxc5 dxc5 Qxd8+ Rxd8 ",
	"e4 c5 Nf3 g6 d4 Bg7 Nc3 cxd4 Nxd4 Nc6 Be3 Nf6 Bc4 d6 f3 Qb6 ",
	"e4 c5 Nf3 g6 d4 Bg7 d5 d6 Nc3 Nf6 Bb5+ Nbd7 a4 O-O O-O a6 ",
	"e4 c5 Nf3 g6 d4 Bg7 dxc5 Qa5+ Nc3 Nf6 Bd3 Qxc5 O-O d6 Be3 Qa5 ",
	"e4 c5 Nf3 g6 d4 cxd4 Nxd4 Bg7 Nc3 Nc6 Be3 Nf6 Bc4 Qa5 O-O d6 ",
	"e4 c5 Nf3 g6 d4 cxd4 Nxd4 Bg7 c4 Nc6 Be3 Nh6 Be2 d6 Nc3 O-O ",
	"e4 c5 Nf3 g6 d4 cxd4 Nxd4 Nf6 Nc3 Bg7 e5 Ng8 Bf4 Nc6 Nxc6 bxc6 ",
	"e4 c5 Nf3 g6 d4 cxd4 Qxd4 Nf6 Bb5 Nc6 Bxc6 dxc6 Qxd8+ Kxd8 Nc3 Bg7 ",
	"e4 c5 Nf3 g6 d4 cxd4 Qxd4 Nf6 Bb5 Nc6 Bxc6 dxc6 Qxd8+ Kxd8 e5 Nd5 ",
	"e4 c5 Nf3 g6 d4 cxd4 Qxd4 Nf6 Bb5 Nc6 Bxc6 dxc6 Qxd8+ Kxd8 e5 Nd5 ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 Nc6 Nf3 cxd4 cxd4 e6 a3 d6 Bd3 Qa5+ ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 cxd4 Nf3 Nc6 Bc4 Nb6 Bb3 d5 exd6 Qxd6 ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 cxd4 Nf3 Nc6 Bc4 Nb6 Bb3 d5 exd6 Qxd6 ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 cxd4 cxd4 d6 Nf3 Nc6 Be2 g6 O-O Bg7 ",
	"e4 c5 c3 Nf6 e5 Nd5 d4 cxd4 cxd4 d6 Nf3 Nc6 Nc3 dxe5 dxe5 Be6 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 Nc6 Nf3 Bg4 Be2 cxd4 cxd4 e6 Nc3 Qa5 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 Nc6 Nf3 Bg4 Be2 cxd4 cxd4 e6 h3 Bh5 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 Nc6 Nf3 Bg4 Be2 cxd4 cxd4 e6 h3 Bh5 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 Nc6 Nf3 Nf6 dxc5 Qxc5 Be3 Qa5 Na3 Bg4 ",
	"e4 c5 c3 d5 exd5 Qxd5 d4 Nc6 dxc5 Qxc5 Nf3 Nf6 Na3 Bd7 Be3 Qa5 ",
	"e4 c5 c3 d6 d4 Nf6 Bd3 Nc6 Ne2 g6 O-O Bg7 h3 O-O Be3 cxd4 ",
	"e4 c5 c4 Nf6 Nc3 e6 f4 Nc6 Nf3 d5 e5 Nd7 cxd5 exd5 Bb5 Nd4 ",
	"e4 c5 d4 cxd4 Nf3 Nc6 Nxd4 e5 Nxc6 bxc6 Bc4 Nf6 O-O d5 exd5 cxd5 ",
	"e4 c5 d4 cxd4 Nf3 Nc6 Nxd4 e6 Nb5 d6 Bf4 e5 Be3 f5 N1c3 f4 ",
	"e4 c5 d4 cxd4 Nf3 e5 Bc4 Bb4+ c3 dxc3 bxc3 Bc5 Nxe5 Qf6 Bxf7+ Kf8 ",
	"e4 c5 d4 cxd4 Nf3 e5 Bc4 Be7 c3 d6 Qb3 dxc3 Bxf7+ Kf8 Nxc3 Nc6 ",
	"e4 c5 d4 cxd4 Nf3 e6 Nxd4 Bc5 Nb3 Bb6 Nc3 Ne7 Bf4 O-O Bd6 f5 ",
	"e4 c5 d4 cxd4 Qxd4 Nc6 Qe3 g6 Nc3 Bg7 Be2 d6 Bd2 Nf6 Nd5 Nxd5 ",
	"e4 c5 d4 cxd4 c3 dxc3 Nxc3 Nc6 Bc4 e6 Nf3 a6 O-O d6 Bf4 Be7 ",
	"e4 c5 d4 cxd4 c3 dxc3 Nxc3 Nc6 Nf3 e6 Bc4 Nge7 Bg5 f6 Be3 Ng6 ",
	"e4 c5 f4 Nc6 b3 d5 exd5 Qxd5 Nc3 Qe6+ Qe2 Nd4 Qxe6 Bxe6 Bd3 O-O-O ",
	"e4 c5 f4 d5 exd5 Nf6 Bb5+ Bd7 Bxd7+ Qxd7 c4 e6 Qe2 Bd6 Nf3 O-O ",
	"e4 c5 f4 e6 Nf3 d5 Bb5+ Nc6 Qe2 d4 Bxc6+ bxc6 d3 Nf6 O-O Be7 ",
	"e4 c5 f4 e6 Nf3 d5 exd5 exd5 d4 Bg4 Be2 Bxf3 Bxf3 Nf6 O-O Be7 ",
	"e4 c5 g3 Nc6 Bg2 g6 Ne2 Bg7 O-O d6 c3 e5 Na3 Nge7 Nc2 O-O ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 a3 Be7 g4 Nfd7 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 a3 Be7 g4 Nfd7 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 Nf6 d3 e6 a3 Nbd7 g4 Bd6 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 e6 a3 dxe4 Nxe4 Nf6 Nc3 Nd5 ",
	"e4 c6 Nc3 d5 Nf3 Bg4 h3 Bxf3 Qxf3 e6 d4 Nf6 Bd3 dxe4 Nxe4 Nxe4 ",
	"e4 c6 Nc3 d5 Nf3 Nf6 e5 Ne4 Ne2 Qb6 d4 c5 dxc5 Qxc5 Ned4 Nc6 ",
	"e4 c6 Nc3 d5 Nf3 d4 Ne2 c5 Ng3 Nc6 Bc4 e5 d3 Be7 O-O Nf6 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Ne5 Bh7 Qh5 g6 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Bg4 d4 e6 Bd3 Nd7 Bf4 Ndf6 Neg5 Bd6 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Bg4 h3 Bxf3 Qxf3 Nd7 Ng5 Ngf6 Qb3 e6 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Bg4 h3 Bxf3 Qxf3 Nd7 d4 Ngf6 Bd3 Nxe4 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Bg4 h3 Bxf3 Qxf3 Nd7 d4 Ngf6 Bd3 Nxe4 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Neg5 Nd5 d4 h6 Ne4 N7b6 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Neg5 Nd5 d4 h6 Ne4 N7b6 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Nf6 Nxf6+ exf6 Bc4 Bd6 O-O O-O d4 Be6 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Nf6 Nxf6+ exf6 Bc4 Bd6 Qe2+ Qe7 Qxe7+ Kxe7 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Nf6 Nxf6+ exf6 d4 Bd6 Bc4 O-O O-O Re8 ",
	"e4 c6 Nc3 d5 Nf3 dxe4 Nxe4 Nf6 Nxf6+ gxf6 Be2 Bg4 d4 Qc7 O-O Nd7 ",
	"e4 c6 Nc3 d6 d4 Nd7 Nf3 e5 Bc4 Be7 dxe5 Nxe5 Nxe5 dxe5 Qh5 g6 ",
	"e4 c6 Ne2 d5 e5 c5 d4 Nc6 c3 e6 Nd2 cxd4 cxd4 Nh6 Nf3 Nf5 ",
	"e4 c6 Nf3 d5 Nc3 Bg4 h3 Bxf3 Qxf3 e6 Be2 d4 Nb1 Nf6 d3 c5 ",
	"e4 c6 Nf3 d5 Nc3 Bg4 h3 Bxf3 Qxf3 e6 d4 dxe4 Nxe4 Qxd4 Bd3 Nf6 ",
	"e4 c6 b3 d5 exd5 cxd5 Bb2 Nc6 g3 e5 Bg2 Be6 Qe2 Qc7 Nf3 f6 ",
	"e4 c6 c4 d5 cxd5 cxd5 exd5 Nf6 Nc3 Nxd5 Nf3 e6 d4 Nc6 Bd3 Be7 ",
	"e4 c6 c4 d5 cxd5 cxd5 exd5 Nf6 Nc3 Nxd5 Nf3 g6 Qb3 Nb6 Bb5+ Bd7 ",
	"e4 c6 c4 d5 cxd5 cxd5 exd5 Nf6 Nc3 Nxd5 Nf3 g6 Qb3 Nb6 Bb5+ Bd7 ",
	"e4 c6 c4 d5 cxd5 cxd5 exd5 Nf6 Nc3 Nxd5 Nf3 g6 Qb3 Nb6 Bb5+ Bd7 ",
	"e4 c6 c4 d5 exd5 cxd5 cxd5 Nf6 Nc3 Nxd5 Nf3 Nc6 d4 Bg4 Qb3 Bxf3 ",
	"e4 c6 c4 d5 exd5 cxd5 cxd5 Nf6 Nc3 Nxd5 Nf3 Nc6 d4 Bg4 Qb3 Bxf3 ",
	"e4 c6 c4 d5 exd5 cxd5 cxd5 Nf6 Nc3 Nxd5 Nf3 Nxc3 bxc3 g6 d4 Bg7 ",
	"e4 c6 c4 d5 exd5 cxd5 cxd5 Nf6 Nc3 Nxd5 Nf3 Nxc3 bxc3 g6 h4 h6 ",
	"e4 c6 c4 d5 exd5 cxd5 cxd5 Nf6 Nc3 Nxd5 Nf3 e6 d4 Bb4 Bd2 Nc6 ",
	"e4 c6 c4 d5 exd5 cxd5 cxd5 Nf6 Nc3 g6 Bc4 Bg7 Nf3 O-O O-O Nbd7 ",
	"e4 c6 c4 d5 exd5 cxd5 d4 Nf6 Nc3 Nc6 Bg5 Bg4 Be2 Bxe2 Ngxe2 dxc4 ",
	"e4 c6 c4 d5 exd5 cxd5 d4 Nf6 Nc3 e6 Nf3 Be7 cxd5 Nxd5 Bd3 Nc6 ",
	"e4 c6 c4 d5 exd5 cxd5 d4 Nf6 Nc3 e6 Nf3 Be7 cxd5 Nxd5 Bd3 O-O ",
	"e4 c6 c4 e5 Nf3 f5 exf5 e4 Nd4 Qf6 Nc2 Qxf5 Nc3 Nf6 d4 Na6 ",
	"e4 c6 d3 d5 Nd2 Nd7 Ngf3 Qc7 exd5 cxd5 d4 g6 Bd3 Bg7 O-O Nh6 ",
	"e4 c6 d3 d5 Nd2 Nd7 Ngf3 Qc7 exd5 cxd5 d4 g6 Bd3 Bg7 O-O e6 ",
	"e4 c6 d3 d5 Nd2 e5 Ngf3 Bd6 Qe2 Nf6 d4 dxe4 Nxe5 Bf5 h3 h5 ",
	"e4 c6 d3 d5 Nd2 e5 Ngf3 Nd7 d4 dxe4 Nxe4 exd4 Qxd4 Ngf6 Bg5 Be7 ",
	"e4 c6 d3 d5 Nd2 e5 Ngf3 Nd7 d4 dxe4 Nxe4 exd4 Qxd4 Ngf6 Bg5 Be7 ",
	"e4 c6 d3 d5 Nd2 g6 Ngf3 Bg7 g3 Nf6 Bg2 O-O O-O Bg4 h3 Bxf3 ",
	"e4 c6 d4 d5 Nc3 Nf6 e5 Nfd7 e6 fxe6 Bd3 Nf6 Nf3 g6 h4 c5 ",
	"e4 c6 d4 d5 Nc3 b5 a3 dxe4 Nxe4 Bf5 Bd3 Bxe4 Bxe4 Nf6 Bd3 e6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 Bc4 e6 Qe2 Qc7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 Bd3 Ngf6 O-O e6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 Bd3 Qa5+ Bd2 Qc7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nd7 h4 h6 Bd3 Bxd3 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 Nf3 Nf6 h4 h6 Bd3 Bxd3 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 Bd3 Bxd3 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 h6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 h6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nc3 e6 Bd3 c5 Qe2 cxd4 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Ng3 e6 Bd3 Be7 Qe2 c5 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Ng3 e6 Bd3 c5 O-O cxd4 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Ng3 e6 Bd3 c5 c3 cxd4 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Bc4 Bf5 Qe2 e6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Bc4 Bf5 Qe2 e6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Bc4 Bf5 Qe2 e6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Ne5 Bf5 c3 e6 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nf6 Bd3 Nxe4 Bxe4 Bf5 Bxf5 Qa5+ c3 Qxf5 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nf6 Ng3 e6 Be3 Be7 Bd3 Nbd7 Qe2 Qc7 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nf6 Ng3 h5 h4 Qc7 Be2 Bg4 Bxg4 Nxg4 ",
	"e4 c6 d4 d5 Nc3 dxe4 Nxe4 Nf6 Nxf6+ gxf6 Bc4 Bf5 Ne2 e6 Ng3 Bg6 ",
	"e4 c6 d4 d5 Nc3 g6 Nf3 Bg7 h3 dxe4 Nxe4 Nd7 Bc4 Ngf6 Nxf6+ Nxf6 ",
	"e4 c6 d4 d5 Nc3 g6 h3 Bg7 Nf3 Nf6 Bd3 dxe4 Nxe4 O-O O-O Nbd7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 Nf3 Nd7 h5 Bh7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 f4 e6 Nf3 Nd7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Bf5 Ng3 Bg6 h4 h6 h5 Bh7 Nf3 Nd7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 a5 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 a5 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bb3 h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Bc4 Ngf6 Ng5 e6 Qe2 Nb6 Bd3 h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Ne2 Ngf6 N2g3 Nxe4 Nxe4 Nf6 Nxf6+ gxf6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Nf3 Ngf6 Ng3 e6 Bd3 Be7 Qe2 O-O ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Ng5 Ndf6 N1f3 e6 Ne5 Nh6 Bd3 Bd6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Ng5 Ngf6 Bc4 e6 Qe2 Nb6 Bb3 h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Ng5 Ngf6 Bc4 e6 Qe2 Nb6 Bb3 h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Ng5 Ngf6 Bd3 c5 N1f3 cxd4 O-O Qb6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Ng5 Ngf6 Bd3 e6 N1f3 Bd6 O-O h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Ng5 Ngf6 Bd3 e6 N1f3 Bd6 Qe2 h6 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nf6 Ng3 g6 Bc4 Qd6 c3 Be6 Bd3 Nbd7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nf6 Nxf6+ exf6 Bc4 Qe7+ Qe2 Be6 Bb3 Nd7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nf6 Nxf6+ exf6 g3 c5 Nf3 Bd6 Be3 Qc7 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nf6 Nxf6+ gxf6 Bc4 Bf5 Bf4 Qb6 Bb3 a5 ",
	"e4 c6 d4 d5 Nd2 dxe4 Nxe4 Nf6 Nxf6+ gxf6 c3 Bf5 Bf4 Nd7 Bd3 Bg6 ",
	"e4 c6 d4 d5 Nd2 g6 c3 Bg7 e5 f6 f4 Nh6 Ngf3 O-O Be2 fxe5 ",
	"e4 c6 d4 d5 e5 Bf5 Be2 e6 Nf3 c5 O-O Nc6 c3 Qb6 Qa4 c4 ",
	"e4 c6 d4 d5 e5 Bf5 Nc3 e6 g4 Bg6 Nge2 Be7 Be3 Nd7 Qd2 h5 ",
	"e4 c6 d4 d5 e5 Bf5 Nc3 e6 g4 Bg6 Nge2 c5 h4 cxd4 Nxd4 h5 ",
	"e4 c6 d4 d5 e5 Bf5 Nc3 e6 g4 Bg6 Nge2 c5 h4 h6 Nf4 Bh7 ",
	"e4 c6 d4 d5 e5 Bf5 Nc3 h5 Bd3 Bxd3 Qxd3 e6 Nf3 Qb6 O-O Qa6 ",
	"e4 c6 d4 d5 e5 Bf5 Nf3 e6 Be2 Nd7 O-O Ne7 Nh4 Bg6 Nd2 c5 ",
	"e4 c6 d4 d5 e5 Bf5 Nf3 e6 Be2 c5 O-O Nc6 c3 Bg6 Be3 cxd4 ",
	"e4 c6 d4 d5 e5 Bf5 Nf3 e6 Be2 c5 O-O Nc6 c3 cxd4 cxd4 Nge7 ",
	"e4 c6 d4 d5 e5 Bf5 c3 e6 Be2 Be7 Nf3 g5 O-O h5 Be3 Nd7 ",
	"e4 c6 d4 d5 e5 Bf5 c3 e6 Be2 Be7 Nf3 g5 O-O h5 Be3 Nd7 ",
	"e4 c6 d4 d5 e5 Bf5 c3 e6 Be2 c5 Nf3 Nc6 O-O Rc8 a3 c4 ",
	"e4 c6 d4 d5 e5 Bf5 c3 e6 Be2 c5 Nf3 Nc6 O-O h6 Be3 cxd4 ",
	"e4 c6 d4 d5 e5 Bf5 c4 e6 Nc3 Nd7 Nge2 dxc4 Ng3 Bd3 Bxd3 cxd3 ",
	"e4 c6 d4 d5 e5 Bf5 c4 e6 Nc3 dxc4 Bxc4 Ne7 Nge2 Nd7 O-O Nb6 ",
	"e4 c6 d4 d5 e5 Bf5 h4 h5 c4 e6 Nc3 Nd7 Bg5 f6 exf6 gxf6 ",
	"e4 c6 d4 d5 e5 Bf5 h4 h6 g4 Bd7 h5 c5 c3 e6 f4 Qb6 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nc6 c3 Nf6 Bf4 Bg4 Qb3 Na5 Qa4+ Bd7 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nc6 c3 Nf6 Bf4 Bg4 Qb3 Na5 Qa4+ Bd7 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nc6 c3 Nf6 Bf4 g6 Nf3 Bg7 Nbd2 Nh5 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nc6 c3 Nf6 Bf4 g6 h3 Bg7 Nf3 Ne4 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nf6 c3 Bg4 Qb3 Qb6 Bg5 Nc6 Nd2 e6 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nf6 h3 Nc6 c3 g6 Nf3 Bg7 O-O Qc7 ",
	"e4 c6 d4 d5 exd5 cxd5 Bd3 Nf6 h3 h6 Bf4 e6 Nf3 Bd6 Bxd6 Qxd6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nc6 Nf3 Bg4 cxd5 Qxd5 Be2 e6 O-O Nf6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Bg5 Be6 g3 Qa5 Bg2 Ne4 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Bg5 Qa5 Bd2 dxc4 Bxc4 e6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Bg5 Qa5 Qd2 dxc4 Bxc4 e5 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Bg5 dxc4 d5 Ne5 Qd4 Nd3+ ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Bg5 dxc4 d5 Ne5 Qd4 Nd3+ ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Bg5 dxc4 d5 Ne5 Qd4 h6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Nf3 Be6 c5 g6 Bb5 Bg7 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 Nc6 Nf3 Bg4 cxd5 Nxd5 Qb3 Bxf3 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Bb4 Bd3 dxc4 Bxc4 O-O ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Bb4 Bd3 dxc4 Bxc4 O-O ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Bb4 Bd3 dxc4 Bxc4 O-O ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Bb4 cxd5 Nxd5 Qc2 Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 Bg5 O-O Rc1 Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 Bg5 dxc4 Bxc4 O-O ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 cxd5 Nxd5 Bc4 Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 cxd5 Nxd5 Bc4 Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 cxd5 Nxd5 Bd3 Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 cxd5 Nxd5 Bd3 Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 cxd5 Nxd5 Bd3 O-O ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 cxd5 Nxd5 Bd3 O-O ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 cxd5 exd5 Bb5+ Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 cxd5 exd5 Bb5+ Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Be7 cxd5 exd5 Bb5+ Nc6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 e6 Nf3 Nc6 cxd5 Nxd5 Bc4 Be7 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 g6 Qb3 Bg7 cxd5 O-O Be2 Nbd7 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 g6 Qb3 Bg7 cxd5 O-O Nge2 Na6 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 g6 cxd5 Bg7 Bc4 O-O Nge2 Nbd7 ",
	"e4 c6 d4 d5 exd5 cxd5 c4 Nf6 Nc3 g6 cxd5 Nxd5 Qb3 Nxc3 Bc4 e6 ",
	"e4 c6 d4 d5 f3 e6 Be3 dxe4 Nd2 exf3 Ngxf3 Nf6 Nc4 Nd5 Bd2 Be7 ",
	"e4 c6 d4 d5 f3 e6 Nc3 Nf6 Bg5 h6 Bh4 Qb6 a3 c5 Nge2 Nc6 ",
	"e4 c6 d4 d5 f3 e6 Nc3 Nf6 Bg5 h6 Bh4 Qb6 a3 c5 Nge2 Nc6 ",
	"e4 c6 d4 d6 Nc3 Nf6 f4 Qb6 Nf3 Bg4 Be2 Nbd7 e5 Nd5 O-O Nxc3 ",
	"e4 d5 exd5 Nf6 Bb5+ Bd7 Bc4 Bg4 f3 Bf5 g4 Bc8 Nc3 Nbd7 g5 Nb6 ",
	"e4 d5 exd5 Nf6 Bb5+ c6 dxc6 bxc6 Bc4 e5 d3 Bc5 Be3 Bxe3 fxe3 Qb6 ",
	"e4 d5 exd5 Nf6 Nc3 Nxd5 Bc4 c6 Qf3 e6 Nge2 Nd7 d4 Qf6 Qg3 Qg6 ",
	"e4 d5 exd5 Nf6 Nf3 Nxd5 d4 g6 c4 Nf6 Nc3 Bg7 h3 O-O Be3 Nbd7 ",
	"e4 d5 exd5 Nf6 c4 c6 Nc3 cxd5 d4 e6 Nf3 Bb4 Bd3 O-O O-O dxc4 ",
	"e4 d5 exd5 Nf6 c4 c6 d4 cxd5 Nc3 g6 Qb3 Bg7 cxd5 O-O Be2 Nbd7 ",
	"e4 d5 exd5 Nf6 c4 e6 dxe6 Bxe6 Be2 Nc6 Nf3 Bc5 O-O Nd4 Nxd4 Qxd4 ",
	"e4 d5 exd5 Nf6 d4 Bg4 Bb5+ Nbd7 f3 Bf5 c4 e6 dxe6 Bxe6 d5 Bf5 ",
	"e4 d5 exd5 Nf6 d4 Nxd5 c4 Nb6 Nf3 g6 Be2 Bg7 O-O O-O Nc3 Nc6 ",
	"e4 d5 exd5 Nf6 d4 Nxd5 c4 Nf6 Nc3 Bf5 Nf3 e6 Be3 Bb4 Qb3 Bxc3+ ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 Bc4 Bf5 Nge2 e6 O-O c6 Ng3 Bg6 d3 Nd7 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 Nf3 Nc6 Bb5 Bd7 O-O e6 d4 Bb4 Qd3 Bxc3 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 Nf3 Nf6 Be2 Bg4 O-O e6 Nd4 Bxe2 Qxe2 c6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 Nf3 Nf6 d4 Bg4 h3 Bh5 g4 Bg6 Ne5 e6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 Nf3 Nf6 d4 Bg4 h3 Bxf3 Qxf3 c6 Bc4 e6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 Nf6 Nf3 Bf5 Bd2 Nbd7 Bc4 c6 Qe2 e6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 Nf6 Nf3 Bg4 h3 Bxf3 Qxf3 c6 Bd2 e6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 Nf6 Nf3 Nc6 d5 Nb4 Bb5+ c6 dxc6 bxc6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 c6 Nf3 Nf6 Bd2 Qc7 Bc4 e6 Qe2 Be7 ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 e5 Nf3 Bb4 Bd2 exd4 Qe2+ Ne7 Nxd4 O-O ",
	"e4 d5 exd5 Qxd5 Nc3 Qa5 d4 e5 dxe5 Qxe5+ Be2 Bb4 Nf3 Bxc3+ bxc3 Qxc3+ ",
	"e4 d5 exd5 Qxd5 Nc3 Qd6 d4 Nf6 Nf3 a6 Be3 Nc6 Qd2 Bg4 Ng5 e5 ",
	"e4 d5 exd5 Qxd5 Nc3 Qd8 d4 Nc6 Nf3 Bg4 d5 Ne5 Nxe5 Bxd1 Bb5+ c6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qd8 d4 Nf6 Bc4 Bf5 Qf3 Qc8 Bg5 Bxc2 Rc1 Bg6 ",
	"e4 d5 exd5 Qxd5 Nc3 Qd8 d4 Nf6 Bd3 Nc6 Be3 e6 Nf3 Bd6 O-O O-O ",
	"e4 d5 exd5 Qxd5 Nc3 Qd8 d4 g6 Bf4 Bg7 Qd2 Nf6 O-O-O c6 Bh6 O-O ",
	"e4 d6 d4 Nf6 Bd3 Nc6 Ne2 Nb4 O-O Nxd3 cxd3 g6 Nbc3 Bg7 e5 Ng4 ",
	"e4 d6 d4 Nf6 Bd3 e5 c3 Nc6 Nf3 Be7 O-O O-O d5 Nb8 c4 Bg4 ",
	"e4 d6 d4 Nf6 Bd3 e5 c3 Nc6 Nf3 Bg4 d5 Ne7 c4 Ng6 g3 Be7 ",
	"e4 d6 d4 Nf6 Nc3 Nbd7 Be3 e5 f3 c6 Qd2 Be7 O-O-O Qa5 g4 b5 ",
	"e4 d6 d4 Nf6 Nc3 Nbd7 Nf3 e5 Bc4 Be7 O-O O-O Qe2 c6 a4 exd4 ",
	"e4 d6 d4 Nf6 Nc3 Nbd7 Nge2 b5 e5 dxe5 dxe5 Nxe5 Qxd8+ Kxd8 Nxb5 a6 ",
	"e4 d6 d4 Nf6 Nc3 Nbd7 f4 e5 Nf3 exd4 Qxd4 c6 Be3 d5 exd5 Bc5 ",
	"e4 d6 d4 Nf6 Nc3 Nbd7 g3 e5 Nge2 g6 Bg2 Bg7 O-O O-O h3 exd4 ",
	"e4 d6 d4 Nf6 Nc3 e5 Nf3 Nbd7 Bc4 Be7 O-O O-O a4 c6 Qe2 Qc7 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be2 Nbd7 f4 c6 e5 Nd5 Ne4 Bg7 c4 N5b6 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be3 Bg7 Qd2 Ng4 Bg5 h6 Bh4 O-O O-O-O Nc6 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be3 Bg7 Qd2 c6 Bh6 Bxh6 Qxh6 Qa5 Bd3 c5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be3 Bg7 h3 O-O f4 e5 dxe5 dxe5 Qxd8 Rxd8 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be3 Nbd7 Qd2 c6 Nf3 b5 Bd3 Bg7 Bh6 Bxh6 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be3 c6 Qd2 Nbd7 Nf3 b5 e5 b4 exf6 bxc3 ",
	"e4 d6 d4 Nf6 Nc3 g6 Be3 c6 h3 Bg7 f4 O-O Nf3 Nbd7 e5 Nh5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Bg5 Bg7 Qd2 Nbd7 O-O-O e5 dxe5 dxe5 Nf3 h6 ",
	"e4 d6 d4 Nf6 Nc3 g6 Bg5 Bg7 Qd2 h6 Bf4 c6 O-O-O Qa5 Kb1 g5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Bg5 Nbd7 f4 h6 Bh4 Nh5 Nge2 g5 fxg5 e6 ",
	"e4 d6 d4 Nf6 Nc3 g6 Bg5 c6 Nf3 Bg7 Qd2 Bg4 O-O-O h6 Be3 b5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Bg5 c6 Qd2 b5 Bd3 Bg7 Nf3 h6 Be3 Ng4 ",
	"e4 d6 d4 Nf6 Nc3 g6 Bg5 c6 Qd2 b5 Bd3 h6 Bxf6 exf6 Nge2 h5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Bg5 h6 Be3 c6 Qd2 b5 Bd3 Ng4 Bf4 e5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bg4 Be3 Nc6 Qd2 Re8 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bg4 Be3 Nc6 Qd2 e5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bg4 Be3 Nc6 Qd2 e5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bg4 Be3 Nc6 Qd2 e5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bg4 h3 Bxf3 Bxf3 Nc6 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Bg4 h3 Bxf3 Bxf3 Nc6 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O Nbd7 e5 dxe5 dxe5 Ng4 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O c5 d5 Na6 Bf4 Nc7 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O c6 Re1 Nbd7 Bf4 Nh5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 Be2 O-O O-O c6 h3 b5 e5 Ne8 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 h3 O-O Be3 a6 a4 b6 Bd3 Bb7 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 h3 O-O Be3 b6 Bd3 Bb7 O-O c5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 h3 O-O Be3 c6 a4 Nbd7 a5 Qc7 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nf3 Bg7 h3 O-O Be3 c6 a4 Nbd7 a5 e5 ",
	"e4 d6 d4 Nf6 Nc3 g6 Nge2 Bg7 g3 O-O Bg2 e5 O-O Nc6 dxe5 dxe5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f3 c6 Be3 b5 Qd2 Nbd7 Nge2 Bg7 g3 O-O ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Bg4 h3 Bxf3 Qxf3 Nc6 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Na6 O-O c5 d5 Nc7 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Na6 O-O c5 d5 Rb8 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Na6 e5 dxe5 dxe5 Nd5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Na6 e5 dxe5 dxe5 Nd5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Nc6 O-O e5 fxe5 dxe5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Nc6 e5 dxe5 fxe5 Nd5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Nc6 e5 dxe5 fxe5 Ng4 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Nc6 f5 Nb4 O-O gxf5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Bd3 Nfd7 O-O e5 dxe5 dxe5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Be3 Nc6 Qd2 e5 dxe5 dxe5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O Be3 c5 dxc5 Qa5 Bd3 Ng4 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 O-O e5 Nfd7 Bc4 Nb6 Be2 dxe5 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 c5 d5 O-O Bc4 b5 Nxb5 Nxe4 ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 c5 dxc5 Qa5 Bd3 Qxc5 Qe2 O-O ",
	"e4 d6 d4 Nf6 Nc3 g6 f4 Bg7 Nf3 c5 dxc5 Qa5 Bd3 Qxc5 Qe2 O-O ",
	"e4 d6 d4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O Nge2 e5 O-O Na6 Re1 c6 ",
	"e4 d6 d4 Nf6 Nc3 g6 g3 Bg7 Bg2 O-O Nge2 e5 h3 c6 a4 Nbd7 ",
	"e4 d6 d4 Nf6 f3 d5 e5 Nfd7 c4 dxc4 Bxc4 e6 f4 c5 dxc5 Bxc5 ",
	"e4 d6 d4 Nf6 f3 e5 Ne2 Be7 c4 O-O Nbc3 c6 Be3 a6 d5 cxd5 ",
	"e4 d6 d4 Nf6 f3 e5 d5 Be7 Be3 O-O Qd2 c6 c4 b5 Nc3 b4 ",
	"e4 d6 d4 Nf6 f3 e5 d5 c6 c4 Qb6 Nc3 Be7 Nge2 O-O Ng3 cxd5 ",
	"e4 d6 d4 g6 Be3 Bg7 Nc3 a6 h4 Nf6 f3 b5 g4 h5 e5 Nfd7 ",
	"e4 d6 d4 g6 Nc3 Bg7 Be2 Nf6 Nf3 O-O O-O Bg4 Be3 Nc6 Qd2 Re8 ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 Nf6 Nf3 O-O Bd3 Nc6 e5 dxe5 fxe5 Nh5 ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 Nf6 Nf3 O-O Bd3 Nc6 e5 dxe5 fxe5 Nh5 ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 Nf6 Nf3 O-O Be3 c5 dxc5 Qa5 Qd2 dxc5 ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 Nf6 Nf3 c5 dxc5 Qa5 Bd3 Qxc5 Qe2 O-O ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 Nf6 Nf3 c5 dxc5 Qa5 Bd3 Qxc5 Qe2 O-O ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 Nf6 Nf3 c5 e5 Nfd7 Be3 O-O exd6 exd6 ",
	"e4 d6 d4 g6 Nc3 Bg7 f4 c6 Bc4 Nh6 Nf3 Bg4 Bb3 d5 exd5 O-O ",
	"e4 d6 d4 g6 Nc3 Nf6 Be3 c6 Qd2 b5 Bd3 Qc7 Nf3 Nbd7 O-O-O Nb6 ",
	"e4 d6 d4 g6 Nc3 Nf6 h3 Bg7 Be3 O-O Qd2 c6 g4 e5 O-O-O Qe7 ",
	"e4 d6 d4 g6 Nf3 Bg7 Be2 Nf6 Nc3 O-O O-O c5 d5 Na6 Re1 Nc7 ",
	"e4 d6 d4 g6 Nf3 Bg7 Be2 Nf6 Nc3 O-O O-O c5 d5 Na6 Re1 Nc7 ",
	"e4 e5 Bc4 Bc5 b4 Bb6 Nf3 d6 d4 exd4 Nxd4 Nf6 Nc3 O-O O-O Nxe4 ",
	"e4 e5 Bc4 Bc5 c3 Nc6 Nf3 Nf6 d4 exd4 e5 Qe7 O-O Ng8 cxd4 Bb6 ",
	"e4 e5 Bc4 Nf6 Nc3 Bc5 d3 Nc6 Bg5 h6 Bh4 d6 Na4 Bb6 Nxb6 axb6 ",
	"e4 e5 Bc4 Nf6 d3 Nc6 Nc3 Bb4 Nf3 d6 O-O Bxc3 bxc3 Bg4 h3 Bh5 ",
	"e4 e5 Bc4 Nf6 d3 Nc6 Nf3 h6 O-O d6 Bb3 g6 c3 Bg7 Re1 O-O ",
	"e4 e5 Bc4 Nf6 d3 Nc6 Nf3 h6 O-O d6 Bb3 g6 c3 Bg7 Re1 O-O ",
	"e4 e5 Bc4 Nf6 d3 c6 Nf3 Be7 O-O Qc7 Re1 O-O Nbd2 d5 Bb3 Nbd7 ",
	"e4 e5 Bc4 Nf6 d3 c6 Nf3 d5 Bb3 Bb4+ Bd2 Bxd2+ Nbxd2 dxe4 Nxe5 O-O ",
	"e4 e5 Bc4 Nf6 d3 c6 Nf3 d5 Bb3 a5 Nc3 Bb4 a3 Bxc3+ bxc3 Nbd7 ",
	"e4 e5 Bc4 Nf6 d3 d5 exd5 Nxd5 Nf3 Nc6 O-O Bg4 Re1 Be7 h3 Bxf3 ",
	"e4 e5 Bc4 Nf6 d4 exd4 Nf3 Nxe4 Qxd4 Nf6 Bg5 c6 Nc3 d5 O-O-O Be7 ",
	"e4 e5 Nc3 Bc5 g3 Nc6 Bg2 h5 d3 d6 Na4 Bg4 f3 Be6 Ne2 h4 ",
	"e4 e5 Nc3 Bc5 g3 Nc6 Bg2 h5 h3 h4 g4 d6 Na4 Be6 d3 g5 ",
	"e4 e5 Nc3 Nc6 Bc4 Bc5 Qg4 Qf6 Nd5 Qxf2+ Kd1 Kf8 Nh3 Qd4 d3 d6 ",
	"e4 e5 Nc3 Nc6 Bc4 Nf6 d3 Bc5 Be3 d6 Bxc5 dxc5 Nge2 Na5 Bb3 Nxb3 ",
	"e4 e5 Nc3 Nc6 Bc4 Nf6 d3 Bc5 f4 d6 f5 Na5 Qf3 c6 g4 Nd7 ",
	"e4 e5 Nc3 Nc6 f4 exf4 Nf3 g5 d4 d6 d5 Ne5 Bb5+ Bd7 Bxd7+ Nxd7 ",
	"e4 e5 Nc3 Nc6 f4 exf4 d4 Qh4+ Ke2 b6 Nb5 Ba6 a4 O-O-O Nf3 Qe7 ",
	"e4 e5 Nc3 Nc6 g3 Bc5 Bg2 a6 Nge2 Nf6 d3 Ng4 O-O h5 h3 Nh6 ",
	"e4 e5 Nc3 Nc6 g3 Bc5 Bg2 a6 Nge2 d6 d3 Nge7 Nd5 Nxd5 exd5 Ne7 ",
	"e4 e5 Nc3 Nc6 g3 Nf6 Bg2 Bc5 Nf3 d6 O-O O-O d3 a6 h3 Be6 ",
	"e4 e5 Nc3 Nf6 Bc4 Bc5 d3 d6 f4 Nc6 f5 Na5 Qf3 c6 g4 h6 ",
	"e4 e5 Nc3 Nf6 Bc4 Bc5 d3 h6 f4 d6 f5 c6 Qf3 b5 Bb3 Qb6 ",
	"e4 e5 Nc3 Nf6 Bc4 Nc6 d3 Bb4 Bg5 d6 Ne2 Be6 O-O h6 Bxf6 Qxf6 ",
	"e4 e5 Nc3 Nf6 Bc4 Nc6 d3 Bb4 Bg5 h6 Bxf6 Bxc3+ bxc3 Qxf6 Ne2 d6 ",
	"e4 e5 Nc3 Nf6 Bc4 Nxe4 Qh5 Nd6 Bb3 Be7 d3 O-O Nf3 Nc6 Ng5 h6 ",
	"e4 e5 Nc3 Nf6 Nf3 Bb4 a3 Ba5 b4 Bb6 Nxe5 Qe7 d4 d6 Nf3 Nxe4 ",
	"e4 e5 Nc3 Nf6 Nf3 Nc6 Bb5 Bb4 d3 Nd4 Ba4 b5 Bb3 d6 h3 a5 ",
	"e4 e5 Nc3 Nf6 f4 d5 fxe5 Nxe4 Nf3 Bg4 Be2 Nc6 d3 Bxf3 Bxf3 Qh4+ ",
	"e4 e5 Nc3 Nf6 f4 d5 fxe5 Nxe4 Nf3 Bg4 Qe2 Nc6 Nxe4 Nd4 Qd3 Bxf3 ",
	"e4 e5 Nc3 Nf6 g3 Nc6 Bg2 Bc5 d3 d6 h3 Be6 Nd5 h6 Ne2 a6 ",
	"e4 e5 Nc3 Nf6 g3 d5 exd5 Nxd5 Bg2 Be6 Nf3 Nc6 O-O Be7 Re1 Bf6 ",
	"e4 e5 Nc3 Nf6 g3 d5 exd5 Nxd5 Bg2 Nxc3 bxc3 Bd6 Nf3 O-O O-O Nc6 ",
	"e4 e5 Nf3 Nc6 Bb5 Bb4 O-O Nge7 c3 Ba5 d4 exd4 Nxd4 O-O Bg5 f6 ",
	"e4 e5 Nf3 Nc6 Bb5 Bb4 c3 Ba5 Bxc6 dxc6 Nxe5 Qg5 Nf3 Qxg2 Rg1 Qh3 ",
	"e4 e5 Nf3 Nc6 Bb5 Bc5 O-O Nf6 c3 O-O d4 Bb6 Bg5 h6 Bh4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 Bc5 O-O Qf6 c3 Nge7 b4 Bb6 Na3 g5 d4 g4 ",
	"e4 e5 Nf3 Nc6 Bb5 Bc5 c3 Nf6 d4 Bb6 Qe2 exd4 e5 O-O cxd4 Re8 ",
	"e4 e5 Nf3 Nc6 Bb5 Bc5 c3 Nf6 d4 exd4 e5 Ne4 cxd4 Bb4+ Nbd2 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Bc5 c3 Nge7 O-O O-O d4 exd4 cxd4 Bb6 d5 Nb8 ",
	"e4 e5 Nf3 Nc6 Bb5 Bc5 c3 Qe7 O-O Nf6 d4 Bb6 Bg5 h6 Bxf6 gxf6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 Bc4 c6 O-O d5 exd5 cxd5 Bb5+ Bd7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 O-O Bc5 d3 c6 Ba4 Ne7 Nd2 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 O-O Bc5 d3 c6 Ba4 Ne7 Qh5 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 O-O Bc5 d3 c6 Ba4 Ne7 f4 f5 ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 O-O Bc5 d3 c6 Bc4 d6 c3 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 O-O Bc5 d3 c6 Bc4 d6 f4 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 O-O c6 Ba4 Nf6 Re1 Be7 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 O-O c6 Bc4 d5 exd5 cxd5 Bb5+ Bd7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nd4 Nxd4 exd4 O-O g6 d3 Bg7 Nd2 Ne7 f4 c6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 Nc3 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Ne7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Bc5 Nc3 O-O Nxe5 Re8 Nf3 Nxe4 d4 Nxc3 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Bc5 c3 O-O d4 Bb6 Bg5 h6 Bh4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Bc5 c3 O-O d4 Bb6 Qd3 d5 Bxc6 bxc6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Bc5 c3 O-O d4 Bb6 Re1 d6 Bg5 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Nc3 d6 Bxc6+ bxc6 d4 exd4 Nxd4 Bd7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Nc3 d6 d4 Bd7 Bg5 exd4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Nc3 d6 d4 Bd7 Bxc6 Bxc6 Qd3 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Nc3 d6 d4 Bd7 Re1 exd4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Nc3 d6 d4 exd4 Nxd4 Bd7 Nde2 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Re1 d6 c3 O-O d4 Nd7 Nbd2 Bf6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Re1 d6 d4 exd4 Bxc6+ bxc6 Qxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Be7 Re1 d6 d4 exd4 Nxd4 Bd7 Bf1 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 Re1 Nd6 Nxe5 Be7 Bd3 O-O Nc3 Ne8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Be7 Qe2 Nd6 Bxc6 bxc6 dxe5 Nb7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Be7 Qe2 Nd6 Bxc6 bxc6 dxe5 Nb7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Be7 Qe2 Nd6 Bxc6 bxc6 dxe5 Nb7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Be7 Qe2 Nd6 Bxc6 bxc6 dxe5 Nb7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Be7 dxe5 O-O Qe2 Nc5 Rd1 Qe8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Bg5 Be7 Bxe7 Qxe7 Bxc6 dxc6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Bxc6 dxc6 dxe5 Ne4 Qe2 Bf5 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Bxc6 dxc6 dxe5 Nf5 Qxd8+ Kxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Bxc6 dxc6 dxe5 Nf5 Qxd8+ Kxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Bxc6 dxc6 dxe5 Nf5 Qxd8+ Kxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Bxc6 dxc6 dxe5 Nf5 Qxd8+ Kxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 Bxc6 dxc6 dxe5 Nf5 Qxd8+ Kxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O Nxe4 d4 Nd6 dxe5 Nxb5 a4 Nbd4 Nxd4 Nxd4 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 Bxc6+ bxc6 d4 Be7 Nc3 Nd7 dxe5 dxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 Bxc6+ bxc6 d4 Be7 Nc3 exd4 Nxd4 Bd7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 d4 Bd7 Nc3 Be7 Re1 exd4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 d4 Bd7 Nc3 exd4 Nxd4 Be7 Bxc6 bxc6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 d4 Bd7 Nc3 exd4 Nxd4 Be7 Nde2 a6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 O-O d6 d4 Bd7 Nc3 g6 Re1 Bg7 Bxc6 Bxc6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d3 d6 c3 Bd7 Nbd2 g6 Nf1 Bg7 Bg5 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d4 Nxd4 Nxd4 exd4 e5 c6 O-O cxb5 Bg5 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 Nf6 d4 exd4 e5 Ne4 Qe2 Nc5 O-O Be7 Rd1 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Be7 O-O b5 Bb3 d6 c3 Nf6 Re1 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Bxc6 dxc6 d3 Nd7 Nbd2 Be7 Nc4 Bf6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Bxc6 dxc6 d3 Nd7 Nbd2 f6 O-O Bc5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 Be7 O-O b5 Bb3 d6 d3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 Be7 d3 d6 Nd5 Nxd5 exd5 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Nc3 d6 d4 b5 dxe5 dxe5 Qxd8+ Nxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Bc5 c3 Ba7 d4 Nxe4 Re1 f5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Bxc6 dxc6 Nc3 Bg4 h3 Bh5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Bxc6 dxc6 Nc3 Nd7 d4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Bxc6 dxc6 d3 Nd7 Nbd2 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Nc3 b5 Bb3 O-O d3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Nc3 b5 Bb3 d6 Nd5 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Nc3 b5 Bb3 d6 d3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Nc3 d6 d4 b5 Bb3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 Bb7 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 Bb7 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Qe2 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O a4 Rb8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O h3 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 O-O h3 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 a4 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 b5 Bb3 d6 h3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 d6 Bxc6+ bxc6 d4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 d6 Bxc6+ bxc6 d4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 d6 c3 Nd7 d4 Bf6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 d6 c3 O-O d4 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 Re1 d6 c3 b5 Bb3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 d4 exd4 Re1 b5 e5 Nxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 d4 exd4 e5 Nd5 Nxd4 Nxd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 d4 exd4 e5 Ne4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Be7 d4 exd4 e5 Ne4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 Be7 Re1 f5 d5 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 d5 dxe5 Be6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 b5 Bb3 exd4 Re1 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O Nxe4 d4 exd4 Re1 d5 Nxd4 Bd6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 Re1 Bc5 c3 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 c3 Nxe4 d4 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 d3 Be7 a4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 d3 h6 Nc3 g6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bb7 d4 Nxd4 Nxd4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bc5 c3 Bb6 d4 Qe7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Bc5 c3 d6 d4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Be7 Qe2 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Be7 Re1 d6 c3 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Be7 Re1 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Be7 c3 d6 Re1 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Be7 d4 d6 c3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Be7 d4 d6 c3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 Be7 d4 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 d6 c3 Be7 a4 b4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O b5 Bb3 d6 c3 Bg4 h3 Bh5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 Bxc6+ bxc6 d4 Nxe4 Re1 Bf5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 Bxc6+ bxc6 d4 exd4 Nxd4 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 Bxc6+ bxc6 d4 exd4 Nxd4 c5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 Bxc6+ bxc6 d4 exd4 Nxd4 c5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 Re1 Bd7 c3 Be7 d4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 Re1 Bg4 c3 Be7 h3 Bh5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 c3 Bd7 d4 g6 Nbd2 Qe7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 c3 Be7 d4 b5 Bb3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 O-O d6 d4 b5 dxe5 dxe5 Qxd8+ Nxd8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 Be7 O-O b5 Bb3 d6 a4 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 Be7 O-O b5 Bb3 d6 c3 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 Be7 c3 O-O O-O d6 d4 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 Be7 c3 b5 Bb3 d6 a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Be7 O-O d6 c3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 Qe2 b5 Bb3 Be7 c3 O-O d4 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 b5 Bb3 d6 c3 Be7 Nbd2 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 Bd7 Nbd2 Be7 Nf1 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 Be7 Nbd2 O-O Nf1 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 Be7 Nbd2 O-O Nf1 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 Be7 Nbd2 O-O Nf1 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 Be7 O-O O-O Nbd2 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c3 g6 O-O Bg7 Re1 b5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d3 d6 c4 g6 Nc3 Bg7 O-O O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d4 Nxe4 Qe2 d5 Nxe5 Be6 Nxc6 Qd7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d4 exd4 O-O Be7 Re1 O-O e5 Ne8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d4 exd4 O-O Be7 Re1 b5 e5 Nxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d4 exd4 e5 Ne4 O-O Be7 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nf6 d4 exd4 e5 Ne4 O-O Nc5 Bxc6 dxc6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 Nge7 Bb3 f6 d4 d6 c3 Na5 Bc2 g6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 b5 Bb3 Bb7 O-O Bc5 c3 Na5 Nxe5 Nxb3 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 b5 Bb3 Bc5 c3 d6 d4 Bb6 dxe5 Qe7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 b5 Bb3 Na5 O-O Nxb3 axb3 d6 d4 f6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 b5 Bb3 Na5 O-O d6 d4 Nxb3 axb3 f6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 b5 Bb3 Na5 O-O d6 d4 f6 Nc3 Nxb3 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 Bxc6+ bxc6 d4 exd4 Qxd4 Nf6 O-O Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 Bxc6+ bxc6 d4 exd4 Qxd4 Nf6 b3 c5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 Bxc6+ bxc6 d4 f6 Be3 Ne7 Nc3 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 Bxc6+ bxc6 d4 f6 Be3 Ne7 c4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 Bxc6+ bxc6 d4 f6 Nc3 Ne7 Be3 a5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 Bxc6+ bxc6 d4 f6 O-O Bg4 dxe5 fxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 c3 Nge7 d4 Ng6 Nbd2 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 c3 Nge7 d4 Ng6 Nbd2 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 c3 Nge7 d4 Ng6 Re1 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 c3 Nge7 d4 Ng6 Re1 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 c3 Nge7 d4 Ng6 d5 Nb8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 c3 Nge7 d4 Ng6 d5 Nb8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 c3 g6 d4 Bg7 Bg5 f6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 c4 Nf6 Re1 Be7 Bxc6 Bxc6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 d4 Nf6 Bxc6 Bxc6 Re1 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 d4 Nf6 Bxc6 Bxc6 Re1 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 d4 Nf6 c3 Be7 Nbd2 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bd7 d4 Nge7 d5 Nb8 c4 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Be7 Bxc6+ bxc6 d4 exd4 Nxd4 c5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Be7 c3 Nf6 Re1 O-O h3 Bd7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bg4 c3 Qf6 Bxc6+ bxc6 d4 Ne7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bg4 h3 Bh5 c3 Nf6 Re1 Qd7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bg4 h3 Bh5 c3 Qf6 g4 Bg6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Bg4 h3 h5 c3 Qf6 d3 Bxf3 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Ne7 c3 Bd7 d4 Ng6 Re1 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Nf6 Re1 Bd7 Bxc6 bxc6 d4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Nf6 Re1 Be7 c3 O-O d4 Nd7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 O-O Nf6 d4 exd4 Bxc6+ bxc6 Qxd4 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 O-O Nge7 d4 Ng6 c4 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 O-O g6 d4 Bg7 Be3 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 O-O g6 d4 Bg7 h3 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Be7 O-O Bf6 Be3 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nf6 O-O Be7 Re1 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nf6 O-O Be7 d5 Nb8 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nbd2 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nbd2 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nh4 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nh4 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nh4 Na5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Nh4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Bb3 h6 Qe2 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 Nge7 Nbd2 g6 dxe5 dxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 g6 Bg5 f6 Be3 Nh6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Bd7 d4 g6 O-O Bg7 Bg5 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 Nf6 d4 Nd7 a3 Be7 b4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 f5 exf5 Bxf5 O-O Bd3 Re1 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c3 f5 exf5 Bxf5 d4 e4 Ng5 d5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c4 Bd7 Nc3 g6 d4 Bg7 Be3 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 c4 Bd7 d4 exd4 Nxd4 Nge7 O-O Nxd4 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 d4 Bd7 Bxc6 Bxc6 Nc3 Nf6 Qd3 Qe7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 d4 Bd7 c3 Nf6 Nbd2 Be7 O-O O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 d4 Bd7 c3 Nf6 Nbd2 g6 O-O Qe7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 d6 d4 b5 Bb3 Nxd4 Nxd4 exd4 a4 Bb7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 g6 d4 exd4 Nxd4 Bg7 Nxc6 bxc6 O-O Ne7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 g6 d4 exd4 c3 Bg7 cxd4 b5 Bc2 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Ba4 g6 d4 exd4 c3 Bg7 cxd4 b5 Bc2 d6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 bxc6 d4 exd4 Nxd4 c5 Ne2 Bb7 Nbc3 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 Nc3 Bc5 d3 Bg4 Be3 Bxe3 fxe3 Qe7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 Nc3 Bc5 d3 Bg4 Be3 Qd6 Bxc5 Qxc5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 Nc3 Bc5 d3 Bg4 Be3 Qe7 h3 Bh5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O Bg4 h3 Bxf3 Qxf3 Qd7 d3 Bd6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O Bg4 h3 Bxf3 Qxf3 Qd7 d3 O-O-O ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O Qd6 d3 f6 Be3 Be6 Nbd2 Qd7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 Bg4 c3 Bd6 Be3 Qe7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 Bg4 c3 exd4 cxd4 Qd7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 Bg4 c3 exd4 cxd4 Qd7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 Bg4 dxe5 Qxd1 Rxd1 Bxf3 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 Bg4 dxe5 Qxd1 Rxd1 fxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 Bg4 dxe5 Qxd1 Rxd1 fxe5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 exd4 Nxd4 Ne7 Be3 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 exd4 Nxd4 Ne7 Be3 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 exd4 Nxd4 c5 Nb3 Qxd1 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 exd4 Nxd4 c5 Nb3 Qxd1 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 exd4 Nxd4 c5 Nb3 Qxd1 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 O-O f6 d4 exd4 Nxd4 c5 Nb3 Qxd1 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d3 Bd6 Be3 Ne7 d4 Bg4 Nbd2 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 Bg4 dxe5 Qxd1+ Kxd1 O-O-O+ Ke1 Bc5 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd6 Nc3 Ne7 ",
	"e4 e5 Nf3 Nc6 Bb5 a6 Bxc6 dxc6 d4 exd4 Qxd4 Qxd4 Nxd4 Bd6 Nc3 Ne7 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 Nc3 Bd7 d4 exd4 Nxd4 g6 Nxc6 bxc6 Bc4 Bg7 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 Nc3 Nf6 d4 Be7 O-O Bd7 Re1 Nxd4 Nxd4 exd4 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 O-O Bd7 d4 Nge7 d5 Nb8 Bxd7+ Nxd7 c4 Ng6 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 O-O a6 Bxc6+ bxc6 d4 exd4 Nxd4 Bd7 Re1 c5 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 c3 Bg4 d3 Be7 Nbd2 Nf6 O-O O-O Re1 h6 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 Bd7 Nc3 Nf6 Bxc6 Bxc6 Qd3 exd4 Nxd4 Be7 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 Bd7 Nc3 Nf6 O-O Be7 Bg5 exd4 Nxd4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 Bd7 Nc3 Nf6 dxe5 dxe5 Bg5 Bb4 O-O Bxc3 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 Bd7 Nc3 exd4 Nxd4 Nxd4 Qxd4 Ne7 Bg5 f6 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 Bd7 Nc3 exd4 Nxd4 g6 Be3 Bg7 Qd2 Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 Bg4 d5 a6 Bxc6+ bxc6 dxc6 h6 O-O Nf6 ",
	"e4 e5 Nf3 Nc6 Bb5 d6 d4 exd4 Nxd4 Bd7 Nc3 Nxd4 Bxd7+ Qxd7 Qxd4 Ne7 ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 Nd4 Ba4 Nf6 Nxe5 fxe4 O-O Bc5 Nxe4 Nxe4 ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 Nd4 Ba4 Nf6 exf5 Bc5 d3 c6 O-O d5 ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 Nd4 exf5 c6 Nxe5 Qg5 Bd3 Qxg2 Be4 Qh3 ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 Nf6 Qe2 Nd4 Nxd4 exd4 exf5+ Be7 Ne4 O-O ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 Nf6 Qe2 fxe4 Nxe4 d5 Nxf6+ gxf6 d4 Bg7 ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 Nf6 exf5 e4 Nh4 d5 d3 Be7 dxe4 dxe4 ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 fxe4 Nxe4 Nf6 Qe2 d5 Nxf6+ gxf6 d4 Bg7 ",
	"e4 e5 Nf3 Nc6 Bb5 f5 Nc3 fxe4 Nxe4 Nf6 Qe2 d5 Nxf6+ gxf6 d4 Bg7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 a6 Ba4 d6 d4 Bd7 Re1 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 O-O Bg7 c3 a6 Ba4 d6 d4 Bd7 d5 Nce7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 c3 a6 Ba4 d6 d4 Bd7 O-O Bg7 Re1 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 c3 a6 Ba4 d6 d4 Bd7 O-O Bg7 Re1 Nge7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 d4 Nxd4 Nxd4 exd4 Qxd4 Qf6 Qd3 a6 Bc4 Bg7 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 d4 exd4 Bg5 Be7 Bxe7 Ngxe7 Nxd4 d5 Nc3 dxe4 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 d4 exd4 Bg5 Be7 h4 b6 Bf4 Nf6 Nbd2 a6 ",
	"e4 e5 Nf3 Nc6 Bb5 g6 d4 exd4 Nxd4 Bg7 Nxc6 bxc6 Bc4 Ne7 Nc3 d6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 Nc3 Nf6 d3 d6 Bg5 h6 Bxf6 Qxf6 Nd5 Qd8 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bb6 a4 a6 c3 d6 d3 Nf6 Qb3 Qe7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 O-O Nf6 d4 Nxe4 Ba3 d6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 O-O Nge7 Ng5 d5 exd5 Nxd5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 Nf6 dxe5 Ng4 Bg5 f6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 d6 Qb3 Nh6 Bxh6 gxh6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 d6 Qb3 Qe7 d5 Nd4 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 exd4 O-O Bb6 cxd4 Nge7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 exd4 O-O Bxc3 Nxc3 dxc3 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 exd4 O-O Nf6 Ba3 d6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 exd4 O-O d6 Qb3 Qe7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 exd4 O-O d6 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Ba5 d4 exd4 O-O dxc3 Qb3 Qe7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O Nf6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 O-O d6 d4 exd4 cxd4 Bb6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 d4 exd4 cxd4 Bb6 Bg5 Nge7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 d4 exd4 cxd4 Bb6 O-O Na5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Bc5 d4 exd4 cxd4 Bb6 O-O d6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 Bxb4 c3 Be7 d4 Nf6 dxe5 Ng4 Qd5 O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 d5 exd5 Nxb4 O-O Ne7 Nxe5 O-O d4 Bd6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 b4 d5 exd5 Nxb4 c3 Nxd5 Qb3 c6 O-O e4 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 b4 Bb6 d3 a6 O-O d6 Nbd2 O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 b4 Bb6 d3 d6 a4 a5 b5 Ne7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d3 O-O O-O d6 Bb3 a6 Nbd2 Ba7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d3 d6 O-O O-O Re1 a6 Bb3 Ba7 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 cxd4 Bb4+ Bd2 Bxd2+ Nbxd2 d5 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 cxd4 Bb4+ Nc3 Nxe4 O-O Bxc3 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 cxd4 Bb4+ Nc3 Nxe4 O-O Bxc3 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 cxd4 Bb6 d5 Ne7 e5 Ne4 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Nf6 d4 exd4 cxd4 Bb6 d5 Ne7 e5 Ng4 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Qe7 d4 Bb6 O-O Nf6 Re1 d6 h3 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 Qf6 d4 exd4 e5 Qg6 cxd4 Bb4+ Nc3 d6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 c3 d6 O-O Nf6 d4 exd4 cxd4 Bb6 h3 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Bc5 d3 Nf6 Nc3 d6 Be3 Bb6 Qd2 Bg4 Ng5 Bh5 ",
	"e4 e5 Nf3 Nc6 Bc4 Be7 Nc3 Nf6 d3 d6 h3 Na5 Bb3 Nxb3 axb3 O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Be7 d4 d6 dxe5 dxe5 Bd5 Bd7 Nbd2 Nf6 Nc4 O-O ",
	"e4 e5 Nf3 Nc6 Bc4 Be7 d4 exd4 O-O d6 Nxd4 Nf6 Nc3 O-O b3 Re8 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 Bb5+ c6 dxc6 bxc6 Be2 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 Bb5+ c6 dxc6 bxc6 Be2 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 Bb5+ c6 dxc6 bxc6 Be2 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 Bb5+ c6 dxc6 bxc6 Be2 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 Bb5+ c6 dxc6 bxc6 Be2 h6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 d3 e4 Qe2 Qe7 Nxe4 Nxe4 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 d3 h6 Nf3 Bg4 h3 Bxf3 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 d3 h6 Nf3 e4 Qe2 Nxc4 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 Ng5 d5 exd5 Na5 d3 h6 Nf3 e4 dxe4 Nxc4 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 O-O Bc5 d3 d6 Be3 Bb6 Nbd2 O-O c3 Bg4 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O Bc5 e5 Ne4 Bd5 f5 exf6 Nxf6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O Bc5 e5 Ng4 c3 d5 exd6 Qxd6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O Bc5 e5 d5 exf6 dxc4 fxg7 Rg8 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O Bc5 e5 d5 exf6 dxc4 fxg7 Rg8 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O Nxe4 Re1 d5 Bxd5 Qxd5 Nc3 Qa5 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O Nxe4 Re1 d5 Bxd5 Qxd5 Nc3 Qh5 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O d5 exd5 Nxd5 Ng5 Be6 Re1 Qd6 ",
	"e4 e5 Nf3 Nc6 Bc4 Nf6 d4 exd4 O-O d6 Nxd4 Bd7 Nc3 Be7 b3 O-O ",
	"e4 e5 Nf3 Nc6 Bc4 d6 c3 Be7 Qb3 Nh6 d4 Na5 Qa4+ c6 Bxh6 b5 ",
	"e4 e5 Nf3 Nc6 Bc4 f5 d3 Nf6 O-O d6 Ng5 d5 exd5 Nxd5 Nc3 Nce7 ",
	"e4 e5 Nf3 Nc6 Bc4 f5 d4 d6 dxe5 dxe5 Qxd8+ Kxd8 Bg5+ Nf6 Nc3 Bb4 ",
	"e4 e5 Nf3 Nc6 Bc4 g6 c3 d6 d4 Qe7 dxe5 Nxe5 Nxe5 dxe5 O-O Nf6 ",
	"e4 e5 Nf3 Nc6 Bc4 h6 d4 exd4 c3 Nge7 Qb3 d5 exd5 Nb8 d6 Qxd6 ",
	"e4 e5 Nf3 Nc6 Nc3 Bb4 Nd5 Be7 d4 d6 Bb5 Bg4 dxe5 dxe5 h3 Bd7 ",
	"e4 e5 Nf3 Nc6 Nc3 Bb4 Nd5 Be7 d4 d6 Bb5 Bg4 dxe5 dxe5 h3 Bd7 ",
	"e4 e5 Nf3 Nc6 Nc3 Bc5 Bb5 d6 d4 exd4 Nxd4 Bd7 Nxc6 bxc6 Ba4 Qh4 ",
	"e4 e5 Nf3 Nc6 Nc3 Bc5 Nxe5 Bxf2+ Kxf2 Nxe5 d4 Nc6 Be3 d6 Be2 Nf6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O Bxc3 bxc3 O-O Re1 d6 d4 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O Bxc6 bxc6 Nxe5 Qe8 Nd3 Bxc3 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O Bxc6 bxc6 Nxe5 Qe8 d4 d6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O Bxc6 dxc6 d3 Re8 h3 Bxc3 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O Bxc6 dxc6 d3 Re8 h3 h6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 Bxc3 bxc3 d6 Bg5 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 Bxc3 bxc3 d6 Bg5 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 Bxc3 bxc3 d6 Bg5 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 Bxc3 bxc3 d6 Bg5 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 Bxc3 bxc3 d6 Bg5 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Be6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bb4 O-O O-O d3 d6 Bg5 Bxc3 bxc3 Qe7 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bc5 O-O O-O Nxe5 Nxe5 d4 Bd6 f4 Nc6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bc5 O-O O-O Nxe5 Nxe5 d4 Bd6 f4 Nc6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Bc5 O-O O-O Nxe5 Nxe5 d4 Bd6 f4 Nc6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Ba4 Bc5 Nxe5 Qe7 Nd3 Nxe4 O-O Nxc3 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Nxe5 Nxe4 Nxe4 Nxb5 Nxf7 Qe7 Nxh8 Qxe4+ ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Nxe5 Nxe4 Nxe4 Nxb5 d4 d5 Ng5 Nd6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 Nxe5 Qe7 f4 Nxb5 Nxb5 d6 Nf3 Qxe4+ ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 Nd4 O-O Nxb5 Nxb5 d6 d4 Bd7 Nc3 exd4 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 a6 Bxc6 dxc6 Nxe5 Nxe4 Nxe4 Qd4 O-O Qxe5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 a6 Bxc6 dxc6 O-O Bg4 h3 Bh5 Qe2 Bd6 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 Bb5 d6 d4 exd4 Nxd4 Bd7 O-O Nxd4 Qxd4 Bxb5 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 d6 Bb5 exd4 Nxd4 Bd7 Bxc6 bxc6 Qf3 Bg4 ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 exd4 Nd5 Nb4 Nxd4 Nxe4 Nf5 c6 Nxb4 Bxb4+ ",
	"e4 e5 Nf3 Nc6 Nc3 Nf6 d4 exd4 Nxd4 Bb4 Nxc6 Bxc3+ bxc3 bxc6 Bd3 h6 ",
	"e4 e5 Nf3 Nc6 Nc3 d6 Bb5 Bd7 d4 Nf6 Bxc6 Bxc6 Qd3 exd4 Nxd4 Bd7 ",
	"e4 e5 Nf3 Nc6 Nc3 d6 d4 Bg4 dxe5 dxe5 Qxd8+ Rxd8 Bb5 f6 Be3 a6 ",
	"e4 e5 Nf3 Nc6 Nc3 d6 d4 exd4 Nxd4 Nxd4 Qxd4 Nf6 b3 g6 Bg5 Bg7 ",
	"e4 e5 Nf3 Nc6 c3 Nf6 d4 d5 Bb5 exd4 e5 Ne4 cxd4 Bb4+ Nbd2 O-O ",
	"e4 e5 Nf3 Nc6 c3 Nf6 d4 d6 d5 Nb8 Bd3 Nbd7 h3 Nc5 Bc2 a5 ",
	"e4 e5 Nf3 Nc6 c3 d6 d4 Qe7 Bd3 g6 O-O Bg7 Nbd2 Nf6 Nc4 O-O ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Nf6 O-O Nxe4 Re1 d5 Bxd5 Qxd5 Nc3 Qh5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Bc4 Nf6 O-O Nxe4 Re1 d5 Bxd5 Qxd5 Nc3 Qh5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Be3 Qf6 c3 Nge7 Bb5 a6 Ba4 b5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Be3 Qf6 c3 Nge7 Bc4 O-O O-O Bb6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Be3 Qf6 c3 Nge7 Bc4 O-O O-O Bb6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Nb3 Bb6 Nc3 d6 a4 a6 Be2 Nge7 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Bc5 Nb3 Bb6 a4 a6 Nc3 Nge7 a5 Ba7 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nc3 Bb4 Nxc6 bxc6 Bd3 d5 exd5 cxd5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nxc6 bxc6 Bd3 d5 e5 Nd7 O-O Nc5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nxc6 bxc6 Bd3 d5 e5 Ng4 Bf4 Bc5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nxc6 bxc6 Nd2 Bc5 e5 Qe7 Qe2 Nd5 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nxc6 bxc6 e5 Qe7 Qe2 Nd5 c4 Ba6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nxc6 bxc6 e5 Qe7 Qe2 Nd5 c4 Ba6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 Nxd4 Nf6 Nxc6 bxc6 e5 Qe7 Qe2 Nd5 c4 Nb6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 c3 d5 exd5 Qxd5 cxd4 Nf6 Be2 Bf5 Nc3 Bb4 ",
	"e4 e5 Nf3 Nc6 d4 exd4 c3 dxc3 Nxc3 Bb4 Bc4 Nf6 O-O Bxc3 bxc3 d6 ",
	"e4 e5 Nf3 Nc6 d4 exd4 c3 dxc3 Nxc3 d6 Bc4 Be7 Qb3 Na5 Bxf7+ Kf8 ",
	"e4 e5 Nf3 Nf6 Bc4 Nxe4 Nc3 Nf6 Nxe5 d5 Bb3 Be7 d4 c6 O-O Nbd7 ",
	"e4 e5 Nf3 Nf6 Bc4 Nxe4 Nc3 d5 Bxd5 Nf6 Bb3 Bd6 d3 O-O h3 h6 ",
	"e4 e5 Nf3 Nf6 Nc3 Bb4 Bc4 O-O d3 c6 O-O d5 Bb3 a5 a3 Bxc3 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 Nc3 Bf5 Qe2",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 Qe2 Qe7 d3 Nf6 Bg5 Be6 Nc3 Nbd7 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 Qe2 Qe7 d3 Nf6 Bg5 Be6 Nc3 h6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 Qe2 Qe7 d3 Nf6 Bg5 Nc6 Nc3 Bg4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 Qe2 Qe7 d3 Nf6 Bg5 Qxe2+ Bxe2 Be7 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 Qe2 Qe7 d3 Nf6 Bg5 Qxe2+ Bxe2 Be7 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 Qe2 Qe7 d3 Nf6 Bg5 Qxe2+ Bxe2 Be7 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 Qe2 Qe7 d3 Nf6 Bg5 Qxe2+ Bxe2 Be7 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 Be7 Bd3 Nf6 h3 O-O O-O Re8 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 Be7 Bd3 Nf6 h3 O-O O-O c5 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 Be7 Bd3 Nf6 h3 O-O O-O c5 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 Be7 Bd3 d5 O-O O-O c4 Nf6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 Be7 Bd3 d5 c4 Bg4 Qb3 Nc6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 O-O Bg4 Re1 f5 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 O-O O-O c4 Be6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 O-O O-O c4 Be6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 O-O O-O c4 c6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 O-O O-O c4 c6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 O-O O-O c4 c6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 O-O O-O c4 c6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 O-O O-O c4 c6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bd6 c4 Bb4+ Nbd2 O-O ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Bf5 c4 dxc4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 Re1 Bf5 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 Re1 Bf5 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 Re1 Bg4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 Re1 Bg4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 Re1 Bg4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 c4 Be6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 c4 Be6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 c4 Nb4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O Nc6 c4 Nb4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Be7 O-O O-O Re1 Bf5 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Bg4 O-O Nc6 Re1 f5 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Nc6 Nbd2 Nd6 O-O Be7 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Nc6 O-O Be7 c4 Nb4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Nc6 O-O Be7 c4 Nf6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Nc6 O-O Bg4 c4 Nf6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Nc6 O-O Bg4 c4 Nf6 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Nc6 Qe2 Qe7 O-O Bg4 ",
	"e4 e5 Nf3 Nf6 Nxe5 d6 Nf3 Nxe4 d4 d5 Bd3 Nf6 O-O Be7 Ne5 O-O ",
	"e4 e5 Nf3 Nf6 d3 Nc6 g3 d6 Bg2 Be7 O-O O-O c4 Ne8 Nc3 f5 ",
	"e4 e5 Nf3 Nf6 d4 Nxe4 Bd3 d5 Nxe5 Bd6 O-O Nd7 Nxd7 Bxd7 c4 c6 ",
	"e4 e5 Nf3 Nf6 d4 Nxe4 Bd3 d5 Nxe5 Be7 O-O O-O c4 Nf6 Nc3 dxc4 ",
	"e4 e5 Nf3 Nf6 d4 Nxe4 Bd3 d5 Nxe5 Nd7 Nxd7 Bxd7 O-O Qh4 c4 O-O-O ",
	"e4 e5 Nf3 Nf6 d4 Nxe4 Bd3 d5 Nxe5 Nd7 Nxd7 Bxd7 O-O Qh4 c4 O-O-O ",
	"e4 e5 Nf3 Nf6 d4 Nxe4 Bd3 d5 Nxe5 Nd7 Qe2 Nxe5 Bxe4 dxe4 Qxe4 Be6 ",
	"e4 e5 Nf3 Nf6 d4 Nxe4 dxe5 d5 exd6 Bxd6 Be2 O-O Nbd2 Bf5 O-O Nc6 ",
	"e4 e5 Nf3 Nf6 d4 exd4 Bc4 d5 exd5 Nxd5 O-O Be7 Qxd4 Be6 Bxd5 Bxd5 ",
	"e4 e5 Nf3 Nf6 d4 exd4 e5 Ne4 Qe2 Nc5 Nxd4 Nc6 Nxc6 bxc6 Nc3 Rb8 ",
	"e4 e5 Nf3 d5 exd5 e4 Qe2 Qe7 Nd4 Qe5 Nb5 Bd6 d4 Qe7 c4 Bb4+ ",
	"e4 e5 Nf3 d6 Bc4 Be7 d3 Nf6 c3 O-O O-O c6 Bb3 Be6 Bc2 h6 ",
	"e4 e5 Nf3 d6 d4 Bg4 dxe5 Bxf3 Qxf3 dxe5 Bc4 Nf6 Qb3 Bd6 Bxf7+ Kf8 ",
	"e4 e5 Nf3 d6 d4 Bg4 dxe5 Bxf3 Qxf3 dxe5 Bc4 Nf6 Qb3 Qe7 Nc3 c6 ",
	"e4 e5 Nf3 d6 d4 Nd7 dxe5 dxe5 Bc4 h6 g4 c6 Nc3 Bc5 Qe2 Qe7 ",
	"e4 e5 Nf3 d6 d4 Nf6 Nc3 Nbd7 Bc4 Be7 O-O O-O Re1 c6 a4 a5 ",
	"e4 e5 Nf3 d6 d4 Nf6 Nc3 Nbd7 Bc4 h6 Be3 c6 Qe2 Qc7 a4 exd4 ",
	"e4 e5 Nf3 d6 d4 exd4 Bc4 h6 c3 c6 O-O dxc3 Qb3 Qc7 Nxc3 g5 ",
	"e4 e5 Nf3 d6 d4 exd4 Nxd4 Nf6 Nc3 Be7 Bd3 O-O f4 c5 Nf3 Nc6 ",
	"e4 e5 Nf3 d6 d4 exd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 Bg5 f6 Bh4 Nh6 ",
	"e4 e5 Nf3 d6 d4 exd4 Qxd4 Nc6 Bb5 Bd7 Bxc6 Bxc6 Bg5 f6 Bh4 Nh6 ",
	"e4 e5 Nf3 d6 d4 exd4 Qxd4 Nc6 Bb5 Ne7 Bg5 a6 Bxc6+ Nxc6 Qd2 Be7 ",
	"e4 e5 Nf3 d6 d4 exd4 Qxd4 Nf6 e5 dxe5 Qxd8+ Kxd8 Nxe5 Be6 Nc3 Bd6 ",
	"e4 e5 Nf3 d6 d4 exd4 Qxd4 a6 Bg5 f6 Be3 Be6 Nc3 Ne7 Be2 Nec6 ",
	"e4 e5 Nf3 f5 Nxe5 Qf6 Nc4 fxe4 Nc3 Qg6 d3 Bb4 Bd2 Bxc3 Bxc3 d5 ",
	"e4 e5 c3 Nf6 d4 Nxe4 dxe5 Bc5 Qg4 Nxf2 Qxg7 Rf8 Bg5 f6 exf6 Rxf6 ",
	"e4 e5 d4 exd4 Nf3 Nc6 Nxd4 Nf6 Nxc6 bxc6 Bd3 d5 e5 Ng4 Bf4 Bc5 ",
	"e4 e5 d4 exd4 Qxd4 Nc6 Qc4 Nf6 Nc3 Be7 Be3 O-O O-O-O Ng4 Qe2 Nxe3 ",
	"e4 e5 d4 exd4 c3 d5 exd5 Qxd5 cxd4 Nc6 Nf3 Bg4 Be2 O-O-O Nc3 Bb4 ",
	"e4 e5 d4 exd4 c3 d5 exd5 Qxd5 cxd4 Nc6 Nf3 Bg4 Be2 O-O-O Nc3 Bb4 ",
	"e4 e5 d4 exd4 c3 d5 exd5 Qxd5 cxd4 Nc6 Nf3 Bg4 Be2 O-O-O Nc3 Qh5 ",
	"e4 e5 d4 exd4 c3 dxc3 Bc4 Nf6 Nxc3 Bb4 Nf3 O-O Ng5 Nc6 O-O h6 ",
	"e4 e5 d4 exd4 c3 dxc3 Bc4 Nf6 Nxc3 d6 e5 Qe7 Nf3 Nbd7 O-O Nxe5 ",
	"e4 e5 d4 exd4 c3 dxc3 Bc4 cxb2 Bxb2 Bb4+ Kf1 Bf8 Nc3 Nh6 Nf3 Nc6 ",
	"e4 e5 d4 exd4 c3 dxc3 Bc4 cxb2 Bxb2 d6 Ne2 Nc6 O-O Be6 Bd5 Nf6 ",
	"e4 e5 d4 exd4 c3 dxc3 Bc4 cxb2 Bxb2 d6 Qb3 Qd7 Nc3 Nc6 Nd5 Na5 ",
	"e4 e5 f4 Bc5 Nf3 Nc6 b4 Bxb4 c3 Ba5 Bc4 Bb6 d4 exd4 cxd4 d6 ",
	"e4 e5 f4 Bc5 Nf3 Nc6 fxe5 d5 exd5 Qxd5 Nc3 Qd8 Ne4 Bb6 c3 Bg4 ",
	"e4 e5 f4 Bc5 Nf3 d6 Nc3 Nf6 Bc4 Nc6 d3 Bg4 h3 Bxf3 Qxf3 Nd4 ",
	"e4 e5 f4 Bc5 Nf3 d6 c3 Bg4 Bc4 Bxf3 Qxf3 Nf6 b4 Bb6 d3 Nbd7 ",
	"e4 e5 f4 Bc5 Nf3 d6 c3 Bg4 Bc4 Nf6 fxe5 Bxf3 Qxf3 dxe5 d3 Nc6 ",
	"e4 e5 f4 Bc5 Nf3 d6 c3 Bg4 Be2 Bxf3 Bxf3 Nc6 b4 Bb6 b5 Nce7 ",
	"e4 e5 f4 Bc5 Nf3 d6 c3 Bg4 fxe5 dxe5 Qa4+ Bd7 Qc2 Nc6 b4 Bd6 ",
	"e4 e5 f4 Bc5 Nf3 d6 c3 Bg4 fxe5 dxe5 Qa4+ Bd7 Qc2 Qe7 d4 exd4 ",
	"e4 e5 f4 Bc5 Nf3 d6 c3 Nc6 Bb5 Bd7 d4 Bb6 O-O Nf6 fxe5 dxe5 ",
	"e4 e5 f4 Bc5 Nf3 d6 c3 Nc6 Bb5 Bd7 d4 Bb6 fxe5 dxe5 d5 Nb8 ",
	"e4 e5 f4 Bc5 Nf3 d6 c3 Nc6 Bb5 a6 Ba4 b5 Bc2 Bb6 d3 Nf6 ",
	"e4 e5 f4 Nc6 Nf3 d6 Bb5 Bd7 O-O Nd4 Nxd4 exd4 Bc4 g6 c3 Bg7 ",
	"e4 e5 f4 Nf6 fxe5 Nxe4 Nf3 Ng5 d4 Nxf3+ Qxf3 Qh4+ Qf2 Qxf2+ Kxf2 Nc6 ",
	"e4 e5 f4 d5 exd5 e4 d3 Nf6 Nd2 exd3 Bxd3 Qxd5 Ngf3 Bc5 Qe2+ Qe6 ",
	"e4 e5 f4 d5 exd5 e4 d3 Nf6 dxe4 Nxe4 Nf3 Bc5 Qe2 Bf5 Nc3 Qe7 ",
	"e4 e5 f4 d5 exd5 exf4 Qf3 Nf6 Bb5+ Bd7 Nc3 Bb4 Nge2 O-O Bxd7 Nbxd7 ",
	"e4 e5 f4 exf4 Bc4 Ne7 Nc3 c6 Nf3 d5 Bb3 dxe4 Nxe4 Nd5 Qe2 Be7 ",
	"e4 e5 f4 exf4 Bc4 Nf6 Nc3 c6 e5 d5 exf6 dxc4 Qe2+ Be6 Ne4 Nd7 ",
	"e4 e5 f4 exf4 Bc4 Qh4+ Kf1 d6 Nc3 Be6 Qe2 c6 Nf3 Qe7 d4 Bxc4 ",
	"e4 e5 f4 exf4 Bc4 d5 Bxd5 Qh4+ Kf1 g5 Nf3 Qh5 h4 Bg7 Nc3 c6 ",
	"e4 e5 f4 exf4 Nc3 d5 Nxd5 Qh4+ Ke2 Bd6 d4 Nf6 Nf3 Bg4 Nxf6+ gxf6 ",
	"e4 e5 f4 exf4 Nf3 Be7 Bc4 Bh4+ g3 fxg3 O-O gxh2+ Kh1 d5 Bxd5 Nf6 ",
	"e4 e5 f4 exf4 Nf3 d5 exd5 Qxd5 Nc3 Qe6+ Kf2 Qb6+ d4 Bg4 Bxf4 Bxf3 ",
	"e4 e5 f4 exf4 Nf3 g5 Bc4 Bg7 O-O d6 c3 Nc6 Qb3 Qe7 d4 Nf6 ",
	"e4 e5 f4 exf4 Nf3 g5 Bc4 Bg7 O-O d6 c3 Qe7 d4 Be6 Bxe6 fxe6 ",
	"e4 e5 f4 exf4 Nf3 g5 Bc4 Bg7 h4 g4 Ng5 Nh6 d4 f6 Bxf4 fxg5 ",
	"e4 e5 f4 exf4 Nf3 g5 Bc4 d6 h4 g4 Ng5 Nh6 d4 f6 Bxf4 Nc6 ",
	"e4 e5 f4 exf4 Nf3 g5 Bc4 g4 d4 Qe7 O-O gxf3 Nc3 c6 Qxf3 Bg7 ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ne5 Nf6 Bc4 d5 exd5 Bd6 O-O Bxe5 ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ne5 Nf6 Bc4 d5 exd5 Bd6 d4 Nh5 ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ne5 Nf6 Bc4 d5 exd5 Bd6 d4 Nh5 ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ne5 Nf6 d4 d6 Nd3 Nxe4 Bxf4 Bg7 ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ne5 d6 Nxg4 Be7 d4 Bxh4+ Nf2 Bxf2+ ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ne5 h5 Bc4 Rh7 d4 Bh6 Nc3 Nc6 ",
	"e4 e5 f4 exf4 Nf3 g5 h4 g4 Ne5 h5 Bc4 Rh7 d4 d6 Nd3 f3 ",
	"e4 e6 Nc3 d5 d4 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 Rg6 ",
	"e4 e6 Nc3 d5 d4 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nf3 Be7 Ng3 c5 dxc5 Bxc5 ",
	"e4 e6 b3 d5 Bb2 dxe4 Nc3 Nf6 Qe2 Nc6 Nxe4 Nxe4 Qxe4 Qd5 Qxd5 exd5 ",
	"e4 e6 d3 c5 Nd2 Nc6 g3 g6 Bg2 Bg7 Ngf3 Nge7 O-O O-O c3 d6 ",
	"e4 e6 d3 c5 Nd2 Nc6 g3 g6 Bg2 Bg7 Ngf3 Nge7 O-O O-O c3 d6 ",
	"e4 e6 d3 c5 Nf3 Nc6 g3 d5 Qe2 Nf6 Bg2 Be7 O-O O-O e5 Ne8 ",
	"e4 e6 d3 c5 Nf3 Nc6 g3 d5 Qe2 Nf6 Bg2 Be7 O-O O-O e5 Ne8 ",
	"e4 e6 d3 c5 Nf3 Nc6 g3 g6 Bg2 Bg7 O-O Nge7 c3 O-O d4 cxd4 ",
	"e4 e6 d3 c5 Nf3 Nc6 g3 g6 Bg2 Bg7 O-O Nge7 c3 O-O d4 d6 ",
	"e4 e6 d3 d5 Nd2 Bd6 Ngf3 c5 g3 Nc6 Bg2 Nge7 O-O O-O Re1 Qc7 ",
	"e4 e6 d3 d5 Nd2 Nf6 Ngf3 Be7 c3 c5 Qc2 Nc6 Be2 e5 O-O O-O ",
	"e4 e6 d3 d5 Nd2 Nf6 Ngf3 c5 g3 Nc6 Bg2 Be7 O-O O-O Re1 Rb8 ",
	"e4 e6 d3 d5 Nd2 Nf6 e5 Nfd7 f4 c5 Ngf3 Nc6 g3 b5 Bg2 Qb6 ",
	"e4 e6 d3 d5 Nd2 Nf6 g3 c5 Bg2 Nc6 Ngf3 Be7 O-O O-O e5 Nd7 ",
	"e4 e6 d3 d5 Nd2 c5 g3 Nf6 Bg2 Be7 Ngf3 O-O O-O Nc6 Re1 Qc7 ",
	"e4 e6 d3 d5 Nd2 c5 g3 g6 Bg2 Bg7 f4 Ne7 Ngf3 Nbc6 O-O O-O ",
	"e4 e6 d4 b6 Bd3 Bb7 Nc3 Bb4 Ne2 Bxc3+ bxc3 c5 O-O d6 f4 Nd7 ",
	"e4 e6 d4 c5 Nf3 cxd4 Nxd4 a6 Bd3 g6 Be3 Bg7 Nc3 Ne7 O-O O-O ",
	"e4 e6 d4 c5 Nf3 cxd4 Nxd4 a6 Nc3 Qc7 g3 Nf6 Bg2 Nc6 O-O d6 ",
	"e4 e6 d4 c5 d5 exd5 exd5 d6 Nf3 Bg4 Be2 a6 a4 Bxf3 Bxf3 Be7 ",
	"e4 e6 d4 c6 Bd3 d5 exd5 exd5 Nf3 Bg4 O-O Bd6 h3 Bh5 Be3 Nd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 Bd2 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 Nc6 O-O-O Rg6 ",
	"e4 e6 d4 d5 Nc3 Bb4 Bd2 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 Nc6 O-O-O Rg6 ",
	"e4 e6 d4 d5 Nc3 Bb4 Bd3 c5 exd5 Qxd5 Bd2 Bxc3 Bxc3 cxd4 Bxd4 Qxg2 ",
	"e4 e6 d4 d5 Nc3 Bb4 Bd3 dxe4 Bxe4 Nf6 Bg5 Nbd7 Bf3 c5 dxc5 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 Ne2 dxe4 a3 Be7 Nxe4 Nf6 N2c3 Nbd7 Bf4 Nxe4 ",
	"e4 e6 d4 d5 Nc3 Bb4 Ne2 dxe4 a3 Be7 Nxe4 Nf6 N2c3 Nbd7 Bf4 Nxe4 ",
	"e4 e6 d4 d5 Nc3 Bb4 Qd3 dxe4 Qxe4 Nf6 Qh4 c5 dxc5 Nd5 Qxd8+ Kxd8 ",
	"e4 e6 d4 d5 Nc3 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 Nbd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 Rg6 ",
	"e4 e6 d4 d5 Nc3 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 Rg6 ",
	"e4 e6 d4 d5 Nc3 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 c5 ",
	"e4 e6 d4 d5 Nc3 Bb4 a3 Bxc3+ bxc3 dxe4 Qg4 Nf6 Qxg7 Rg8 Qh6 c5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 Bd2 c5 Nb5 Bxd2+ Qxd2 O-O dxc5 Nd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 b6 Qg4 Ng6 h4 h5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Nf3 Bd7 Bd3 c4 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Nf3 b6 Bb5+ Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 Kf8 Nf3 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 O-O Bd3 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 O-O Bd3 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 O-O Bd3 Nd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 a4 Nbc6 Nf3 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 a4 Nbc6 Nf3 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Ne7 a3 Bxc3+ bxc3 c5 a4 Nbc6 Nf3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Qd7 Nf3 b6 Bd2 Ba6 Bxa6 Nxa6 O-O Nb8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Qd7 Nf3 b6 Bd2 Bf8 Be2 Ba6 O-O c6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Qd7 a3 Bf8 Nh3 b6 Nf4 Ne7 Bb5 c6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 Qd7 a3 Bxc3+ bxc3 b6 Qg4 f5 Qh5+ Qf7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 Qg4 Bf8 Nh3 Ne7 Bg5 Nbc6 Bb5 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 Qg4 Bf8 Qg3 Ne7 Bg5 Nf5 Bxd8 Nxg3 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 a3 Bxc3+ bxc3 Qd7 Qg4 f5 Qg3 Ba6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 b6 a3 Bxc3+ bxc3 Qd7 h4 Ba6 Bxa6 Nxa6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 Bd2 Ne7 a3 Bxc3 Bxc3 b6 b4 Qc7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 Qg4 Ne7 dxc5 Nbc6 Bd2 Nf5 Nf3 Bxc5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 Bd2 Nc6 Nb5 Nxd4 Nxd4 cxd4 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 Bd2 cxd4 Nb5 Bxd2+ Qxd2 Nc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 Qg4 Ne7 dxc5 Bxc3+ bxc3 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Nb5 Bc7 f4 Nc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Nb5 Bc7 f4 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Nb5 Bc7 f4 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Qg4 Ne7 Nb5 Bc7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Qg4 Ne7 bxa5 dxc3 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 Qg4 Ne7 bxa5 dxc3 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 b4 cxd4 bxa5 dxc3 Qg4 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Ba5 dxc5 Bxc3+ bxc3 Qc7 Nf3 Nd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 Be2 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 Be2 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Nbc6 Be2 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Qa5 Qd2 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Nf3 Qc7 a4 b6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Nf5 Bd3 h5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Nf5 Bd3 h5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Nf5 Bd3 h5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 O-O Nf3 Nbc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Qc7 Bd3 cxd4 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 Qc7 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 cxd4 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 cxd4 Qxg7 Rg8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 Qg4 cxd4 cxd4 Qc7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 a4 Nbc6 Nf3 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 a4 Qc7 Nf3 b6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Ne7 h4 Nbc6 h5 Qa5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qa5 Bd2 Qa4 Qg4 Kf8 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Nf3 Nc6 Be2 Bd7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Nf3 Ne7 a4 b6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Nf3 Ne7 a4 b6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Nf3 b6 a4 Ba6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Qg4 f5 Qg3 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Qg4 f5 Qg3 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Qg4 f5 Qh5+ g6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Qg4 f6 Nf3 Nc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Bxc3+ bxc3 Qc7 Qg4 f6 Nf3 Nc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 Qa5 axb4 Qxa1 Nb5 Na6 bxc5 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 cxd4 axb4 dxc3 Nf3 Ne7 Bd3 Ng6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 a3 cxd4 axb4 dxc3 bxc3 Qc7 Nf3 Ne7 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 c5 dxc5 Ne7 Nf3 Nbc6 Bd3 d4 a3 Ba5 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 f6 Nf3 c5 a3 Ba5 b4 cxb4 Nb5 Nc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 e5 f6 Nf3 c5 a3 Ba5 b4 cxb4 Nb5 b3+ ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Bd3 Nc6 a3 Bxc3+ bxc3 Nge7 Qf3 Be6 ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Bd3 Ne7 Qh5 Qd7 h3 Nf5 Ne2 Nc6 ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Bd3 Nf6 Bg5 O-O Qf3 Bxc3+ bxc3 Qe8+ ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Bd3 c6 Bf4 Ne7 Qh5 Nd7 Bg5 h6 ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Qf3 Nc6 Bb5 Ne7 Bf4 O-O O-O-O Na5 ",
	"e4 e6 d4 d5 Nc3 Bb4 exd5 exd5 Qf3 Nc6 Bb5 Ne7 Bf4 O-O O-O-O Na5 ",
	"e4 e6 d4 d5 Nc3 Nc6 Nf3 Nf6 exd5 exd5 Bb5 Bg4 h3 Bxf3 Qxf3 Be7 ",
	"e4 e6 d4 d5 Nc3 Nc6 Nf3 Nf6 exd5 exd5 Bb5 Bg4 h3 Bxf3 Qxf3 Be7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bd3 c5 Nf3 cxd4 Nxd4 a6 exd5 Nxd5 O-O Nxc3 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bd3 dxe4 Nxe4 Nbd7 Nxf6+ Nxf6 Nf3 Be7 Qe2 O-O ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 Bd3 h6 Bxf6 Qxf6 e5 Qe7 Qg4 O-O ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 Ne2 dxe4 a3 Be7 Bxf6 Bxf6 Nxe4 Nc6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 Ne2 dxe4 a3 Be7 Bxf6 gxf6 Nxe4 f5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 e5 h6 Bd2 Bxc3 bxc3 Ne4 Bd3 Nxd2 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 e5 h6 Bd2 Bxc3 bxc3 Ne4 Qg4 Kf8 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 e5 h6 Bd2 Bxc3 bxc3 Ne4 Qg4 Kf8 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 e5 h6 Bd2 Bxc3 bxc3 Ne4 Qg4 g6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 e5 h6 Bd2 Bxc3 bxc3 Ne4 Qg4 g6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 e5 h6 Bd2 Bxc3 bxc3 Ne4 Qg4 g6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 e5 h6 Bd2 Bxc3 bxc3 Ne4 Qg4 g6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Bb4 exd5 Qxd5 Nf3 Ne4 Bd2 Bxc3 bxc3 Nxd2 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 Bxf6 Bxf6 Nf3 O-O Bd3 c5 e5 cxd4 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 Bxf6 Bxf6 Nf3 O-O Bd3 c5 e5 cxd4 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Ne4 Nxe4 dxe4 Bxe7 Qxe7 Qe2 b6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 Qd2 O-O Nd1 f6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 Qd2 O-O f4 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 f4 O-O Nf3 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 f4 O-O Nf3 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 Bxe7 Qxe7 f4 a6 Nf3 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 h4 Bxg5 hxg5 Qxg5 Nh3 Qe7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 h4 Bxg5 hxg5 Qxg5 Nh3 Qe7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 h4 Nc6 Be3 f6 Bd3 fxe5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 h4 Nc6 Nh3 f6 Nf4 Ndxe5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 h4 a6 Bxe7 Qxe7 f4 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Nfd7 h4 a6 Qg4 g6 Bxe7 Qxe7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 Be7 e5 Ng8 Bxe7 Nxe7 Nf3 b6 h4 Ba6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 Bxf6 Nf3 Bd7 Qd2 Bc6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 Bxf6 Nf3 Nd7 Bc4 Be7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 Bxf6 Nf3 Nd7 Bc4 O-O ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 Bxf6 Nf3 Nd7 Qd2 Be7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 Bxf6 c3 Nd7 Nf3 Qe7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 gxf6 Bc4 a6 a4 b6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 gxf6 Bc4 c6 c3 f5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 gxf6 Nf3 b6 Bc4 Bb7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 gxf6 Nf3 f5 Ng3 c5 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Be7 Bxf6 gxf6 g3 Bd7 Nf3 Bc6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nf3 Be7 Nxf6+ Bxf6 h4 h6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nf3 Be7 Nxf6+ Nxf6 Bd3 b6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nxf6+ Nxf6 Nf3 Be7 Bd3 h6 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nxf6+ Nxf6 Nf3 c5 Bb5+ Bd7 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nxf6+ Nxf6 Nf3 c5 Bc4 cxd4 ",
	"e4 e6 d4 d5 Nc3 Nf6 Bg5 dxe4 Nxe4 Nbd7 Nxf6+ Nxf6 Nf3 c5 Bc4 cxd4 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 Nf3 c5 dxc5 Nc6 Bf4 Bxc5 Bd3 f6 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 Qb6 Na4 Qa5+ ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 Qb6 Na4 Qa5+ ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 Qb6 Na4 Qa5+ ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 Qb6 Na4 Qa5+ ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 a6 Qd2 b5 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 a6 Qd2 b5 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 a6 Qd2 b5 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 a6 Qd2 b5 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 cxd4 Nxd4 Bc5 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 cxd4 Nxd4 Bc5 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 Nc6 Be3 cxd4 Nxd4 Bc5 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 Nf3 a6 Be3 b5 Qd2 Bb7 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 dxc5 Bxc5 Qg4 O-O Bd3 f5 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 dxc5 Nc6 a3 Nxc5 b4 Nd7 ",
	"e4 e6 d4 d5 Nc3 Nf6 e5 Nfd7 f4 c5 dxc5 Nc6 a3 Nxc5 b4 Nd7 ",
	"e4 e6 d4 d5 Nc3 Nf6 exd5 exd5 Bd3 Nc6 Nge2 Nb4 Ng3 Nxd3+ Qxd3 Be7 ",
	"e4 e6 d4 d5 Nc3 dxe4 Nxe4 Be7 Nf3 Nf6 Bd3 Nxe4 Bxe4 c5 O-O Nd7 ",
	"e4 e6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Bd3 Be7 O-O Nxe4 Bxe4 Nf6 ",
	"e4 e6 d4 d5 Nc3 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Ne5 Bd6 Qf3 c6 ",
	"e4 e6 d4 d5 Nc3 dxe4 Nxe4 Nf6 Bd3 Be7 Nf3 Nbd7 O-O O-O c3 b6 ",
	"e4 e6 d4 d5 Nd2 Nc6 Ngf3 Nf6 e5 Nd7 Be2 f6 exf6 Qxf6 Nf1 Bd6 ",
	"e4 e6 d4 d5 Nd2 Nc6 Ngf3 Nf6 e5 Nd7 Nb3 Be7 Bb5 Ncb8 h4 h6 ",
	"e4 e6 d4 d5 Nd2 Nc6 Ngf3 Nf6 e5 Nd7 Nb3 f6 Bb5 Be7 Bf4 O-O ",
	"e4 e6 d4 d5 Nd2 Nc6 Ngf3 Nf6 e5 Nd7 Nb3 f6 Bb5 Be7 Bf4 O-O ",
	"e4 e6 d4 d5 Nd2 Nc6 Ngf3 Nf6 e5 Nd7 Nb3 f6 Bb5 a6 Bxc6 bxc6 ",
	"e4 e6 d4 d5 Nd2 Nc6 Ngf3 Nf6 e5 Nd7 Nb3 f6 Bb5 fxe5 dxe5 Nc5 ",
	"e4 e6 d4 d5 Nd2 Nc6 Ngf3 Nh6 c3 f5 exd5 exd5 Bd3 Be7 b4 a6 ",
	"e4 e6 d4 d5 Nd2 Nc6 Ngf3 Nh6 e5 f6 Bb5 Bd7 Bxc6 Bxc6 Nb3 Nf7 ",
	"e4 e6 d4 d5 Nd2 Nc6 c3 e5 exd5 Qxd5 Ngf3 Bg4 Bc4 Bxf3 Qb3 Na5 ",
	"e4 e6 d4 d5 Nd2 Nf6 Bd3 c5 e5 Nfd7 c3 Nc6 Ne2 Qb6 Nf3 cxd4 ",
	"e4 e6 d4 d5 Nd2 Nf6 Bd3 c5 e5 Nfd7 c3 Nc6 Ne2 cxd4 cxd4 f6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Ne4 Bd3 f5 exf6 Nxf6 Ngf3 Bd6 O-O O-O ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Ne4 Nxe4 dxe4 Be3 b6 Ne2 Bb7 Ng3 c5 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Bd3 b6 Ne2 Ba6 Bxa6 Nxa6 O-O c5 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Bd3 b6 Ne2 Ba6 Bxa6 Nxa6 O-O c5 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Bd3 c5 c3 Nc6 Ne2 Qb6 Nf3 cxd4 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Bd3 c5 c3 Nc6 Ne2 cxd4 cxd4 Nb6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Bd3 c5 c3 Nc6 Ne2 f6 Nf4 Qe7 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 Bd3 c5 c3 Nc6 Ne2 f6 exf6 Nxf6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 c3 c5 Bd3 Nc6 Ne2 Qb6 Nf3 cxd4 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 c3 c5 Bd3 Nc6 Ne2 cxd4 cxd4 f6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 c3 c5 Bd3 Nc6 Ne2 cxd4 cxd4 f6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 c3 c5 Bd3 Nc6 Ne2 cxd4 cxd4 f6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 c3 c5 Bd3 b6 Qe2 a5 Bb5 Ba6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 c3 c5 Bd3 b6 Qg4 Nc6 Bb5 Bb7 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 c3 c5 Ngf3 Nc6 Bd3 cxd4 cxd4 Nb6 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 c3 c5 f4 Nc6 Ndf3 Qb6 g3 a5 ",
	"e4 e6 d4 d5 Nd2 Nf6 e5 Nfd7 f4 c5 c3 Nc6 Ndf3 f5 Bd3 cxd4 ",
	"e4 e6 d4 d5 Nd2 a6 Ngf3 c5 dxc5 Bxc5 Bd3 Nc6 O-O Nb4 Be2 Ne7 ",
	"e4 e6 d4 d5 Nd2 a6 Ngf3 c5 dxc5 Bxc5 Bd3 Nf6 O-O Nc6 exd5 exd5 ",
	"e4 e6 d4 d5 Nd2 a6 Ngf3 c5 exd5 exd5 dxc5 Bxc5 Nb3 Ba7 Bd3 Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 Bb5 Nf6 exd5 exd5 O-O c4 b3 cxb3 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 Bb5 cxd4 Nxd4 Bd7 Nxc6 Bxc6 Bxc6+ bxc6 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 Bb5 dxe4 Nxe4 Bd7 Bg5 Qa5+ Nc3 cxd4 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 Bb5 dxe4 Nxe4 Bd7 O-O Nxd4 Bg5 f6 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 Bb5 dxe4 Nxe4 Qa5+ Nc3 cxd4 Nxd4 Bd7 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Bd6 O-O Ne7 dxc5 Bxc5 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Bd6 O-O Ne7 dxc5 Bxc5 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Bd6 dxc5 Bxc5 Nb3 Bd6 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Bd6 dxc5 Bxc5 Nb3 Bd6 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Bd6 dxc5 Bxc5 O-O Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Bd6 dxc5 Qe7+ Qe2 Bxc5 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Qe7+ Be2 Qc7 O-O cxd4 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nc6 exd5 exd5 Bb5 Qe7+ Be2 cxd4 O-O Qd8 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nf6 exd5 exd5 Bb5+ Bd7 Bxd7+ Nbxd7 O-O Be7 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 Nf6 exd5 exd5 Bb5+ Bd7 Bxd7+ Nbxd7 O-O Be7 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 a6 exd5 exd5 dxc5 Bxc5 Nb3 Ba7 Bg5 Nf6 ",
	"e4 e6 d4 d5 Nd2 c5 Ngf3 cxd4 exd5 Qxd5 Bc4 Qd6 O-O Nf6 Nb3 Nc6 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 Qxd5 Ngf3 Nc6 Bc4 Qh5 dxc5 Bxc5 Ne4 Nge7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 Qxd5 Ngf3 cxd4 Bc4 Qd6 O-O Nf6 Nb3 Nc6 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 Qxd5 Ngf3 cxd4 Bc4 Qd6 O-O Nf6 Nb3 Nc6 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 Qxd5 Ngf3 cxd4 Bc4 Qd6 O-O Nf6 Nb3 Nc6 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Bb5+ Bd7 Qe2+ Be7 dxc5 Nf6 Nb3 O-O ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Bb5+ Bd7 Qe2+ Be7 dxc5 Nf6 Nb3 O-O ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Bb5+ Bd7 Qe2+ Be7 dxc5 Nf6 Ngf3 O-O ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Bb5+ Nc6 Ngf3 Bd6 O-O Ne7 dxc5 Bxc5 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Bb5+ Nc6 Ngf3 Bd6 dxc5 Bxc5 Nb3 Bb6 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Bb5+ Nc6 Ngf3 Bd6 dxc5 Bxc5 O-O Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Bb5+ Nc6 Qe2+ Be7 dxc5 Nf6 Nb3 O-O ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nc6 Bb5 Bd6 dxc5 Bxc5 O-O Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nc6 Bb5 Bd6 dxc5 Bxc5 O-O Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nc6 Bb5 Bd6 dxc5 Bxc5 O-O Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nc6 Bb5 Bd6 dxc5 Bxc5 O-O Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nc6 Bb5 Qe7+ Be2 cxd4 O-O Qc7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 Nf6 Bb5+ Bd7 Bxd7+ Nbxd7 O-O Be7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 a6 Be2 c4 O-O Bd6 Re1 Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 a6 dxc5 Bxc5 Nb3 Bb6 Bd3 Ne7 ",
	"e4 e6 d4 d5 Nd2 c5 exd5 exd5 Ngf3 c4 Be2 Nf6 O-O Be7 b3 cxb3 ",
	"e4 e6 d4 d5 Nd2 dxe4 Nxe4 Bd7 Nf3 Bc6 Bd3 Nd7 O-O Ngf6 Ng3 Be7 ",
	"e4 e6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Nf3 Be7 Bd3 Ngf6 Qe2 Nxe4 Bxe4 Nf6 ",
	"e4 e6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Nf3 Ngf6 Ng3 c5 c3 cxd4 Nxd4 a6 ",
	"e4 e6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Bd3 c5 dxc5 Bxc5 ",
	"e4 e6 d4 d5 Nd2 dxe4 Nxe4 Nd7 Nf3 Ngf6 Nxf6+ Nxf6 Bd3 c5 dxc5 Bxc5 ",
	"e4 e6 d4 d5 Nd2 dxe4 Nxe4 Nd7 g3 Ngf6 Nxf6+ Nxf6 Bg2 c5 Ne2 Qb6 ",
	"e4 e6 d4 d5 Nd2 f5 exf5 exf5 Ndf3 Nf6 Bg5 Be7 Bd3 Ne4 Bxe7 Qxe7 ",
	"e4 e6 d4 d5 e5 b6 Bb5+ Bd7 Bd3 c5 c3 Nc6 Nf3 f6 O-O fxe5 ",
	"e4 e6 d4 d5 e5 c5 Nf3 Nc6 dxc5 Bxc5 Bd3 Nge7 O-O Ng6 Bxg6 hxg6 ",
	"e4 e6 d4 d5 e5 c5 Nf3 Qb6 Bd3 cxd4 O-O Nd7 Nbd2 Ne7 Nb3 Nc6 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Bd7 Be2 Nge7 Na3 cxd4 cxd4 Nf5 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Bd7 Be2 Nge7 O-O cxd4 cxd4 Nf5 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Qb6 Bd3 cxd4 cxd4 Bd7 O-O Nxd4 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Qb6 Bd3 cxd4 cxd4 Bd7 O-O Qxd4 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Qb6 a3 Nge7 b4 cxd4 cxd4 Nf5 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Qb6 a3 c4 Be2 Na5 Nbd2 Bd7 ",
	"e4 e6 d4 d5 e5 c5 c3 Nc6 Nf3 Qb6 a3 c4 Nbd2 Na5 Be2 Ne7 ",
	"e4 e6 d4 d5 e5 c5 c3 Qb6 Nf3 Ne7 dxc5 Qxc5 Bd3 Bd7 O-O Bb5 ",
	"e4 e6 d4 d5 exd5 exd5 Bd3 Bd6 Nc3 c6 Nge2 Ne7 Bg5 Qc7 Qd2 f6 ",
	"e4 e6 d4 d5 exd5 exd5 Bd3 Bd6 Nc3 c6 Nge2 Ne7 Ng3 Nd7 Be3 Nf6 ",
	"e4 e6 d4 d5 exd5 exd5 Bd3 Nc6 c3 Bd6 Qc2 Nge7 Bg5 Bg4 Ne2 Qd7 ",
	"e4 e6 d4 d5 exd5 exd5 Be3 Nf6 Bd3 Bd6 Nc3 c6 Qd2 Qe7 O-O-O Na6 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Bd6 Bd3 Nf6 O-O O-O Nc3 c6 Bg5 Bg4 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Be6 Bd3 Nf6 O-O h6 Ne5 Bd6 f4 Nc6 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nc6 Bb5 Bd6 c4 dxc4 d5 a6 Ba4 b5 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nf6 Bd3 Bd6 O-O O-O Nc3 c5 dxc5 Bxc5 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nf6 Bd3 Bd6 O-O O-O Nc3 c6 Bg5 h6 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nf6 Bd3 Be6 O-O Bd6 Nc3 c6 Ne5 Qb6 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nf6 Bd3 Bg4 O-O Be7 Re1 O-O Bg5 Nbd7 ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nf6 Bd3 c5 O-O c4 Re1+ Be7 Bf1 O-O ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nf6 Bd3 c5 O-O c4 Re1+ Be7 Bf1 O-O ",
	"e4 e6 d4 d5 exd5 exd5 Nf3 Nf6 Be2 Bd6 O-O h6 Re1 Be6 Nbd2 Nbd7 ",
	"e4 e6 d4 d5 exd5 exd5 c3 Bd6 Bd3 c6 Nf3 Ne7 O-O Bg4 Nbd2 Qc8 ",
	"e4 e6 d4 g6 Bd3 Bg7 Be3 Ne7 Ne2 b6 Nd2 Bb7 O-O d5 e5 O-O ",
	"e4 e6 d4 g6 Bd3 Bg7 Be3 c5 c3 cxd4 cxd4 Nc6 Ne2 Nge7 O-O O-O ",
	"e4 g6 Nc3 Bg7 d4 d6 Be3 a6 Qd2 b5 Bd3 Nd7 O-O-O c6 h4 Nb6 ",
	"e4 g6 d4 Bg7 Nc3 c6 Bc4 b5 Bb3 b4 Nce2 Nf6 e5 Nd5 Nf4 Nxf4 ",
	"e4 g6 d4 Bg7 Nc3 c6 Bc4 d6 Qf3 e6 Nge2 Nd7 Bf4 Qe7 Bb3 e5 ",
	"e4 g6 d4 Bg7 Nc3 c6 Be3 d5 Qd2 dxe4 Nxe4 Nd7 O-O-O Ngf6 Nxf6+ Nxf6 ",
	"e4 g6 d4 Bg7 Nc3 c6 Nf3 d5 h3 dxe4 Nxe4 Nd7 c4 Ngf6 Nc3 O-O ",
	"e4 g6 d4 Bg7 Nc3 d6 Be3 Nf6 Qd2 Nc6 f3 a6 O-O-O e6 g4 b5 ",
	"e4 g6 d4 Bg7 Nc3 d6 Be3 Nf6 f3 c6 Qd2 b5 Bd3 Nbd7 a3 a6 ",
	"e4 g6 d4 Bg7 Nc3 d6 Be3 c6 Qd2 Nd7 f4 Ngf6 Nf3 O-O h3 b5 ",
	"e4 g6 d4 Bg7 Nc3 d6 Be3 c6 f4 Qb6 a3 Nf6 Nf3 Bg4 Rb1 d5 ",
	"e4 g6 d4 Bg7 Nc3 d6 Nf3 Nf6 Be2 O-O O-O Bg4 Be3 Nc6 Qd2 e5 ",
	"e4 g6 d4 Bg7 Nc3 d6 Nf3 Nf6 Be2 O-O O-O b6 e5 Nfd7 Bf4 Nc6 ",
	"e4 g6 d4 Bg7 Nc3 d6 Nf3 Nf6 Be2 O-O O-O c6 Bf4 Nbd7 Re1 Qb6 ",
	"e4 g6 d4 Bg7 Nc3 d6 Nge2 Nf6 g3 O-O Bg2 e5 O-O Nc6 dxe5 dxe5 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nc6 Be3 Nf6 Nf3 O-O Qd2 Ng4 Bg1 e5 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nc6 Be3 Nf6 h3 O-O g4 e5 dxe5 dxe5 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nc6 d5 Nb8 Nf3 c6 Be3 Nf6 Qd2 O-O ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nf6 Nf3 O-O Bd3 Bg4 h3 Bxf3 Qxf3 Nc6 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nf6 Nf3 O-O Bd3 Na6 O-O c5 d5 Nc7 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nf6 Nf3 O-O Bd3 Nc6 e5 dxe5 fxe5 Nh5 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nf6 Nf3 O-O Bd3 Nc6 e5 dxe5 fxe5 Nh5 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nf6 Nf3 O-O Bd3 Nfd7 O-O c5 d5 e6 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nf6 Nf3 c5 Bb5+ Bd7 Bxd7+ Nfxd7 d5 O-O ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 Nf6 Nf3 c5 dxc5 Qa5 Bd3 Qxc5 Qe2 O-O ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 a6 Nf3 b5 Bd3 Bb7 Qe2 c5 dxc5 dxc5 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 a6 a4 Nc6 Be3 e6 Nf3 Nge7 Bd3 f5 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 c6 Nf3 Bg4 Be3 Nd7 h3 Bxf3 Qxf3 e6 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 c6 Nf3 Bg4 Be3 Qb6 Qd2 Bxf3 gxf3 Nd7 ",
	"e4 g6 d4 Bg7 Nc3 d6 f4 c6 Nf3 Bg4 Be3 Qb6 Qd2 Bxf3 gxf3 Nd7 ",
	"e4 g6 d4 Bg7 Nf3 d6 Bc4 Nf6 Nc3 O-O Qe2 c6 e5 dxe5 dxe5 Nd5 ",
	"e4 g6 d4 Bg7 Nf3 d6 Bc4 Nf6 Qe2 c6 Bb3 O-O O-O Qc7 e5 dxe5 ",
	"e4 g6 d4 Bg7 Nf3 d6 Bc4 Nf6 Qe2 c6 Bb3 O-O O-O a5 e5 Nd5 ",
	"e4 g6 d4 Bg7 Nf3 d6 Bc4 c5 dxc5 Qa5+ c3 Qxc5 Qb3 e6 Be3 Qc7 ",
	"e4 g6 d4 Bg7 Nf3 d6 Bc4 c6 Bb3 Nf6 Nbd2 O-O O-O Qc7 e5 dxe5 ",
	"e4 g6 d4 Bg7 Nf3 d6 Be2 Nf6 Nc3 O-O O-O Bg4 Be3 Nc6 a4 e5 ",
	"e4 g6 d4 Bg7 Nf3 d6 c3 Nf6 Bd3 O-O O-O Nbd7 Nbd2 e5 Re1 c6 ",
	"e4 g6 d4 Bg7 Nf3 d6 c3 Nf6 Bd3 O-O O-O Nbd7 Nbd2 e5 Re1 c6 ",
	"e4 g6 d4 Bg7 Nf3 d6 h3 Nf6 Nc3 O-O Be3 a6 a4 b6 Bd3 Bb7 ",
	"e4 g6 d4 Bg7 c3 d6 Nf3 Nf6 Bd3 O-O O-O Nc6 Bg5 h6 Bh4 Nh5 ",
	"e4 g6 d4 Bg7 c3 d6 Nf3 Nf6 Nbd2 O-O Be2 Nc6 O-O e5 dxe5 Nxe5 ",
	"e4 g6 d4 Bg7 c4 c5 Nf3 Qa5+ Bd2 Qb6 Bc3 Nf6 d5 O-O Bd3 d6 ",
	"e4 g6 d4 Bg7 c4 c5 d5 d6 Nc3 Na6 Be3 Nc7 Qd2 a6 Bd3 Bd7 ",
	"e4 g6 d4 Bg7 c4 d6 Nc3 Nc6 Be3 Nf6 d5 Ne5 f4 Ned7 Nf3 O-O ",
	"e4 g6 d4 Bg7 f4 d5 e5 c5 dxc5 f6 Nf3 Bg4 Bb5+ Nc6 O-O Nh6 ",
	"e4 g6 d4 Bg7 f4 d6 Nf3 c6 Bd3 Bg4 e5 e6 Nbd2 d5 h3 Bxf3 ",
	"e4 g6 d4 d6 Bg5 Bg7 c3 Nf6 Nd2 Na6 Ngf3 O-O Be2 c5 O-O Nc7 ",
	"e4 g6 d4 d6 Nc3 Bg7 Be3 Nf6 Qd2 c6 Bh6 Bxh6 Qxh6 Qa5 Bd3 Na6 ",
	"e4 g6 d4 d6 Nc3 c6 f4 d5 e5 h5 Nf3 Nh6 Be3 Bg4 h3 Bxf3 ",
	"e4 g6 d4 d6 c4 Bg7 Nc3 Nf6 f3 O-O Be3 Nbd7 Bd3 e5 d5 Nc5 ",
	"e4 g6 d4 d6 c4 Bg7 Nc3 Nf6 f3 O-O Be3 e5 d5 c6 Bd3 b5 ",
	"e4 h6 d4 a5 Bd3 b6 Ne2 e6 O-O Ba6 c4 Nf6 e5 Nh7 f4 Be7 ",
	"f4 Nf6 Nc3 d5 d3 c5 e4 dxe4 dxe4 Qxd1+ Kxd1 Nc6 Bb5 Bd7 Be3 O-O-O ",
	"f4 Nf6 Nf3 d5 e3 g6 Be2 Bg7 O-O O-O d3 b6 a4 Bb7 Qe1 c5 ",
	"f4 d5 Nf3 c5 e3 g6 Bb5+ Bd7 Bxd7+ Nxd7 Nc3 e6 e4 d4 Ne2 Ngf6 ",
	"g3 Nf6 Bg2 c5 c4 e6 Nf3 a6 O-O Qc7 Nc3 Be7 e4 d6 b3 b6 ",
	"g3 Nf6 Bg2 g6 e4 d6 d4 Bg7 Ne2 O-O O-O e5 Nbc3 c6 a4 Nbd7 ",
	"g3 c5 Bg2 Nc6 Nf3 g6 O-O Bg7 c3 Nf6 d4 cxd4 cxd4 d6 d5 Ne5 ",
	"g3 c5 Bg2 Nc6 Nf3 g6 O-O Bg7 d3 e5 Nh4 d5 Nc3 Be6 e4 Nge7 ",
	"g3 c5 Bg2 Nc6 e4 g6 d3 Bg7 f4 d6 Nf3 Nf6 O-O O-O c3 Rb8 ",
	"g3 d5 Bg2 Nf6 Nf3 e6 O-O Be7 c4 O-O d4 dxc4 Qc2 a6 Qxc4 b5 ",
	"g3 d5 Bg2 e5 Nf3 e4 Nd4 Nf6 O-O Be7 d3 c5 Nb3 exd3 cxd3 O-O ",
	"g3 d5 Nf3 Bg4 Bg2 Nd7 c4 c6 cxd5 cxd5 O-O Ngf6 Nc3 e6 d3 Bc5 ",
	"g3 d5 Nf3 Nf6 Bg2 c6 O-O Bg4 c4 e6 b3 Nbd7 Bb2 Bd6 d3 O-O ",
	"g3 d5 Nf3 Nf6 Bg2 e6 O-O Be7 c4 O-O b3 c6 Bb2 b5 d3 Nbd7 ",
	"g3 d5 Nf3 Nf6 Bg2 g6 c4 Bg7 cxd5 Nxd5 d4 O-O e4 Nb6 Nc3 Bg4 ",
	"g3 d5 Nf3 c6 Bg2 Bg4 d3 Nd7 h3 Bxf3 Bxf3 e5 Nd2 Ngf6 e4 dxe4 ",
	"g3 d5 Nf3 g6 Bg2 Bg7 O-O e5 d3 Ne7 Nbd2 O-O e4 d4 a4 f6 ",
	"g3 e5 Bg2 Nf6 d3 d5 Nf3 Nc6 O-O Be7 b3 O-O Bb2 d4 Nbd2 Re8 ",
	"g3 e5 Bg2 Nf6 d3 d5 Nf3 Nc6 O-O Be7 c4 O-O cxd5 Nxd5 Nbd2 Be6 ",
	"g3 e5 c4 Nc6 Bg2 g6 Nc3 Bg7 e3 d6 Nge2 Nge7 O-O O-O d3 Be6 ",
	"g3 e5 c4 Nf6 Bg2 d5 cxd5 Nxd5 Nc3 Nb6 d3 Be7 Be3 O-O Rc1 f5 ",
	"g3 g6 Bg2 Bg7 Nf3 Nf6 O-O O-O b3 d6 d4 e5 dxe5 dxe5 Bb2 e4 ",
	"g3 g6 Bg2 Bg7 Nf3 Nf6 O-O O-O d4 d5 c4 c6 Nbd2 Bf5 b3 Ne4 ",
	"g3 g6 Bg2 Bg7 c4 d6 d4 Nd7 Nc3 e5 Nf3 Ne7 e4 exd4 Nxd4 Nc6 ",
	"g3 g6 Bg2 Bg7 c4 e5 Nc3 Nc6 e3 d6 Nge2 h5 d4 h4 d5 Nce7 ",
	"g3 g6 Bg2 Bg7 d4 d6 e4 Nf6 Ne2 O-O O-O Nbd7 Nbc3 c6 a4 a5 "
};

